/*
 * Licensed Materials - Use restricted, please refer to the "Sample Code" terms 
 * and conditions in the IBM International Program License Agreement (IPLA).
 * 
 *  Copyright IBM Corporation 2006, 2007. All Rights Reserved.
 */

package com.ibm.rpm.wbs.sample;

import com.ibm.rpm.framework.SampleTestController;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * This sample commits affected resources to a project loaded from the rpm
 * repository
 * 
 * @desc Commit affected resources to a project.
 * 
 */
public class WBSCommitResSample extends SampleTestController
{
    static String projectName = "GENERIC_PROJECT_ABC";

    protected void runSample() throws Exception
    {
        WorkElementScope pScope = new WorkElementScope();

        Project project = (Project) loadFromXpath(
            "/Project[@name='" + projectName + "']", pScope).getRpmObjectList()[0];

        SaveResult result = application.commitAffectedResources(sessionID,
            project, pScope);
        if (!result.isSuccessful())
        {
            System.err.println("commitAffectedResources failed");
        }
    }

    public static void main(String[] args)
    {
        new WBSCommitResSample();
    }
}