/*
 * Licensed Materials - Use restricted, please refer to the "Sample Code" terms 
 * and conditions in the IBM International Program License Agreement (IPLA).
 * 
 *  Copyright IBM Corporation 2006, 2007. All Rights Reserved.
 */

package com.ibm.rpm.wbs.sample;

import java.util.Calendar;

import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.framework.SampleTestController;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.scope.WorkElementScope;
import com.ibm.rpm.wbs.types.ConstraintType;

/**
 * This sample associates a specific constraint to a task
 * 
 * @precondition taskName must exist in the repository
 * 
 * @desc Associate a constraint to a task
 */
public class WBSTaskConstraintsSample extends SampleTestController
{
    static String taskName = "_CHILD_TASK_";

    protected void runSample() throws Exception
    {
        /**
         * Load from the repository a specific task
         */
        WorkElementScope tScope = new WorkElementScope();
        Task task = (Task) loadFromXpath("/Task[@name='" + taskName + "']",
            tScope).getRpmObjectList()[0];

        task.setConstraintType(ConstraintType.FinishNoEarlierThan);
        task.setConstraintDate(Calendar.getInstance());

        /**
         * Store the task into the repository with the new constraint
         */
        save(task, tScope, ReloadType.None);
    }

    public static void main(String[] args)
    {
        new WBSTaskConstraintsSample();
    }
}
