/*
 * Licensed Materials - Use restricted, please refer to the "Sample Code" terms 
 * and conditions in the IBM International Program License Agreement (IPLA).
 * 
 *  Copyright IBM Corporation 2006, 2007. All Rights Reserved.
 */

package com.ibm.rpm.wbs.sample;

import com.ibm.rpm.framework.SampleTestController;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * This sample shows how to copy proposed dates to plan dates
 * 
 * @desc Copy proposed dates to plan dates.
 * 
 */
public class WBSTaskCopyProposedToPlan extends SampleTestController
{
    static String projectName = "GENERIC_PROJECT_ABC";

    protected void runSample() throws Exception
    {
        WorkElementScope tScope = new WorkElementScope();

        /**
         * Load the project, and copy the proposed dates to planned dates
         */
        Project project = (Project) loadFromXpath(
            "/Project[@name='" + projectName + "']", tScope).getRpmObjectList()[0];

        SaveResult result = application.copyProposedToPlan(sessionID, project,
            tScope);
        if (!result.isSuccessful())
        {
            System.err.println("The save was unsuccessful");
        }
    }

    public static void main(String[] args)
    {
        new WBSTaskCopyProposedToPlan();
    }
}
