/*
 * Created on Sep 19, 2005
 */
package com.ibm.rpm.applicationadministration.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.applicationadministration.containers.AttributeCategory;
import com.ibm.rpm.applicationadministration.util.AttributeValidator;
import com.ibm.rpm.asset.containers.AssetModule;
import com.ibm.rpm.clientcostcenters.containers.ClientModule;
import com.ibm.rpm.document.containers.DocumentModule;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.resource.containers.PoolModule;
import com.ibm.rpm.resource.containers.ResourceModule;
import com.ibm.rpm.scopemanagement.containers.ScopeManagementModule;
import com.ibm.rpm.wbs.containers.WbsModule;

public class AttributeCategoryCheckpoint extends GenericAttributeCheckpoint
{
    private static final List ATTRIBUTE_CATEGORY_PARENT_LIST = new ArrayList();

    static
    {
        ATTRIBUTE_CATEGORY_PARENT_LIST.add(AttributeCategory.class);
        ATTRIBUTE_CATEGORY_PARENT_LIST.add(AssetModule.class);
        ATTRIBUTE_CATEGORY_PARENT_LIST.add(ClientModule.class);
        ATTRIBUTE_CATEGORY_PARENT_LIST.add(DocumentModule.class);
        ATTRIBUTE_CATEGORY_PARENT_LIST.add(PoolModule.class);
        ATTRIBUTE_CATEGORY_PARENT_LIST.add(ResourceModule.class);
        ATTRIBUTE_CATEGORY_PARENT_LIST.add(ScopeManagementModule.class);
        ATTRIBUTE_CATEGORY_PARENT_LIST.add(WbsModule.class);
    }

    protected static AttributeCategoryCheckpoint instance = new AttributeCategoryCheckpoint();

    public static AttributeCategoryCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        if (!AttributeValidator.validateInstance(rpmObject,
            AttributeCategory.class, msgCtx))
        {
            return;
        }

        // Initialize
        AttributeCategory attributeCategory = (AttributeCategory) rpmObject;

        super.validateSave(attributeCategory, msgCtx, true,
            ATTRIBUTE_CATEGORY_PARENT_LIST);
    }

}