/*
 * Created on Sep 19, 2005
 */
package com.ibm.rpm.applicationadministration.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.applicationadministration.constants.ValidationConstants;
import com.ibm.rpm.applicationadministration.containers.AttributeCategory;
import com.ibm.rpm.applicationadministration.containers.AttributeClassification;
import com.ibm.rpm.applicationadministration.util.AttributeValidator;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

public class AttributeClassificationCheckpoint extends GenericAttributeCheckpoint
{
    private static List ATTRIBUTE_CLASSIFICATION_PARENTS = new ArrayList();

    protected static AttributeClassificationCheckpoint instance = new AttributeClassificationCheckpoint();

    public static AttributeClassificationCheckpoint getInstance()
    {
        return instance;
    }
    
    static
    {
        ATTRIBUTE_CLASSIFICATION_PARENTS.add(AttributeCategory.class);
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        if (!AttributeValidator.validateInstance(rpmObject,
            AttributeClassification.class, msgCtx))
        {
            return;
        }

        // Initialize
        AttributeClassification attributeClassification = (AttributeClassification) rpmObject;

        super.validateSave(attributeClassification,
            msgCtx, true, ATTRIBUTE_CLASSIFICATION_PARENTS);

        // if the object has already been created then selectType
        // cannot be null
        if (attributeClassification.getID() != null)
        {
            AttributeValidator.validateNotNull(
                attributeClassification, ValidationConstants.SELECT_TYPE_FIELD,
                attributeClassification.getSelectType(), msgCtx);
        }
    }
}