/*
 * Created on Sep 16, 2005
 */
package com.ibm.rpm.applicationadministration.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.applicationadministration.constants.ValidationConstants;
import com.ibm.rpm.applicationadministration.containers.ContactGroup;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.resource.containers.ResourceModule;

public class ContactGroupCheckpoint extends AbstractCheckpoint
{
    private static final List CONTACTGROUP_PARENTS = new ArrayList();
    static
    {
        CONTACTGROUP_PARENTS.add(ResourceModule.class);
        CONTACTGROUP_PARENTS.add(ContactGroup.class);
    }
    
    
    protected static ContactGroupCheckpoint instance = new ContactGroupCheckpoint();

    public static ContactGroupCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.isValidParent(rpmObject, msgCtx, false, CONTACTGROUP_PARENTS);

        if (!GenericValidator.validateInstance(rpmObject, ContactGroup.class, msgCtx))
            return;

        // Initialize
        ContactGroup mainCG = (ContactGroup) rpmObject;

        // Field validation: name
        if (mainCG.testNameModified())
        {
            GenericValidator.validateMaxLength(mainCG, "name", mainCG
                .getName(), ValidationConstants.CONTACTGROUP_NAME_MAX, msgCtx);
        }

        // Field validation: description
        if (mainCG.testDescriptionModified())
        {
            GenericValidator.validateMaxLength(mainCG, "description",
                mainCG.getDescription(),
                ValidationConstants.CONTACTGROUP_DESCRIPTION_MAX, msgCtx);
        }       
    }    
    
}
