/*
 * Created on Sep 19, 2005
 */
package com.ibm.rpm.applicationadministration.checkpoints;

import com.ibm.rpm.applicationadministration.containers.OrganizationalAssignment;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.resource.containers.Resource;

/**
 * @author gosselin
 */
public class OrganizationalAssignmentCheckpoint extends AbstractCheckpoint
{
    private static final Class ORGANIZATIONALASSIGNMENT_PARENTS = Resource.class;

    protected static OrganizationalAssignmentCheckpoint instance = new OrganizationalAssignmentCheckpoint();

    public static OrganizationalAssignmentCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.isValidParent(rpmObject, msgCtx, true, ORGANIZATIONALASSIGNMENT_PARENTS);

        if (!GenericValidator.validateInstance(rpmObject, OrganizationalAssignment.class,
            msgCtx))
            return;

        // Initialize
        OrganizationalAssignment mainOA = (OrganizationalAssignment) rpmObject;

        // Field validation: organizational
        GenericValidator.validateMandatoryID(mainOA, "organizational", mainOA
            .getOrganizational(), msgCtx);
    }
    
}
