/*
 * Created on Sep 16, 2005
 */
package com.ibm.rpm.applicationadministration.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.applicationadministration.constants.ValidationConstants;
import com.ibm.rpm.applicationadministration.containers.PoolDomain;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.resource.containers.PoolModule;

/**
 * @author dominiqu
 */
public class PoolDomainCheckpoint extends AbstractCheckpoint
{
    private static final List POOLDOMAIN_PARENTS = new ArrayList();
    static
    {
        POOLDOMAIN_PARENTS.add(PoolModule.class);
        POOLDOMAIN_PARENTS.add(PoolDomain.class);
    }
    
    
    protected static PoolDomainCheckpoint instance = new PoolDomainCheckpoint();

    public static PoolDomainCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.isValidParent(rpmObject, msgCtx, false, POOLDOMAIN_PARENTS);

        if (!GenericValidator.validateInstance(rpmObject, PoolDomain.class, msgCtx))
            return;

        // Initialize
        PoolDomain mainPoolDomain = (PoolDomain) rpmObject;

        // Field validation: name
        if (mainPoolDomain.testNameModified())
        {
            GenericValidator
                .validateMaxLength(mainPoolDomain, "name", mainPoolDomain
                    .getName(), ValidationConstants.POOLDOMAIN_NAME_MAX, msgCtx);
        }

        // Field validation: description
        if (mainPoolDomain.testDescriptionModified())
        {
            GenericValidator.validateMaxLength(mainPoolDomain,
                "description", mainPoolDomain.getDescription(),
                ValidationConstants.POOLDOMAIN_DESCRIPTION_MAX, msgCtx);
        }        
    }    
   
}
