package com.ibm.rpm.applicationadministration.constants;

public class ErrorCodes
{

    /**
     * Validation error codes for app admin containers.
     * Error code range: 401,001 - 402,000
     * 401,001 - 401,299: validation codes
     * 401,300 - 401,499: xpath codes
     * 401,500 + : manager codes
     * 
     * These error messages usually have the container name at the beginning. 
     * The className of the RPMException will be a container.
     * All validation errors that can be thrown to an end user should
     * be of this type.
     */
    
    // validation codes
    public final static int CANNOT_ASSIGN_MULTIPLE_ATTRIBUTES_FROM_A_SINGLE_SELECT_CLASSIFICATION = 401001;
    
    public final static int ATTRIBUTE_ASSIGNMENT_DATE_VALUE_WITH_WRONG_FORMAT = 401002;
    
    public final static int ATTRIBUTE_ASSIGNMENT_WARNING_INPUT_NOT_THE_SAME_AS_OUTPUT = 401003;
    
    public final static int ATTRIBUTE_ASSIGNMENT_STRING_MUST_BE_VALID_NUMBER = 401506;
    
    // manager codes
    public final static int CANNOT_CREATE_CURRENCY = 401500;
    
    public final static int INVALID_WORKINTERVAL = 401501;

    public final static int NO_INTERVALS = 401502;

    public final static int UNBALANCED_INTERVALS = 401503;
   
    public final static int ATTRIBUTE_ASSIGNMENT_TYPE_MISMATCH = 401504;

    public final static int INVALID_ATTRIBUTE_ROOT = 401505;
    
    
}
