package com.ibm.rpm.applicationadministration.managers;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

import com.ibm.rpm.applicationadministration.containers.ContactGroup;
import com.ibm.rpm.applicationadministration.scope.ContactGroupScope;
import com.ibm.rpm.framework.AbstractRPMObjectManager;
import com.ibm.rpm.framework.JoinCondition;
import com.ibm.rpm.framework.ManagerUtil;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RPMManagerFactory;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectManager;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.ExceptionUtil;
import com.ibm.rpm.framework.util.FieldValueMap;
import com.ibm.rpm.framework.util.StringUtil;
import com.ibm.rpm.resource.managers.ResourceModuleManager;
import com.ibm.rpm.wbs.managers.WbsManager;
import com.ibm.rpm.workflow.managers.WorkflowManager;
import com.ibm.rpm.workflow.managers.WorkflowRoleMappingManager;

public class ContactGroupsManager extends AbstractRPMObjectManager
{
    private static final HashMap FIELDPROPERTYMAP = new HashMap();

    private static final HashSet CONTAINERS = new HashSet();

    static
    {
        CONTAINERS.add(ContactGroup.class.getName());

        String[] objs = new String[CONTAINERS.size()];
        CONTAINERS.toArray(objs);
        for (int i = 0; i < objs.length; i++)
        {
            RPMManagerFactory.getInstance().addContainerToMap(objs[i],
                ContactGroupsManager.class);
        }
    }

    /**
     * Column LEVEL_ID of type Types.INTEGER mapped to Integer.
     * 
     * REPLACE PROPERTYNAME with container property in upper case. public static
     * final String PROPERTY_LEVEL_ID = "PROPERTYNAME"; static{
     * FIELDPROPERTYMAP.put(PROPERTY_LEVEL_ID,NAME_LEVEL_ID);}
     */
    public static final int ID_LEVEL_ID = 1;

    public static final int TYPE_LEVEL_ID = Types.INTEGER;

    public static final String NAME_LEVEL_ID = "TMT_CONTACTS.LEVEL_ID";

    /**
     * Column TYPE_ID of type Types.INTEGER mapped to Integer.
     */
    public static final int ID_TYPE_ID = 2;

    public static final int TYPE_TYPE_ID = Types.INTEGER;

    public static final String NAME_TYPE_ID = "TMT_CONTACTS.TYPE_ID";

    public static final String PROPERTY_TYPE_ID = "TYPE_ID";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_TYPE_ID, NAME_TYPE_ID);
    }

    /**
     * Column MAX_RANK of type Types.INTEGER mapped to Integer.
     * 
     * REPLACE PROPERTYNAME with container property in upper case. public static
     * final String PROPERTY_MAX_RANK = "PROPERTYNAME"; static{
     * FIELDPROPERTYMAP.put(PROPERTY_MAX_RANK,NAME_MAX_RANK);}
     */
    public static final int ID_MAX_RANK = 3;

    public static final int TYPE_MAX_RANK = Types.INTEGER;

    public static final String NAME_MAX_RANK = "TMT_CONTACTS.MAX_RANK";

    /**
     * Column CHILD_COUNT of type Types.INTEGER mapped to Integer.
     * 
     * REPLACE PROPERTYNAME with container property in upper case. public static
     * final String PROPERTY_CHILD_COUNT = "PROPERTYNAME"; static{
     * FIELDPROPERTYMAP.put(PROPERTY_CHILD_COUNT,NAME_CHILD_COUNT);}
     */
    public static final int ID_CHILD_COUNT = 4;

    public static final int TYPE_CHILD_COUNT = Types.INTEGER;

    public static final String NAME_CHILD_COUNT = "TMT_CONTACTS.CHILD_COUNT";

    /**
     * Column DELETED_COUNT of type Types.INTEGER mapped to Integer.
     */
    public static final int ID_DELETED_COUNT = 5;

    public static final int TYPE_DELETED_COUNT = Types.INTEGER;

    public static final String NAME_DELETED_COUNT = "TMT_CONTACTS.DELETED_COUNT";

    public static final String PROPERTY_DELETED_COUNT = "DELETED";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_DELETED_COUNT, NAME_DELETED_COUNT);
    }

    /**
     * Column ELEMENT_ID of type Types.CHAR mapped to String.
     */
    public static final int ID_ELEMENT_ID = 6;

    public static final int TYPE_ELEMENT_ID = Types.CHAR;

    public static final String NAME_ELEMENT_ID = "TMT_CONTACTS.ELEMENT_ID";

    public static final String PROPERTY_ELEMENT_ID = "ID";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_ELEMENT_ID, NAME_ELEMENT_ID);
    }

    /**
     * Column ELEMENT_NAME of type Types.CHAR mapped to String.
     */
    public static final int ID_ELEMENT_NAME = 7;

    public static final int TYPE_ELEMENT_NAME = Types.CHAR;

    public static final String NAME_ELEMENT_NAME = "TMT_CONTACTS.ELEMENT_NAME";

    public static final String PROPERTY_ELEMENT_NAME = "NAME";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_ELEMENT_NAME, NAME_ELEMENT_NAME);
    }

    /**
     * Column PARENT_ID of type Types.CHAR mapped to String.
     */
    public static final int ID_PARENT_ID = 8;

    public static final int TYPE_PARENT_ID = Types.CHAR;

    public static final String NAME_PARENT_ID = "TMT_CONTACTS.PARENT_ID";

    public static final String PROPERTY_PARENT_ID = "PARENT";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_PARENT_ID, NAME_PARENT_ID);
    }

    /**
     * Column REC_USER of type Types.CHAR mapped to String.
     * 
     * REPLACE PROPERTYNAME with container property in upper case. public static
     * final String PROPERTY_REC_USER = "PROPERTYNAME"; static{
     * FIELDPROPERTYMAP.put(PROPERTY_REC_USER,NAME_REC_USER);}
     */
    public static final int ID_REC_USER = 9;

    public static final int TYPE_REC_USER = Types.CHAR;

    public static final String NAME_REC_USER = "TMT_CONTACTS.REC_USER";

    /**
     * Column REC_STATUS of type Types.CHAR mapped to String.
     * 
     * REPLACE PROPERTYNAME with container property in upper case. public static
     * final String PROPERTY_REC_STATUS = "PROPERTYNAME"; static{
     * FIELDPROPERTYMAP.put(PROPERTY_REC_STATUS,NAME_REC_STATUS);}
     */
    public static final int ID_REC_STATUS = 10;

    public static final int TYPE_REC_STATUS = Types.CHAR;

    public static final String NAME_REC_STATUS = "TMT_CONTACTS.REC_STATUS";

    /**
     * Column REC_DATETIME of type Types.TIMESTAMP mapped to java.util.Date.
     */
    public static final int ID_REC_DATETIME = 11;

    public static final int TYPE_REC_DATETIME = Types.TIMESTAMP;

    public static final String NAME_REC_DATETIME = "TMT_CONTACTS.REC_DATETIME";

    /**
     * Column RANK of type Types.VARCHAR mapped to String.
     */
    public static final int ID_RANK = 12;

    public static final int TYPE_RANK = Types.VARCHAR;

    public static final String NAME_RANK = "TMT_CONTACTS.RANK";

    public static final String PROPERTY_RANK = "RANKID";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_RANK, NAME_RANK);
    }

    /**
     * Column DESCRIPTION of type Types.VARCHAR mapped to String.
     */
    public static final int ID_DESCRIPTION = 13;

    public static final int TYPE_DESCRIPTION = Types.VARCHAR;

    public static final String NAME_DESCRIPTION = "TMT_CONTACTS.DESCRIPTION";

    public static final String PROPERTY_DESCRIPTION = "DESCRIPTION";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_DESCRIPTION, NAME_DESCRIPTION);
    }

    private static final String TABLE_NAME = "TMT_CONTACTS";

    /**
     * Create an array of type string containing all the fields of the
     * TMT_CONTACTS table.
     */
    private static final String[] FIELD_NAMES =
    {
        NAME_LEVEL_ID, NAME_TYPE_ID, NAME_MAX_RANK, NAME_CHILD_COUNT, NAME_DELETED_COUNT,
        NAME_ELEMENT_ID, NAME_ELEMENT_NAME, NAME_PARENT_ID, NAME_REC_USER,
        NAME_REC_STATUS, NAME_REC_DATETIME, NAME_RANK, NAME_DESCRIPTION
    };

    private static final String ALL_FIELDS;
    static
    {
        StringBuffer fieldcat = new StringBuffer(FIELD_NAMES[0]);
        for (int i = 1; i < FIELD_NAMES.length; i++)
        {
            fieldcat.append(",");
            fieldcat.append(FIELD_NAMES[i]);
        }
        ALL_FIELDS = fieldcat.toString();
    };

    /**
     * 
     * @return ContactGroupsManager
     */
    public ContactGroupsManager()
    {
        super();
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.managers.AbstractRPMObjectManager#getTableName()
     */
    public String getTableName()
    {
        return TABLE_NAME;
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.containers.AbstractRPMObjectManager#getFieldsNames()
     */
    protected String[] getFieldsNames()
    {
        return FIELD_NAMES;
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.managers.AbstractRPMObjectManager#getAllFields()
     */
    protected String getAllFields()
    {
        return ALL_FIELDS;
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.managers.AbstractRPMObjectManager#getPrimaryKey()
     */
    public String getPrimaryKey()
    {
        return NAME_ELEMENT_ID;
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.managers.AbstractRPMObjectManager#getContainerType(java.sql.ResultSet)
     */
    protected Integer getContainerType(ResultSet resultSet) throws RPMException,
            SQLException
    {

        int typeId = resultSet.getInt(ID_TYPE_ID);
        return new Integer(typeId);
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.managers.AbstractRPMObjectManager#getPropertiesMap()
     */
    protected HashMap getPropertiesMap()
    {
        return FIELDPROPERTYMAP;
    }

    protected RPMObject createContainer(int typeId) throws RPMException
    {

        RPMObject object = null;

        switch (typeId)
        {
        case ContactGroup.TYPE_ID:
            object = new ContactGroup();
            break;
        default:
            ExceptionUtil.handleUnsupportedTypeId(this, typeId);
        }
        return object;
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.managers.AbstractRPMObjectManager#decodeRow(java.sql.ResultSet,
     *      com.ibm.rpm.containers.RPMObject)
     */
    protected RPMObject decodeRow(ResultSet rs, RPMObject rpmObject, boolean isDelta)
            throws SQLException
    {
        ContactGroup temp = (ContactGroup) rpmObject;
        temp.setID(rs.getString(ID_ELEMENT_ID));
        if (isDelta)
        {
            temp.deltaDescription(rs.getString(ID_DESCRIPTION));
            temp.deltaName(rs.getString(ID_ELEMENT_NAME));
            temp.deltaTypeID(new Integer(rs.getInt(ID_TYPE_ID)));
        }
        else
        {
            temp.setDescription(rs.getString(ID_DESCRIPTION));
            temp.setName(rs.getString(ID_ELEMENT_NAME));
            temp.assignTypeID(new Integer(rs.getInt(ID_TYPE_ID)));
        }
        return rpmObject;
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.managers.AbstractRPMObjectManager#getRelatedFields(java.sql.ResultSet,
     *      com.ibm.rpm.FieldValueMap, int)
     */
    protected FieldValueMap decodeRelatedFields(ResultSet resultSet,
            FieldValueMap relatedFields, int index) throws RPMException, SQLException
    {

        String parentId = resultSet.getString(ID_PARENT_ID);
        relatedFields.put(index, ID_PARENT_ID, parentId);

        return relatedFields;
    }

    protected void doDelete(RPMObject rpmObject, MessageContext messageContext)
            throws RPMException, SQLException
    {
        ContactGroup pd = null;
        if (rpmObject != null)
        {
            pd = (ContactGroup) rpmObject;
            SP_D_CONTACT(pd, messageContext);
        }
    }

    protected JoinCondition getJoinCondition(RPMObjectManager manager, String condition,
            int level, String containerName, String contextName) throws RPMException
    {
        int typeId = 0;

        if (containerName != null)
        {
            if (containerName.equalsIgnoreCase(StringUtil
                    .getShortClassName(ContactGroup.class)))
            {
                typeId = ContactGroup.TYPE_ID;
            }
            else
            {
                ExceptionUtil.handleNoTypeId(this, containerName);
            }
        }

        StringBuffer baseCondition = new StringBuffer();
        baseCondition.append(NAME_ELEMENT_ID);
        baseCondition.append(" IS NOT NULL ");
        if (typeId != 0)
        {
            baseCondition.append(" AND ");
            baseCondition.append(NAME_TYPE_ID);
            baseCondition.append(" = ");
            baseCondition.append(typeId);
        }
        
        JoinCondition joinCondition = null;
        if (manager == null)
        {
            joinCondition = new JoinCondition();
            joinCondition.setTableName(getTableName());
            if (condition != null)
            {
                baseCondition.append(" AND ");
                baseCondition.append(condition);
            }
            joinCondition.setCondition(baseCondition.toString());
        }
        else if (manager instanceof ContactGroupsManager)
        {
            joinCondition = new JoinCondition();
            StringBuffer where = new StringBuffer();
            int rankLenght = 4 * level;
            String rank = getTableName() + ".RANK";

            where.append("(LEVEL_ID >= ");
            where.append(level);
            where.append(") AND SUBSTR(");
            where.append(rank);
            where.append(",1,LENGTH(");
            where.append(rank);
            where.append(")- ");
            where.append(rankLenght);
            where.append(") IN (SELECT ");
            where.append(rank);
            where.append(" FROM ");
            where.append(getTableName());
            where.append(" WHERE ");
            where.append(baseCondition);
            if (condition != null)
            {
                where.append(" AND ");
                where.append(condition);
            }

            joinCondition.setCondition(where.toString());
        }
        else if(manager instanceof ResourceModuleManager)
        	joinCondition = new JoinCondition();
        
        else
        {
            ExceptionUtil.handleUnsupportedJoinCondition(this, manager,
                ExceptionUtil.JOIN);
        }
        return joinCondition;
    }

    protected JoinCondition getSubTableJoinCondition(RPMObjectManager manager,
            String condition, int level, String containerName, String contextName)
            throws RPMException
    {
        // TODO Implement method getSubTableJoinCondition if needed
        JoinCondition joinCondition = null;

        ExceptionUtil.handleUnsupportedJoinCondition(this, manager,
            ExceptionUtil.SUB_TABLE_JOIN);

        return joinCondition;
    }

    protected JoinCondition getForeignKeyCondition(RPMObjectManager manager,
            String extraWhere, String contextName) throws RPMException
    {

        JoinCondition joinCondition = null;
        if (manager instanceof ContactGroupsManager)
        {
            //where clause of the join condition
            StringBuffer condition = new StringBuffer();
            condition.append(getPrimaryKey());
            condition.append(" = ?");
            joinCondition = getJoinCondition(manager, condition.toString(), 1, null, null);
            if (extraWhere != null && extraWhere.length() > 0)
            {
                StringBuffer sb = new StringBuffer();
                sb.append(joinCondition.getCondition());
                sb.append(" AND ");
                sb.append(extraWhere);
                joinCondition.setCondition(sb.toString());
            }
            joinCondition.setTableName(getTableName());
        }else if(manager instanceof ResourceModuleManager)
        {
        	joinCondition = getJoinCondition(manager,null,2, null, contextName);
            if(extraWhere != null && extraWhere.length() > 0){
                joinCondition.setCondition(extraWhere);
            }
            joinCondition.setTableName(getTableName(contextName));
        }
        else if (manager instanceof WorkflowRoleMappingManager)
        {
            // for loading WorkflowRoleMapping.contactGroup
            joinCondition = new JoinCondition(TABLE_NAME);
            joinCondition.appendSubSelect(NAME_ELEMENT_ID,
                WorkflowRoleMappingManager.NAME_GROUP_ID,
                WorkflowRoleMappingManager.TABLE_NAME,
                WorkflowRoleMappingManager.NAME_PROJECT_ID + "=? AND "
                        + WorkflowRoleMappingManager.NAME_WKF_ROLE_ID + "=?");
            joinCondition.appendCondition(extraWhere);
        }
        else
        {
            ExceptionUtil.handleUnsupportedJoinCondition(this, manager,
                ExceptionUtil.FOREIGN_KEY);
        }
        return joinCondition;
    }

    protected RPMObject loadRelatedObjects(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext messageContext, FieldValueMap relatedFields, int index,
            boolean isDelta) throws RPMException, SQLException, ParseException
    {
        if (rpmScope != null)
        {

            ContactGroup object = (ContactGroup) rpmObject;

            //Parent
            if (rpmScope.getParent() != null)
            {

                String oldParentId = (String) relatedFields.get(index, ID_PARENT_ID);

                ContactGroup newParent = null;
                if (isDelta)
                {
                    newParent = (ContactGroup) object.getParent();
                    ContactGroup oldParent = null;
                    if (oldParentId != null)
                    {
                        oldParent = new ContactGroup();
                        oldParent.setID(oldParentId);
                        if (newParent != null && newParent.getID() != null
                            && newParent.getID().equals(oldParentId))
                        {
                            oldParent = (ContactGroup) loadByPrimaryKey(newParent, rpmScope
                                .getParent(), messageContext, true);
                        }
                        else
                        {
                            //In this case, old parent is loaded without the
                            // scope to avoid problem with the cache
                            oldParent = (ContactGroup) loadByPrimaryKey(oldParent, null,
                                messageContext, false);
                        }
                    }
                    deltaParent(object, oldParent);
                }
                else
                {
                    if (oldParentId != null)
                    {
                        if (newParent == null)
                        {//newParent not in cache
                            newParent = new ContactGroup();
                            newParent.setID(oldParentId);
                            newParent = (ContactGroup) loadByPrimaryKey(newParent, rpmScope
                                .getParent(), messageContext, false);
                        }
                        setParent(object, newParent);
                    }
                }
            }

            if (rpmScope instanceof ContactGroupScope)
            {
                ContactGroupScope scope = (ContactGroupScope) rpmScope;

                //children
                object = loadGroups(object, scope, messageContext, isDelta);
            }
        }

        return rpmObject;
    }

    private void deltaParent(RPMObject rpmChild, RPMObject rpmParent)
    {
        ((ContactGroup) rpmChild).deltaParent(rpmParent);
    }

    private ContactGroup loadGroups(ContactGroup pd, ContactGroupScope scope,
            MessageContext messageContext, boolean isDelta) throws RPMException,
            ParseException, SQLException
    {
        if (scope != null)
        {
            if (scope.getContactGroups() != null)
            {
                ArrayList temp = loadByForeignKey(pd.getContactGroups(), scope
                    .getContactGroups(), messageContext, this, new Object[]
                {
                    pd.getID()
                }, "TYPE_ID = " + ContactGroup.TYPE_ID, null, isDelta);
                if (temp != null)
                {
                    ContactGroup[] pDomains = new ContactGroup[temp.size()];
                    temp.toArray(pDomains);
                    pd.setContactGroups(pDomains);
                }
            }
        }
        return pd;
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.managers.AbstractRPMObjectManager#createObject(com.ibm.rpm.containers.RPMObject)
     */
    public void createObject(RPMObject rpmObject, MessageContext messageContext)
            throws SQLException, RPMException
    {
        ContactGroup pObject = (ContactGroup) rpmObject;
        pObject.setID(SP_I_CONTACT(pObject, messageContext));
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.managers.AbstractRPMObjectManager#updateObject(com.ibm.rpm.containers.RPMObject,
     *      boolean)
     */
    public RPMObject updateObject(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext messageContext) throws SQLException, RPMException,
            ParseException
    {
        ContactGroup pObject = (ContactGroup) rpmObject;
        ContactGroupScope scope = (ContactGroupScope) rpmScope;
        if (pObject.testNameModified())
        {
            SP_U_CONTACT(pObject, messageContext);
        }

        if (scope != null)
        {
            if (rpmObject != null)
            {
                pObject = saveGroups((ContactGroup) rpmObject, scope, messageContext);
            }
        }
        return pObject;
    }

    protected ContactGroup saveGroups(ContactGroup aGroup, RPMObjectScope rpmScope,
            MessageContext messageContext) throws RPMException,
            SQLException, ParseException
    {
        ContactGroupScope scope = (ContactGroupScope) rpmScope;
        aGroup.setContactGroups((ContactGroup[]) 
                updateChildren(aGroup, 
                        aGroup.getContactGroups(), 
                        scope.getContactGroups(), 
                        messageContext, null));
        return aGroup;
    }

    private ContactGroup setParent(RPMObject rpmChild, RPMObject rpmParent)
    {
        ContactGroup pdChild = (ContactGroup) rpmChild;
        ContactGroup pdParent = (ContactGroup) rpmParent;
        pdChild.setParent(pdParent);
        return pdChild;
    }

    /*
     * Build an array containing name, parentID, typeID and userID
     */
    private String SP_I_CONTACT(ContactGroup cg, MessageContext messageContext)
            throws SQLException, RPMException
    {
        String name = "SP_I_CONTACT";
        Object args[] = new Object[4];
        args[0] = cg.getName();
        if (cg.getParent() != null)
        {
            args[1] = cg.getParent().getID();
        }
        args[2] = cg.retrieveTypeID();
        args[3] = getUser(messageContext).getID();
        //The needed parameters for the SP are:
        //ELEMENT_NAME, PARENT_ID, TYPE_ID, REC_USER
        return executeProcedure(messageContext, name, args);
    }

    private void SP_U_CONTACT(ContactGroup cg, MessageContext messageContext)
            throws SQLException, RPMException
    {
        String name = "SP_U_CONTACT";
        Object args[] = new Object[5];
        args[0] = cg.getID();
        if (cg.getParent() != null)
        {
            args[1] = cg.getParent().getID();
        }
        args[2] = cg.getName();
        args[3] = cg.getDescription();
        if (getUser(messageContext) != null)
        {
            args[4] = getUser(messageContext).getID();
        }
        //The needed parameters for the SP are:
        //ELEMENT_ID, ELEMENT_NAME, DESCRIPTION, REC_USER
        executeProcedure(messageContext, name, args);
    }

    private void SP_D_CONTACT(ContactGroup cg, MessageContext messageContext)
            throws RPMException, SQLException
    {
        String name = "SP_D_CONTACT";
        Object args[] = new Object[4];
        args[0] = cg.getID();
        args[1] = ManagerUtil.getParentId(this,cg, messageContext, TABLE_NAME);
        args[2] = "X";
        if (getUser(messageContext) != null)
        {
            args[3] = getUser(messageContext).getID();
        }
        //The needed parameters for the SP are:
        //ELEMENT_ID, PARENT_ID, REC_STATUS, REC_USER
        executeProcedure(messageContext, name, args);
    }
}