package com.ibm.rpm.applicationadministration.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class InputType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected InputType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Date = "Date";
	public static final InputType Date = new InputType(_Date);
	
		
	public static final String _None = "None";
	public static final InputType None = new InputType(_None);
	
		
	public static final String _Numeric = "Numeric";
	public static final InputType Numeric = new InputType(_Numeric);
	
		
	public static final String _RiskAppetite = "RiskAppetite";
	public static final InputType RiskAppetite = new InputType(_RiskAppetite);
	
		
	public static final String _RiskTolerance = "RiskTolerance";
	public static final InputType RiskTolerance = new InputType(_RiskTolerance);
	
		
	public static final String _Text = "Text";
	public static final InputType Text = new InputType(_Text);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static InputType fromValue(String value) throws IllegalStateException {
		InputType retVal = (InputType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static InputType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof InputType && ordinal == ((InputType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((InputType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final InputType[] VALUES = {Date, None, Numeric, RiskAppetite, RiskTolerance, Text};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}