package com.ibm.rpm.applicationadministration.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class SelectType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected SelectType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Multi = "Multi";
	public static final SelectType Multi = new SelectType(_Multi);
	
		
	public static final String _Single = "Single";
	public static final SelectType Single = new SelectType(_Single);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static SelectType fromValue(String value) throws IllegalStateException {
		SelectType retVal = (SelectType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static SelectType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof SelectType && ordinal == ((SelectType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((SelectType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final SelectType[] VALUES = {Multi, Single};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}