/*
 * Created on Sep 30, 2005
 *
 */
package com.ibm.rpm.applicationadministration.util;

import java.util.HashMap;
import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.ibm.rpm.framework.util.ContextUtil;

/**
 * @author karim
 *  
 */
public class RtfUtil
{

    private static Log logger = LogFactory.getLog(RtfUtil.class);

    private Map tableNameByContext = new HashMap();

    private Map tableTypeByContext = new HashMap();

    private ContextUtil contextUtil = ContextUtil.getInstance();

    private static RtfUtil singleton = new RtfUtil();

    private RtfUtil()
    {
        init();
    }

    synchronized public static RtfUtil getInstance()
    {
        return singleton;
    }

    private void init()
    {
        tableNameByContext.put(ContextUtil.ASSET_CONTEXT, "ASSET_RTF");
        tableTypeByContext.put(ContextUtil.ASSET_CONTEXT, new Integer(9));
        tableNameByContext.put(ContextUtil.CLIENT_CONTEXT, "CLIENT_RTF");
        tableTypeByContext.put(ContextUtil.CLIENT_CONTEXT, new Integer(11));
        tableNameByContext.put(ContextUtil.UMBRELLA_DOCUMENT_CONTEXT, "DOC_RTF");
        tableTypeByContext.put(ContextUtil.UMBRELLA_DOCUMENT_CONTEXT, new Integer(4));
        tableNameByContext.put(ContextUtil.WBS_CONTEXT, "WBS_RTF");
        tableTypeByContext.put(ContextUtil.WBS_CONTEXT, new Integer(1));
        tableNameByContext.put(ContextUtil.SCOPE_CONTEXT, "CRI_RTF");
        tableTypeByContext.put(ContextUtil.SCOPE_CONTEXT, new Integer(3));

        tableNameByContext.put(ContextUtil.ASSET_DOCUMENT_CONTEXT, "DOC_RTF");
        tableTypeByContext.put(ContextUtil.ASSET_DOCUMENT_CONTEXT, new Integer(
            4));
        tableNameByContext.put(ContextUtil.CLIENT_DOCUMENT_CONTEXT, "DOC_RTF");
        tableTypeByContext.put(ContextUtil.CLIENT_DOCUMENT_CONTEXT,
            new Integer(4));
        tableNameByContext.put(ContextUtil.WBS_DOCUMENT_CONTEXT, "DOC_RTF");
        tableTypeByContext.put(ContextUtil.WBS_DOCUMENT_CONTEXT, new Integer(4));
        tableNameByContext.put(ContextUtil.RESOURCE_DOCUMENT_CONTEXT, "DOC_RTF");
        tableTypeByContext.put(ContextUtil.RESOURCE_DOCUMENT_CONTEXT,
            new Integer(4));
        tableNameByContext.put(ContextUtil.POOL_DOCUMENT_CONTEXT, "DOC_RTF");
        tableTypeByContext.put(ContextUtil.POOL_DOCUMENT_CONTEXT,
            new Integer(4));
    }

    public String getTableName(String contextName)
    {
        return (String) tableNameByContext.get(contextName);
    }

    public Integer getTableType(String contextName)
    {
        return (Integer) tableTypeByContext.get(contextName);
    }
}
