/*
 * Created on Sep 16, 2005
 */
package com.ibm.rpm.asset.checkpoints;

import com.ibm.rpm.asset.constants.ValidationConstants;
import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.asset.containers.DepreciationSchedule;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;

/**
 * @author gosselin, mmatwiy
 */
public class AssetDepreciationCheckpoint extends AbstractCheckpoint
{
    private static final Class DEPRECIATIONSCHEDULE_PARENTS = Asset.class;

    protected static AssetDepreciationCheckpoint instance = new AssetDepreciationCheckpoint();

    public static AssetDepreciationCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.isValidParent(rpmObject, msgCtx, true,
            DEPRECIATIONSCHEDULE_PARENTS);

        if (!GenericValidator.validateInstance(rpmObject,
            DepreciationSchedule.class, msgCtx))
            return;

        DepreciationSchedule depreciationSchedule = (DepreciationSchedule) rpmObject;

        if (depreciationSchedule.testAmountModified())
        {
            GenericValidator.validateRange(depreciationSchedule,
                ValidationConstants.AMOUNT_FIELD, depreciationSchedule
                    .getAmount(), ValidationConstants.AMOUNT_MIN,
                ValidationConstants.AMOUNT_MAX, msgCtx);
        }
    }
}
