/*
 * Created on Jan 9, 2006
 * @author mmatwiy
 * Checkpoint validation of container AssetOrganizationalAssignment
 */
package com.ibm.rpm.asset.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.asset.constants.ValidationConstants;
import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.asset.containers.AssetOrganizationalAssignment;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;

public class AssetOrganizationalAssignmentCheckpoint extends AbstractCheckpoint
{

    private static final List ASSET_ORG_ASSIGNMENT_PARENTS = new ArrayList();

    static
    {
        ASSET_ORG_ASSIGNMENT_PARENTS.add(Asset.class);
    }

    protected static AssetOrganizationalAssignmentCheckpoint instance = new AssetOrganizationalAssignmentCheckpoint();

    public static AssetOrganizationalAssignmentCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        if (!GenericValidator.validateInstance(rpmObject,
            AssetOrganizationalAssignment.class, msgCtx))
        {
            return;
        }

        super.isValidParent(rpmObject, msgCtx, true,
            ASSET_ORG_ASSIGNMENT_PARENTS);

        AssetOrganizationalAssignment assignment = (AssetOrganizationalAssignment) rpmObject;

        GenericValidator.validateMandatory(assignment,
            ValidationConstants.ORGANIZATIONAL_FIELD, assignment
                .getOrganizational(), msgCtx);
    }

}
