/*
 * Created on Jan 9, 2006
 * @author mmatwiy
 * Checkpoint validation of container AssetResourceAssignment
 */
package com.ibm.rpm.asset.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.asset.constants.ValidationConstants;
import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.asset.containers.AssetResourceAssignment;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;

public class AssetResourceAssignmentCheckpoint extends AbstractCheckpoint
{

    private static final List ASSET_RES_ASSIGNMENT_PARENTS = new ArrayList();

    static
    {
        ASSET_RES_ASSIGNMENT_PARENTS.add(Asset.class);
    }

    protected static AssetResourceAssignmentCheckpoint instance = new AssetResourceAssignmentCheckpoint();

    public static AssetResourceAssignmentCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        if (!GenericValidator.validateInstance(rpmObject,
            AssetResourceAssignment.class, msgCtx))
        {
            return;
        }

        super.isValidParent(rpmObject, msgCtx, true,
            ASSET_RES_ASSIGNMENT_PARENTS);

        AssetResourceAssignment assignment = (AssetResourceAssignment) rpmObject;

        GenericValidator.validateMandatory(assignment,
            ValidationConstants.RESOURCE_FIELD, assignment.getResource(),
            msgCtx);
    }

}
