package com.ibm.rpm.authentication;

import java.util.Properties;

import junit.framework.TestCase;

public class TestSingleStringConfig extends TestCase
{
    
    public void testSingleStringConfig()
    {
        Properties myprop = new Properties();
        LdapAuthenticationController.parseSingleStringConfiguration("", myprop);
        
        assertEquals( 0, myprop.size());
        
        
        LdapAuthenticationController.parseSingleStringConfiguration("a=\"b\"", myprop);
        
        assertEquals( "b", myprop.get("a"));

        LdapAuthenticationController.parseSingleStringConfiguration("a=\" b \"", myprop);
        
        assertEquals( " b ", myprop.get("a"));

        LdapAuthenticationController.parseSingleStringConfiguration("a=\" c \" asdf=\" asdf \"", myprop);
        
        assertEquals( " c ", myprop.get("a"));
        assertEquals( " asdf ", myprop.get("asdf"));
        
        LdapAuthenticationController.parseSingleStringConfiguration("a=\" c \" \n\t\rasdf=\" \n\t\rasdf \"", myprop);
        
        assertEquals( " c ", myprop.get("a"));
        assertEquals( " \n\t\rasdf ", myprop.get("asdf"));        
        
        LdapAuthenticationController.parseSingleStringConfiguration("a=\" c \" \n\t\rasdf=\" \n\t\ras==df \"", myprop);
        
        assertEquals( " c ", myprop.get("a"));
        assertEquals( " \n\t\ras==df ", myprop.get("asdf"));        

    }
    

}
