package com.ibm.rpm.client.junit;

import java.util.ArrayList;

import com.ibm.rpm.framework.ArrayResult;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.Result;
import com.ibm.rpm.interfaces.Application;
import com.ibm.rpm.interfaces.Authenticate;

public class SpecificTestController
{
    public String url = RpmTestProperties
        .getProperty("rpm.test.middleware.url");

    public Authenticate authenticateInterface = null;

    public Application appInterface = null;
    
    public InternalServices internalServices = null;
    
    private boolean useLiteral = Boolean.valueOf(RpmTestProperties
        .getProperty("rpm.test.wrappedliteral")).booleanValue();

    public static void overrideOption(String option, Object value)
    {
        // overriding options is not supported in remote mode
        // instead, use multiple deployment descriptors

        // overrideOptions.put(option, value);
    }
    
    public static void clearOverrideOptions()
    {
        // overriding options is not supported in remote mode
        // instead, use multiple deployment descriptors
        
        // overrideOptions.clear();
    }    
    
    public void setUp() throws Exception
    {
        //get the authenticate remote reference
        authenticateInterface = new AuthenticateController(url, useLiteral);

        //get the application remote reference
        appInterface = new ApplicationController(url, useLiteral);

    }

    public void tearDown() throws Exception
    {
        // Nothing specific to do.
    }

    /**
     * Return true when the tests are executed remotely, through the Web Service
     * interface. Otherwise, returns false.
     * 
     * @return True when the tests are executed remotely.
     */
    public boolean isRemote()
    {
        return true;
    }

    public String getRemoteURL()
    {
        return url;
    }
    
    public ArrayResult loadFromXpath(String sessionID, String xpath,
			RPMObjectScope scope, Integer idsType, String idsList,
			String attributesIdsList, Integer viewType, Integer inclusions,
			Integer startIndex, Integer endIndex, String extraWhere, String orderBy,
			boolean buildSecurity)
    {
    	return null;
    }

    public Result executeProcedure(String sessionID, Class callerClass, String procedureName,
            Object[] args)
    {
    	return null;
    }
    
    public Result executeSqlUpdate(String sessionID, String updateString,
            Object[] args)
    {
    	return null;
    }
    
    public ArrayList executeSqlQuery(String sessionID, String query,
            Object[] args) throws RPMException
    {
    	return null;
    }
}
