/*
 * Created on Feb 6, 2006
 *
 */
package com.ibm.rpm.client.junit.applicationadministration.testcases;

import java.util.ArrayList;

import junit.framework.Test;
import junit.framework.TestSuite;

import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.clientcostcenters.containers.ClientCostCenter;
import com.ibm.rpm.document.containers.Document;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.scopemanagement.containers.Action;
import com.ibm.rpm.wbs.containers.Proposal;

/**
 * @author karim
 *
 */
public class AllAttributeAssignmentTests
{

    private static ArrayList TEST_PARENTS = new ArrayList();
	private static ArrayList TEST_METHODS = new ArrayList();
	
	static {
	    TEST_PARENTS.add(new ClientCostCenter());
	    TEST_PARENTS.add(new Asset());
	    TEST_PARENTS.add(new Pool());
	    TEST_PARENTS.add(new Resource());
	    TEST_PARENTS.add(new Proposal());
	    TEST_PARENTS.add(new Action());
	    TEST_PARENTS.add(new Document());
	    
		TEST_METHODS.add("testInsertWithNoScopeLoadFromXPath");
		TEST_METHODS.add("testInsertWithNoScopeLoadFromID");
		TEST_METHODS.add("testUpdateWithNoScopeLoadFromID");
	}
	
    public static Test suite(){
    	TestSuite suite = new TestSuite();
    	
    	RPMObject parent;
    	String testMethodName;
    	String testName;
    	
    	for (int k = 0; k < TEST_PARENTS.size(); k++)
        {	
    	    parent = (RPMObject) TEST_PARENTS.get(k);
            for (int j = 0; j < TEST_METHODS.size(); j++)
            {
                testMethodName = (String) TEST_METHODS.get(j);
                testName = testMethodName;
                suite.addTest(new TestAttributeAssignment(testName, parent));
            }
        }
        return suite;
    }
    
}
