package com.ibm.rpm.client.junit.applicationadministration.testcases.fixes;

import com.ibm.rpm.applicationadministration.containers.AttributeAssignment;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.wbs.containers.Deliverable;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/*
Description
I have the following WBS structure:

Proposal
 `---- Deliverable
                `---- AttributeAssignment
 `---- Task
                `---- AttributeAssignment

I try to delete the Deliverable Attribute Assignment. The delete operation 
is ending up with the following error message:

::ERROR:: An RPMObject of type 'AttributeAssignment' with ID 
'6EC980A5092241E982DB9DB3642F0192D48636E1FDEF43449D9038613DE6C2D72' does not exist

However, before calling the delete operation I reloaded the deliverable with the 
following scope

WorkElementScope scope = new WorkElementScope();
Scope.setAttributeAssigment(new Boolean(true));

The assignment is visible from the client before and after the delete.  
 */
public class Test60702 extends ClientTestController
{
    public void testDeleteAttributeAssignment() throws Exception
    {
        WorkElementScope scope = new WorkElementScope();
        scope.setAttributeAssignments(true);
//        scope.setParent(new RPMObjectScope());
        
        Deliverable deliverable = (Deliverable) WorkElementFixture.createFixture(
            new Deliverable(), scope, this);
        
        Proposal parentProject = (Proposal) loadFromXpath(
            "/Proposal[@name='STATIC_PROPOSAL_FIXTURE']", 
            new WorkElementScope())[0];
        
        deliverable.setParent(parentProject);
        
        deliverable = (Deliverable) save(deliverable, scope).getRpmObject();
       
        deliverable = (Deliverable) loadFromXpath("/Deliverable[@id='" + deliverable.getID() +"']", scope)[0];
        
        AttributeAssignment assignment = deliverable.getAttributeAssignments()[0];
        
//        assignment = (AttributeAssignment) loadFromID(assignment, new RPMObjectScope());
//        assignment.setParent(null);
        delete(assignment);
    }
    
//    public void testDeleteAttributeAssignmentWithoutFixture() throws Exception
//    {
//        Proposal parentProject = (Proposal) loadFromXpath(
//            "/Proposal[@name='STATIC_PROPOSAL_FIXTURE']", 
//            new WorkElementScope())[0];
//        
//        Deliverable deliverable = new Deliverable();
//        deliverable.setName(HelperTestUtilities.createName());
//        deliverable.setParent(parentProject);
//        
//        deliverable = (Deliverable) save(deliverable, new WorkElementScope()).getRpmObject();
//        assertNotNull("Deliverable was not saved", deliverable);
//        
//        AttributeAssignment attributeAssignment = new AttributeAssignment();
//        attributeAssignment.setAttribute(value)
//    }
}
