package com.ibm.rpm.client.junit.applicationadministration.testcases.fixes;

import com.ibm.rpm.applicationadministration.containers.AttributeCategory;
import com.ibm.rpm.applicationadministration.scope.AttributeScope;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.security.testcases.resource.BaseResourceSecurityTestLocal;
import com.ibm.rpm.wbs.containers.WbsModule;
import com.ibm.rpm.wbs.scope.WbsModuleScope;

public class Test64208Local extends BaseResourceSecurityTestLocal
{
    public void testCreateAttributeFromParentModule() throws Exception
    {
        // Set up the test
        WbsModuleScope moduleScope = new WbsModuleScope();
        AttributeScope attributeCategoryScope = new AttributeScope();
        moduleScope.setAttributeCategories(attributeCategoryScope);
        AttributeCategory category = new AttributeCategory();
        category.setName(HelperTestUtilities.createName());
        
        WbsModule module = new WbsModule();
        module.setAttributeCategories(new AttributeCategory[]{category});

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditAttributeAdmin(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create an attribute, should fail
        saveAndValidate(module, moduleScope, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditAttributeAdmin(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create an attribute, should succeed
        saveAndValidate(module, moduleScope, true);
    }
    
    public void testCreateAttribute() throws Exception
    {
        // Set up the test
        AttributeCategory category = new AttributeCategory();
        category.setName(HelperTestUtilities.createName());
        category.setParent(new WbsModule());
        
        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditAttributeAdmin(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create an attribute, should fail
        saveAndValidate(category, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditAttributeAdmin(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create an attribute, should succeed
        saveAndValidate(category, null, true);
    }
}
