/*
 * Created on 1-Nov-2005
 */
package com.ibm.rpm.client.junit.applicationadministration.testcases.xpath;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.applicationadministration.containers.RPMCalendar;
import com.ibm.rpm.applicationadministration.scope.CalendarScope;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.RPMCalendarFixture;
import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

/**
 * @author njarazi
 */
public class TestRPMCalendarDataXPath extends ObjectXPathTester
{
    protected ArrayList generateLocalSkipList()
    {
        ArrayList localSkip = new ArrayList();
        localSkip.add("getStandardMonday");
        localSkip.add("getStandardTuesday");
        localSkip.add("getStandardWednesday");
        localSkip.add("getStandardThursday");
        localSkip.add("getStandardFriday");
        localSkip.add("getStandardSaturday");
        localSkip.add("getStandardSunday");
        return localSkip;
    }
    
    protected RPMObject createObject() throws Exception
    {
        return RPMCalendarFixture.createFixture((CalendarScope)mainScope, 1, 1);
    }

    protected RPMObjectScope createScope() throws Exception
    {
        CalendarScope s = new CalendarScope();
        s.setExceptions(true);
        return s;
    }

    /**
     * @param dbObject
     * @throws AssertionFailedError
     * @throws Exception
     */
    protected void objectCompare(RPMObject myObject, RPMObject dbObject,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        RPMCalendarFixture.compare((RPMCalendar) myObject,
                (RPMCalendar) dbObject, (CalendarScope)mainScope);
    }
}