/*
 * Created on Oct 14, 2005
 *
 */
package com.ibm.rpm.client.junit.contract.fixtures;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.contract.containers.Contract;
import com.ibm.rpm.contract.containers.ContractFolder;
import com.ibm.rpm.contract.scope.ContractScope;

/**
 * @author shiv
 *
 */
public class ContractFolderFixture extends RPMObjectFixture {
	private static final int DEFAULT_NB_LEVELS = 1;

	private static final int DEFAULT_NB_FOLDERS_BY_LEVEL = 1;

	private static final int DEFAULT_NB_CONTRACTS_BY_LEVEL = 1;

	public static ContractFolder createSaveFixture(int nbContracts,
			ClientTestController ctc) throws Exception {
		ContractScope scope = createScope(1, DEFAULT_NB_LEVELS,
				DEFAULT_NB_FOLDERS_BY_LEVEL, DEFAULT_NB_CONTRACTS_BY_LEVEL);
		ContractFolder folder = createFixture(DEFAULT_NB_FOLDERS_BY_LEVEL,
				DEFAULT_NB_CONTRACTS_BY_LEVEL, scope, ctc);
		folder = (ContractFolder) save(ctc, folder, scope);
		return folder;
	}

	public static ContractFolder createFixture(int nb_folders_by_level,
			int nb_contracts_by_level, ContractScope scope,
			ClientTestController ctc) throws Exception {
		return createFolder(random(), nb_folders_by_level,
				nb_contracts_by_level, scope, ctc);
	}

	private static ContractFolder createFolder(int index,
			int nb_folders_by_level, int nb_contracts_by_level,
			ContractScope scope, ClientTestController ctc) throws Exception {
		ContractFolder folder = new ContractFolder();
		HelperTestUtilities.setByIntrospection(folder, index, skipSetters);
		if (scope != null) {

			//TODO needs corrections. Must define an array of contracts and folders
		    
		    //create subfolders
//			if (scope.getFolders() != null) {
//				ContractFolder subFolder = null;
//				ContractFolder[] subFolders = new ContractFolder[nb_folders_by_level];
//				for (int i = 1; i <= nb_folders_by_level; i++) {
//					subFolder = ContractFolderFixture.createFixture(
//							nb_folders_by_level, nb_contracts_by_level, scope
//									.getFolders(), ctc);
//					subFolders[i - 1] = subFolder;
//				}
//				folder.setFolders(subFolders);
//			}
			//create contracts
			if (scope.getChildren() != null) {
				Contract contract = null;
				Contract[] contratcs = new Contract[nb_contracts_by_level];
				for (int i = 1; i <= nb_contracts_by_level; i++) {
					contract = ContractFixture.createFixture(scope
							.getChildren(), ctc);
					contratcs[i - 1] = contract;
				}
				folder.setChildren(contratcs);
			}
		}
		return folder;
	}

	public static ContractScope createScope(int currentLevel, int maxLevels,
			int nb_folders_by_level, int nb_contract_by_level) {

		ContractScope scope = new ContractScope();
		if (currentLevel <= maxLevels) {
			
		    //TODO needs corrections
//		    if (nb_folders_by_level > 0 && currentLevel < maxLevels) {
//				//create subfolders scope
//				ContractScope subFolderScope = ContractFolderFixture
//						.createScope(currentLevel + 1, maxLevels,
//								nb_folders_by_level, nb_contract_by_level);
//				subFolderScope.setParent(scope);
//				scope.setFolders(subFolderScope);
//			}
			if (nb_contract_by_level > 0) {
				//create contract scope
				ContractScope conractScope = ContractFixture.createScope();
				conractScope.setParent(scope);
				scope.setChildren(conractScope);
			}
		}
		return scope;
	}

	//update fields
	public static void updateFixtureFields(ContractFolder folder,
			ContractScope scope) throws Exception {
		updateFields(folder, random(), scope);
	}

	private static void updateFields(ContractFolder folder, int index,
			ContractScope scope) throws Exception {
		{
			HelperTestUtilities.setByIntrospection(folder, index, skipSetters);
			if (scope != null) {
			    
			    //TODo needs corrections
				//update subfolders fields
//				if (scope.getFolders() != null) {
//					for (int i = 0; i < folder.getFolders().length; i++) {
//						ContractFolderFixture.updateFixtureFields(folder
//								.getFolders()[i], scope.getFolders());
//					}
//				}
//				//update contract fields
//
//				if (scope.getChildren() != null) {
//					for (int i = 0; i < folder.getChildren().length; i++) {
//						ContractFixture.updateFixture(folder.getChildren()[i],
//								scope.getChildren());
//					}
//				}
			}
		}
	}

	//update structure
	public static void updateFixtureStructure(ContractFolder folder,
			int deltaNbFoldersByLevel, int deltaNbContractsByLevel,
			ContractScope scope, ClientTestController ctc) throws Exception {
		updateStructure(folder, deltaNbFoldersByLevel, deltaNbContractsByLevel,
				scope, ctc);
	}

	private static void updateStructure(ContractFolder folder,
			int deltaNbFoldersByLevel, int deltaNbContractsByLevel,
			ContractScope scope, ClientTestController ctc) throws Exception {
		if (scope != null) {
			
			//TODO needs corrections
			//add new contracts
			if (scope.getChildren() != null) {
				if (deltaNbContractsByLevel > 0) {//add new elements
					Contract newContract = null;
					Contract[] newContracts = new Contract[deltaNbContractsByLevel];
					for (int i = 0; i < deltaNbContractsByLevel; i++) {
						newContract = ContractFixture.createFixture(scope
								.getChildren(), ctc);
						newContract.setParent(folder);
						newContracts[i] = newContract;
					}
					ArrayList temp = mergeArrays(folder.getChildren(),
							newContracts);
					Contract[] totalContracts = new Contract[temp.size()];
					temp.toArray(totalContracts);
					folder.setChildren(totalContracts);
				}
			}
			//add new subfolders
//			if (scope.getFolders() != null) {
//				if (deltaNbFoldersByLevel > 0) {//add new elements
//					ContractFolder newFolder = null;
//					ContractFolder[] newFolders = new ContractFolder[deltaNbFoldersByLevel];
//					for (int i = 0; i < deltaNbFoldersByLevel; i++) {
//						newFolder = ContractFolderFixture.createFixture(
//								deltaNbFoldersByLevel, newNbContractsByLevel,
//								scope.getFolders(), ctc);
//						newFolder.setParent(folder);
//						newFolders[i] = newFolder;
//					}
//					ArrayList temp = mergeArrays(folder.getFolders(),
//							newFolders);
//					ContractFolder[] totalFolders = new ContractFolder[temp
//							.size()];
//					temp.toArray(totalFolders);
//					folder.setFolders(totalFolders);
//					newNbFoldersByLevel = totalFolders.length;
//				}
//			}
		}
	}

	//compare
	public static void compare(ContractFolder f1, ContractFolder f2,
			ContractScope scope) throws AssertionFailedError, Exception {
		RPMObjectFixture.compare(f1, f2);
		if (scope == null)
			return;
		
		//TODO needs corrections
		
		//validate subfolder
//		if (scope.getFolders() != null) {
//			ContractScope s = scope.getFolders();
//			if (s != null) {
//				s.setParent(null);
//			}
//			ContractFolderFixture.compare(f1.getFolders(), f2.getFolders(), s);
//		}
//		//validate contracts
//
//		if (scope.getChildren() != null) {
//			ContractScope s = scope.getChildren();
//			if (s != null) {
//				s.setParent(null);
//			}
//			ContractFixture.compare(f1.getChildren(), f2.getChildren(), s);
//		}
//		//validate parents
//		if (scope.getParent() != null) {
//			ContractScope s = scope.getParent();
//			s.setChildren(null);
//			s.setFolders(null);
//			ContractFolderFixture.compare((ContractFolder) f1.getParent(),
//					(ContractFolder) f2.getParent(), s);
//		}
	}

	public static void compare(ContractFolder[] fArray1,
			ContractFolder[] fArray2, ContractScope scope)
			throws AssertionFailedError, Exception {
		sortWithComparator(fArray1, RPMObjectNameAndIDComparator.INSTANCE);
		sortWithComparator(fArray2, RPMObjectNameAndIDComparator.INSTANCE);
		RPMObjectFixture.compare(fArray1, fArray2);
		if (fArray1 == null)
			return;
		for (int i = 0; i < fArray1.length; i++) {
			ContractFolderFixture.compare(fArray1[i], fArray2[i], scope);
		}
	}

	private static ArrayList mergeArrays(Object[] array1, Object[] array2) {

		ArrayList temp = new ArrayList();

		addArray(temp, array1);

		addArray(temp, array2);

		return temp;

	}

	private static void addArray(ArrayList result, Object[] array) {

		if (array != null && array.length != 0) {

			for (int i = 0; i < array.length; i++) {

				result.add(array[i]);

			}
		}
	}

}