package com.ibm.rpm.client.junit.customfield.testcases;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.customfield.fixtures.CustomFieldFixture;
import com.ibm.rpm.client.junit.resource.fixtures.ResourceFixture;
import com.ibm.rpm.customfield.containers.CustomField;
import com.ibm.rpm.customfield.containers.CustomFieldAssignment;
import com.ibm.rpm.customfield.types.FieldInputType;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.scope.PoolScope;
import com.ibm.rpm.resource.scope.ResourceScope;

/**
 * @author gmeloche
 *
 */
public class TestCustomFieldAssignmentsWithBrokenLinks extends ClientTestController
{

    public void testObjectWithCustomFieldAssignment() throws Exception
    {
    
        CustomField cf = CustomFieldFixture.createSaveCustomField(
            CustomFieldFixture.CF_RESOURCE_CONTEXT, FieldInputType.Text, this);
    
        ResourceScope scope = new ResourceScope();
        scope.setCustomFieldAssignments(true);
        scope.setParent(new PoolScope());
    
        Resource object = ResourceFixture.createSaveFixture(scope, this);
    
        //assigned custom field with the default value
        CustomFieldAssignment cfa = new CustomFieldAssignment();
        cfa.setCustomField(cf);
        cfa.setValue(cf.getDefaultValue());
        object.setCustomFieldAssignments(new CustomFieldAssignment[]
        {
            cfa
        });
    
        save(object, scope);
        
        delete(cf);
    
        Resource loaded = (Resource) loadFromID(object, scope);
    
        assertNull(loaded.getCustomFieldAssignments());
    }
    
    public void testLoadCustomFieldAssignmentWithXpath() throws Exception
    {
    
        CustomField cf = CustomFieldFixture.createSaveCustomField(
            CustomFieldFixture.CF_RESOURCE_CONTEXT, FieldInputType.Text, this);
    
        ResourceScope scope = new ResourceScope();
        scope.setCustomFieldAssignments(true);
        scope.setParent(new PoolScope());
    
        Resource object = ResourceFixture.createSaveFixture(scope, this);
    
        //assigned custom field with the default value
        CustomFieldAssignment cfa = new CustomFieldAssignment();
        cfa.setCustomField(cf);
        cfa.setValue(cf.getDefaultValue());
        object.setCustomFieldAssignments(new CustomFieldAssignment[]
        {
            cfa
        });
    
        save(object, scope);
        
        delete(cf);
    
        RPMObject[] objects = loadFromXpath("Resource[id = '"+ object.getID() + "']/CustomFieldAssignment", null);
    
        assertNull(objects);
    }


}
