package com.ibm.rpm.client.junit.customfield.testcases.xpath;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.customfield.fixtures.CustomFieldAssignmentFixture;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.constants.ErrorCodes;

public class TestCustomFieldAssignmentXPath extends ClientTestController
{
    // ==============================
    // INITIALIZATION AND TERMINATION
    // ==============================

    protected void setUp() throws Exception
    {
        super.setUp();
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testXPathSucceedsWithNullParent()
    throws Exception
    {
        CustomFieldAssignmentFixture.createSaveCustomFieldAssignment(
            CustomFieldAssignmentFixture.ASSET_CONTEXT, this);

        String xpath = "/CustomFieldAssignment";

        RPMObject [] rpmObjects = loadFromXpath(xpath, null);
        assertNotNull(rpmObjects);
        assertTrue(rpmObjects.length != 0);
    }
    
    // ============
    // XPath failure tests
    // ============  
    
    public void testXPathFailsWithInvalidParent()
    throws Exception
    {

        String xpath = "/Attribute/CustomFieldAssignment";
        boolean invalid = false;

        try
        {
            loadFromXpathMustFail(xpath, null);
        }
        catch (RPMException e)
        {
            assertEquals(ErrorCodes.XPATH_INVALID_JOIN, e.getErrorID());
            invalid = true;
        }
        assertTrue(invalid);
    }
    
    public void testXPathFailsWithInvalidChild()
    throws Exception
    {

        String xpath = "/CustomFieldAssignment[CustomFieldCategory]";
        boolean invalid = false;

        try
        {
            loadFromXpathMustFail(xpath, null);
        }
        catch (RPMException e)
        {
            assertEquals(ErrorCodes.XPATH_INVALID_SUBJOIN, e.getErrorID());
            invalid = true;
        }
        assertTrue(invalid);
    }
}
