package com.ibm.rpm.client.junit.customfield.testcases.xpath;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.customfield.fixtures.CustomFieldFixture;
import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.resource.fixtures.ResourceModuleFixture;
import com.ibm.rpm.customfield.containers.CustomField;
import com.ibm.rpm.customfield.containers.CustomFieldCategory;
import com.ibm.rpm.customfield.scope.CustomFieldScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.resource.containers.ResourceModule;
import com.ibm.rpm.resource.scope.ResourceModuleScope;

/**
 * @author legaults
  */
public class TestCustomFieldDataXPath extends ObjectXPathTester
{
    private CustomFieldCategory parentCategory;
    
    
    public void setUp() throws Exception
    {
        super.setUp();
    }

    public void tearDown() throws Exception
    {
        if(parentCategory != null){
            delete(parentCategory);
        }
        
        super.tearDown();
    }

    protected RPMObject createObject() throws Exception
    {       
        //Using a Module object to create the CustomFieldCategory
        ResourceModuleScope moduleScope = new ResourceModuleScope();              
        moduleScope.setCustomFieldCategories(new CustomFieldScope());        
        ResourceModule module = ResourceModuleFixture.createFixture(moduleScope, this);        
        module = (ResourceModule)save(module,moduleScope).getRpmObject();        
        parentCategory = module.getCustomFieldCategories()[0];
        
        //Create a new customField and set the parent
        mainScope = CustomFieldFixture.createCustomFieldScope(1);
        CustomField customField = module.getCustomFieldCategories()[0].getChildren()[0];
        customField.setParent(parentCategory);
        
        return customField;
    }

    protected RPMObjectScope createScope() throws Exception
    {
        CustomFieldScope scope = CustomFieldFixture.createCustomFieldScope(1);
        return scope;
    }

    protected void objectCompare(RPMObject original, RPMObject reloaded,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        CustomFieldFixture.assertEquals(original,
                reloaded, (CustomFieldScope) scope);
    }
}
