/*
 * Created on Nov 3, 2005
 *
 */
package com.ibm.rpm.client.junit.document.testcases;

import java.util.ArrayList;

import junit.framework.Test;
import junit.framework.TestSuite;

import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.clientcostcenters.containers.ClientCostCenter;
import com.ibm.rpm.document.containers.DocumentElement;
import com.ibm.rpm.document.containers.DocumentFolder;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.scopemanagement.containers.Action;
import com.ibm.rpm.wbs.containers.Proposal;


/**
 * @author hrishike
 *
 */
public class AllDocumentTests
{
    private static ArrayList TEST_PARENTS = new ArrayList();
    private static ArrayList TEST_DOCUMENTS = new ArrayList();
	private static ArrayList TEST_METHODS = new ArrayList();
	
	static {
	    TEST_PARENTS.add(new ClientCostCenter());
	    TEST_PARENTS.add(new Asset());
	    TEST_PARENTS.add(new Pool());
	    TEST_PARENTS.add(new Resource());
	    TEST_PARENTS.add(new Proposal());
	    TEST_PARENTS.add(new Action());
	       
	    TEST_DOCUMENTS.add(new DocumentFolder());
	    
		TEST_METHODS.add("testInsertWithNoScopeLoadFromXPath");//success
		TEST_METHODS.add("testInsertWithNoScopeLoadFromID");//success
		TEST_METHODS.add("testUpdateWithNoScopeLoadFromID");//success
		TEST_METHODS.add("testInsertWithScopeLoadFromID");//success
		TEST_METHODS.add("testUpdateWithScopeLoadFromID");//success
	}
	
    public static Test suite(){
    	TestSuite suite = new TestSuite();
    	
    	RPMObject parent;
    	DocumentElement docElement;
    	String testMethodName;
    	String testName;
    	
    	for (int k = 0; k < TEST_PARENTS.size(); k++)
        {	
    	    parent = (RPMObject) TEST_PARENTS.get(k);
            for (int i = 0; i < TEST_DOCUMENTS.size(); i++)
            {
                docElement = (DocumentElement) TEST_DOCUMENTS.get(i);
                for (int j = 0; j < TEST_METHODS.size(); j++)
                {
                    testMethodName = (String) TEST_METHODS.get(j);
                    testName = testMethodName;
                    suite.addTest(new TestDocumentElement(testName, parent, docElement));
                }
            }
        }
        return suite;
    }

}
