/*
 * Created on Dec 1, 2006
 */
package com.ibm.rpm.client.junit.document.testcases;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.document.fixtures.DocumentElementFixture;
import com.ibm.rpm.document.containers.DocumentElement;
import com.ibm.rpm.document.containers.GenericDocument;
import com.ibm.rpm.document.containers.WPDoc;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.wbs.containers.Proposal;

public class TestManualCheckoutDocument extends ClientTestController
{
    private DocumentScope mainScope;

    private static final int NB_MAX_LEVELS = 2;

    private static final int NB_CHILDREN_BY_LEVEL = 1;

    private static final int DELTA_CHILDREN_BY_LEVEL = 1;

    // Global Variables
    Proposal parent = new Proposal();

    DocumentElement documentElement = null;

    public void setUp() throws Exception
    {
        super.setUp();
        documentElement = new WPDoc();
        mainScope = DocumentElementFixture.createScope(documentElement, 1,
            NB_MAX_LEVELS, NB_CHILDREN_BY_LEVEL);

        // create/save a parent object (proposal, document, ...) depending on
        // the type of the parent sent to the constructor
        parent = (Proposal) DocumentElementFixture.createSaveParent(parent,
            this);

        // make sure the ID is null so that we create a new DocumentElement
        documentElement.setID(null);
        documentElement = insertDocumentElement(documentElement, mainScope);
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testDocTimelessCheckout() throws Exception
    {
        WPDoc documentElement2 = new WPDoc();
        documentElement2.setID(documentElement.getID());
        disableAutomaticCheckout();
        mainScope.setParent(new RPMObjectScope());
        documentElement2 = (WPDoc) loadFromID(documentElement2, mainScope);
        checkOut(documentElement2, true);
        documentElement2.setName("toto");
        save(documentElement2, null);
        checkIn(documentElement2);
    }

    private DocumentElement insertDocumentElement(
            DocumentElement documentElement, DocumentScope scope)
            throws Exception
    {
        RPMObject parentDocumentElement = DocumentElementFixture
            .getParentDocumentFolder(parent);
        documentElement = DocumentElementFixture.createFixture(
            parentDocumentElement, documentElement, NB_CHILDREN_BY_LEVEL,
            scope, this);

        if (documentElement instanceof GenericDocument)
        {
            ((GenericDocument) documentElement).setVisibleAtParent(new Boolean(
                true));
        }

        DocumentElement returnedDocumentElem = (DocumentElement) save(
            documentElement, scope).getRpmObject();
        return returnedDocumentElem;
    }
}
