/*
 * Created on Dec 11, 2006
 *
 */
package com.ibm.rpm.client.junit.document.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.document.containers.Document;
import com.ibm.rpm.document.containers.DocumentElement;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.document.types.ElementSecurityType;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author karim
 *
 */
public class Test58862 extends ClientTestController {

	public void testSaveDocumentWithUnrestrictedElementSecurityType() throws Exception
	{
		WorkElementScope workElementScope = new WorkElementScope();
		DocumentScope documentScope = new DocumentScope();
		documentScope.setChildren(documentScope);
		workElementScope.setDocumentFolder(documentScope);
		
		Proposal proposal = new Proposal();
		proposal.setName("WS-Proposal-Defect-58862");

		SaveResult saveResult = save(proposal,workElementScope);
		proposal = (Proposal)saveResult.getRpmObject();

		Document proposalDoc = new Document();
		proposalDoc.setName("Document-of-Proposal");
		proposalDoc.setElementSecurityType(ElementSecurityType.Unrestricted);
		proposal.getDocumentFolder().setChildren(new DocumentElement[] {proposalDoc});
		
		saveResult = save(proposal,workElementScope);
		proposal = (Proposal)saveResult.getRpmObject();
		assertNotNull(proposal);
		assertNotNull(proposal.getDocumentFolder());
		assertNotNull(proposal.getDocumentFolder().getChildren());
		assertEquals(1, proposal.getDocumentFolder().getChildren().length);
		
		Document savedProposalDoc = (Document)proposal.getDocumentFolder().getChildren()[0];
		assertNotNull(savedProposalDoc.getElementSecurityType());
		assertEquals(ElementSecurityType.Unrestricted, savedProposalDoc.getElementSecurityType());
	}
	
}
