package com.ibm.rpm.client.junit.document.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.resource.fixtures.PoolFixture;
import com.ibm.rpm.client.junit.resource.fixtures.ResourceFixture;
import com.ibm.rpm.document.containers.DocumentElement;
import com.ibm.rpm.document.containers.DocumentFolder;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.scope.ResourceScope;

public class Test61792 extends ClientTestController {

	private Resource createSaveResource() throws Exception
	{
		Pool pool = PoolFixture.retrieveStaticFixture(this);
		Resource resource = ResourceFixture.createFixture(pool, null, this);
		resource = (Resource)save(resource, null).getRpmObject();
		assertNotNull(resource);
		return resource;
	}
	
	private DocumentFolder loadResourceDocFolder(Resource resource) throws Exception
	{
		ResourceScope resourceScope = new ResourceScope();
		resourceScope.setDocumentFolder(new DocumentScope());
		resource = (Resource)loadFromID(resource, resourceScope);
		assertNotNull(resource);
		assertNotNull(resource.getDocumentFolder());
		return resource.getDocumentFolder();
	}
	
	
	private DocumentFolder createSaveDocumentFolder(DocumentElement parent) throws Exception
	{
		DocumentFolder docFolder = new DocumentFolder();
		docFolder.setName(HelperTestUtilities.createName());
		docFolder.setParent(parent);
		docFolder = (DocumentFolder)save(docFolder,null).getRpmObject();
		assertNotNull(docFolder);
		return docFolder;
	}
	
	private void loadAndValidateDocuments(Resource resource) throws Exception
	{
		ResourceScope resourceScope = new ResourceScope();
		DocumentScope documentScope = new DocumentScope();
		documentScope.setChildren(documentScope);
		resourceScope.setDocumentFolder(documentScope);
		resource = (Resource)loadFromID(resource, resourceScope);
		assertNotNull(resource);
		assertNotNull(resource.getDocumentFolder());
		assertNotNull(resource.getDocumentFolder().getChildren());
		assertTrue(resource.getDocumentFolder().getChildren().length == 1);
		assertNotNull(resource.getDocumentFolder().getChildren()[0]);
	}
	
	private void loadAndValidateParents(DocumentElement documentElement) throws Exception
	{
		DocumentScope documentScope = new DocumentScope();
		documentScope.setParent(documentScope);
		documentElement = (DocumentElement)loadFromID(documentElement, documentScope);
		assertNotNull(documentElement);
		assertNotNull(documentElement.getParent());
	}
	
	public void testLoadResDocFolder() throws Exception
	{
		Resource resource = createSaveResource();
		DocumentFolder parent = loadResourceDocFolder(resource);
		DocumentFolder docFolder = createSaveDocumentFolder(parent);
		loadAndValidateParents(docFolder);
		loadAndValidateDocuments(resource);
	}
	
}
