package com.ibm.rpm.client.junit.document.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.resource.fixtures.PoolFixture;
import com.ibm.rpm.client.junit.resource.fixtures.ResourceFixture;
import com.ibm.rpm.document.containers.Document;
import com.ibm.rpm.document.containers.DocumentFolder;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.framework.LoadResult;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.scope.PoolScope;
import com.ibm.rpm.resource.scope.ResourceScope;

public class Test62641 extends ClientTestController {

	public void testLoadResourceDocumentChildren() throws Exception
	{
		Resource resource = createResource();

		createResourceDocument(resource.getDocumentFolder());

		loadAndValidateDocuments(resource);
	}

	private Resource createResource() throws Exception
	{
		 Pool parentPool = PoolFixture.createSaveFixture(this);
		 Resource resource = ResourceFixture.createFixture(parentPool,null, this);

		 ResourceScope resScope = new ResourceScope();
		 resScope.setParent(new PoolScope());
		 resScope.setDocumentFolder(new DocumentScope());

		 resource = (Resource)save(resource, resScope).getRpmObject();

		 assertNotNull(resource);
		 assertNotNull(resource.getDocumentFolder());

		 return resource;
	}

	private void createResourceDocument(DocumentFolder parent) throws Exception
	{
		Document document = new Document();
		document.setName("Document 1");
		document.setParent(parent);

		DocumentScope docScope = new DocumentScope();
		docScope.setParent(new DocumentScope());

		document = (Document)save(document, docScope).getRpmObject();

		assertNotNull(document);
	}

	private void loadAndValidateDocuments(Resource resource) throws Exception
	{
		ResourceScope resScope = createScope();
		resource = (Resource)loadFromID(resource, resScope);
		validate(resource);
	}

	private ResourceScope createScope()
	{
		ResourceScope resScope = new ResourceScope();
		DocumentScope docScope = new DocumentScope();
		docScope.setChildren(docScope);
		resScope.setDocumentFolder(docScope);
		return resScope;
	}

	private void validate(Resource resource)
	{
		assertNotNull(resource);
		assertNotNull(resource.getDocumentFolder());
		assertNotNull(resource.getDocumentFolder().getChildren());
		assertEquals(new Integer(1),new Integer(resource.getDocumentFolder().getChildren().length));
		assertNotNull(resource.getDocumentFolder().getChildren()[0]);
	}
}


