package com.ibm.rpm.client.junit.document.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.document.containers.Document;
import com.ibm.rpm.document.containers.DocumentElement;
import com.ibm.rpm.document.containers.GenericDocument;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * 
 * @author SandeepS
 *
 */

public class Test63299 extends ClientTestController {

	public void testLockDocument() throws Exception
	{
		WorkElementScope workElementScope = createScope();
		Proposal proposal = createProposal(workElementScope);
		lockDocument(proposal, workElementScope);
	}
	
	public void testUnlockDocument() throws Exception
	{
		WorkElementScope workElementScope = createScope();
		Proposal proposal = createProposal(workElementScope);
		GenericDocument proposalDoc = lockDocument(proposal, workElementScope);
		proposalDoc = unLockdocument(proposalDoc);
	}
	
	private WorkElementScope createScope()
	{
		WorkElementScope workElementScope = new WorkElementScope();
		DocumentScope documentScope = new DocumentScope();
		documentScope.setChildren(documentScope);
		workElementScope.setDocumentFolder(documentScope);
		return workElementScope;
	}
	
	private Proposal createProposal(WorkElementScope workElementScope)throws Exception
	{
		Proposal proposal = new Proposal();
		proposal.setName("WS_PROP_DEF_63299");
		
		SaveResult saveResult = save(proposal,workElementScope);
		proposal = (Proposal)saveResult.getRpmObject();
		
		assertNotNull(proposal);
		assertNotNull(proposal.getDocumentFolder());
		
		return proposal;
	}
	
	private GenericDocument lockDocument(Proposal proposal, WorkElementScope workElementScope)throws Exception
	{
		Document proposalDoc = new Document();
		proposalDoc.setName("Document-of-Proposal");
		proposal.getDocumentFolder().setChildren(new DocumentElement[] {proposalDoc});
		
		SaveResult saveResult = save(proposal,workElementScope);
		proposal = (Proposal)saveResult.getRpmObject();
		
		assertNotNull(proposal);
		assertNotNull(proposal.getDocumentFolder());
		assertNotNull(proposal.getDocumentFolder().getChildren());
		assertEquals(proposal.getDocumentFolder().getChildren().length,1);
		assertNotNull(proposal.getDocumentFolder().getChildren()[0]);
		
		proposalDoc = (Document)proposal.getDocumentFolder().getChildren()[0];
	
		proposalDoc = (Document)lockDocument(proposalDoc).getRpmObject();
		
		assertNotNull(proposalDoc);
		assertNotNull(proposalDoc.getLocked());
		assertEquals(true, proposalDoc.getLocked().booleanValue());
		return proposalDoc;
	}

	private GenericDocument unLockdocument(GenericDocument proposalDoc)throws Exception
	{
		proposalDoc = (Document)unLockDocument(proposalDoc).getRpmObject();

		assertNotNull(proposalDoc);
		assertNotNull(proposalDoc.getLocked());
		assertEquals(false, proposalDoc.getLocked().booleanValue());
		
		return proposalDoc;
	}
	

	
}
