/*
 * Created on 25-Apr-2007
 *
 */
package com.ibm.rpm.client.junit.document.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.document.containers.DocumentElement;
import com.ibm.rpm.document.containers.UrlDocument;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author karim
 *
 */
public class Test64468 extends ClientTestController 
{
	public void testURL() throws Exception
	{
		WorkElementScope workElementScope = createScope();
		Proposal proposal = createProposal(workElementScope);
		updateRUPandProcessLinks(proposal, workElementScope);
	}
	
	private WorkElementScope createScope()
	{
		WorkElementScope workElementScope = new WorkElementScope();
		DocumentScope documentScope = new DocumentScope();
		documentScope.setChildren(documentScope);
		workElementScope.setDocumentFolder(documentScope);
		return workElementScope;
	}
	
	private Proposal createProposal(WorkElementScope workElementScope)throws Exception
	{
		Proposal proposal = new Proposal();
		proposal.setName(HelperTestUtilities.createName());
		
		SaveResult saveResult = save(proposal,workElementScope);
		proposal = (Proposal)saveResult.getRpmObject();
		
		assertNotNull(proposal);
		assertNotNull(proposal.getDocumentFolder());
		
		return proposal;
	}
	
	private void updateRUPandProcessLinks(Proposal proposal, WorkElementScope workElementScope)throws Exception
	{
		UrlDocument urlDoc = new UrlDocument();
		urlDoc.setName(HelperTestUtilities.createName());
		proposal.getDocumentFolder().setChildren(new DocumentElement[] {urlDoc});
		
		SaveResult saveResult = save(proposal,workElementScope);
		proposal = (Proposal)saveResult.getRpmObject();
		
		assertNotNull(proposal);
		assertNotNull(proposal.getDocumentFolder());
		assertNotNull(proposal.getDocumentFolder().getChildren());
		assertEquals(proposal.getDocumentFolder().getChildren().length,1);
		assertNotNull(proposal.getDocumentFolder().getChildren()[0]);
		
		urlDoc = (UrlDocument)proposal.getDocumentFolder().getChildren()[0];

		updateAndValidateLinks(urlDoc, true, false);
		
		updateAndValidateLinks(urlDoc, false, true);
	}

	private void updateAndValidateLinks(UrlDocument urlDoc, boolean rupLink, boolean processLink)throws Exception
	{
		urlDoc.setRUPLink(new Boolean(rupLink));
		urlDoc.setProcessLink(new Boolean(processLink));

		SaveResult saveResult = save(urlDoc,null);
		urlDoc = (UrlDocument)saveResult.getRpmObject();
		
		assertNotNull(urlDoc);
		assertEquals(rupLink, urlDoc.getRUPLink().booleanValue());
		assertEquals(processLink, urlDoc.getProcessLink().booleanValue());
	}

}
