/*
 * Created on Aug 11, 2005
 *
 */
package com.ibm.rpm.client.junit.financial.fixtures;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.financial.containers.TimeCode;
import com.ibm.rpm.financial.containers.TimeCodeAssignment;
import com.ibm.rpm.wbs.containers.WorkElement;

/**
 * @author sailajap
 * @author shahla
 */

public class TimeCodeAssignmentFixture extends RPMObjectFixture
{
	public static TimeCodeAssignment createFixture(WorkElement parent,
            boolean isTimeCode1, ClientTestController ctc) throws Exception
    {
        TimeCodeAssignment assignment = new TimeCodeAssignment();
        assignment.setParent(parent);

        TimeCode timeCode = TimecodeFixture.retrieveStaticFixture(
            isTimeCode1, ctc);
        assignment.setTimeCode(timeCode);
       
        return assignment;
    }
    
    public static TimeCodeAssignment createSaveFixture(WorkElement parent,
            TimeCode timeCode, ClientTestController ctc) throws Exception
    {
        TimeCodeAssignment assignment = new TimeCodeAssignment();
        assignment.setParent(parent);
        assignment.setTimeCode(timeCode);        
        return (TimeCodeAssignment) save(ctc, assignment, null);
    }
	
	public static TimeCodeAssignment createSaveFixture(WorkElement parent,
            boolean isTimeCode1, ClientTestController ctc) throws Exception
    {
	    TimeCodeAssignment timeCodeAssignment = createFixture(parent,
            isTimeCode1, ctc);
        return (TimeCodeAssignment) save(ctc, timeCodeAssignment, null);
	}
	
	/*
	 * update the structure of TimeCodeAssignment
	 */
	public static TimeCodeAssignment[] updateFixture(
            TimeCodeAssignment[] timeCodeAssignments, ClientTestController ctc) 
		throws Exception
    {
	    ArrayList temp = new ArrayList();
        temp.add(createFixture(
            (WorkElement) timeCodeAssignments[0].getParent(), true, ctc));
        temp.add(createFixture(
            (WorkElement) timeCodeAssignments[0].getParent(), false, ctc));
	    
	    for (int i = 1; i < timeCodeAssignments.length; i++)
	    {
	        temp.add(timeCodeAssignments[i]);
	    }
	    
        return timeCodeAssignments;
    }
	
	public static void compare(TimeCodeAssignment[] array1, 
	        TimeCodeAssignment[] array2)
    	throws AssertionFailedError, Exception
	{
        RPMObjectFixture.compare(array1, array2);
        
        if (array1 == null) 
            return;
		
		for (int i = 0; i < array1.length; i++)
        {
            TimecodeFixture.compare(array1[i].getTimeCode(), array2[i]
                .getTimeCode());
        }
	}
    
    public static void compare(TimeCodeAssignment obj1, TimeCodeAssignment obj2) 
    	throws AssertionFailedError, Exception
	{
		TimecodeFixture.compare(obj1.getTimeCode(), obj2.getTimeCode(), null);
	}
}
