/*
 * Created on Feb 21, 2006
 *
 */
package com.ibm.rpm.client.junit.financial.testcases;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.applicationadministration.containers.ChargeCodeState;
import com.ibm.rpm.client.junit.financial.fixtures.FinancialModuleFixture;
import com.ibm.rpm.client.junit.framework.testcases.ModuleTestController;
import com.ibm.rpm.financial.containers.ChargeCodeCategory;
import com.ibm.rpm.financial.containers.FinancialModule;
import com.ibm.rpm.financial.containers.TimeCodeGroup;
import com.ibm.rpm.financial.scope.FinancialModuleScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.containers.AbstractModule;


/**
 * @author karim
 *
 */
public class TestFinancialModule extends ModuleTestController
{
    public TestFinancialModule(String testName)
    {
        setName(testName);
    }

    public void setUp() throws Exception
    {
        logger.info("setUp");
        super.setUp();

        mainScope = FinancialModuleFixture.createFullScope();        
        moduleContaineName = "FINANCIALMODULE";
    }

    
    
    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public RPMObject load(AbstractModule aModule, RPMObjectScope aScope)
            throws Exception
    {

        FinancialModule module = (FinancialModule) aModule;
        FinancialModuleScope scope = (FinancialModuleScope) aScope;

        FinancialModule loadedModule = new FinancialModule();
        
        if (scope != null)
        {
            if(scope.getChargeCodeCategories()!=null)
            {
            	ChargeCodeCategory[] chargeCodeCategories = (ChargeCodeCategory[]) loadElements(module.getChargeCodeCategories(),
            			scope.getChargeCodeCategories(),ChargeCodeCategory.class);        
            	loadedModule.setChargeCodeCategories(chargeCodeCategories);
            }
            if(scope.isChargeCodeStates())
            {
            	ChargeCodeState[] chargeCodeStages = (ChargeCodeState[]) loadDatafields(
                        module.getChargeCodeStates(), scope
                                .isChargeCodeStates(), ChargeCodeState.class);
                loadedModule.setChargeCodeStates(chargeCodeStages);
            }
            if(scope.getTimeCodeGroups()!=null)
            {
            	TimeCodeGroup[] timeCodeGroups = (TimeCodeGroup[]) loadElements(module.getTimeCodeGroups(),
            			scope.getTimeCodeGroups(),TimeCodeGroup.class);        
            	loadedModule.setTimeCodeGroups(timeCodeGroups);
            }
        }

        return loadedModule;
    }
    
    protected void deleteModule(AbstractModule aModule, RPMObjectScope aScope)
            throws AssertionError, Exception
    {

        FinancialModule module = (FinancialModule) aModule;
        FinancialModuleScope scope = (FinancialModuleScope) aScope;

        //delete the element
        if (module != null && scope != null)
        {
            if (module.getChargeCodeCategories() != null && scope.getChargeCodeCategories()!=null)
            {
                delete(module.getChargeCodeCategories());
            }
            
            //reload the deleted element
            FinancialModule deletedModule = (FinancialModule) loadDeletedModule(module, scope);

            //Validate the deleted element
            if (scope.getChargeCodeCategories() != null)
            {
                assertNull(deletedModule.getChargeCodeCategories());
            }
        }
    }

    protected AbstractModule createFixture(RPMObjectScope scope)
            throws Exception
    {
        return FinancialModuleFixture.createFixture((FinancialModuleScope) scope, this);
    }

    protected AbstractModule updateFixture(AbstractModule module,
            RPMObjectScope scope) throws Exception
    {
        return FinancialModuleFixture.updateFixture((FinancialModule) module, (FinancialModuleScope) scope, this);
    }

    protected void compare(AbstractModule module,
            AbstractModule returnedModule, RPMObjectScope scope)
            throws AssertionFailedError, Exception
    {
        FinancialModuleFixture.compare((FinancialModule) module,
            (FinancialModule) returnedModule, (FinancialModuleScope) scope);
    }
}
