package com.ibm.rpm.client.junit.framework.testcases;

import junit.framework.Assert;

import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

/**
 * @author mcduffs
 */
public class FrameworkUtility
{

    public static void compareObjects(RPMObject source, RPMObject destination,
            RPMObjectScope scope) throws Exception
    {
        if (source == null)
        {
            Assert.assertNull(destination);
            return;
        }

        RpmTestFramework.INSTANCE.findFixture(source.getClass()).assertCompare(
            source, destination, scope, false);
    }


    private static boolean attemptCompareObjects(RPMObject source, RPMObject destination,
            RPMObjectScope scope) throws Exception
    {
        if (source == null)
        {
            Assert.assertNull(destination);
            // @DUFF return;
        }

        // @DUFF RpmTestFramework.INSTANCE.findFixture(source.getClass()).compareObject(
        //     source, destination, scope);
        return false;
    }
    
    public void compareArrays( Object[] sourceArray,
            Object[] destinationArray,
            RPMObjectScope scope) throws Exception
    {
        if (RpmObjectAbstractTester.isArrayEmpty(sourceArray))
        {
            // @DUFF assertEmptyArray(null, destinationArray);
        }
        else
        {
            Object[] modifiedDestination = (Object[]) destinationArray.clone();
            for (int i = 0; i < sourceArray.length; i++)
            {
                Object object = sourceArray[i];
//              @DUFFfindInDestinationArray(currentCompare, object,
//              @DUFF    modifiedDestination, scope);
            }

//          @DUFFassertEmptyArray(currentCompare
//          @DUFF        + " remaining destination array should be empty",
//          @DUFF    modifiedDestination);
        }
    }

    public void findInDestinationArray(
            String currentCompare, Object sourceObject,
            Object modifiedDestination[], RPMObjectScope scope)
            throws Exception
    {
        if (sourceObject == null)
        {
            return;
        }

        boolean found = false;

        if (sourceObject instanceof RPMObject)
        {
            RPMObject sourceRPMObject = (RPMObject) sourceObject;

            for (int i = 0; i < modifiedDestination.length; i++)
            {
                RPMObject destinationObject = (RPMObject) modifiedDestination[i];
                if (destinationObject != null)
                {
                    boolean isEqual = attemptCompareObjects( 
                        sourceRPMObject, destinationObject,
                        scope);

                    if (isEqual)
                    {
                        modifiedDestination[i] = null;
                        found = true;
                        break;
                    }
                }
            }
        }
        else
        {
            for (int i = 0; i < modifiedDestination.length; i++)
            {
                Object destinationObject = modifiedDestination[i];
                if (destinationObject != null)
                {
                    boolean isEqual = sourceObject.equals(destinationObject);

                    if (isEqual)
                    {
                        modifiedDestination[i] = null;
                        found = true;
                        break;
                    }
                }
            }
        }

        if (!found)
        {
            Assert.fail(currentCompare + " failed to find " + sourceObject);
        }

    }
    
    public static void compareObjectArray(Object[] source, Object[] destination)
    {
//      @DUFFsafasdfsda;
    }

    public static Object getStaticFixture(Class objectClass)
    {
//      @DUFF
        return null;
    }

}
