package com.ibm.rpm.client.junit.framework.testcases;

import java.util.Calendar;

import com.ibm.rpm.applicationadministration.scope.CalendarScope;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.RPMCalendarFixture;
import com.ibm.rpm.client.junit.resource.fixtures.ResourceFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.ResourceTaskAssignmentFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.framework.util.DateUtil;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.scope.ResourceScope;
import com.ibm.rpm.timesheet.containers.SummaryTimesheet;
import com.ibm.rpm.wbs.containers.ResourceTaskAssignment;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.containers.TaskAssignment;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.TaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * cannot set Task Assignment Forecast Start Date
 */
public class Test49818 extends ClientTestController
{
    /**
     * - date issue - create task in the structure - get xpath to work - observe
     * that the date is not set.
     */
    public void testQueryTimesheetFirstWeek() throws Exception
    {
        /**
         * Create a task assignment.
         */
        WorkElementScope aTaskScope = new WorkElementScope();
        ResourceTaskAssignmentScope rtaScope = new ResourceTaskAssignmentScope();
        rtaScope.setParent(aTaskScope);
        rtaScope.setTaskAssignment(new TaskAssignmentScope());
        aTaskScope.setResourceTaskAssignments(rtaScope);
        aTaskScope.setContainingProject(new WorkElementScope());

        Task aTask = (Task) WorkElementFixture.createFixture(new Task(),
            aTaskScope, this);

        aTask = (Task) save(aTask, aTaskScope).getRpmObject();
        ResourceTaskAssignment resourceTA = ResourceTaskAssignmentFixture
            .createFixture(rtaScope, false, this);
        Resource resourceToAssign = ResourceFixture.createSaveFixture(this);
        resourceToAssign.setCalendar(RPMCalendarFixture.createSaveFixture(new CalendarScope(), this));
        ResourceScope resourceScope = new ResourceScope();
        resourceScope.setCalendar(new CalendarScope());
        resourceToAssign = (Resource) save(resourceToAssign, resourceScope).getRpmObject();
        
        resourceTA.setResource(resourceToAssign);
        aTask.setResourceTaskAssignments(new ResourceTaskAssignment[]
        {
            resourceTA
        });

        aTask = (Task) save(aTask, aTaskScope).getRpmObject();
        aTask = (Task) copyProposedToPlan(aTask, aTaskScope).getRpmObject();


        Calendar expectStartDate = Calendar.getInstance();

        // load from XPath
        TaskAssignment taskAssignment = aTask.getResourceTaskAssignments()[0].getTaskAssignment();
        assertNotNull(taskAssignment);
        SummaryTimesheet summaryTimesheet = new SummaryTimesheet();
       
        summaryTimesheet.setForecastStartDate(expectStartDate);
        summaryTimesheet.setTaskAssignment(taskAssignment);
        summaryTimesheet.setWeekOf(expectStartDate);
        SaveResult result = save(summaryTimesheet, null);
        assertNotNull(result);
        summaryTimesheet = (SummaryTimesheet) result.getRpmObject();

        String xpath = "/SummaryTimesheet[weekOf='"
                + DateUtil.convertToString(summaryTimesheet.getWeekOf())
                + "' and taskassignment[id = '"
                + summaryTimesheet.getTaskAssignment().getID() + "']]";

        RPMObject results[] = loadFromXpath(xpath, null);
        assertNotNull(results);
        assertTrue(results[0] instanceof SummaryTimesheet);
        SummaryTimesheet timesheet = (SummaryTimesheet) results[0];
        TaskAssignment summaryTimesheetTaskAssignment = (TaskAssignment) timesheet.getTaskAssignment();

        assertNotNull(summaryTimesheetTaskAssignment.getForecastStartDate());
        
        assertTrue((summaryTimesheetTaskAssignment.getForecastStartDate().getTime())
            .equals(summaryTimesheet.getForecastStartDate().getTime()));
        DateUtil.convertToString(expectStartDate);
        assertTrue( DateUtil.convertToStringNoTime((summaryTimesheetTaskAssignment.getForecastStartDate().getTime()))
            .equals(DateUtil.convertToStringNoTime(expectStartDate.getTime())));
    }
}
