/*
 * Created on 2-Aug-2006
 * @author mmatwiy
 * Test validation of extended characters.
 */
package com.ibm.rpm.client.junit.framework.testcases.validation;

import com.ibm.rpm.asset.constants.ValidationConstants;
import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.client.junit.asset.fixtures.AssetFolderFixture;
import com.ibm.rpm.client.junit.framework.testcases.GenericValidation;
import com.ibm.rpm.client.junit.framework.testcases.RPMExceptionMock;
import com.ibm.rpm.framework.constants.ErrorCodes;


public class TestExtendedCharacterValidation extends GenericValidation
{
    Asset asset;

    public void setUp() throws Exception
    {
        super.setUp();
        
        asset = new Asset();
        asset.setParent(AssetFolderFixture.createSaveFixture(this, null));
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testFailureValidationMax() throws AssertionError, Exception
    {
        // get a non-alpha test string that's the legal maximum length
        // it should fail once it's converted to UTF-8
        asset.setName(getTestStringNonAlpha(ValidationConstants.ABSTRACTASSET_NAME_MAX));

        RPMExceptionMock[] expectedExceptions =
        {
            createRPMException(ErrorCodes.MAX_LENGTH, asset.getClass()
                .getName(), ValidationConstants.NAME_FIELD, asset.getID())
        };

        verifySaveMustFail(asset, null, expectedExceptions);
    }
}
