/*
 * Created on 22-Dec-06
 * @author mmatwiy
 * Defect 59520
 * 
 * DocumentElement has a field externalparent of type RPMObject. 
 * This parent may be a WorkElement, Resource, ClientCostCenter, etc... but not a Pool. 
 * When you try with a Pool, the error message is the following:
 * /Document[Pool[@id='AC3D075DA8FC4FC2A26A6748BD402854']]    
 * 
 * PoolManager.getSubTableJoinCondition is not implemented for the manager DocumentManager.
 * This message needs to be expanded.
 * 
 * Resolution - new error message is:
 * Invalid join condition.
 * 
 * If the join condition seems to be valid, the user should log a defect.
 */
package com.ibm.rpm.client.junit.framework.testcases.validation;

import junit.framework.Assert;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.constants.ErrorCodes;

public class TestInvalidJoinCondition extends ClientTestController
{
    public void test() throws Exception
    {
        boolean error = false;
        
        try
        {
            loadFromXpathMustFail("/Document[Pool[@name='abc']]", null);
        }
        catch (RPMException e)
        {
            assertEquals(e.getErrorID(), ErrorCodes.NOT_IMPLEMENTED_JOIN);
            error = true;
        }
        
        if (!error)
        {
            Assert.fail("Xpath should have failed with a non-implemented join error.");
        }
    }
}
