/*
 * Created on Jul 19, 2005
 */
package com.ibm.rpm.client.junit.resource.fixtures;

import java.util.ArrayList;
import java.util.Comparator;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.applicationadministration.containers.ContactGroup;
import com.ibm.rpm.applicationadministration.containers.ContactGroupAssignment;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.ContactGroupFixture;
import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.resource.containers.Resource;

/**
 * @author gosselin
 */
public class ResourceContactGroupAssignmentFixture extends RPMObjectFixture
{
	protected static ArrayList localSkipGetters = new ArrayList();
    static
    {
    	//set skipGetters
    	localSkipGetters.addAll(skipGetters);
    	localSkipGetters.add("getName");
    }

    public static ContactGroupAssignment createAssignmentFixture(Resource resource, ClientTestController ctc) throws Exception
    {
        return createAssignment(resource, ctc);
    }

    public static ContactGroupAssignment createAssignment(Resource resource, ClientTestController ctc) throws Exception
    {
    	ContactGroupAssignment assignment = new ContactGroupAssignment();
    	
   		assignment.setParent(resource);
   		
   		ContactGroup contactGroup = ContactGroupFixture.createSaveFixture(1, ctc);
   		
   		assignment.setGroups(contactGroup);

    	return assignment;
    	
    }
	
	
    public static void compare(ContactGroupAssignment obj1,
            ContactGroupAssignment obj2) throws AssertionFailedError,
            Exception
    {
    	RPMObjectFixture.compareWithSkip(obj1, obj2, localSkipGetters);

    	ResourceFixture.compareWithoutCanProperties((Resource)obj1.getParent(), (Resource)obj2.getParent(), null);
    	
    	ContactGroupFixture.compare(obj1.getGroups(), obj2.getGroups(), null);    	

    }

    public static void compare(ContactGroupAssignment[] pArray1,
            ContactGroupAssignment[] pArray2)
            throws AssertionFailedError, Exception
    {
    	sortWithComparator(pArray1, new RPMObjectComparator());
    	sortWithComparator(pArray2, new RPMObjectComparator()); 
        
        RPMObjectFixture.compare(pArray1, pArray2);

        if (pArray1 == null)
            return;

        for (int i = 0; i < pArray1.length; i++)
        {
            ResourceContactGroupAssignmentFixture.compare(pArray1[i],
                    pArray2[i]);
        }
    }
    
    protected static class RPMObjectComparator implements Comparator {

        private RPMObjectNameAndIDComparator contactGroupComparator = RPMObjectNameAndIDComparator.INSTANCE;
        
        public RPMObjectComparator() {
            super();
        }
        
        public int compare(Object o1, Object o2){ 
            
            ContactGroupAssignment obj1 = (ContactGroupAssignment)o1;
            ContactGroupAssignment obj2 = (ContactGroupAssignment)o2;
            
            ContactGroup key1 = null;
            ContactGroup key2 = null;
            
            if(obj1 != null){
                if(obj1.getGroups()!=null){
                    key1 = obj1.getGroups();                
                }
            }
            if(obj2 != null){
                if(obj2.getGroups()!=null){
                    key2 = obj2.getGroups();                
                }
            }
            
            return contactGroupComparator.compare(key1, key2);

        }
    }
}
