package com.ibm.rpm.client.junit.resource.testcases.fixes;

import com.ibm.rpm.applicationadministration.containers.RPMCalendar;
import com.ibm.rpm.applicationadministration.scope.CalendarScope;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.RPMCalendarFixture;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.scope.PoolScope;
import com.ibm.rpm.resource.scope.ResourceScope;
import com.ibm.rpm.wbs.containers.Proposal;

/**
 * @author gmeloche
 *  
 */
public class Test48765 extends ClientTestController
{

    public void testAssignProposalCalendarToResource() throws Exception
    {

        RPMCalendar calendar = RPMCalendarFixture
            .retrieveStaticFixtureForInserts(this);

        Proposal proposal = new Proposal();
        proposal.setCalendar(calendar);
        proposal.setName(HelperTestUtilities.createName());
        SingleResult result1 = save(proposal, null);
        proposal = (Proposal) result1.getRpmObject();

        Pool pool = new Pool();
        pool.setName(HelperTestUtilities.createName());
        SingleResult result = save(pool, null);
        pool = (Pool) result.getRpmObject();

        Resource resource = new Resource();
        resource.setFullName(HelperTestUtilities.createName());
        resource.setCalendar(proposal.getCalendar());

        pool.setResources(new Resource[]
        {
            resource
        });

        PoolScope poolScope = new PoolScope();
        poolScope.setResources(new ResourceScope());
        poolScope.getResources().setCalendar(new CalendarScope());

        SingleResult result2 = save(pool, poolScope);
        pool = (Pool) result2.getRpmObject();

        assertNotNull(pool.getResources());
        assertEquals(1, pool.getResources().length);
        assertNotNull(pool.getResources()[0].getCalendar());

    }
}
