/*
 * Created on 8-Sep-2005
 */
package com.ibm.rpm.client.junit.resource.testcases.xpath;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.applicationadministration.containers.AttributeAssignment;
import com.ibm.rpm.applicationadministration.scope.PoolDomainScope;
import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.framework.testcases.xpath.XpathTesterUtils;
import com.ibm.rpm.client.junit.resource.fixtures.PoolFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.scope.*;

/**
 * @author njarazi
 */
public class TestPoolDataXPath extends ObjectXPathTester
{
    protected RPMObject createObject() throws Exception
    {
        return PoolFixture
                .createFixture(true, 1, ((PoolScope) mainScope), this);
    }

    protected RPMObjectScope createScope() throws Exception
    {
        PoolScope parentScope = new PoolScope();
        PoolScope s = new PoolScope();
        
        s.setAttributeAssignments(true);
        s.setDomain(new PoolDomainScope());
        s.setParent(parentScope);
        s.setPools(new PoolScope());
        s.setPoolReferences(new PoolReferenceScope());
        s.setResources(new ResourceScope());

        return s;
    }
    
    public void testAttributeAssignments()
    {
        StringBuffer xpath = new StringBuffer();

        Pool p = (Pool) myObject;

        AttributeAssignment[] aa = p.getAttributeAssignments();

        String query;

        if (aa.length > 0)
        {
            //The query generated here is of this type :
            //  "/Object1[Object2[Object3[Field='field value']]]"
            //  ex: "/Pool[AttributeAssignment[Attribute[Name = 'Name njarazi66']]]"
            xpath.append(XpathTesterUtils.FORWARD_SLASH).append("Pool").append(XpathTesterUtils.OPEN_BRACKET)
                    .append("AttributeAssignment").append(XpathTesterUtils.OPEN_BRACKET).append(
                            "Attribute").append(XpathTesterUtils.OPEN_BRACKET)
                    .append("Name = '").append(aa[0].getAttribute().getName())
                    .append("'").append(XpathTesterUtils.CLOSE_BRACKET).append(XpathTesterUtils.CLOSE_BRACKET)
                    .append(XpathTesterUtils.CLOSE_BRACKET);

            query = xpath.toString();

            internalLoadRPMObjectFromXPathAndCompare(p, query,
                mainScope, aa[0].getID(), 1);
            
            if (aa[0].getValue() != null)
            {
	            xpath.setLength(0);
	            
	            //The query generated here is of this type :
	            //  "/Object1[Object2[Field='field value'][Object3[Field='field value']"
	            //  ex: "/Pool[AttributeAssignment[Value='Value 96'][Attribute[Name = 'Name njarazi66']]]"
	            xpath.append(XpathTesterUtils.FORWARD_SLASH).append("Pool").append(XpathTesterUtils.OPEN_BRACKET)
	                    .append("AttributeAssignment").append(XpathTesterUtils.OPEN_BRACKET).append(
	                            "Value").append(XpathTesterUtils.EQUALS).append(XpathTesterUtils.SINGLE_QUOTE).append(
	                            aa[0].getValue()).append(XpathTesterUtils.SINGLE_QUOTE).append(
	                            XpathTesterUtils.CLOSE_BRACKET).append(XpathTesterUtils.OPEN_BRACKET).append(
	                            "Attribute").append(XpathTesterUtils.OPEN_BRACKET)
	                    .append("Name = '").append(aa[0].getAttribute().getName())
	                    .append("'").append(XpathTesterUtils.CLOSE_BRACKET).append(XpathTesterUtils.CLOSE_BRACKET)
	                    .append(XpathTesterUtils.CLOSE_BRACKET);
	
	            query = xpath.toString();
	
	            internalLoadRPMObjectFromXPathAndCompare(p, query,
	                    mainScope, aa[0].getID(), 2);
            }
        }

        errorHandler.handleError();
    }

    /**
     * @param dbObject
     * @throws AssertionFailedError
     * @throws Exception
     */
    protected void objectCompare(RPMObject myObject, RPMObject dbObject,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        PoolFixture
                .compare((Pool) myObject, (Pool) dbObject, (PoolScope) scope);
    }
        
    protected void internalLoadRPMObjectFromXPathAndCompare(
            RPMObject localObject, String xPath, RPMObjectScope scope,
            String idOfObjectToFind, int queryNumber)
    {
        doObjectComparison(localObject, loadRPMObjectFromXPath(localObject.getClass(), xPath,
                scope, idOfObjectToFind, queryNumber));
    }
    
}
