package com.ibm.rpm.client.junit.scopemanagement.fixtures;
import java.util.ArrayList;

import junit.framework.Assert;
import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.scopemanagement.containers.MitigationFactor;
import com.ibm.rpm.scopemanagement.containers.MitigationTrigger;

public class MitigationFactorFixture extends RPMObjectFixture 
{
	protected static ArrayList localSkipGetters = new ArrayList();
	protected static ArrayList localSkipSetters = new ArrayList();
	public static int nbChildren = 1;
	static  {
    	//set skipGetters
    	localSkipGetters.addAll(skipGetters);
    	//set skipSetters
    	localSkipSetters.addAll(skipSetters);
    
    }
		public static MitigationFactor createFixture( RPMObject parent, ClientTestController ctc) throws Exception {
		return createMitigationFactor(parent, random(), ctc);
	}
	private static MitigationFactor createMitigationFactor( RPMObject parent, int index, ClientTestController ctc)throws Exception	{
		MitigationFactor mitigationFactor = new MitigationFactor();
		mitigationFactor.setParent(parent);
		MitigationTrigger[] mitigationTriggerArray = new MitigationTrigger[nbChildren];
		for (int i= 0; i<nbChildren ; i++ ){
			mitigationTriggerArray[i] = MitigationFactorFixture.createMitigationTrigger(mitigationFactor, index, ctc);
		}
		mitigationFactor.setMitigationTriggers(mitigationTriggerArray);
		//set the fields
		HelperTestUtilities.setByIntrospection(mitigationFactor, index, localSkipSetters);
		
		return mitigationFactor;
   }
	
	private static MitigationTrigger createMitigationTrigger( RPMObject parent,int index , ClientTestController ctc)throws Exception	{
		MitigationTrigger mitTrigger= new MitigationTrigger();
		mitTrigger.setParent(parent);
		//	set the fields
		HelperTestUtilities.setByIntrospection(mitTrigger, index, localSkipSetters);
		return mitTrigger;
	}

    public static void compare(MitigationFactor[] cArray1, MitigationFactor[] cArray2) throws AssertionFailedError, Exception
    {
    	sortWithComparator(cArray1, RPMObjectIDComparator.INSTANCE);
    	sortWithComparator(cArray2, RPMObjectIDComparator.INSTANCE); 
    	
        RPMObjectFixture.compare(cArray1, cArray2);
        if(cArray1 == null) return;

        for (int i = 0; i < cArray1.length; i++)
        {
            MitigationFactorFixture.compare(cArray1[i], cArray2[i]);
        }
    }
	
    public static void compare(MitigationFactor mit1, MitigationFactor mit2) throws AssertionFailedError, Exception
    {
        RPMObjectFixture.compareWithSkip(mit1, mit2, localSkipGetters);
        
        MitigationTrigger m1[] = mit1.getMitigationTriggers();
		MitigationTrigger m2[] = mit2.getMitigationTriggers();
		
		if(m1!=null&&m2==null)
		{
			Assert.fail("compare :: MitigationTrigger is null");
		}
		MitigationFactorFixture.compare(m1,m2);
        
    }
    
    
    public static void compare(MitigationTrigger[] cArray1, MitigationTrigger[] cArray2) throws AssertionFailedError, Exception
    {
    	sortWithComparator(cArray1, RPMObjectIDComparator.INSTANCE);
    	sortWithComparator(cArray2, RPMObjectIDComparator.INSTANCE); 
    	
        RPMObjectFixture.compare(cArray1, cArray2);
        if(cArray1 == null) return;

        for (int i = 0; i < cArray1.length; i++)
        {
            MitigationFactorFixture.compare(cArray1[i], cArray2[i]);
        }
    }

    
    public static void compare(MitigationTrigger mit1, MitigationTrigger mit2) throws AssertionFailedError, Exception
    {
        RPMObjectFixture.compareWithSkip(mit1, mit2, localSkipGetters);
    }
	

}





