/*
 * Created on Sep 28, 2006
 *
 */
package com.ibm.rpm.client.junit.scopemanagement.fixtures;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.scopemanagement.containers.ReqProConnection;
import com.ibm.rpm.scopemanagement.containers.ReqProIntegrationFolder;

/**
 * @author karim
 *
 */
public class ReqProConnectionFixture extends RPMObjectFixture {
	
    protected static ArrayList localSkipGetters = new ArrayList();
    protected static ArrayList localSkipSetters = new ArrayList();
    static
    {
        //set skipGetters
        localSkipGetters.addAll(skipGetters);
        localSkipGetters.add("getReqProID");
        localSkipGetters.add("getCreateNewWhenUpdated");
        localSkipGetters.add("getDeleteOnServerRemoval");
        localSkipSetters.add("setCreateNewWhenUpdated");
    }
	
	public static ReqProConnection createFixture(ReqProIntegrationFolder parent)
			throws Exception {
		return createReqProConnection(parent, random());
	}

	public static void updateFixture(ReqProConnection reqProConnection)
	throws Exception {
		updateReqProConnection(reqProConnection, random());
	}
	
	private static ReqProConnection createReqProConnection(
			ReqProIntegrationFolder parent, int index) throws Exception {
		ReqProConnection reqProConnection = new ReqProConnection();

		reqProConnection.setParent(parent);

		HelperTestUtilities.setByIntrospection(reqProConnection, index,
				skipSetters);

		return reqProConnection;
	}
	
	private static void updateReqProConnection(
			ReqProConnection reqProConnection, int index) throws Exception {

		HelperTestUtilities.setByIntrospection(reqProConnection, index,
				skipSetters);
	}
	
    public static void compare(ReqProConnection c1, ReqProConnection c2)
			throws AssertionFailedError, Exception {
		RPMObjectFixture.compareWithSkip(c1, c2, localSkipGetters);
	}
}
