/*
 * Created on Sep 28, 2006
 *
 */
package com.ibm.rpm.client.junit.scopemanagement.fixtures;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.scopemanagement.containers.ReqProImportStatus;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;

/**
 * @author karim
 *  
 */
public class ReqProImportStatusFixture extends RPMObjectFixture {

    protected static ArrayList localSkipGetters = new ArrayList();
    protected static ArrayList localSkipSetters = new ArrayList();
    static
    {
        //set skipGetters
        localSkipGetters.addAll(skipGetters);
        localSkipGetters.add("getReqProID");
        localSkipGetters.add("getReqProParentID");
    }
	
	public static ReqProImportStatus createFixture(
			ScopeElement parent) throws Exception {
		return createReqProImportStatus(parent, random());
	}

	public static void updateFixture(
			ReqProImportStatus reqProImportStatus) throws Exception {
		createReqProImportStatus(reqProImportStatus, random());
	}
	
	private static ReqProImportStatus createReqProImportStatus(
			ScopeElement parent, int index) throws Exception {
		ReqProImportStatus reqProImportStatus = new ReqProImportStatus();

		reqProImportStatus.setParent(parent);

		HelperTestUtilities.setByIntrospection(reqProImportStatus, index,
				skipSetters);

		return reqProImportStatus;
	}
	
	private static void createReqProImportStatus(
			ReqProImportStatus reqProImportStatus, int index) throws Exception {
		HelperTestUtilities.setByIntrospection(reqProImportStatus, index,
				skipSetters);
	}
	
    public static void compare(ReqProImportStatus i1, ReqProImportStatus i2)
			throws AssertionFailedError, Exception {
		RPMObjectFixture.compareWithSkip(i1, i2, localSkipGetters);
	}

}
