/*
 * Created on Sep 28, 2006
 *
 */
package com.ibm.rpm.client.junit.scopemanagement.testcases;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ReqProIntegrationFolderFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.scopemanagement.containers.ReqProIntegrationFolder;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author karim
 *
 */
public class TestReqProIntegrationFolder extends ClientTestController
{
    protected ScopeElementScope mainScope;

    protected ScopeFolder parentScopeFolder = null;

    protected WorkElementScope proposalScope;

    protected Proposal proposal = null;
    
    protected int nbChildren = 1;
    
    public void setUp() throws Exception
    {
        logger.info("setUp");
        super.setUp(); 

        mainScope = ReqProIntegrationFolderFixture.getFullScope();

        proposalScope = new WorkElementScope();

        proposal = (Proposal) WorkElementFixture.retrieveStaticFixture(new Proposal(), this);

        RPMObject[] rpmObjects = loadFromXpath("/ScopeFolder[name='"
                + proposal.getName() + "']", new ScopeElementScope());
        parentScopeFolder = (ScopeFolder) rpmObjects[0];
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

	public void testInsertWithNoScopeLoadFromID() throws AssertionError,
	    Exception
	{
		//not applicable
	}

    public void testInsertWithScopeLoadFromXPath() throws AssertionError,
    Exception
	{
    	insertReqProIntegrationFolder(mainScope, false);
	}
	
	public void testInsertWithScopeLoadFromID() throws AssertionError,
	    Exception
	{
		insertReqProIntegrationFolder(mainScope, true);
	}
	
	public void testUpdateWithNoScopeLoadFromID() throws AssertionError,
	    Exception
	{
		//not applicable
	}
	
	public void testUpdateWithScopeLoadFromID() throws AssertionError,
	    Exception
	{
		update(mainScope, true);
	}
    
    
    private ReqProIntegrationFolder insertReqProIntegrationFolder(ScopeElementScope scope, boolean loadFromId)
    throws Exception
	{
		//create and save a workelement
		ReqProIntegrationFolder reqProIntegrationFolder = ReqProIntegrationFolderFixture.createFixture(parentScopeFolder, scope);
		
		SingleResult result = save(reqProIntegrationFolder, scope);
		
		//compare the returned ReqProIntegrationFolder
		ReqProIntegrationFolder returnedReqProIntegrationFolder = (ReqProIntegrationFolder) result.getRpmObject();
		ReqProIntegrationFolderFixture.compare(reqProIntegrationFolder, returnedReqProIntegrationFolder, scope);
		
		//reload the ReqProIntegrationFolder and compare it
		returnedReqProIntegrationFolder = load(returnedReqProIntegrationFolder, scope, loadFromId);
		ReqProIntegrationFolderFixture.compare(reqProIntegrationFolder, returnedReqProIntegrationFolder, scope);
		
		return returnedReqProIntegrationFolder;
	}


	private void update(ScopeElementScope scope, boolean loadFromId)
	    throws AssertionError, Exception
	{
		//insert
		ReqProIntegrationFolder reqProIntegrationFolder = insertReqProIntegrationFolder(scope, loadFromId);
		//update
		reqProIntegrationFolder = updateReqProIntegrationFolder(reqProIntegrationFolder, scope, loadFromId);		
	}
		
    private ReqProIntegrationFolder updateReqProIntegrationFolder(ReqProIntegrationFolder reqProIntegrationFolder,
            ScopeElementScope scope, boolean loadFromId)
            throws Exception
    {
       	ReqProIntegrationFolderFixture.updateFixture(reqProIntegrationFolder, scope);

        //Insert the updated reqProIntegrationFolder into the DB
        SingleResult result = save(reqProIntegrationFolder, scope);

        //compare the returned ReqProIntegrationFolder
        ReqProIntegrationFolder returnedReqProIntegrationFolder = (ReqProIntegrationFolder) result.getRpmObject();
        ReqProIntegrationFolderFixture.compare(reqProIntegrationFolder, returnedReqProIntegrationFolder, scope);

        //reload the ReqProIntegrationFolder and compare it
        returnedReqProIntegrationFolder = load(returnedReqProIntegrationFolder, scope, loadFromId);
        ReqProIntegrationFolderFixture.compare(reqProIntegrationFolder, returnedReqProIntegrationFolder, scope);

        //return the returnedReqProIntegrationFolder
        return returnedReqProIntegrationFolder;
    }
    
    protected ReqProIntegrationFolder load(ReqProIntegrationFolder reqProIntegrationFolder,
            ScopeElementScope scope, boolean loadFromId) throws Exception
    {
        RPMObject obj = null;

        if (loadFromId)
        {
            //load from an id
        	obj = new ReqProIntegrationFolder();
            obj.setID(reqProIntegrationFolder.getID());
            return (ReqProIntegrationFolder)loadFromID(obj, scope);
        }
        //load from an xpath
        RPMObject[] objs = loadFromXpath("/ReqProIntegrationFolder[id='"
                + reqProIntegrationFolder.getID() + "']", scope);
        if (objs == null || objs.length == 0)
        {
            return null;
        }
        return (ReqProIntegrationFolder)objs[0];
    }
	
}
