package com.ibm.rpm.client.junit.scopemanagement.testcases;

import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.financial.scope.FinancialScope;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;

/**
 * @author gosselin
 */
public class TestScopeElement2 extends TestScopeElement
{
    public void testUpdateWithApprovedCostBenefits() throws AssertionError,
            Exception
    {
        mainScope.setApprovedCostBenefits(true);
        mainFolder = ScopeElementFixture.createFolderFixture(mainScope,
            nbChildren, mainFolder, this);
        save(mainFolder, mainScope);

        mainFolder = (ScopeFolder) ScopeElementFixture.updateFixture(
            mainFolder, mainScope, nbChildren + 2, this);
        insertAndCompare(mainFolder, mainScope, true);
    }

    public void testUpdateWithAttributeAssignment() throws AssertionError,
            Exception
    {
        mainScope.setAttributeAssignments(true);
        mainFolder = ScopeElementFixture.createFolderFixture(mainScope,
            nbChildren, mainFolder, this);
        save(mainFolder, mainScope);

        mainFolder = (ScopeFolder) ScopeElementFixture.updateFixture(
            mainFolder, mainScope, nbChildren + 2, this);
        insertAndCompare(mainFolder, mainScope, true);
    }

    public void testUpdateWithAssetAndAssetCode() throws AssertionError,
            Exception
    {
        mainScope.setAsset(true);
        mainScope.setAssetCode(true);
        mainFolder = ScopeElementFixture.createFolderFixture(mainScope,
            nbChildren, mainFolder, this);
        save(mainFolder, mainScope);

        mainFolder = (ScopeFolder) ScopeElementFixture.updateFixture(
            mainFolder, mainScope, nbChildren + 2, this);
        insertAndCompare(mainFolder, mainScope, true);
    }

    public void testUpdateWithWorksheetFinancial() throws AssertionError,
            Exception
    {
        FinancialScope finScope = new FinancialScope();
        finScope.setChargeCode(true);
        mainScope.setWorksheetFinancials(finScope);
        mainFolder = ScopeElementFixture.createFolderFixture(mainScope,
            nbChildren, mainFolder, this);
        save(mainFolder, mainScope);

        mainFolder = (ScopeFolder) ScopeElementFixture.updateFixture(
            mainFolder, mainScope, nbChildren + 2, this);
        insertAndCompare(mainFolder, mainScope, true);
    }

    public void testUpdateWithWbsFinancial() throws AssertionError, Exception
    {
        FinancialScope finScope = new FinancialScope();
        finScope.setChargeCode(true);
        mainScope.setWbsFinancials(finScope);
        mainFolder = ScopeElementFixture.createFolderFixture(mainScope,
            nbChildren, mainFolder, this);
        save(mainFolder, mainScope);

        mainFolder = (ScopeFolder) ScopeElementFixture.updateFixture(
            mainFolder, mainScope, nbChildren + 2, this);
        insertAndCompare(mainFolder, mainScope, true);
    }

}
