package com.ibm.rpm.client.junit.scopemanagement.testcases.fixes;

import com.ibm.rpm.applicationadministration.scope.CalendarScope;
import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.LoadResult;
import com.ibm.rpm.framework.Result;
import com.ibm.rpm.resource.scope.ResourceScope;
import com.ibm.rpm.scopemanagement.containers.AbstractScope;
import com.ibm.rpm.scopemanagement.containers.Issue;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.security.containers.AbstractScopeSecurityRole;
import com.ibm.rpm.security.containers.AbstractWbsSecurityRole;
import com.ibm.rpm.security.containers.IssueSecurityRole;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.containers.WorkElement;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.TaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class Test49117 extends ClientTestController {
	
	public void testSecurityRoleAfterLoadTransferredElementAsScopeElement() throws Exception {
		
		AbstractScope abstractScope = createScopeElementWithRTA();
    	
		Result result = transferUnderWBS(new Task(), abstractScope);
		assertNull(result.getErrors());
		
		ScopeElementScope newScope = new ScopeElementScope();
		newScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
		LoadResult lr = getApplicationInterface().loadFromXpath(sessionid, "/Issue[name='"+abstractScope.getName()+"']", newScope);
		assertNull(lr.getErrors());
		assertNotNull(lr.getRpmObjectList());
		Issue reloadedIssue = (Issue)lr.getRpmObjectList()[0];
		assertNotNull(reloadedIssue);
		assertNotNull(reloadedIssue.getResourceTaskAssignments());
		assertTrue(reloadedIssue.getResourceTaskAssignments().length > 0);
		assertNotNull(reloadedIssue.getResourceTaskAssignments()[0]);
		assertNotNull(reloadedIssue.getResourceTaskAssignments()[0].getSecurityRole());
		assertTrue(reloadedIssue.getResourceTaskAssignments()[0].getSecurityRole() instanceof AbstractScopeSecurityRole);
	}
	public void testSecurityRoleAfterLoadTransferredElementAsWorkElement() throws Exception {
		
		AbstractScope abstractScope = createScopeElementWithRTA();
    	
		Result result = getApplicationInterface().transferUnderWBS(sessionid, new Task(), abstractScope);
		assertNull(result.getErrors());
		
		WorkElementScope newScope = new WorkElementScope();
		newScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
		LoadResult lr = getApplicationInterface().loadFromXpath(sessionid, "/WorkElement[name='"+abstractScope.getName()+"']", newScope);
		assertNull(lr.getErrors());
		assertNotNull(lr.getRpmObjectList());
		WorkElement reloadedWE = (WorkElement)lr.getRpmObjectList()[0];
		assertNotNull(reloadedWE);
		assertNotNull(reloadedWE.getResourceTaskAssignments());
		assertTrue(reloadedWE.getResourceTaskAssignments().length > 0);
		assertNotNull(reloadedWE.getResourceTaskAssignments()[0]);
		assertNotNull(reloadedWE.getResourceTaskAssignments()[0].getSecurityRole());
		assertTrue(reloadedWE.getResourceTaskAssignments()[0].getSecurityRole() instanceof AbstractWbsSecurityRole);
	}
	private AbstractScope createScopeElementWithRTA() throws Exception
	{
		WorkElementScope workElementScope = new WorkElementScope();
		workElementScope.setScopeElement(new ScopeElementScope());
		Proposal proposal = (Proposal)WorkElementFixture.createSaveFixture(new Proposal(), workElementScope, this);
		assertNotNull(proposal);
		assertNotNull(proposal.getScopeElement());
		assertTrue(proposal.getScopeElement() instanceof ScopeFolder);
		
		Issue issue = new Issue();
		ScopeElementScope sScope = new ScopeElementScope();
		ResourceTaskAssignmentScope rtaScope = new ResourceTaskAssignmentScope();
		rtaScope.setTaskAssignment(new TaskAssignmentScope());
		ResourceScope resourceScope = new ResourceScope();
		resourceScope.setCalendar(new CalendarScope());
		rtaScope.setResource(resourceScope);
	
		sScope.setResourceTaskAssignments(rtaScope);
		issue = ScopeElementFixture.createIssueFixture(sScope, 0, proposal.getScopeElement(), this);
		issue = (Issue)save(issue, sScope).getRpmObject();
		assertNotNull(issue);
		return issue;
	}
}
