/*
 * Created on May 1, 2007
 */
package com.ibm.rpm.client.junit.scopemanagement.testcases.fixes;

import java.util.Calendar;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.framework.util.DateUtil;
import com.ibm.rpm.scopemanagement.containers.Defect;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;

/**
 * @author cobber
 */

public class Test63545 extends ClientTestController
{
    public void test() throws Exception
    {
        ScopeElementScope scopeScope = new ScopeElementScope();
        scopeScope.setChildren(scopeScope);
        ScopeFolder scopeFolder = (ScopeFolder) ScopeElementFixture
                .createFixture(scopeScope, this, 1);
        SingleResult result = this.save(scopeFolder, scopeScope);
        validateSave(result);
        assertTrue(result.getRpmObject() instanceof ScopeFolder);
        scopeFolder = (ScopeFolder)result.getRpmObject();
        
        Defect defect = ScopeElementFixture.createDefectFixture(null, 1, scopeFolder, this);
        defect.setEstimatedFinishDate(null);
        result = this.save(defect, null);
        validateSave(result);
        assertTrue(result.getRpmObject() instanceof Defect);
        defect = (Defect)result.getRpmObject();
        assertNotNull(defect.getEstimatedFinishDate());
        
        Calendar estimatedStartDate = DateUtil.convertToCalendarNoTime("2007-05-01");
        Calendar estimatedFinishDate = DateUtil.convertToCalendarNoTime("2007-05-20");
        defect.setEstimatedStartDate(estimatedStartDate);
        defect.setEstimatedFinishDate(estimatedFinishDate);
        result = this.save(defect, null);
        validateSave(result);
        assertTrue(result.getRpmObject() instanceof Defect);
        defect = (Defect)result.getRpmObject();
        assertNotNull(defect.getEstimatedFinishDate());
        assertEquals(DateUtil.convertToString(estimatedFinishDate), DateUtil.convertToString(defect.getEstimatedFinishDate()));
    }
    
    private void validateSave(SingleResult result)
    {
        assertTrue(result.isSuccessful());
        assertTrue(result.isWarningFree());
        assertNotNull(result.getRpmObject());
    }
}
