package com.ibm.rpm.client.junit.scopemanagement.testcases.xpath;

import java.util.ArrayList;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.framework.testcases.xpath.ObjectXPathTester;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ReqProIntegrationFolderFixture;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ReqProRequirementFixture;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ReqProScopeFolderFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.scopemanagement.containers.ReqProRequirement;
import com.ibm.rpm.scopemanagement.containers.ReqProScopeFolder;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Proposal;

public class TestReqProRequirementXpath extends ObjectXPathTester
{
    
    public void testContainerInstances()
    {
    }

    protected RPMObject createObject() throws Exception
    {
        Proposal proposal = (Proposal) WorkElementFixture
            .retrieveStaticFixture(new Proposal(), this);

        RPMObject[] rpmObjects = loadFromXpath("/ScopeFolder[name='"
                + proposal.getName() + "']", new ScopeElementScope());
        ScopeFolder parent = (ScopeFolder) rpmObjects[0];

        RPMObject myParent = ReqProIntegrationFolderFixture.createFixture(
            (ScopeFolder) parent, (ScopeElementScope) mainScope);
        myParent = save(myParent, createScope()).getRpmObject();

        myParent = ReqProScopeFolderFixture.createFixture(myParent,
            (ScopeElementScope) createScope());
        myParent = save(myParent, createScope()).getRpmObject();

        
        myObject = ReqProRequirementFixture.createFixture((ReqProScopeFolder)myParent, (ScopeElementScope)createScope());

        return myObject;
    }

    protected RPMObjectScope createScope() throws Exception
    {
        ScopeElementScope myScope = new ScopeElementScope();
        myScope.setReqProData(new RPMObjectScope());
        return myScope;
    }

    protected ArrayList generateLocalSkipList()
    {
        ArrayList skip = new ArrayList();
        skip.add("getApprovedByDate");
        skip.add("getDefaultScope");
        skip.add("getExternalReferenceNumber");
        skip.add("getTargetDate");
        skip.add("getTask");
        skip.add("getRank");
        skip.add("getReferenceNumber");
        skip.add("getEstimatedStartDate");
        skip.add("getClosedByDate");
        skip.add("getProposedByDate");
        skip.add("getTransferedUnderWbsRoot");
        skip.add("getPriority");
        skip.add("getPrivateFolder");
        skip.add("getApprovedByName");
        skip.add("getProposedByName");
        skip.add("getParentSortingRank");
        skip.add("getClosedByName");
        return skip;
    }

    protected void objectCompare(RPMObject myObject, RPMObject dbObject,
            RPMObjectScope scope) throws AssertionFailedError, Exception
    {
        if (myObject instanceof ReqProRequirement)
        {
            ReqProRequirementFixture.compare((ReqProRequirement) myObject,
                (ReqProRequirement) dbObject, (ScopeElementScope) scope);
        }
    }
}
