package com.ibm.rpm.client.junit.scorecard.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.scorecard.fixtures.ScorecardFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;
import com.ibm.rpm.scorecard.scope.ScorecardFolderScope;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.containers.WbsModule;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * Identify platform versions 7.1.1.1 on rpmdev07 DB2
 * 
 * Overview of problem Getting a null pointer exception as well as a
 * nondescriptive error message :
 * 
 * 
 * objectToAssign is of type Asset or AbstractScope or GenericProject but must
 * be of the type {2} - Severity: Error - Class: Task - Error ID: 400014 at
 * com.ibm.rpm.scorecard.checkpoints.ScorecardMethodCheckpoint.isValidObject(ScorecardMethodCheckpoint.java:144)
 * 
 * @author andreit
 * 
 */
public class Test68247 extends ClientTestController
{
    protected ScorecardFolderScope mainScope;
    
    public void setUp() throws Exception
    {
        super.setUp();
        
        mainScope = ScorecardFixture.createScope();
    }
    
    public void testAssignScorecard() throws Exception
    {
        ScorecardFolder folder = ScorecardFixture.createSaveFixture(
            new WbsModule(), mainScope, this);
        Task task = (Task) WorkElementFixture.createSaveFixture(new Task(),
            new WorkElementScope(), this);

        Task reloadedTask = (Task) this.getApplicationInterface()
            .assignScoreCard(getSessionID(), task, new WorkElementScope(),
                folder.getScorecards()[0], ReloadType.ReloadResult)
            .getRpmObject();
        assertNull(reloadedTask); // errors 400014, 400011 and 405003 are expected
    }
}
