/*
 * Created on Mar 27, 2006
 * @author mmatwiy
 * Test the assignment of two scorecards to the same container.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.asset.containers.AssetModule;
import com.ibm.rpm.asset.scope.AssetModuleScope;
import com.ibm.rpm.client.junit.asset.fixtures.AssetModuleFixture;
import com.ibm.rpm.client.junit.framework.testcases.GenericValidation;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.scorecard.containers.Scorecard;
import com.ibm.rpm.scorecard.containers.ScorecardCategory;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;
import com.ibm.rpm.scorecard.containers.ScorecardQuestion;
import com.ibm.rpm.scorecard.containers.ScorecardResponse;

public class TestAssetsAssignMultipleScorecardsValidation extends
        GenericValidation
{

    public void testFailureMultipleAssignments() throws Exception
    {

        ScorecardAssetsValidationUtility utility = new ScorecardAssetsValidationUtility();

        AssetModule module = utility.createAssetModule();

        Asset assignedAsset = utility.prepareScorecardAssignment(module);

        //attempt to assign a second scorecard to the assignedAsset container
        Scorecard scorecard2 = createModule().getScorecardFolders()[0]
            .getScorecards()[0];
        
        SingleResult result = getApplicationInterface().assignScoreCard(
            sessionid, assignedAsset, null, scorecard2, ReloadType.ReloadResult);
    
        assertFalse(result.isSuccessful());

    }

    private AssetModule createModule() throws Exception
    {
        AssetModule module = new AssetModule();

        ScorecardFolder folder = new ScorecardFolder();
        folder.setName(HelperTestUtilities.unitTestPrefix + "Test assets scorecards - folder2");

        Scorecard scorecard = new Scorecard();
        scorecard.setName(HelperTestUtilities.unitTestPrefix + "Test assets scorecards - scorecard2");
        scorecard.setActive(new Boolean(true));

        ScorecardCategory category = new ScorecardCategory();
        category.setName(HelperTestUtilities.unitTestPrefix + "Test assets scorecards - category2");

        ScorecardQuestion question = new ScorecardQuestion();
        question.setName(HelperTestUtilities.unitTestPrefix + "Test assets scorecards - question2");

        ScorecardResponse response1 = new ScorecardResponse();
        response1.setName(HelperTestUtilities.unitTestPrefix + "Test assets scorecards - response 2-1");
        response1.setDefaultResponse(new Boolean(true));

        ScorecardResponse response2 = new ScorecardResponse();
        response2.setName(HelperTestUtilities.unitTestPrefix + "Test assets scorecards - response 2-2");

        module.setScorecardFolders(new ScorecardFolder[]
        {
            folder
        });
        folder.setScorecards(new Scorecard[]
        {
            scorecard
        });
        scorecard.setScorecardCategories(new ScorecardCategory[]
        {
            category
        });
        category.setScorecardQuestions(new ScorecardQuestion[]
        {
            question
        });
        question.setScorecardResponses(new ScorecardResponse[]
        {
                response1, response2
        });

        AssetModuleScope moduleScope = AssetModuleFixture.createFullScope();

        module = (AssetModule) save(module, moduleScope).getRpmObject();

        return module;
    }
}
