/*
 * Created on January 25, 2006
 * @author mmatwiy
 * Test validation for container AssignedScorecardResponse for an Asset.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.asset.containers.AssetModule;
import com.ibm.rpm.scorecard.containers.AssignedScorecardResponse;

public class TestAssetsAssignedScorecardResponseValidation extends
        AbstractTestAssignedScorecardResponseValidation
{
    private AssetModule module;

    public void setUp() throws Exception
    {
        super.setUp();

        ScorecardAssetsValidationUtility utility = new ScorecardAssetsValidationUtility();
        
        module = utility.createAssetModule();

        Asset assignedAsset = utility.prepareScorecardAssignment(module);

        AssignedScorecardResponse response = assignedAsset
            .getAssignedScorecard().getAssignedScorecardCategories()[0]
            .getAssignedScorecardQuestions()[0].getAssignedScorecardResponses()[0];

        initializeValues(response);
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testFailureValidationMax() throws Exception
    {
        failureValidationMax();
    }
    
    public void testSuccessValidationMax() throws Exception
    {
        successValidationMax();
    }
    
    public void testReadOnlyFields() throws Exception
    {
        readOnlyFields();
    }
    
    public void testDefaultValuesInsert() throws Exception
    {
        defaultValuesInsert();
    }
    
    public void testDefaultValuesUpdateToNull() throws Exception
    {
        defaultValuesUpdateToNull();
    }

}
