/*
 * Created on Dec 6, 2005
 * @author mmatwiy
 * Validation of ScorecardFolder container with module AssetModule.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.asset.containers.AssetModule;
import com.ibm.rpm.asset.scope.AssetModuleScope;
import com.ibm.rpm.client.junit.asset.fixtures.AssetModuleFixture;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;

public class TestAssetsScorecardFolderValidation extends
        AbstractTestScorecardFolderValidation
{
    private AssetModule module;

    public void setUp() throws Exception
    {
        module = new AssetModule();

        ScorecardFolder folder = new ScorecardFolder();

        AssetModuleScope assetModuleScope = AssetModuleFixture.createFullScope();

        module.setScorecardFolders(new ScorecardFolder[]
        {
            folder
        });

        super.setUp(module, assetModuleScope, folder);
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testInsertWithoutModule() throws AssertionError, Exception
    {
        super.insertWithoutModule();
    }

    public void testInsertWithoutMandatoryFields() throws AssertionError,
            Exception
    {
        super.insertWithoutMandatoryFields();
    }

    public void testInsertSuccess() throws AssertionError, Exception
    {
        super.insertSuccess();
    }

    public void testSuccessValidationMax() throws AssertionError, Exception
    {
        super.successValidationMax();
    }

    public void testFailureValidationMax() throws AssertionError, Exception
    {
        super.failureValidationMax();
    }

    public void testFailureValidationMin() throws AssertionError, Exception
    {
        super.failureValidationMin();
    }
}
