/*
 * Created on Dec 5, 2005
 * @author mmatwiy
 * Validation of Scorecard container with module AssetModule.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.asset.containers.AssetModule;
import com.ibm.rpm.asset.scope.AssetModuleScope;
import com.ibm.rpm.client.junit.asset.fixtures.AssetModuleFixture;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.scorecard.containers.Scorecard;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;


public class TestAssetsScorecardValidation extends
        AbstractTestScorecardValidation
{
    private AssetModule module;

    public void setUp() throws Exception
    {
        module = new AssetModule();

        ScorecardFolder folder = new ScorecardFolder();
        folder.setName(HelperTestUtilities.unitTestPrefix + "Test assets scorecard - folder");

        Scorecard scorecard = new Scorecard();

        folder.setScorecards(new Scorecard[]
        {
            scorecard
        });

        module.setScorecardFolders(new ScorecardFolder[]
        {
            folder
        });
        
        AssetModuleScope assetModuleScope = AssetModuleFixture.createFullScope();
        
        super.setUp(module, assetModuleScope, scorecard);
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testInsertWithoutModule() throws AssertionError, Exception
    {
        insertWithoutModule();
    }

    public void testInsertWithoutMandatoryFields() throws AssertionError,
            Exception
    {
        insertWithoutMandatoryFields();
    }

    public void testInsertSuccess() throws AssertionError, Exception
    {
        insertSuccess();
    }

    public void testSuccessValidationMax() throws AssertionError, Exception
    {
        successValidationMax();
    }

    public void testFailureValidationMax() throws AssertionError, Exception
    {
        failureValidationMax();
    }
    
    public void testSuccessValidationMin() throws AssertionError, Exception
    {
        successValidationMin();
    }

    public void testFailureValidationMin() throws AssertionError, Exception
    {
        failureValidationMin();
    }
    
    public void testDefaultValuesInsert() throws AssertionError, Exception
    {
        defaultValuesInsert();
    }
    
    public void testDefaultUpdateToNull() throws AssertionError, Exception
    {
        defaultValuesUpdateToNull();
    }
}
