/*
 * Created on Mar 27, 2006
 * @author mmatwiy
 * Test the assignment of two scorecards to the same container.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.client.junit.framework.testcases.GenericValidation;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.scope.fixtures.ScopeManagementModuleFixture;
import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.scopemanagement.containers.Action;
import com.ibm.rpm.scopemanagement.containers.ScopeManagementModule;
import com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope;
import com.ibm.rpm.scorecard.containers.Scorecard;
import com.ibm.rpm.scorecard.containers.ScorecardCategory;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;
import com.ibm.rpm.scorecard.containers.ScorecardQuestion;
import com.ibm.rpm.scorecard.containers.ScorecardResponse;

public class TestScopeActionAssignMultipleScorecardsValidation extends
        GenericValidation
{

    public void testFailureMultipleAssignments() throws Exception
    {

        ScorecardScopeValidationUtility utility = new ScorecardScopeValidationUtility();

        ScopeManagementModule module = utility.createModule();

        Action assignedAction = utility.prepareActionAssignment(module);

        //attempt to assign a second scorecard to the assignedAction container
        Scorecard scorecard2 = createModule().getScorecardFolders()[0]
            .getScorecards()[0];
        
        SingleResult result = getApplicationInterface().assignScoreCard(
            sessionid, assignedAction, null, scorecard2, ReloadType.ReloadResult);
    
        assertFalse(result.isSuccessful());
        assertTrue(result.getErrors().length == 1);

    }

    private ScopeManagementModule createModule() throws Exception
    {
        ScopeManagementModule module = new ScopeManagementModule();

        ScorecardFolder folder = new ScorecardFolder();
        folder.setName(HelperTestUtilities.unitTestPrefix + "Test scope management scorecards - folder2");

        Scorecard scorecard = new Scorecard();
        scorecard.setName(HelperTestUtilities.unitTestPrefix + "Test scope management scorecards - scorecard2");
        scorecard.setActive(new Boolean(true));

        ScorecardCategory category = new ScorecardCategory();
        category.setName(HelperTestUtilities.unitTestPrefix + "Test scope management scorecards - category2");

        ScorecardQuestion question = new ScorecardQuestion();
        question.setName(HelperTestUtilities.unitTestPrefix + "Test scope management scorecards - question2");

        ScorecardResponse response1 = new ScorecardResponse();
        response1.setName(HelperTestUtilities.unitTestPrefix + "Test scope management scorecards - response 2-1");
        response1.setDefaultResponse(new Boolean(true));

        ScorecardResponse response2 = new ScorecardResponse();
        response2.setName(HelperTestUtilities.unitTestPrefix + "Test scope management scorecards - response 2-2");

        module.setScorecardFolders(new ScorecardFolder[]
        {
            folder
        });
        folder.setScorecards(new Scorecard[]
        {
            scorecard
        });
        scorecard.setScorecardCategories(new ScorecardCategory[]
        {
            category
        });
        category.setScorecardQuestions(new ScorecardQuestion[]
        {
            question
        });
        question.setScorecardResponses(new ScorecardResponse[]
        {
                response1, response2
        });

        ScopeManagementModuleScope moduleScope = ScopeManagementModuleFixture.createFullScope();

        module = (ScopeManagementModule) save(module, moduleScope).getRpmObject();

        return module;
    }
}
