/*
 * Created on Dec 6, 2005
 * @author mmatwiy
 * Validation of ScorecardCategory container with module 
 * ScopeManagementModule.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.scorecard.fixtures.ScorecardFixture;
import com.ibm.rpm.scopemanagement.containers.ScopeManagementModule;
import com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope;
import com.ibm.rpm.scorecard.containers.Scorecard;
import com.ibm.rpm.scorecard.containers.ScorecardCategory;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;

public class TestScopeScorecardCategoryValidation extends
        AbstractTestScorecardCategoryValidation
{
    private ScopeManagementModule scopeMgmtModule;

    public void setUp() throws Exception
    {
        scopeMgmtModule = new ScopeManagementModule();

        ScorecardFolder folder = new ScorecardFolder();
        folder.setName(HelperTestUtilities.unitTestPrefix + "Test scope management scorecard category - folder");

        Scorecard scorecard = new Scorecard();
        scorecard
            .setName(HelperTestUtilities.unitTestPrefix + "Test scope management scorecard category - scorecard");

        folder.setScorecards(new Scorecard[]
        {
            scorecard
        });

        ScorecardCategory category = new ScorecardCategory();

        scorecard.setScorecardCategories(new ScorecardCategory[]
        {
            category
        });
        scopeMgmtModule.setScorecardFolders(new ScorecardFolder[]
        {
            folder
        });

        ScopeManagementModuleScope moduleScope = new ScopeManagementModuleScope();
        moduleScope.setScorecardFolders(ScorecardFixture.createScope());

        super.setUp(scopeMgmtModule, moduleScope, category);
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testInsertWithoutModule() throws AssertionError, Exception
    {
        insertWithoutModule();
    }

    public void testInsertWithoutMandatoryFields() throws AssertionError,
            Exception
    {
        insertWithoutMandatoryFields();
    }

    public void testInsertSuccess() throws AssertionError, Exception
    {
        insertSuccess();
    }

    public void testSuccessValidationMax() throws AssertionError,
            Exception
    {
        successValidationMax();
    }

    public void testFailureValidationMax() throws AssertionError,
            Exception
    {
        failureValidationMax();
    }

    public void testSuccessValidationMin() throws AssertionError,
            Exception
    {
        successValidationMin();
    }

    public void testFailureValidationMin() throws AssertionError,
            Exception
    {
        failureValidationMin();
    }

    public void testDefaultValuesInsert() throws AssertionError, Exception
    {
        defaultValuesInsert();
    }

    public void testDefaultUpdateToNull() throws AssertionError, Exception
    {
        defaultValuesUpdateToNull();
    }
}
