/*
 * Created on Dec 6, 2005
 * @author mmatwiy
 * Validation of ScorecardFolder container with module 
 * ScopeManagementModule.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.client.junit.scorecard.fixtures.ScorecardFixture;
import com.ibm.rpm.scopemanagement.containers.ScopeManagementModule;
import com.ibm.rpm.scopemanagement.scope.ScopeManagementModuleScope;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;


public class TestScopeScorecardFolderValidation extends
        AbstractTestScorecardFolderValidation
{
    private ScopeManagementModule scopeMgmtModule;

    public void setUp() throws Exception
    {
        scopeMgmtModule = new ScopeManagementModule();

        ScorecardFolder folder = new ScorecardFolder();

        ScopeManagementModuleScope moduleScope = new ScopeManagementModuleScope();
        moduleScope.setScorecardFolders(ScorecardFixture.createScope());

        scopeMgmtModule.setScorecardFolders(new ScorecardFolder[]
        {
            folder
        });
        
        super.setUp(scopeMgmtModule, moduleScope, folder);
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testInsertWithoutModule() throws AssertionError, Exception
    {
        super.insertWithoutModule();
    }

    public void testInsertWithoutMandatoryFields() throws AssertionError,
            Exception
    {
        super.insertWithoutMandatoryFields();
    }

    public void testInsertSuccess() throws AssertionError, Exception
    {
        super.insertSuccess();
    }

    public void testSuccessValidationMax() throws AssertionError, Exception
    {
        super.successValidationMax();
    }

    public void testFailureValidationMax() throws AssertionError, Exception
    {
        super.failureValidationMax();
    }
    
    public void testFailureValidationMin() throws AssertionError, Exception
    {
        super.failureValidationMin();
    }
}
