/*
 * Created on Mar 27, 2006
 * @author mmatwiy
 * Test the assignment of two scorecards to the same container. This is 
 * valid for WBS.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.client.junit.framework.testcases.GenericValidation;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.scorecard.fixtures.ScorecardFixture;
import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.framework.SingleResult;
import com.ibm.rpm.scorecard.containers.Scorecard;
import com.ibm.rpm.scorecard.containers.ScorecardCategory;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;
import com.ibm.rpm.scorecard.containers.ScorecardQuestion;
import com.ibm.rpm.scorecard.containers.ScorecardResponse;
import com.ibm.rpm.scorecard.scope.ScorecardFolderScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.containers.WbsModule;
import com.ibm.rpm.wbs.scope.WbsModuleScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class TestWBSProjectAssignMultipleScorecardsValidation extends
        GenericValidation
{

    public void testSuccessMultipleAssignments() throws Exception
    {

        ScorecardWBSValidationUtility utility = new ScorecardWBSValidationUtility();

        WbsModule module = utility.createModule();

        Project project = utility.prepareProjectAssignment(module);

        //attempt to assign a second scorecard to the project container
        WbsModule module2 = createModule();
        Scorecard scorecard2 = module2.getScorecardFolders()[0]
            .getScorecards()[0];
        
        WorkElementScope scope = utility.createScope();
        
        SingleResult result = getApplicationInterface().assignScoreCard(
            sessionid, project, scope, scorecard2, ReloadType.ReloadResult);
    
        assertTrue(result.isSuccessful());
        assertTrue(result.getRpmObject() instanceof Project);
        assertNotNull(((Project)result.getRpmObject()).getAssignedScorecards());
        assertTrue(((Project)result.getRpmObject()).getAssignedScorecards().length == 2);

    }

    private WbsModule createModule() throws Exception
    {

        WbsModule module = new WbsModule();

        ScorecardFolder scorecardFolder = new ScorecardFolder();
        scorecardFolder
            .setName(HelperTestUtilities.unitTestPrefix + "Test WBS scorecards - folder2");

        Scorecard scorecard = new Scorecard();
        scorecard.setName(HelperTestUtilities.unitTestPrefix + "Test WBS scorecards - scorecard2");
        scorecard.setActive(new Boolean(true));

        ScorecardCategory category = new ScorecardCategory();
        category.setName(HelperTestUtilities.unitTestPrefix + "Test WBS scorecards - category2");

        ScorecardQuestion question = new ScorecardQuestion();
        question.setName(HelperTestUtilities.unitTestPrefix + "Test WBS scorecards - question2");

        ScorecardResponse response1 = new ScorecardResponse();
        response1.setName(HelperTestUtilities.unitTestPrefix + "Test WBS scorecards - response 2-1");
        response1.setDefaultResponse(new Boolean(true));

        ScorecardResponse response2 = new ScorecardResponse();
        response2.setName(HelperTestUtilities.unitTestPrefix + "Test WBS scorecards - response 2-2");

        module.setScorecardFolders(new ScorecardFolder[]
        {
            scorecardFolder
        });
        scorecardFolder.setScorecards(new Scorecard[]
        {
            scorecard
        });
        scorecard.setScorecardCategories(new ScorecardCategory[]
        {
            category
        });
        category.setScorecardQuestions(new ScorecardQuestion[]
        {
            question
        });
        question.setScorecardResponses(new ScorecardResponse[]
        {
                response1, response2
        });

        ScorecardFolderScope scorecardScope = ScorecardFixture.createScope();
        WbsModuleScope moduleScope =  new WbsModuleScope();          
        moduleScope.setScorecardFolders(scorecardScope);

        module = (WbsModule) save(module, moduleScope).getRpmObject();

        return module;
    }
}
