/*
 * Created on Dec 7, 2005
 * @author mmatwiy
 * Validation of Scorecard container with module WbsModule.
 */
package com.ibm.rpm.client.junit.scorecard.testcases.validation;

import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.scorecard.fixtures.ScorecardFixture;
import com.ibm.rpm.scorecard.containers.Scorecard;
import com.ibm.rpm.scorecard.containers.ScorecardCategory;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;
import com.ibm.rpm.scorecard.containers.ScorecardQuestion;
import com.ibm.rpm.scorecard.containers.ScorecardResponse;
import com.ibm.rpm.wbs.containers.WbsModule;
import com.ibm.rpm.wbs.scope.WbsModuleScope;

public class TestWBSScorecardResponseValidation extends
        AbstractTestScorecardResponseValidation
{
    private WbsModule wbsModule;
    
    public void setUp() throws Exception
    {
        wbsModule = new WbsModule();

        ScorecardFolder folder = new ScorecardFolder();
        folder.setName(HelperTestUtilities.unitTestPrefix + "Test WBS scorecard category - folder");

        Scorecard scorecard = new Scorecard();
        scorecard.setName(HelperTestUtilities.unitTestPrefix + "Test WBS scorecard category - scorecard");

        ScorecardCategory category = new ScorecardCategory();
        category.setName(HelperTestUtilities.unitTestPrefix + "Test WBS scorecard question - category");

        ScorecardQuestion question = new ScorecardQuestion();
        question.setName(HelperTestUtilities.unitTestPrefix + "Test WBS scorecard response - question");

        ScorecardResponse response = new ScorecardResponse();
        response.setDefaultResponse(new Boolean(true));

        wbsModule.setScorecardFolders(new ScorecardFolder[]
        {
            folder
        });
        folder.setScorecards(new Scorecard[]
        {
            scorecard
        });
        scorecard.setScorecardCategories(new ScorecardCategory[]
        {
            category
        });
        category.setScorecardQuestions(new ScorecardQuestion[]
        {
            question
        });
        question.setScorecardResponses(new ScorecardResponse[]
        {
            response
        });

        WbsModuleScope moduleScope = new WbsModuleScope();
        moduleScope.setScorecardFolders(ScorecardFixture.createScope());

        super.setUp(wbsModule, moduleScope, response);
    }

    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testInsertWithoutMandatoryFields() throws AssertionError,
            Exception
    {
        insertWithoutMandatoryFields();
    }

    public void testInsertSuccess() throws AssertionError, Exception
    {
        insertSuccess();
    }

    public void testSuccessValidationMax() throws AssertionError,
            Exception
    {
        successValidationMax();
    }

    public void testFailureValidationMax() throws AssertionError,
            Exception
    {
        failureValidationMax();
    }

    public void testSuccessValidationMin() throws AssertionError,
            Exception
    {
        successValidationMin();
    }

    public void testFailureValidationMin() throws AssertionError,
            Exception
    {
        failureValidationMin();
    }
    
    public void testDefaultValuesInsert() throws AssertionError, Exception
    {
        defaultValuesInsert();
    }
    
    public void testDefaultUpdateToNull() throws AssertionError, Exception
    {
        defaultValuesUpdateToNull();
    }
}
