package com.ibm.rpm.client.junit.security.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.security.containers.ProjectSecurityRole;
import com.ibm.rpm.security.containers.SecurityGroup;

public class Test56676 extends ClientTestController {
	
	public void testCreateChildSecurityRole() throws Exception
	{
		ProjectSecurityRole projectSecurityRole = loadProjectManagerSecurityRole();
		
		ProjectSecurityRole childSecurityRole = new ProjectSecurityRole();
		childSecurityRole.setName(HelperTestUtilities.createName());
		childSecurityRole.setParent(projectSecurityRole);
		
		childSecurityRole = (ProjectSecurityRole)save(childSecurityRole, null).getRpmObject();
		assertNotNull(childSecurityRole);
		
		boolean newValue = !childSecurityRole.getCanEditAssignedOrganizations().booleanValue();
		childSecurityRole.setCanEditAssignedOrganizations(new Boolean(newValue));
		childSecurityRole = (ProjectSecurityRole)save(childSecurityRole, null).getRpmObject();
		assertNotNull(childSecurityRole);
		assertNotNull(childSecurityRole.getCanEditAssignedOrganizations());
		assertEquals(newValue,childSecurityRole.getCanEditAssignedOrganizations().booleanValue());
	}
	
	public void testCreateSecurityGroup() throws Exception
	{
		SecurityGroup defaultSecurityGroup = loadDefaultSecurityGroup();
		SecurityGroup securityGroup = new SecurityGroup();
		securityGroup.setName(HelperTestUtilities.createName());
		securityGroup.setParent(defaultSecurityGroup);
		securityGroup = (SecurityGroup)save(securityGroup, null).getRpmObject();
		assertNotNull(securityGroup);
		
		boolean newValue = !securityGroup.getCanEditCurrencyExchangeRates().booleanValue();
		securityGroup.setCanEditCurrencyExchangeRates(new Boolean(newValue));
		securityGroup = (SecurityGroup)save(securityGroup,null).getRpmObject();
		assertNotNull(securityGroup);
		assertNotNull(securityGroup.getCanEditCurrencyExchangeRates());
		assertEquals(newValue, securityGroup.getCanEditCurrencyExchangeRates().booleanValue());
	}
	
	private ProjectSecurityRole loadProjectManagerSecurityRole() throws Exception
	{
		RPMObject[] rpmObjects = loadFromXpath("/ProjectSecurityRole[name='Project Manager']", null);
        assertNotNull(rpmObjects);
        assertNotNull(rpmObjects[0]);
        return (ProjectSecurityRole)rpmObjects[0];
	}
	
	private SecurityGroup loadDefaultSecurityGroup() throws Exception
	{
		RPMObject[] rpmObjects = loadFromXpath("/SecurityGroup[@name='DEFAULT_SECURITY_ROLE']", null);
        assertNotNull(rpmObjects);
        assertNotNull(rpmObjects[0]);
        return (SecurityGroup)rpmObjects[0];
	}
}
