/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2005.  All Rights Reserved.                    |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.igs;

import com.ibm.rpm.client.junit.SpecificTestController;
import com.ibm.rpm.client.junit.security.testcases.BaseSecurityTestLocal;
import com.ibm.rpm.framework.RpmOptions;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.security.containers.SecurityRole;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.containers.ResourceTaskAssignment;

/**
 * @author Marc-Andre Lamothe
 *
 */
public class BaseIGSSecurityTestLocal extends BaseSecurityTestLocal
{
    public void setUp() throws Exception
    {
        SpecificTestController.overrideOption(
            RpmOptions.WEB_SERVICES_SECURITY_CONTROLLER_CLASS_NAME, IGS_SEC);
        super.setUp();
    }

    protected void assignOtherResourceAsProjectManager(Project project)
            throws Exception
    {
        SecurityRole managerRole = project.getResourceTaskAssignments()[0]
            .getSecurityRole();
        // Create a different resource and make it Manager of the Project
        Resource resource = loadOrCreateUserResource("SECURITY_TESTER2", "rpm");
        ResourceTaskAssignment assignment = new ResourceTaskAssignment();
        assignment.setParent(project);
        assignment.setResource(resource);
        assignment.setSecurityRole(managerRole);
        save(assignment, null);
        addObjectToDelete(assignment);
    }

}
