/*
 * +------------------------------------------------------------------------+
 * | Licensed Materials - Property of IBM                                   | 
 * | (C) Copyright IBM Corp. 2005. All Rights Reserved.                     | 
 * |                                                                        |
 * | US Government Users Restricted Rights - Use, duplication or disclosure |
 * | restricted by GSA ADP Schedule Contract with IBM Corp.                 | 
 * +------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.igs;

import com.ibm.rpm.client.junit.timesheet.fixtures.StepFixture;
import com.ibm.rpm.client.junit.timesheet.fixtures.SummaryTimesheetFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.PortfolioFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.TaskAssignmentFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.timesheet.containers.GenericStep;
import com.ibm.rpm.timesheet.containers.Step;
import com.ibm.rpm.timesheet.containers.StepTimesheet;
import com.ibm.rpm.timesheet.containers.SummaryTimesheet;
import com.ibm.rpm.timesheet.scope.StepScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.containers.TaskAssignment;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Marc-Andre Lamothe
 */
public class TestProjectGenericStepSecurityLocal extends BaseIGSSecurityTestLocal
{
    private WorkElementScope projectScope = null;

    private Project testProject = null;

    public void setUp() throws Exception
    {
        super.setUp();

        // Prepare a project
        projectScope = new WorkElementScope();
        projectScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
        testProject = (Project) WorkElementFixture.createFixture(null,
            new Project(), projectScope, this);
        testProject.setPortfolio(PortfolioFixture.loadOrCreateRootPortfolio(this));
    }

    public void test() {}
    
//    public void testAddProjectGenericStep() throws Exception
//    {
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//        Task task = (Task) WorkElementFixture.createFixture(testProject,
//            new Task(), null, this);
//        task.setContainingProject(testProject);
//        saveAndValidate(task, null, true);
//
//        StepScope scope = StepFixture.createScope(true, true, false, true,
//            false, true);
//
//        TaskAssignment taskAssignment = TaskAssignmentFixture
//            .createSaveFixture(task,
//                testProject.getResourceTaskAssignments()[0].getResource(),
//                null, this);
//
//        // Associate a step element to the project, should succeed
//        Step step = StepFixture
//            .createFixture(taskAssignment, scope, null, this);
//        step.setProject(testProject);
//        step.setWeight(new Double(50));
//        step = (Step) saveAndValidate(step, scope, true);
//
//        Step step_2 = StepFixture.createFixture(taskAssignment, scope, null,
//            this);
//        step_2.setProject(testProject);
//        step_2.setWeight(new Double(20));
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Edit value of the step element to the project, should fail
//        saveAndValidate(step_2, scope, false);
//    }
//
//    public void testDeleteProjectGenericStep() throws Exception
//    {
//         testProject = (Project) saveAndValidate(testProject, projectScope, true);
//        Task task = (Task) WorkElementFixture.createFixture(testProject,
//            new Task(), null, this);
//        task.setContainingProject(testProject);
//        saveAndValidate(task, null, true);
//
//        StepScope scope = StepFixture.createScope(true, true, false, true,
//            false, true);
//
//        TaskAssignment taskAssignment = TaskAssignmentFixture
//            .createSaveFixture(task,
//                testProject.getResourceTaskAssignments()[0].getResource(),
//                null, this);
//
//        // Associate a step element to the project, should succeed   
//        SummaryTimesheet summaryTimesheet = SummaryTimesheetFixture
//            .createSaveFixture(taskAssignment, taskAssignment.getAssignmentStartDate(),
//                null, false, this);
//        addObjectToDelete(summaryTimesheet);
//             
//        StepTimesheet[] sTS = {new StepTimesheet()};         
//        sTS[0].setWeekOf(summaryTimesheet.getWeekOf());
//        sTS[0].setRegularMonday(new Double(0.0));
//        sTS[0].setRegularTuesday(new Double(0.0));
//        sTS[0].setRegularWednesday(new Double(0.0));
//        sTS[0].setRegularThursday(new Double(0.0));
//        sTS[0].setRegularFriday(new Double(0.0));       
//                
//        Step step = new Step();
//        step.setName("Test_Step");
//        step.setStepTimesheets(sTS);
//        step.setTaskAssignment(taskAssignment);  
//        step.setProject(testProject);             
//        step = (Step) saveAndValidate(step, scope, true);
//
//        // Deletes the step, should succeed    
//        deleteAndValidate(step, true);
//
//        // Associate a step element to the project, should succeed
//        step = new Step();
//        step.setName("Test_Step");
//        step.setStepTimesheets(sTS);
//        step.setTaskAssignment(taskAssignment);  
//        step.setProject(testProject);             
//        step = (Step) saveAndValidate(step, scope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Deletes the step, should fail
//        deleteAndValidate(step, false);
//    }
//
//    public void testUpdateProjectGenericStep() throws Exception
//    {
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//        Task task = (Task) WorkElementFixture.createFixture(testProject,
//            new Task(), null, this);
//        task.setContainingProject(testProject);
//        saveAndValidate(task, null, true);
//
//        StepScope scope = StepFixture.createScope(true, true, false, true,
//            false, true);
//        TaskAssignment taskAssignment = TaskAssignmentFixture
//            .createSaveFixture(task,
//                testProject.getResourceTaskAssignments()[0].getResource(),
//                null, this);
//
//        // Associate a step element to the project, should succeed
//        GenericStep step = StepFixture.createFixture(taskAssignment, scope,
//            null, this);
//        step.setProject(testProject);
//        step = (GenericStep) saveAndValidate(step, scope, true);
//
//        // Updates the step element, should succeed
//        step.setModified();
//        saveAndValidate(step, scope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Updates the step element, should fail
//        step.setModified();
//        saveAndValidate(step, scope, false);
//    }

}
