/*
 * +------------------------------------------------------------------------+
 * | Licensed Materials - Property of IBM                                   | 
 * | (C) Copyright IBM Corp. 2005. All Rights Reserved.                     | 
 * |                                                                        |
 * | US Government Users Restricted Rights - Use, duplication or disclosure |
 * | restricted by GSA ADP Schedule Contract with IBM Corp.                 | 
 * +------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.igs;

import com.ibm.rpm.client.junit.scopemanagement.fixtures.ReqProConnectionFixture;
import com.ibm.rpm.client.junit.scopemanagement.fixtures.ReqProIntegrationFolderFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.PortfolioFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.scopemanagement.containers.ReqProConnection;
import com.ibm.rpm.scopemanagement.containers.ReqProIntegrationFolder;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Marc-Andre Lamothe
 */
public class TestProjectReqProConnectionSecurityLocal extends BaseIGSSecurityTestLocal
{
    private WorkElementScope projectScope = null;

    private Project testProject = null;

    public void setUp() throws Exception
    {
        super.setUp();

        // Prepare a project
        projectScope = new WorkElementScope();
        projectScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
        testProject = (Project) WorkElementFixture.createFixture(null,
            new Project(), projectScope, this);
        testProject.setPortfolio(PortfolioFixture.loadOrCreateRootPortfolio(this));
    }

    public void test() {}
    
//    public void testAddProjectReqProConnection() throws Exception
//    {
//        // Sets up the test Project
//        ScopeElementScope reqProScope = ReqProIntegrationFolderFixture
//            .getFullScope();
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a req pro integration folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ReqProIntegrationFolder reqProIntegrationFolder = ReqProIntegrationFolderFixture
//            .createFixture(rootScopeFolder, 0, reqProScope);
//        reqProIntegrationFolder = (ReqProIntegrationFolder) saveAndValidate(
//            reqProIntegrationFolder, reqProScope, true);
//
//        // Add a req pro connection, should succeed
//        ReqProConnection reqProConnection = ReqProConnectionFixture
//            .createFixture(reqProIntegrationFolder);
//        reqProConnection = (ReqProConnection) saveAndValidate(reqProConnection,
//            null, true);
//        reqProIntegrationFolder.setReqProConnection(reqProConnection);
//        reqProIntegrationFolder = (ReqProIntegrationFolder) saveAndValidate(
//            reqProIntegrationFolder, reqProScope, true);
//
//        // Add a new req pro connection, should fail
//        reqProConnection = ReqProConnectionFixture
//            .createFixture(reqProIntegrationFolder);
//        reqProConnection = (ReqProConnection) saveAndValidate(reqProConnection,
//            null, true);
//        reqProIntegrationFolder.setReqProConnection(reqProConnection);
//
//        //Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//        saveAndValidate(reqProIntegrationFolder, reqProScope, false);
//    }
//
    // Not valid because we cannot delete req pro connections
    //
    // public void testDeleteProjectReqProConnection() throws Exception
    // {
    // // Sets up the test Project
    // ScopeElementScope reqProScope =
    // ReqProIntegrationFolderFixture.getFullScope();
    // ScopeElementScope scopeElementScope = new ScopeElementScope();
    // projectScope.setScopeElement(scopeElementScope);
    // testProject = (Project) saveAndValidate(testProject, projectScope, true);
    //        
    // // Add a req pro integration folder, should succeed
    // ScopeFolder rootScopeFolder = (ScopeFolder)
    // testProject.getScopeElement();
    // ReqProIntegrationFolder reqProIntegrationFolder =
    // ReqProIntegrationFolderFixture.createFixture(rootScopeFolder, 0,
    // reqProScope);
    // reqProIntegrationFolder = (ReqProIntegrationFolder)
    // saveAndValidate(reqProIntegrationFolder, reqProScope, true);
    //        
    // // Add a req pro connection, should succeed
    // ReqProConnection reqProConnection =
    // ReqProConnectionFixture.createFixture(reqProIntegrationFolder);
    // saveAndValidate(reqProConnection, null, true);
    // reqProIntegrationFolder.setReqProConnection(reqProConnection);
    // reqProIntegrationFolder = (ReqProIntegrationFolder)
    // saveAndValidate(reqProIntegrationFolder, reqProScope, true);
    //        
    // // Delete a req pro connection, should succeed
    // deleteAndValidate(reqProConnection, true);
    //        
    // // Add a req pro connection, should succeed
    // reqProConnection =
    // ReqProConnectionFixture.createFixture(reqProIntegrationFolder);
    // saveAndValidate(reqProConnection, null, true);
    // reqProIntegrationFolder.setReqProConnection(reqProConnection);
    // reqProIntegrationFolder = (ReqProIntegrationFolder)
    // saveAndValidate(reqProIntegrationFolder, reqProScope, true);
    //        
    // // Assign another resource as manager of the Project
    // assignOtherResourceAsProjectManager(testProject);
    //
    // // Delete a req pro connection, should fail
    // deleteAndValidate(reqProConnection, false);
    // }
//
//    public void testUpdateProjectReqProConnection() throws Exception
//    {
//        // Sets up the test Project
//        ScopeElementScope reqProScope = ReqProIntegrationFolderFixture
//            .getFullScope();
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a req pro integration folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ReqProIntegrationFolder reqProIntegrationFolder = ReqProIntegrationFolderFixture
//            .createFixture(rootScopeFolder, 0, reqProScope);
//        reqProIntegrationFolder = (ReqProIntegrationFolder) saveAndValidate(
//            reqProIntegrationFolder, reqProScope, true);
//
//        // Add a req pro connection, should succeed
//        ReqProConnection reqProConnection = ReqProConnectionFixture
//            .createFixture(reqProIntegrationFolder);
//        reqProConnection = (ReqProConnection) saveAndValidate(reqProConnection,
//            null, true);
//        reqProIntegrationFolder.setReqProConnection(reqProConnection);
//        reqProIntegrationFolder = (ReqProIntegrationFolder) saveAndValidate(
//            reqProIntegrationFolder, reqProScope, true);
//
//        // Update the req pro connection, should succeed
//        reqProConnection.setReqProLogon("test");
//        reqProConnection = (ReqProConnection) saveAndValidate(reqProConnection,
//            null, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Update the req pro connection, should fail
//        reqProConnection.setReqProLogon("test2");
//        reqProConnection = (ReqProConnection) saveAndValidate(reqProConnection,
//            null, false);
//    }

}
