/*
 * +------------------------------------------------------------------------+
 * | Licensed Materials - Property of IBM                                   | 
 * | (C) Copyright IBM Corp. 2005. All Rights Reserved.                     | 
 * |                                                                        |
 * | US Government Users Restricted Rights - Use, duplication or disclosure |
 * | restricted by GSA ADP Schedule Contract with IBM Corp.                 | 
 * +------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.igs;

import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.PortfolioFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.scopemanagement.containers.Risk;
import com.ibm.rpm.scopemanagement.containers.RiskMatrix;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Marc-Andre Lamothe
 */
public class TestProjectRiskMatrixSecurityLocal extends BaseIGSSecurityTestLocal
{
    private WorkElementScope projectScope = null;

    private Project testProject = null;

    public void setUp() throws Exception
    {
        super.setUp();

        // Prepare a project
        projectScope = new WorkElementScope();
        projectScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
        testProject = (Project) WorkElementFixture.createFixture(null,
            new Project(), projectScope, this);
        testProject.setPortfolio(PortfolioFixture.loadOrCreateRootPortfolio(this));
    }

    public void test() {}
    
//    public void testAddProjectRiskMatrix() throws Exception
//    {
//        // Sets up the test Project
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        scopeElementScope.setChildren(scopeElementScope);
//        scopeElementScope.setRiskMatrix(true);
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project's folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ScopeElement[] se =
//        {
//            ScopeElementFixture.createRiskFixture(scopeElementScope, 0,
//                rootScopeFolder, this)
//        };
//        rootScopeFolder.setChildren(se);
//        rootScopeFolder = (ScopeFolder) saveAndValidate(rootScopeFolder,
//            scopeElementScope, true);
//
//        // Add a risk matrix, should succeed
//        se = rootScopeFolder.getChildren();
//        RiskMatrix riskMatrix = new RiskMatrix();
//        riskMatrix.setParent(se[0]);
//        ((Risk) se[0]).setRiskMatrix(riskMatrix);
//        saveAndValidate(se[0], scopeElementScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Add new risk matrix, should fail
//        se = rootScopeFolder.getChildren();
//        riskMatrix = new RiskMatrix();
//        riskMatrix.setParent(se[0]);
//        ((Risk) se[0]).setRiskMatrix(riskMatrix);
//        saveAndValidate(se[0], scopeElementScope, false);
//    }
//
//    // Can't delete a risk matrix.
//    //   
//    // public void testDeleteProjectRiskMatrix() throws Exception
//    // {
//    // // Sets up the test Project with a child item
//    // ScopeElementScope scopeElementScope = new ScopeElementScope();
//    // scopeElementScope.setChildren(scopeElementScope);
//    // scopeElementScope.setRiskMatrix(true);
//    // projectScope.setScopeElement(scopeElementScope);
//    // testProject = (Project) saveAndValidate(testProject, projectScope, true);
//    //
//    // // Add a child element to project's folder, should succeed
//    // ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//    // .getScopeElement();
//    // ScopeElement[] se =
//    // {
//    // ScopeElementFixture.createRiskFixture(scopeElementScope, 0,
//    // rootScopeFolder, this)
//    // };
//    // rootScopeFolder.setChildren(se);
//    // rootScopeFolder = (ScopeFolder) saveAndValidate(rootScopeFolder,
//    // scopeElementScope, true);
//    //        
//    // // Add a risk matrix, should succeed
//    // se = rootScopeFolder.getChildren();
//    // RiskMatrix riskMatrix = new RiskMatrix();
//    // riskMatrix.setParent(se[0]);
//    // ((Risk)se[0]).setRiskMatrix(riskMatrix);
//    // se[0] = (ScopeElement) saveAndValidate(se[0], scopeElementScope, true);
//    //
//    // // Deletes the risk matrix, should succeed
//    // se = rootScopeFolder.getChildren();
//    // riskMatrix = ((Risk)se[0]).getRiskMatrix();
//    // deleteAndValidate(riskMatrix, true);
//    //
//    // // Add a risk matrix, should succeed
//    // se = rootScopeFolder.getChildren();
//    // riskMatrix = new RiskMatrix();
//    // riskMatrix.setParent(se[0]);
//    // ((Risk)se[0]).setRiskMatrix(riskMatrix);
//    // se[0] = (ScopeElement) saveAndValidate(se[0], scopeElementScope, true);
//    //
//    // // Assign another resource as manager of the Project
//    // assignOtherResourceAsProjectManager(testProject);
//    //
//    // // Deletes the risk matrix, should fail
//    // se = rootScopeFolder.getChildren();
//    // riskMatrix = ((Risk)se[0]).getRiskMatrix();
//    // deleteAndValidate(riskMatrix, false);
//    // }
//
//    public void testUpdateProjectRiskMatrix() throws Exception
//    {
//        // Sets up the test Project
//        ScopeElementScope scopeElementScope = new ScopeElementScope();
//        scopeElementScope.setChildren(scopeElementScope);
//        scopeElementScope.setRiskMatrix(true);
//        projectScope.setScopeElement(scopeElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project's folder, should succeed
//        ScopeFolder rootScopeFolder = (ScopeFolder) testProject
//            .getScopeElement();
//        ScopeElement[] se =
//        {
//            ScopeElementFixture.createRiskFixture(scopeElementScope, 0,
//                rootScopeFolder, this)
//        };
//        rootScopeFolder.setChildren(se);
//        rootScopeFolder = (ScopeFolder) saveAndValidate(rootScopeFolder,
//            scopeElementScope, true);
//
//        // Add a risk matrix, should succeed
//        se = rootScopeFolder.getChildren();
//        RiskMatrix riskMatrix = new RiskMatrix();
//        riskMatrix.setParent(se[0]);
//        ((Risk) se[0]).setRiskMatrix(riskMatrix);
//        se[0] = (ScopeElement) saveAndValidate(se[0], scopeElementScope, true);
//
//        // Updates the risk matrix, should succeed
//        riskMatrix = ((Risk) se[0]).getRiskMatrix();
//        riskMatrix
//            .setImpact(new Integer(riskMatrix.getImpact().intValue() + 20));
//        se[0] = (ScopeElement) saveAndValidate(se[0], scopeElementScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Updates the risk matrix, should fail
//        riskMatrix = ((Risk) se[0]).getRiskMatrix();
//        riskMatrix
//            .setImpact(new Integer(riskMatrix.getImpact().intValue() + 20));
//        saveAndValidate(se[0], scopeElementScope, false);
//    }

}
