/*
 * +------------------------------------------------------------------------+
 * | Licensed Materials - Property of IBM                                   | 
 * | (C) Copyright IBM Corp. 2005. All Rights Reserved.                     | 
 * |                                                                        |
 * | US Government Users Restricted Rights - Use, duplication or disclosure |
 * | restricted by GSA ADP Schedule Contract with IBM Corp.                 | 
 * +------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.igs;

import com.ibm.rpm.client.junit.timesheet.fixtures.SummaryTimesheetFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.PortfolioFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.TaskAssignmentFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.timesheet.containers.SummaryTimesheet;
import com.ibm.rpm.timesheet.scope.SummaryTimesheetScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.containers.TaskAssignment;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Marc-Andre Lamothe
 */
public class TestProjectSummaryTimesheetSecurityLocal extends BaseIGSSecurityTestLocal
{
    private WorkElementScope projectScope = null;

    private Project testProject = null;

    public void setUp() throws Exception
    {
        super.setUp();

        // Prepare a project
        projectScope = new WorkElementScope();
        projectScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
        testProject = (Project) WorkElementFixture.createFixture(null,
            new Project(), projectScope, this);
        testProject.setPortfolio(PortfolioFixture.loadOrCreateRootPortfolio(this));
    }

    public void test() {}
    
//    public void testAddProjectSummaryTimesheet() throws Exception
//    {
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//        Task task = (Task) WorkElementFixture.createFixture(testProject,
//            new Task(), null, this);
//        task.setContainingProject(testProject);
//        saveAndValidate(task, null, true);
//        TaskAssignment taskAssignment = TaskAssignmentFixture
//            .createSaveFixture(task,
//                testProject.getResourceTaskAssignments()[0].getResource(),
//                null, this);
//
//        // Associate a timesheet element to the project, should succeed
//        SummaryTimesheet timesheet = SummaryTimesheetFixture.createFixture(
//            taskAssignment, null, null, false, this);
//        timesheet = (SummaryTimesheet) saveAndValidate(timesheet,
//            new SummaryTimesheetScope(), true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Associate a new timesheet element to the project, should fail
//        timesheet = SummaryTimesheetFixture.createFixture(taskAssignment, null,
//            null, false, this);
//        saveAndValidate(timesheet, new SummaryTimesheetScope(), false);
//    }
//
////    public void testDeleteProjectSummaryTimesheet() throws Exception
////    {
////        testProject = (Project) saveAndValidate(testProject, projectScope, true);
////
////        // Associate a timesheet element to the project, should succeed
////        SummaryTimesheet timesheet = SummaryTimesheetFixture.createFixture(
////            null, null, null, false, this);
////        timesheet.setProject(testProject);
////        timesheet = (SummaryTimesheet) saveAndValidate(timesheet,
////            new SummaryTimesheetScope(), true);
////
////        // Deletes the timesheet, should succeed
////        deleteAndValidate(timesheet, true);
////
////        // Associate a timesheet element to the project, should succeed
////        timesheet = SummaryTimesheetFixture.createFixture(null, null, null,
////            false, this);
////        timesheet.setProject(testProject);
////        timesheet = (SummaryTimesheet) saveAndValidate(timesheet,
////            new SummaryTimesheetScope(), true);
////
////        // Assign another resource as manager of the Project
////        assignOtherResourceAsProjectManager(testProject);
////
////        // Deletes the timesheet, should fail
////        deleteAndValidate(timesheet, false);
////    }
//
//    public void testUpdateProjectSummaryTimesheet() throws Exception
//    {
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//        Task task = (Task) WorkElementFixture.createFixture(testProject,
//            new Task(), null, this);
//        task.setContainingProject(testProject);
//        saveAndValidate(task, null, true);
//        TaskAssignment taskAssignment = TaskAssignmentFixture
//            .createSaveFixture(task,
//                testProject.getResourceTaskAssignments()[0].getResource(),
//                null, this);
//
//        // Associate a timesheet element to the project, should succeed
//        SummaryTimesheet timesheet = SummaryTimesheetFixture.createFixture(
//            taskAssignment, null, null, false, this);
//        timesheet = (SummaryTimesheet) saveAndValidate(timesheet,
//            new SummaryTimesheetScope(), true);
//
//        // Updates the timesheet element, should succeed
//        timesheet.setCostPerHour(new Double(timesheet.getCostPerHour()
//            .intValue() + 100));
//        saveAndValidate(timesheet, new SummaryTimesheetScope(), true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Updates the timesheet element, should fail
//        timesheet.setCostPerHour(new Double(timesheet.getCostPerHour()
//            .intValue() + 100));
//        saveAndValidate(timesheet, new SummaryTimesheetScope(), false);
//    }

}
