/*
 * +------------------------------------------------------------------------+
 * | Licensed Materials - Property of IBM                                   | 
 * | (C) Copyright IBM Corp. 2005. All Rights Reserved.                     | 
 * |                                                                        |
 * | US Government Users Restricted Rights - Use, duplication or disclosure |
 * | restricted by GSA ADP Schedule Contract with IBM Corp.                 | 
 * +------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.igs;

import com.ibm.rpm.client.junit.wbs.fixtures.PortfolioFixture;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.wbs.containers.Milestone;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.containers.WorkElement;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Marc-Andre Lamothe
 */
public class TestProjectWorkElementsSecurityLocal extends BaseIGSSecurityTestLocal
{
    private WorkElementScope projectScope = null;

    private Project testProject = null;

    public void setUp() throws Exception
    {
        super.setUp();

        // Prepare a project
        projectScope = new WorkElementScope();
        projectScope.setResourceTaskAssignments(new ResourceTaskAssignmentScope());
        testProject = (Project) WorkElementFixture.createFixture(null,
            new Project(), projectScope, this);
        testProject.setPortfolio(PortfolioFixture.loadOrCreateRootPortfolio(this));
    }

    public void test() {}
    
//    public void testAddProjectWorkElements() throws Exception
//    {
//        // Sets up the test Project with a child item
//        WorkElementScope childElementScope = new WorkElementScope();
//        projectScope.setChildren(childElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project, should succeed
//        WorkElement[] we =
//        {
//            WorkElementFixture.createFixture(testProject, new Task(),
//                childElementScope, this)
//        };
//        testProject.setChildren(we);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Add new child, should fail
//        WorkElement[] we2 =
//        {
//                we[0],
//                WorkElementFixture.createFixture(testProject, new Milestone(),
//                    childElementScope, this)
//        };
//        testProject.setChildren(we2);
//        saveAndValidate(testProject, projectScope, false);
//    }
//
//    public void testDeleteProjectWorkElements() throws Exception
//    {
//        // Sets up the test Project with a child item
//        WorkElementScope childElementScope = new WorkElementScope();
//        projectScope.setChildren(childElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project, should succeed
//        WorkElement[] we =
//        {
//            WorkElementFixture.createFixture(testProject, new Task(),
//                childElementScope, this)
//        };
//        testProject.setChildren(we);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Deletes the child, should succeed
//        we = testProject.getChildren();
//        deleteAndValidate(we[0], true);
//
//        // Add a child element to project, should succeed
//        we[0] = WorkElementFixture.createFixture(testProject, new Task(),
//            childElementScope, this);
//        testProject.setChildren(we);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Deletes the child, should fail
//        we = testProject.getChildren();
//        deleteAndValidate(we[0], false);
//    }
//
//    public void testUpdateProjectWorkElements() throws Exception
//    {
//        // Sets up the test Project with a child item
//        WorkElementScope childElementScope = new WorkElementScope();
//        projectScope.setChildren(childElementScope);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Add a child element to project, should succeed
//        WorkElement[] we =
//        {
//            WorkElementFixture.createFixture(testProject, new Task(),
//                childElementScope, this)
//        };
//        testProject.setChildren(we);
//        testProject = (Project) saveAndValidate(testProject, projectScope, true);
//
//        // Updates the child, should succeed
//        we = testProject.getChildren();
//        we[0].setPriority(new Integer(we[0].getPriority().intValue() + 1));
//        saveAndValidate(we[0], childElementScope, true);
//
//        // Assign another resource as manager of the Project
//        assignOtherResourceAsProjectManager(testProject);
//
//        // Updates the child, should fail
//        we = testProject.getChildren();
//        we[0].setPriority(new Integer(we[0].getPriority().intValue() + 1));
//        saveAndValidate(we[0], childElementScope, false);
//    }

}
