/*
 * Created on Jan 31, 2007
 *
 */
package com.ibm.rpm.client.junit.security.testcases.resource;

import com.ibm.rpm.applicationadministration.containers.ContactGroup;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.ContactGroupFixture;

/**
 * @author karim
 *
 */
public class TestContactGroupSecurityLocal extends
        BaseResourceSecurityTestLocal
{
    public void testCreateContactGroup() throws Exception
    {
        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditLocationGroups(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create a Contact Group, should fail
        ContactGroup contactGroup = ContactGroupFixture.createFixture(0, null);
        contactGroup = (ContactGroup) saveAndValidate(contactGroup, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditLocationGroups(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create a Contact Group, should succeed
        contactGroup = ContactGroupFixture.createFixture(0, null);
        contactGroup = (ContactGroup) saveAndValidate(contactGroup, null, true);
    }

    public void testDeleteContactGroupMustFail() throws Exception
    {
        // Create a Contact Group, should succeed
        ContactGroup contactGroup = ContactGroupFixture.createFixture(0, null);
        contactGroup = (ContactGroup) saveAndValidate(contactGroup, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditLocationGroups(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should fail
        deleteAndValidate(contactGroup, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditLocationGroups(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should succeed
        deleteAndValidate(contactGroup, true);
    }

    public void testEditContactGroup() throws Exception
    {
        // Create a Contact Group, should fail
        ContactGroup contactGroup = ContactGroupFixture.createFixture(0, null);
        contactGroup = (ContactGroup) saveAndValidate(contactGroup, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditLocationGroups(
            Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should fail
        contactGroup.setDescription("test");
        saveAndValidate(contactGroup, null, false);

        // Give right to edit
        getCurrentUser().getResourceSecurityRights().setCanEditLocationGroups(
            Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should succeed
        contactGroup.setDescription("test");
        saveAndValidate(contactGroup, null, true);
    }

}