/*
 * Created on Jan 31, 2007
 *
 */
package com.ibm.rpm.client.junit.security.testcases.resource;

import com.ibm.rpm.client.junit.contract.fixtures.ContractFixture;
import com.ibm.rpm.contract.containers.Contract;
import com.ibm.rpm.contract.scope.ContractScope;

/**
 * @author karim
 *
 */
public class TestContractSecurityLocal extends BaseResourceSecurityTestLocal
{
    public void testCreateContract() throws Exception
    {
        // Remove the right to create
        getCurrentUser().getResourceSecurityRights()
            .setCanCreateContractsAndFolders(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create a contract, should fail
        Contract contract = ContractFixture.createFixture(null, this);
        contract = (Contract) saveAndValidate(contract, null, false);

        // Give the right to create
        getCurrentUser().getResourceSecurityRights()
            .setCanCreateContractsAndFolders(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create a contract, should succeed
        contract = ContractFixture.createFixture(null, this);
        contract = (Contract) saveAndValidate(contract, null, true);
    }

    public void testDeleteContract() throws Exception
    {
        // Create a contract, should suceed
        Contract contract = ContractFixture.createFixture(null, this);
        contract = (Contract) saveAndValidate(contract, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanDeleteContractsAndFolders(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Delete the container
        deleteAndValidate(contract, false);

        // Give the right to delete
        getCurrentUser().getResourceSecurityRights()
            .setCanDeleteContractsAndFolders(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should suceed
        deleteAndValidate(contract, true);
    }

    public void testEditContractName() throws Exception
    {
        // Create a contract, should suceed
        ContractScope contractScope = new ContractScope();
        contractScope.setContractType(true);
        Contract contract = ContractFixture.createFixture(contractScope, this);
        contract = (Contract) saveAndValidate(contract, contractScope, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditContractsAndFolderNames(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should fail
        contract.setName(contract.getName() + "_UPDATED");
        saveAndValidate(contract, contractScope, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditContractsAndFolderNames(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should suceed
        saveAndValidate(contract, contractScope, true);
    }

}
