/*
 * Created on Jan 31, 2007
 *
 */
package com.ibm.rpm.client.junit.security.testcases.resource;

import com.ibm.rpm.client.junit.customfield.fixtures.CustomFieldFixture;
import com.ibm.rpm.customfield.containers.CustomFieldCategory;

/**
 * @author karim
 *
 */
public class TestCustomFieldSecurityLocal extends BaseResourceSecurityTestLocal
{
    public void testCreateCustomField() throws Exception
    {
        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditCustomFieldsAdmin(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create a custom field, should fail
        CustomFieldCategory customFieldCategory = CustomFieldFixture
            .createCustomFieldCategory();
        customFieldCategory
            .setContextName(CustomFieldFixture.CF_WBS_SCOPE_CONTEXT);
        customFieldCategory = (CustomFieldCategory) saveAndValidate(
            customFieldCategory, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditCustomFieldsAdmin(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create a custom field, should succeed
        customFieldCategory = CustomFieldFixture.createCustomFieldCategory();
        customFieldCategory
            .setContextName(CustomFieldFixture.CF_WBS_SCOPE_CONTEXT);
        customFieldCategory = (CustomFieldCategory) saveAndValidate(
            customFieldCategory, null, true);
    }

    public void testDeleteCustomField() throws Exception
    {
        // Create a custom field, should succeed
        CustomFieldCategory customFieldCategory = CustomFieldFixture
            .createCustomFieldCategory();
        customFieldCategory
            .setContextName(CustomFieldFixture.CF_WBS_SCOPE_CONTEXT);
        customFieldCategory = (CustomFieldCategory) saveAndValidate(
            customFieldCategory, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditCustomFieldsAdmin(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should fail
        deleteAndValidate(customFieldCategory, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditCustomFieldsAdmin(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should succeed
        deleteAndValidate(customFieldCategory, true);
    }

    public void testUpdateCustomField() throws Exception
    {
        // Create a custom field, should succeed
        CustomFieldCategory customFieldCategory = CustomFieldFixture
            .createCustomFieldCategory();
        customFieldCategory
            .setContextName(CustomFieldFixture.CF_WBS_SCOPE_CONTEXT);
        customFieldCategory = (CustomFieldCategory) saveAndValidate(
            customFieldCategory, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditCustomFieldsAdmin(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should fail
        customFieldCategory.setModified();
        saveAndValidate(customFieldCategory, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditCustomFieldsAdmin(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should succeed
        customFieldCategory.setModified();
        saveAndValidate(customFieldCategory, null, true);
    }

}