/*
 * Created on Jan 31, 2007
 *
 */
package com.ibm.rpm.client.junit.security.testcases.resource;

import com.ibm.rpm.applicationadministration.containers.Geographical;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.GeographicalFixture;

/**
 * @author karim
 *
 */
public class TestGeographicalSecurityLocal extends
        BaseResourceSecurityTestLocal
{
    public void testCreateGeographical() throws Exception
    {
        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationGeographies(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create a Geographical, should fail
        Geographical geographical = GeographicalFixture.createFixture(0, null);
        geographical = (Geographical) saveAndValidate(geographical, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationGeographies(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create a Geographical, should suceed
        geographical = GeographicalFixture.createFixture(0, null);
        geographical = (Geographical) saveAndValidate(geographical, null, true);
    }

    public void testDeleteGeographical() throws Exception
    {
        // Create a Geographical, should suceed
        Geographical geographical = GeographicalFixture.createFixture(0, null);
        geographical = (Geographical) saveAndValidate(geographical, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationGeographies(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should fail
        deleteAndValidate(geographical, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationGeographies(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should succeed
        deleteAndValidate(geographical, true);
    }

    public void testUpdateGeographical() throws Exception
    {
        // Create a Geographical, should suceed
        Geographical geographical = GeographicalFixture.createFixture(0, null);
        geographical = (Geographical) saveAndValidate(geographical, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationGeographies(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should fail
        geographical
            .setDescription(geographical.getDescription() + "_MODIFIED");
        saveAndValidate(geographical, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationGeographies(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should succeed
        geographical
            .setDescription(geographical.getDescription() + "_MODIFIED");
        saveAndValidate(geographical, null, true);
    }

}
