/*
 * Created on Jan 31, 2007
 *
 */
package com.ibm.rpm.client.junit.security.testcases.resource;

import com.ibm.rpm.applicationadministration.containers.PoolDomain;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.PoolDomainFixture;

/**
 * @author karim
 *
 */
public class TestPoolDomainSecurityLocal extends BaseResourceSecurityTestLocal
{
    public void testCreatePoolDomain() throws Exception
    {
        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationPoolDomains(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Create a pool domain, should fail
        PoolDomain poolDomain = PoolDomainFixture.createFixture(0, null);
        poolDomain = (PoolDomain) saveAndValidate(poolDomain, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationPoolDomains(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Create a pool domain, should succeed
        poolDomain = PoolDomainFixture.createFixture(0, null);
        poolDomain = (PoolDomain) saveAndValidate(poolDomain, null, true);
    }

    public void testDeletePoolDomain() throws Exception
    {
        // Create a pool domain, should succeed
        PoolDomain poolDomain = PoolDomainFixture.createFixture(0, null);
        poolDomain = (PoolDomain) saveAndValidate(poolDomain, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationPoolDomains(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should fail
        deleteAndValidate(poolDomain, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationPoolDomains(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Delete the container, should succeed
        deleteAndValidate(poolDomain, true);
    }

    public void testUpdatePoolDomain() throws Exception
    {
        // Create a pool domain, should succeed
        PoolDomain poolDomain = PoolDomainFixture.createFixture(0, null);
        poolDomain = (PoolDomain) saveAndValidate(poolDomain, null, true);

        // Remove the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationPoolDomains(Boolean.FALSE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should fail
        poolDomain.setDescription(poolDomain.getDescription() + "_MODIFIED");
        saveAndValidate(poolDomain, null, false);

        // Give the right to edit
        getCurrentUser().getResourceSecurityRights()
            .setCanEditLocationPoolDomains(Boolean.TRUE);
        saveCurrentUserSecurityRights(null);

        // Update the container, should succeed
        poolDomain.setDescription(poolDomain.getDescription() + "_MODIFIED");
        saveAndValidate(poolDomain, null, true);
    }

}