package com.ibm.rpm.client.junit.security.testcases.role;

import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

public class PlannedDocumentSecurityTestCanAddRemoveLocal extends 
	AbstractPlannedDocumentSecurityTestLocal{
    
	public PlannedDocumentSecurityTestCanAddRemoveLocal(Class securityRoleClass,
            RPMObject containerObject, RPMObject grandparentWorkElement,
            RPMObjectScope scope, String fieldToTest, String flagName)
    {
        super(securityRoleClass, containerObject, grandparentWorkElement,
            scope, fieldToTest, flagName);
    }

	protected void runTest() throws Exception
    {
		runTestForAdd();
		runTestForRemove(); 
    }

	protected void verifyMustFailScenario() throws Exception 
	{
		verifyMustFailScenarioForAdd();
	}

	protected void verifyMustSuccessScenario() throws Exception 
	{
		verifyMustSuccessScenarioForAdd();
	}

	private void runTestForAdd() throws Exception
	{
		super.runTest();
	}

	private void runTestForRemove() throws Exception
	{
		turnOffTestFlag(testObject, testObjectSecurityRole, flagName);
        verifyMustFailScenarioForRemove();
        turnOnTestFlag(testObject, testObjectSecurityRole, flagName);
        verifyMustSuccessScenarioForRemove();
	}

	/**
     * Prepare the container which will be used in the test.
     * 
     * @throws Exception
     */

	protected void prepareTestContainer() throws Exception
    {
        testObject = prepareContainer(testObject, parentObject,
            testObjectScope, securityTestUser, testObjectSecurityRole);
    }
}
