package com.ibm.rpm.client.junit.security.testcases.role;

import com.ibm.rpm.document.containers.DocumentElement;
import com.ibm.rpm.document.containers.NoteMinutes;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

public class PlannedDocumentSecurityTestCanCreateLocal extends
		AbstractPlannedDocumentSecurityTestLocal {

	public PlannedDocumentSecurityTestCanCreateLocal(Class securityRoleClass,
			RPMObject containerObject, RPMObject grandparentWorkElement,
			RPMObjectScope scope, String fieldToTest, String flagName)
	{
		super(securityRoleClass, containerObject, grandparentWorkElement,
				scope, fieldToTest, flagName);
	}
	
	protected void runTest() throws Exception
	{
		setUp();
		flagOff(parentObject, flagName);
		verifyMustFailScenario();
		turnOnTestFlag(grandparentObject, grandparentObjectSecurityRole, flagName);
		verifyMustSuccessScenario();
	}
	
	protected void prepareTestContainer() throws Exception
	{
		testObject = processDocuments((DocumentElement)testObject, parentObject, testObjectScope);
		
		if(NoteMinutes.class.isAssignableFrom(testObject.getClass()))
		{
			((NoteMinutes)testObject).setVisibleAtParent(null);
		}
	}
	
	protected void verifyMustFailScenario() throws Exception 
	{
		super.verifyMustFailScenarioForCreate();
	}

	protected void verifyMustSuccessScenario() throws Exception 
	{
		super.verifyMustSuccessScenarioForCreate();
	}
}
