package com.ibm.rpm.client.junit.security.testcases.role;

import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

public class PlannedDocumentSecurityTestCanLockUnlockLocal extends
		AbstractPlannedDocumentSecurityTestLocal {
	
	public PlannedDocumentSecurityTestCanLockUnlockLocal(Class securityRoleClass,
			RPMObject containerObject, RPMObject grandparentWorkElement,
			RPMObjectScope scope, String fieldToTest, String flagName)
	{
		super(securityRoleClass, containerObject, grandparentWorkElement,
				scope, fieldToTest, flagName);
	}
	
	protected void runTest() throws Exception
    {
		runTestForLock();
		runTestForUnlock(); 
    }

	protected void verifyMustFailScenario() throws Exception 
	{
		verifyMustFailScenarioForLock();
	}

	protected void verifyMustSuccessScenario() throws Exception 
	{
		verifyMustSuccessScenarioForLock();
	}
	
	private void runTestForLock() throws Exception
	{
		super.runTest();
	}
	
	private void runTestForUnlock() throws Exception
	{
		turnOffTestFlag(testObject, testObjectSecurityRole, flagName);
        verifyMustFailScenarioForUnlock();
        turnOnTestFlag(testObject, testObjectSecurityRole, flagName);
        verifyMustSuccessScenarioForUnlock();
	}
}
