package com.ibm.rpm.client.junit.security.testcases.role;

import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.wbs.containers.WorkElement;

public class PlannedScopeElementSecurityTestCanCreateLocal extends
	AbstractPlannedScopeElementSecurityTestLocal {
	
	public PlannedScopeElementSecurityTestCanCreateLocal(Class securityRoleClass,
			RPMObject containerObject, WorkElement grandparentWorkElement,
			RPMObjectScope scope, String fieldToTest, String flagName)
	{
		super(securityRoleClass, containerObject, grandparentWorkElement,
				scope, fieldToTest, flagName);
	}

	protected void runTest() throws Exception
	{
		setUp();
		flagOff(parentObject, flagName);
		verifyMustFailScenario();
		turnOnTestFlag(grandparentObject, grandparentObjectSecurityRole, flagName);
		verifyMustSuccessScenario();
	}
	
	protected void prepareTestContainer() throws Exception
	{
		testObject = processScopeElements((ScopeElement)testObject, (ScopeElement)parentObject, testObjectScope);
	}
	
	protected void verifyMustFailScenario() throws Exception 
	{
		verifyMustFailScenarioForCreate();
	}

	protected void verifyMustSuccessScenario() throws Exception 
	{
		verifyMustSuccessScenarioForCreate();
	}

}
