package com.ibm.rpm.client.junit.security.testcases.role;

import java.util.ArrayList;

import com.ibm.rpm.document.containers.DelDoc;
import com.ibm.rpm.document.containers.Document;
import com.ibm.rpm.document.containers.DocumentFolder;
import com.ibm.rpm.document.containers.NoteMinutes;
import com.ibm.rpm.document.containers.Software;
import com.ibm.rpm.document.containers.UrlDocument;
import com.ibm.rpm.document.containers.WPDoc;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.security.containers.DocumentSecurityRole;
import com.ibm.rpm.security.containers.FolderSecurityRole;
import com.ibm.rpm.security.containers.NotesMinutesSecurityRole;
import com.ibm.rpm.wbs.containers.Proposal;

public class TestDocumentSecurityLocal extends BaseRoleSecurityTestLocal
{
    private DocumentScope testObjectScope;
    
    protected void setUp() throws Exception
    {
        super.setUp();
        testObjectScope = new DocumentScope();
    }

    /************ Keywords ***********/
    public void testCanEditKeywordsWithDelDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
            "Keywords", "CanEditKeywords");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditKeywordsWithDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope,
            "Keywords", "CanEditKeywords");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditKeywordsWithSoftware() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope,
            "Keywords", "CanEditKeywords");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditKeywordsWithUrlDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
            testObjectScope, "Keywords", "CanEditKeywords");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditKeywordsWithWPDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
            "Keywords", "CanEditKeywords");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    /************* DocumentSummary ******************/
    public void testCanEditDocumentSummaryWithDelDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
            "Summary", "CanEditDocumentSummary");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditDocumentSummaryWithDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope,
            "Summary", "CanEditDocumentSummary");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditDocumentSummaryWithSoftware() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope,
            "Summary", "CanEditDocumentSummary");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditDocumentSummaryWithUrlDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
            testObjectScope, "Summary", "CanEditDocumentSummary");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditDocumentSummaryWithWPDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
            "Summary", "CanEditDocumentSummary");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    /******************* ReferenceNumber *******************/
    public void testCanEditReferenceNumberWithDelDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanEditReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditReferenceNumberWithDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanEditReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditReferenceNumberWithSoftware() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanEditReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditReferenceNumberWithUrlDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
            testObjectScope, "ReferenceNumber", "CanEditReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditReferenceNumberWithWPDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanEditReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    /********************** Description ***********************/
    public void testCanEditDescriptionWithNotesMinutes() throws Exception
    {
        testObjectScope.setRtfAssignments(true);
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
            testObjectScope, "RtfAssignments", "CanEditDescription");
        test.runTest();
    }

    /********************** VisibleAtParent **********************/
    public void testCanEditVisibleAtParentWithDelDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
            "VisibleAtParent", "CanEditVisibleAtParent");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditVisibleAtParentWithDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope,
            "VisibleAtParent", "CanEditVisibleAtParent");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditVisibleAtParentWithSoftware() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope,
            "VisibleAtParent", "CanEditVisibleAtParent");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditVisibleAtParentWithUrlDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
            testObjectScope, "VisibleAtParent", "CanEditVisibleAtParent");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditVisibleAtParentWithWPDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
            "VisibleAtParent", "CanEditVisibleAtParent");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanEditVisibleAtParentWithNotesMinutes() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
            testObjectScope, "VisibleAtParent", "CanEditVisibleAtParent");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.testObjectRequiredOffFlags = new ArrayList();
        test.testObjectRequiredOffFlags.add("CanEditNoteMinutes");
        test.runTest();
    }

    /*********************** Rename **********************/
    public void testCanRenameWithDelDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
            "Name", "CanRename");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
//        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
//        test.parentRequiredOffFlags = new ArrayList();
//        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanRenameWithDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope,
            "Name", "CanRename");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
        test.parentRequiredOffFlags = new ArrayList();
        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanRenameWithSoftware() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope,
            "Name", "CanRename");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
        test.parentRequiredOffFlags = new ArrayList();
        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanRenameWithUrlDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
            testObjectScope, "Name", "CanRename");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
        test.parentRequiredOffFlags = new ArrayList();
        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanRenameWithWPDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
            "Name", "CanRename");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
        test.parentRequiredOffFlags = new ArrayList();
        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanRenameWithNotesMinutes() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
            testObjectScope, "Name", "CanRename");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
//        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
//        test.parentRequiredOffFlags = new ArrayList();
//        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanEditNoteMinutes() throws Exception
    {
        PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
            NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
            testObjectScope, "VisibleAtParent", "CanEditNoteMinutes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }
    
    /******************** State ***********************/
    public void testCanEditStateWithDelDoc() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new DelDoc(),
				new Proposal(), testObjectScope, "state",
				"CanEditState");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }

    public void testCanEditStateWithDocument() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new Document(),
				new Proposal(), testObjectScope, "state",
				"CanEditState");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditStateWithSoftware() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new Software(),
				new Proposal(), testObjectScope, "state",
				"CanEditState");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditStateWithUrlDocument() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new UrlDocument(),
				new Proposal(), testObjectScope, "state",
				"CanEditState");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditStateWithWPDoc() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new WPDoc(),
				new Proposal(), testObjectScope, "state",
				"CanEditState");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditStateWithNoteMinutes() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
				NotesMinutesSecurityRole.class, new NoteMinutes(),
				new Proposal(), testObjectScope, "state",
				"CanEditState");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    /************************* Rank ************************************/
    public void testCanEditRankWithNoteMinutes() throws Exception
    {
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
				NotesMinutesSecurityRole.class, new NoteMinutes(),
				new Proposal(), testObjectScope, "rank",
				"CanEditRank");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    /******************************** ElementSecurityType ************************/
    public void testCanEditElementSecurityWithDelDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new DelDoc(),
				new Proposal(), testObjectScope, "ElementSecurityType",
				"CanEditElementSecurity");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditElementSecurityWithDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new Document(),
				new Proposal(), testObjectScope, "ElementSecurityType",
				"CanEditElementSecurity");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditElementSecurityWithSoftware() throws Exception
    {
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new Software(),
				new Proposal(), testObjectScope, "ElementSecurityType",
				"CanEditElementSecurity");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditElementSecurityWithUrlDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new UrlDocument(),
				new Proposal(), testObjectScope, "ElementSecurityType",
				"CanEditElementSecurity");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditElementSecurityWithWPDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new WPDoc(),
				new Proposal(), testObjectScope, "ElementSecurityType",
				"CanEditElementSecurity");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditElementSecurityWithNoteMinutes() throws Exception
    {
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
				NotesMinutesSecurityRole.class, new NoteMinutes(),
				new Proposal(), testObjectScope, "ElementSecurityType",
				"CanEditElementSecurity");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    /************************* Priority ****************************/
    public void testCanEditPriorityWithNoteMinutes() throws Exception
    {
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
				NotesMinutesSecurityRole.class, new NoteMinutes(),
				new Proposal(), testObjectScope, "Priority",
				"CanEditPriority");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    /************************ Attributes ***********************/
    public void testCanEditAttributesWithDelDoc() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new DelDoc(),
				new Proposal(), testObjectScope, "AttributeAssignments",
				"canEditAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditAttributesWithDocument() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new Document(),
				new Proposal(), testObjectScope, "AttributeAssignments",
				"canEditAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditAttributesWithSoftware() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new Software(),
				new Proposal(), testObjectScope, "AttributeAssignments",
				"canEditAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditAttributesWithUrlDocument() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new UrlDocument(),
				new Proposal(), testObjectScope, "AttributeAssignments",
				"canEditAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditAttributesWithWPDoc() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
    			DocumentSecurityRole.class, new WPDoc(),
				new Proposal(), testObjectScope, "AttributeAssignments",
				"canEditAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanEditAttributesWithNoteMinutes() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedDocumentSecurityTestCanEditLocal test = new PlannedDocumentSecurityTestCanEditLocal(
				NotesMinutesSecurityRole.class, new NoteMinutes(),
				new Proposal(), testObjectScope, "AttributeAssignments",
				"canEditAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    /************************* ReferenceNumber *************************/
    public void testCanViewReferenceNumberWithDelDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanViewReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanViewReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithSoftware() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanViewReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithUrlDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
            testObjectScope, "ReferenceNumber", "CanViewReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithWPDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanViewReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanViewReferenceNumber");
        test.runTest();
    }

    /************************* Priority *******************************/
    public void testCanViewPriorityWithNoteMinutes() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
            testObjectScope, "Priority", "CanViewPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    /************************ Keywords ********************************/
    public void testCanViewKeywordsWithDelDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
            "Keywords", "CanViewKeywords");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewKeywordsWithDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope,
            "Keywords", "CanViewKeywords");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewKeywordsWithSoftware() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope,
            "Keywords", "CanViewKeywords");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewKeywordsWithUrlDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
            testObjectScope, "Keywords", "CanViewKeywords");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewKeywordsWithWPDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
            "Keywords", "CanViewKeywords");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    /**************************** DocumentSummary *******************************/
    public void testCanViewDocumentSummaryWithDelDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
            "Summary", "CanViewDocumentSummary");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewDocumentSummaryWithDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope,
            "Summary", "CanViewDocumentSummary");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewDocumentSummaryWithSoftware() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope,
            "Summary", "CanViewDocumentSummary");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewDocumentSummaryWithUrlDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
            testObjectScope, "Summary", "CanViewDocumentSummary");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewDocumentSummaryWithWPDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
            "Summary", "CanViewDocumentSummary");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    /****************************** Description *******************************/
    public void testCanViewDescriptionWithNotesMinutes() throws Exception
    {
        testObjectScope.setRtfAssignments(true);
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
            testObjectScope, "RtfAssignments", "CanViewDescription");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    /*********** VisibleAtParent *****************/
    
    public void testCanViewVisibleAtParentWithDelDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
            "VisibleAtParent", "CanViewVisibleAtParent");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewVisibleAtParentWithDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope,
            "VisibleAtParent", "CanViewVisibleAtParent");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewVisibleAtParentWithSoftware() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope,
            "VisibleAtParent", "CanViewVisibleAtParent");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewVisibleAtParentWithUrlDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
            testObjectScope, "VisibleAtParent", "CanViewVisibleAtParent");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewVisibleAtParentWithWPDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
            "VisibleAtParent", "CanViewVisibleAtParent");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewVisibleAtParentWithNoteMinutes() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
            testObjectScope, "VisibleAtParent", "CanViewVisibleAtParent");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.testObjectRequiredOffFlags = new ArrayList();
        test.testObjectRequiredOffFlags.add("CanViewNoteMinutes");
        test.runTest();
    }

    public void testCanViewNoteMinutes() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
            testObjectScope, "VisibleAtParent", "CanViewNoteMinutes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    /******************************** ElementSecurity ************************/
    public void testCanViewElementSecurityWithDelDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewElementSecurityWithDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewElementSecurityWithSoftware() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewElementSecurityWithUrlDocument() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
            testObjectScope, "ElementSecurityType", "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewElementSecurityWithWPDoc() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewElementSecurityWithNoteMinutes() throws Exception
    {
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
            testObjectScope, "ElementSecurityType", "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    /**************************** DocumentProperties ********************************/
    public void testCanViewDocumentPropertiesWithDelDoc() throws Exception
    {
        testObjectScope.setAttributeAssignments(true);
        ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("VisibleAtParent");
        fieldsToTest.add("ElementSecurityType");
        fieldsToTest.add("Keywords");
        fieldsToTest.add("Summary");
        fieldsToTest.add("AttributeAssignments");
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewDocumentProperties");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewDocumentPropertiesWithDocument() throws Exception
    {
        testObjectScope.setAttributeAssignments(true);
        ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("VisibleAtParent");
        fieldsToTest.add("ElementSecurityType");
        fieldsToTest.add("Keywords");
        fieldsToTest.add("Summary");
        fieldsToTest.add("AttributeAssignments");
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewDocumentProperties");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewDocumentPropertiesWithSoftware() throws Exception
    {
        testObjectScope.setAttributeAssignments(true);
        ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("VisibleAtParent");
        fieldsToTest.add("ElementSecurityType");
        fieldsToTest.add("Keywords");
        fieldsToTest.add("Summary");
        fieldsToTest.add("AttributeAssignments");
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewDocumentProperties");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewDocumentPropertiesWithUrlDocument() throws Exception
    {
        testObjectScope.setAttributeAssignments(true);
        ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("VisibleAtParent");
        fieldsToTest.add("ElementSecurityType");
        fieldsToTest.add("Keywords");
        fieldsToTest.add("Summary");
        fieldsToTest.add("AttributeAssignments");
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
            testObjectScope, fieldsToTest, "CanViewDocumentProperties");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanViewDocumentPropertiesWithWPDoc() throws Exception
    {
        testObjectScope.setAttributeAssignments(true);
        ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("VisibleAtParent");
        fieldsToTest.add("ElementSecurityType");
        fieldsToTest.add("Keywords");
        fieldsToTest.add("Summary");
        fieldsToTest.add("AttributeAssignments");
        PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
            DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewDocumentProperties");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }
    
    /********************** Rank *********************/
    public void testCanViewRankWithNoteMinutes() throws Exception
    {
    	PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
				NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
				testObjectScope, "Rank", "CanViewRank");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    /******************** Attributes ******************/
    public void testCanViewAttributesWithDelDoc() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
		PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
				DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
				"AttributeAssignments", "canViewAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanViewAttributesWithDocument() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
		PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
				DocumentSecurityRole.class, new Document(), new Proposal(),
				testObjectScope, "AttributeAssignments", "canViewAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanViewAttributesWithSoftware() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
		PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
				DocumentSecurityRole.class, new Software(), new Proposal(),
				testObjectScope, "AttributeAssignments", "canViewAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanViewAttributesWithUrlDocument() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
		PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
				DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
				testObjectScope, "AttributeAssignments", "canViewAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanViewAttributesWithWPDoc() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
		PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
				DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
				"AttributeAssignments", "canViewAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    public void testCanViewAttributesWithNoteMinutes() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
		PlannedDocumentSecurityTestCanViewLocal test = new PlannedDocumentSecurityTestCanViewLocal(
				NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
				testObjectScope, "AttributeAssignments", "canViewAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }
    
    // ============================== CAN CREATE =================================
    
    public void testCanCreateDelDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanCreateLocal test = new PlannedDocumentSecurityTestCanCreateLocal(
    			DocumentSecurityRole.class, new DelDoc(), new Proposal(),
    			testObjectScope,"ID","CanCreateDocuments");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanCreateDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanCreateLocal test = new PlannedDocumentSecurityTestCanCreateLocal(
    			DocumentSecurityRole.class, new Document(), new Proposal(),
    			testObjectScope,"ID","CanCreateDocuments");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanCreateSoftware() throws Exception
    {
    	PlannedDocumentSecurityTestCanCreateLocal test = new PlannedDocumentSecurityTestCanCreateLocal(
    			DocumentSecurityRole.class, new Software(), new Proposal(),
    			testObjectScope,"ID","CanCreateDocuments");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanCreateUrlDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanCreateLocal test = new PlannedDocumentSecurityTestCanCreateLocal(
    			DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
    			testObjectScope,"ID","CanCreateDocuments");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanCreateWPDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanCreateLocal test = new PlannedDocumentSecurityTestCanCreateLocal(
    			DocumentSecurityRole.class, new WPDoc(), new Proposal(),
    			testObjectScope,"ID","CanCreateDocuments");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanCreateNoteMinutes() throws Exception
    {
    	PlannedDocumentSecurityTestCanCreateLocal test = new PlannedDocumentSecurityTestCanCreateLocal(
    			NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
    			testObjectScope,"ID","CanCreateNoteMinutes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanCreateDocumentFolder() throws Exception
    {
    	PlannedDocumentSecurityTestCanCreateLocal test = new PlannedDocumentSecurityTestCanCreateLocal(
    			FolderSecurityRole.class, new DocumentFolder(), new Proposal(),
    			testObjectScope,"ID","CanCreateDocumentsFolders");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    // ============================ CAN LOCK | CAN UNLOCK ==============================
    
    public void testCanLockUnlockDelDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanLockUnlockLocal test = new PlannedDocumentSecurityTestCanLockUnlockLocal(
    			DocumentSecurityRole.class, new DelDoc(), new Proposal(),
    			testObjectScope,"Locked","CanLockUnlock");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanLockUnlockDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanLockUnlockLocal test = new PlannedDocumentSecurityTestCanLockUnlockLocal(
    			DocumentSecurityRole.class, new Document(), new Proposal(),
    			testObjectScope,"Locked","CanLockUnlock");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanLockUnlockSoftware() throws Exception
    {
    	PlannedDocumentSecurityTestCanLockUnlockLocal test = new PlannedDocumentSecurityTestCanLockUnlockLocal(
    			DocumentSecurityRole.class, new Software(), new Proposal(),
    			testObjectScope,"Locked","CanLockUnlock");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanLockUnlockUrlDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanLockUnlockLocal test = new PlannedDocumentSecurityTestCanLockUnlockLocal(
    			DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
    			testObjectScope,"Locked","CanLockUnlock");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanLockUnlockWPDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanLockUnlockLocal test = new PlannedDocumentSecurityTestCanLockUnlockLocal(
    			DocumentSecurityRole.class, new WPDoc(), new Proposal(),
    			testObjectScope,"Locked","CanLockUnlock");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanLockUnlockNoteMinutes() throws Exception
    {
    	PlannedDocumentSecurityTestCanLockUnlockLocal test = new PlannedDocumentSecurityTestCanLockUnlockLocal(
    			NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
    			testObjectScope,"Locked","CanLockUnlock");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    // ========================= CAN CHECKOUT ==========================================
    public void testCanCheckOutDelDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanCheckoutLocal test = new PlannedDocumentSecurityTestCanCheckoutLocal(
    			DocumentSecurityRole.class, new DelDoc(), new Proposal(),
    			testObjectScope,"DocumentStatus","canCheckOutOrCheckOutTo");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanCheckOutDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanCheckoutLocal test = new PlannedDocumentSecurityTestCanCheckoutLocal(
    			DocumentSecurityRole.class, new Document(), new Proposal(),
    			testObjectScope,"DocumentStatus","canCheckOutOrCheckOutTo");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanCheckOutSoftware() throws Exception
    {
    	PlannedDocumentSecurityTestCanCheckoutLocal test = new PlannedDocumentSecurityTestCanCheckoutLocal(
    			DocumentSecurityRole.class, new Software(), new Proposal(),
    			testObjectScope,"DocumentStatus","canCheckOutOrCheckOutTo");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanCheckOutUrlDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanCheckoutLocal test = new PlannedDocumentSecurityTestCanCheckoutLocal(
    			DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
    			testObjectScope,"DocumentStatus","canCheckOutOrCheckOutTo");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanCheckOutWPDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanCheckoutLocal test = new PlannedDocumentSecurityTestCanCheckoutLocal(
    			DocumentSecurityRole.class, new WPDoc(), new Proposal(),
    			testObjectScope,"DocumentStatus","canCheckOutOrCheckOutTo");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    //============================= CAN ASSIGN ====================================
    
    public void testCanAssignParticipantToDelDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanAssignLocal test = new PlannedDocumentSecurityTestCanAssignLocal(
    			DocumentSecurityRole.class, new DelDoc(), new Proposal(),
    			testObjectScope,"ResourceAssignments","CanAssignParticipant");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanAssignParticipantToDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanAssignLocal test = new PlannedDocumentSecurityTestCanAssignLocal(
    			DocumentSecurityRole.class, new Document(), new Proposal(),
    			testObjectScope,"ResourceAssignments","CanAssignParticipant");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanAssignParticipantToSoftware() throws Exception
    {
    	PlannedDocumentSecurityTestCanAssignLocal test = new PlannedDocumentSecurityTestCanAssignLocal(
    			DocumentSecurityRole.class, new Software(), new Proposal(),
    			testObjectScope,"ResourceAssignments","CanAssignParticipant");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanAssignParticipantToUrlDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanAssignLocal test = new PlannedDocumentSecurityTestCanAssignLocal(
    			DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
    			testObjectScope,"ResourceAssignments","CanAssignParticipant");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanAssignParticipantToWPDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanAssignLocal test = new PlannedDocumentSecurityTestCanAssignLocal(
    			DocumentSecurityRole.class, new WPDoc(), new Proposal(),
    			testObjectScope,"ResourceAssignments","CanAssignParticipant");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanAssignParticipantToNoteMinutes() throws Exception
    {
    	PlannedDocumentSecurityTestCanAssignLocal test = new PlannedDocumentSecurityTestCanAssignLocal(
    			NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
    			testObjectScope,"ResourceAssignments","CanAssignParticipant");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    //==================================== CAN REMOVE =================================
    
    public void testCanRemoveParticipantToDelDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanRemoveLocal test = new PlannedDocumentSecurityTestCanRemoveLocal(
    			DocumentSecurityRole.class, new DelDoc(), new Proposal(),
    			testObjectScope,"ResourceAssignments","CanRemoveParticipant");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanRemoveParticipantToDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanRemoveLocal test = new PlannedDocumentSecurityTestCanRemoveLocal(
    			DocumentSecurityRole.class, new Document(), new Proposal(),
    			testObjectScope,"ResourceAssignments","CanRemoveParticipant");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanRemoveParticipantToSoftware() throws Exception
    {
    	PlannedDocumentSecurityTestCanRemoveLocal test = new PlannedDocumentSecurityTestCanRemoveLocal(
    			DocumentSecurityRole.class, new Software(), new Proposal(),
    			testObjectScope,"ResourceAssignments","CanRemoveParticipant");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanRemoveParticipantToUrlDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanRemoveLocal test = new PlannedDocumentSecurityTestCanRemoveLocal(
    			DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
    			testObjectScope,"ResourceAssignments","CanRemoveParticipant");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanRemoveParticipantToWPDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanRemoveLocal test = new PlannedDocumentSecurityTestCanRemoveLocal(
    			DocumentSecurityRole.class, new WPDoc(), new Proposal(),
    			testObjectScope,"ResourceAssignments","CanRemoveParticipant");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    public void testCanRemoveParticipantToNoteMinutes() throws Exception
    {
    	PlannedDocumentSecurityTestCanRemoveLocal test = new PlannedDocumentSecurityTestCanRemoveLocal(
    			NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(),
    			testObjectScope,"ResourceAssignments","CanRemoveParticipant");
    	test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
    	test.runTest();
    }
    
    /******************* AddRemoveAttributes ******************/

    public void testCanAddRemoveAttributesWithNoteMinutes() throws Exception
    {
    	PlannedDocumentSecurityTestCanAddRemoveLocal test = new PlannedDocumentSecurityTestCanAddRemoveLocal(
				NoteMinutes.class, new NoteMinutes(), new Proposal(),
				testObjectScope, "AttributeAssignments", "CanAddRemoveAttributes");
		test.grandparentRequiredOffFlags = new ArrayList();
		test.grandparentRequiredOffFlags.add("AllDocumentPermissionsGranted");
		test.runTest();
    }

    public void testCanAddRemoveAttributesWithDelDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanAddRemoveLocal test = new PlannedDocumentSecurityTestCanAddRemoveLocal(
            DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanAddRemoveAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanAddRemoveLocal test = new PlannedDocumentSecurityTestCanAddRemoveLocal(
            DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanAddRemoveAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithSoftware() throws Exception
    {
    	PlannedDocumentSecurityTestCanAddRemoveLocal test = new PlannedDocumentSecurityTestCanAddRemoveLocal(
            DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanAddRemoveAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithUrlDocument() throws Exception
    {
    	PlannedDocumentSecurityTestCanAddRemoveLocal test = new PlannedDocumentSecurityTestCanAddRemoveLocal(
            DocumentSecurityRole.class, new UrlDocument(), new Proposal(),
            testObjectScope, "AttributeAssignments", "CanAddRemoveAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithWPDoc() throws Exception
    {
    	PlannedDocumentSecurityTestCanAddRemoveLocal test = new PlannedDocumentSecurityTestCanAddRemoveLocal(
            DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanAddRemoveAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }
    
    // ====================================== CAN DELETE =================================
    public void testCanDeleteWithNoteMinutes() throws Exception
    {
  	  PlannedDocumentSecurityTestCanDeleteLocal test = new PlannedDocumentSecurityTestCanDeleteLocal(
  			NotesMinutesSecurityRole.class, new NoteMinutes(), new Proposal(), testObjectScope, "Deleted","CanDelete");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }
    public void testCanDeleteWithWPDoc() throws Exception
    {
  	  PlannedDocumentSecurityTestCanDeleteLocal test = new PlannedDocumentSecurityTestCanDeleteLocal(
  			DocumentSecurityRole.class, new WPDoc(), new Proposal(), testObjectScope, "Deleted","CanDelete");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }
    public void testCanDeleteWithDelDoc() throws Exception
    {
  	  PlannedDocumentSecurityTestCanDeleteLocal test = new PlannedDocumentSecurityTestCanDeleteLocal(
  			DocumentSecurityRole.class, new DelDoc(), new Proposal(), testObjectScope, "Deleted","CanDelete");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }
    public void testCanDeleteWithDocument() throws Exception
    {
  	  PlannedDocumentSecurityTestCanDeleteLocal test = new PlannedDocumentSecurityTestCanDeleteLocal(
  			DocumentSecurityRole.class, new Document(), new Proposal(), testObjectScope, "Deleted","CanDelete");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllDocumentPermissionsGranted");
        test.runTest();
    }    
    public void testCanDeleteWithSoftware() throws Exception
    {
    	  PlannedDocumentSecurityTestCanDeleteLocal test = new PlannedDocumentSecurityTestCanDeleteLocal(
    			  DocumentSecurityRole.class, new Software(), new Proposal(), testObjectScope, "Deleted","CanDelete");
          test.grandparentRequiredOffFlags = new ArrayList();
          test.grandparentRequiredOffFlags
              .add("AllDocumentPermissionsGranted");
          test.runTest();
    }    
    public void testCanDeleteWithUrlDocument() throws Exception
    {
      	  PlannedDocumentSecurityTestCanDeleteLocal test = new PlannedDocumentSecurityTestCanDeleteLocal(
      			DocumentSecurityRole.class, new UrlDocument(), new Proposal(), testObjectScope, "Deleted","CanDelete");
            test.grandparentRequiredOffFlags = new ArrayList();
            test.grandparentRequiredOffFlags
                .add("AllDocumentPermissionsGranted");
            test.runTest();
     }
}
