package com.ibm.rpm.client.junit.security.testcases.role;

import java.util.ArrayList;

import com.ibm.rpm.applicationadministration.scope.CalendarScope;
import com.ibm.rpm.resource.scope.ResourceScope;
import com.ibm.rpm.scopemanagement.containers.Action;
import com.ibm.rpm.scopemanagement.containers.ChangeRequest;
import com.ibm.rpm.scopemanagement.containers.Defect;
import com.ibm.rpm.scopemanagement.containers.Issue;
import com.ibm.rpm.scopemanagement.containers.Requirement;
import com.ibm.rpm.scopemanagement.containers.Risk;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.containers.ServiceRequest;
import com.ibm.rpm.scopemanagement.scope.MitigationFactorScope;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.security.containers.ActionItemSecurityRole;
import com.ibm.rpm.security.containers.ChangeRequestSecurityRole;
import com.ibm.rpm.security.containers.DefectSecurityRole;
import com.ibm.rpm.security.containers.FolderSecurityRole;
import com.ibm.rpm.security.containers.IssueSecurityRole;
import com.ibm.rpm.security.containers.RequirementSecurityRole;
import com.ibm.rpm.security.containers.RiskSecurityRole;
import com.ibm.rpm.security.containers.ServiceRequestSecurityRole;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.scope.ResourceTaskAssignmentScope;
import com.ibm.rpm.wbs.scope.TaskAssignmentScope;

public class TestScopeElementSecurityRoleLocal extends BaseRoleSecurityTestLocal
{
    private ScopeElementScope testObjectScope;

    protected void setUp() throws Exception
    {
        super.setUp();
        testObjectScope = new ScopeElementScope();
    }

    public void testCanRenameWithDefect() throws Exception
    {
        PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "Name", "CanRenameScopeElements");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
        test.parentRequiredOffFlags = new ArrayList();
        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanRenameWithActionItem() throws Exception
    {
        PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "Name", "CanRenameScopeElements");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
        test.parentRequiredOffFlags = new ArrayList();
        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanRenameWithRequirement() throws Exception
    {
        PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(),
            testObjectScope, "Name", "CanRenameScopeElements");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
        test.parentRequiredOffFlags = new ArrayList();
        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanRenameWithServiceRequest() throws Exception
    {
        PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(),
            new Proposal(), testObjectScope, "Name", "CanRenameScopeElements");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
        test.parentRequiredOffFlags = new ArrayList();
        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanRenameWithRisk() throws Exception
    {
        PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope, "Name",
            "CanRenameScopeElements");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
        test.parentRequiredOffFlags = new ArrayList();
        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanRenameWithChangeRequest() throws Exception
    {
        PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(),
            new Proposal(), testObjectScope, "Name", "CanRenameScopeElements");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
        test.parentRequiredOffFlags = new ArrayList();
        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanRenameWithIssue() throws Exception
    {
        PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "Name", "CanRenameScopeElements");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanRenameWBSItems");
        test.parentRequiredOffFlags = new ArrayList();
        test.parentRequiredOffFlags.add("CanRenameFolders");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithDefect() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanViewReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithActionItem() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanViewReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithRequirement() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(),
            testObjectScope, "ReferenceNumber", "CanViewReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithServiceRequest() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(),
            new Proposal(), testObjectScope, "ReferenceNumber", "CanViewReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithRisk() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanViewReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithChangeRequest() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(),
            new Proposal(), testObjectScope, "ReferenceNumber", "CanViewReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithIssue() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanViewReferenceNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.grandparentRequiredOffFlags.add("CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewPriorityWithDefect() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "Priority", "CanViewPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewPriorityWithActionItem() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "Priority", "CanViewPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewPriorityWithRequirement() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(),
            testObjectScope, "Priority", "CanViewPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewPriorityWithServiceRequest() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(),
            new Proposal(), testObjectScope, "Priority", "CanViewPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewPriorityWithRisk() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "Priority", "CanViewPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewPriorityWithChangeRequest() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(),
            new Proposal(), testObjectScope, "Priority", "CanViewPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewPriorityWithIssue() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "Priority", "CanViewPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewOrderOfMagnitudeCostBenefitsWithDefect()
            throws Exception
    {
        testObjectScope.setOrderOfMagnitudeCostBenefits(true);
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "OrderOfMagnitudeCostBenefits", "CanViewOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewOrderOfMagnitudeCostBenefitsWithActionItem()
            throws Exception
    {
        testObjectScope.setOrderOfMagnitudeCostBenefits(true);
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "OrderOfMagnitudeCostBenefits", "CanViewOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewOrderOfMagnitudeCostBenefitsWithRequirement()
            throws Exception
    {
        testObjectScope.setOrderOfMagnitudeCostBenefits(true);
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(),
            testObjectScope, "OrderOfMagnitudeCostBenefits", "CanViewOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewOrderOfMagnitudeCostBenefitsWithServiceRequest()
            throws Exception
    {
        testObjectScope.setOrderOfMagnitudeCostBenefits(true);
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(),
            new Proposal(), testObjectScope, "OrderOfMagnitudeCostBenefits", "CanViewOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewOrderOfMagnitudeCostBenefitsWithRisk()
            throws Exception
    {
        testObjectScope.setOrderOfMagnitudeCostBenefits(true);
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "OrderOfMagnitudeCostBenefits", "CanViewOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewOrderOfMagnitudeCostBenefitsWithChangeRequest()
            throws Exception
    {
        testObjectScope.setOrderOfMagnitudeCostBenefits(true);
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(),
            new Proposal(), testObjectScope, "OrderOfMagnitudeCostBenefits", "CanViewOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewOrderOfMagnitudeCostBenefitsWithIssue()
            throws Exception
    {
        testObjectScope.setOrderOfMagnitudeCostBenefits(true);
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "OrderOfMagnitudeCostBenefits", "CanViewOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewElementSecurityWithDefect() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewElementSecurityWithActionItem() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewElementSecurityWithRequirement() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(),
            testObjectScope, "ElementSecurityType", "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewElementSecurityWithServiceRequest() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(),
            new Proposal(), testObjectScope, "ElementSecurityType",
            "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewElementSecurityWithRisk() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewElementSecurityWithChangeRequest() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(),
            new Proposal(), testObjectScope, "ElementSecurityType",
            "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanViewElementSecurityWithIssue() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanViewElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewApprovedByWithIssue() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ApprovedByName");
        fieldsToTest.add("ApprovedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewApprovedByWithAction() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ApprovedByName");
        fieldsToTest.add("ApprovedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewApprovedByWithDefect() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ApprovedByName");
        fieldsToTest.add("ApprovedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewApprovedByWithRequirement() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ApprovedByName");
        fieldsToTest.add("ApprovedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewApprovedByWithServiceRequest() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ApprovedByName");
        fieldsToTest.add("ApprovedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewApprovedByWithChangeRequest() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ApprovedByName");
        fieldsToTest.add("ApprovedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewApprovedByWithRisk() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ApprovedByName");
        fieldsToTest.add("ApprovedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    //ApprovedCostBenefits Field does not exist for Issue and Risk
   
    public void testCanViewApprovedCostBenefitsWithAction() throws Exception
    {
    	testObjectScope.setApprovedCostBenefits(true);
    	PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
    			ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ApprovedCostBenefits", "CanViewApprovedCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewApprovedCostBenefitsWithDefect() throws Exception
    {
    	testObjectScope.setApprovedCostBenefits(true);
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ApprovedCostBenefits", "CanViewApprovedCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewApprovedCostBenefitsWithRequirement() throws Exception
    {
    	testObjectScope.setApprovedCostBenefits(true);
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "ApprovedCostBenefits", "CanViewApprovedCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewApprovedCostBenefitsWithServiceRequest() throws Exception
    {
    	testObjectScope.setApprovedCostBenefits(true);
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "ApprovedCostBenefits", "CanViewApprovedCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewApprovedCostBenefitsWithChangeRequest() throws Exception
    {
    	testObjectScope.setApprovedCostBenefits(true);
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "ApprovedCostBenefits", "CanViewApprovedCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    
    //-------------------------------------------------------------------------------------------------------
    public void testCanViewClosedByWithIssue() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ClosedByName");
        fieldsToTest.add("ClosedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewClosedByWithAction() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ClosedByName");
        fieldsToTest.add("ClosedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewClosedByWithDefect() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ClosedByName");
        fieldsToTest.add("ClosedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewClosedByWithRequirement() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ClosedByName");
        fieldsToTest.add("ClosedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewClosedByWithServiceRequest() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ClosedByName");
        fieldsToTest.add("ClosedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewClosedByWithChangeRequest() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ClosedByName");
        fieldsToTest.add("ClosedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewClosedByWithRisk() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ClosedByName");
        fieldsToTest.add("ClosedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    //-------------------------------------------------------------------------------------------------------
    public void testCanViewProposedByWithIssue() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ProposedByName");
        fieldsToTest.add("ProposedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewProposedByWithAction() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ProposedByName");
        fieldsToTest.add("ProposedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewProposedByWithDefect() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ProposedByName");
        fieldsToTest.add("ProposedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewProposedByWithRequirement() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ProposedByName");
        fieldsToTest.add("ProposedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewProposedByWithServiceRequest() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ProposedByName");
        fieldsToTest.add("ProposedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewProposedByWithChangeRequest() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ProposedByName");
        fieldsToTest.add("ProposedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewProposedByWithRisk() throws Exception
    {
    	ArrayList fieldsToTest = new ArrayList();
        fieldsToTest.add("ProposedByName");
        fieldsToTest.add("ProposedByDate");
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            fieldsToTest, "CanViewProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    //-------------------------------------------------------------------------------------------------------
    public void testCanViewExternalReferenceWithIssue() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanViewExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewExternalReferenceWithAction() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanViewExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewExternalReferenceWithDefect() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanViewExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewExternalReferenceWithRequirement() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanViewExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewExternalReferenceWithServiceRequest() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanViewExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewExternalReferenceWithChangeRequest() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanViewExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewExternalReferenceWithRisk() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanViewExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    //-------------------------------------------------------------------------------------------------------
    public void testCanViewTargetDateWithIssue() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "TargetDate", "CanViewTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewTargetDateWithAction() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "TargetDate", "CanViewTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewTargetDateWithDefect() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "TargetDate", "CanViewTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewTargetDateWithRequirement() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "TargetDate", "CanViewTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewTargetDateWithServiceRequest() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "TargetDate", "CanViewTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewTargetDateWithChangeRequest() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        		ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "TargetDate", "CanViewTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewTargetDateWithRisk() throws Exception
    {
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "TargetDate", "CanViewTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditApprovedByDateWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ApprovedByDate", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditApprovedByDateWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "ApprovedByDate", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedByDateWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "ApprovedByDate", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedByDateWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "ApprovedByDate", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedByDateWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ApprovedByDate", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedByDateWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "ApprovedByDate", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedByDateWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "ApprovedByDate", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditApprovedByNameWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ApprovedByName", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditApprovedByNameWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "ApprovedByName", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedByNameWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "ApprovedByName", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedByNameWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "ApprovedByName", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedByNameWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ApprovedByName", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedByNameWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "ApprovedByName", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedByNameWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "ApprovedByName", "CanEditApprovedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
//  ApprovedCostBenefits Field does not exist for Issue and Risk
    public void testCanEditApprovedCostBenefitsWithDefect() throws Exception
    {
    	testObjectScope.setApprovedCostBenefits(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ApprovedCostBenefits", "CanEditApprovedCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditApprovedCostBenefitsWithRequirement() throws Exception
    {
    	testObjectScope.setApprovedCostBenefits(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "ApprovedCostBenefits", "CanEditApprovedCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedCostBenefitsWithAction() throws Exception
    {
    	testObjectScope.setApprovedCostBenefits(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ApprovedCostBenefits", "CanEditApprovedCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedCostBenefitsWithChangeRequest() throws Exception
    {
    	testObjectScope.setApprovedCostBenefits(true);
    	PlannedScopeElementSecurityTestCanEditLocal  test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "ApprovedCostBenefits", "CanEditApprovedCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }    
    public void testCanEditApprovedCostBenefitsWithServiceRequest() throws Exception
    {
    	testObjectScope.setApprovedCostBenefits(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "ApprovedCostBenefits", "CanEditApprovedCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditClosedByNameWithDefect() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ClosedByName", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditClosedByNameWithIssue() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "ClosedByName", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditClosedByNameWithAction() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ClosedByName", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditClosedByNameWithRisk() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "ClosedByName", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditClosedByNameWithRequirement() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "ClosedByName", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditClosedByNameWithServiceRequest() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "ClosedByName", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditClosedByNameWithChangeRequest() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "ClosedByName", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditClosedByDateWithDefect() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ClosedByDate", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditClosedByDateWithIssue() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "ClosedByDate", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditClosedByDateWithAction() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ClosedByDate", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditClosedByDateWithRisk() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "ClosedByDate", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditClosedByDateWithRequirement() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "ClosedByDate", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditClosedByDateWithServiceRequest() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "ClosedByDate", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditClosedByDateWithChangeRequest() throws Exception
    {
    	testObjectScope.setClosedByName(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "ClosedByDate", "CanEditClosedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditElementSecurityWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanEditElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditElementSecurityWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanEditElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditElementSecurityWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanEditElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditElementSecurityWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanEditElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditElementSecurityWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanEditElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditElementSecurityWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanEditElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditElementSecurityWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "ElementSecurityType", "CanEditElementSecurity");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditExternalReferenceWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanEditExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditExternalReferenceWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanEditExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditExternalReferenceWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanEditExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditExternalReferenceWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanEditExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditExternalReferenceWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanEditExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditExternalReferenceWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanEditExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditExternalReferenceWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "ExternalReferenceNumber", "CanEditExternalReference");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditPriorityWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "Priority", "CanEditPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditPriorityWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "Priority", "CanEditPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditPriorityWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "Priority", "CanEditPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditPriorityWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "Priority", "CanEditPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditPriorityWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "Priority", "CanEditPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditPriorityWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "Priority", "CanEditPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditPriorityWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "Priority", "CanEditPriority");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditProposedByNameWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ProposedByName", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditProposedByNameWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "ProposedByName", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditProposedByNameWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ProposedByName", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditProposedByNameWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "ProposedByName", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditProposedByNameWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "ProposedByName", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditProposedByNameWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "ProposedByName", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditProposedByNameWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "ProposedByName", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditProposedByDateWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "ProposedByDate", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditProposedByDateWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "ProposedByDate", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditProposedByDateWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "ProposedByDate", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditProposedByDateWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "ProposedByDate", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditProposedByDateWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "ProposedByDate", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditProposedByDateWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "ProposedByDate", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditProposedByDateWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "ProposedByDate", "CanEditProposedBy");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditRankWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "Rank", "CanEditRank");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditRankWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "Rank", "CanEditRank");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditRankWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "Rank", "CanEditRank");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditRankWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "Rank", "CanEditRank");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditRankWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "Rank", "CanEditRank");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditRankWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "Rank", "CanEditRank");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditRankWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "Rank", "CanEditRank");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditTargetDateWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "TargetDate", "CanEditTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditTargetDateWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "TargetDate", "CanEditTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditTargetDateWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "TargetDate", "CanEditTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditTargetDateWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "TargetDate", "CanEditTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditTargetDateWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "TargetDate", "CanEditTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditTargetDateWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "TargetDate", "CanEditTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditTargetDateWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "TargetDate", "CanEditTargetDate");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditOrderOfMagnitudeCostBenefitsWithIssue() throws Exception
    {
    	testObjectScope.setOrderOfMagnitudeCostBenefits(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "OrderOfMagnitudeCostBenefits", "CanEditOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditOrderOfMagnitudeCostBenefitsWithDefect() throws Exception
    {
    	testObjectScope.setOrderOfMagnitudeCostBenefits(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "OrderOfMagnitudeCostBenefits", "CanEditOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditOrderOfMagnitudeCostBenefitsWithRisk() throws Exception
    {
    	testObjectScope.setOrderOfMagnitudeCostBenefits(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "OrderOfMagnitudeCostBenefits", "CanEditOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditOrderOfMagnitudeCostBenefitsWithAction() throws Exception
    {
    	testObjectScope.setOrderOfMagnitudeCostBenefits(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "OrderOfMagnitudeCostBenefits", "CanEditOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditOrderOfMagnitudeCostBenefitsWithRequirement() throws Exception
    {
    	testObjectScope.setOrderOfMagnitudeCostBenefits(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "OrderOfMagnitudeCostBenefits", "CanEditOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditOrderOfMagnitudeCostBenefitsWithChangeRequest() throws Exception
    {
    	testObjectScope.setOrderOfMagnitudeCostBenefits(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "OrderOfMagnitudeCostBenefits", "CanEditOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditOrderOfMagnitudeCostBenefitsWithServiceRequest() throws Exception
    {
    	testObjectScope.setOrderOfMagnitudeCostBenefits(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "OrderOfMagnitudeCostBenefits", "CanEditOrderOfMagnitudeCostBenefits");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditEstimatedStartDateWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedStartDateWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedStartDateWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedStartDateWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedStartDateWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedStartDateWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedStartDateWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedFinishDateWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedFinishDateWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedFinishDateWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedFinishDateWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedFinishDateWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedFinishDateWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditEstimatedFinishDateWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditOccurredDateTimeWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "OccuredDateTime", "CanEditOccurredDateTime");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditOccurredDateTimeWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "OccuredDateTime", "CanEditOccurredDateTime");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
   // Does not exist for Action & Requirement
    public void testCanEditOccurredDateTimeWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "OccuredDateTime", "CanEditOccurredDateTime");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditOccurredDateTimeWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "OccuredDateTime", "CanEditOccurredDateTime");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditOccurredDateTimeWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "OccuredDateTime", "CanEditOccurredDateTime");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditTimesReassignedWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "NumberTimesReassigned", "CanEditTimesReassigned");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditTimesReassignedWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "NumberTimesReassigned", "CanEditTimesReassigned");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
   // Does not exist for Action, Requirement, Risk
    public void testCanEditTimesReassignedWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "NumberTimesReassigned", "CanEditTimesReassigned");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditTimesReassignedWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "NumberTimesReassigned", "CanEditTimesReassigned");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditMitigationFactorsWithRisk() throws Exception
    {
    	testObjectScope.setMitigationFactors(new MitigationFactorScope());
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "MitigationFactors", "CanEditMitigationFactors");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditRiskMatrixWithRisk() throws Exception
    {
    	testObjectScope.setRiskMatrix(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "RiskMatrix", "CanEditRiskMatrix");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditAttributesWithRisk() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanEditAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditAttributesWithDefect() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanEditAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditAttributesWithIssue() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanEditAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditAttributesWithAction() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanEditAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditAttributesWithRequirement() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanEditAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditAttributesWithChangeRequest() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    			ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanEditAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditAttributesWithServiceRequest() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
    		ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanEditAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------
    public void testCanEditStateWithRisk() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditStateWithIssue() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditStateWithDefect() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditStateWithAction() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditStateWithRequirement() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditStateWithChangeRequest() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditStateWithServiceRequest() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
//  -------------------------------------------------------------------------------------------------------    
    public void testCanEditQuantificationImpactWithRisk() throws Exception
    {
    	testObjectScope.setImpact(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "Impact", "CanEditQuantificationImpact");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditQuantificationImpactWithDefect() throws Exception
    {
    	testObjectScope.setImpact(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "Impact", "CanEditQuantificationImpact");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditQuantificationImpactWithAction() throws Exception
    {
    	testObjectScope.setImpact(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "Impact", "CanEditQuantificationImpact");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditQuantificationImpactWithIssue() throws Exception
    {
    	testObjectScope.setImpact(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "Impact", "CanEditQuantificationImpact");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditQuantificationImpactWithRequirement() throws Exception
    {
    	testObjectScope.setImpact(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "Impact", "CanEditQuantificationImpact");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanEditQuantificationImpactWithServiceRequest() throws Exception
    {
    	testObjectScope.setImpact(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "Impact", "CanEditQuantificationImpact");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanEditQuantificationImpactWithChangeRequest() throws Exception
    {
    	testObjectScope.setImpact(true);
    	PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "Impact", "CanEditQuantificationImpact");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    
    public void testCanViewDuplicateNumberWithRisk() throws Exception
    {
    	testObjectScope.setDuplicates(true);
    	testObjectScope.setParent(new ScopeElementScope());
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "DuplicateNumber", "CanViewDuplicateNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewDuplicateNumberWithAction() throws Exception
    {
    	testObjectScope.setDuplicates(true);
    	testObjectScope.setParent(new ScopeElementScope());
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "DuplicateNumber", "CanViewDuplicateNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewDuplicateNumberWithDefect() throws Exception
    {
    	testObjectScope.setDuplicates(true);
    	testObjectScope.setParent(new ScopeElementScope());
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "DuplicateNumber", "CanViewDuplicateNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewDuplicateNumberWithChangeRequest() throws Exception
    {
    	testObjectScope.setDuplicates(true);
    	testObjectScope.setParent(new ScopeElementScope());
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "DuplicateNumber", "CanViewDuplicateNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewDuplicateNumberWithServiceRequest() throws Exception
    {
    	testObjectScope.setDuplicates(true);
    	testObjectScope.setParent(new ScopeElementScope());
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "DuplicateNumber", "CanViewDuplicateNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewDuplicateNumberWithRequirement() throws Exception
    {
    	testObjectScope.setDuplicates(true);
    	testObjectScope.setParent(new ScopeElementScope());
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "DuplicateNumber", "CanViewDuplicateNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    public void testCanViewDuplicateNumberWithIssue() throws Exception
    {
    	testObjectScope.setDuplicates(true);
    	testObjectScope.setParent(new ScopeElementScope());
        PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "DuplicateNumber", "CanViewDuplicateNumber");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
    			ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanAddRemoveAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanAddRemoveAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanAddRemoveAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanAddRemoveAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
    			RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanAddRemoveAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanAddRemoveAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "AttributeAssignments", "CanAddRemoveAttributes");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    
    public void testCanAddRemoveDuplicatesWithAction() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
    			ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
            "Duplicates", "CanAddRemoveDuplicates");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveDuplicatesWithDefect() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
            DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
            "Duplicates", "CanAddRemoveDuplicates");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveDuplicatesWithRequirement() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
            RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
            "Duplicates", "CanAddRemoveDuplicates");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveDuplicatesWithServiceRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
            ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
            "Duplicates", "CanAddRemoveDuplicates");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveDuplicatesWithRisk() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
    			RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
            "Duplicates", "CanAddRemoveDuplicates");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveDuplicatesWithChangeRequest() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
            ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
            "Duplicates", "CanAddRemoveDuplicates");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }

    public void testCanAddRemoveDuplicatesWithIssue() throws Exception
    {
    	PlannedScopeElementSecurityTestCanAddRemoveLocal test = new PlannedScopeElementSecurityTestCanAddRemoveLocal(
            IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
            "Duplicates", "CanAddRemoveDuplicates");
        test.grandparentRequiredOffFlags = new ArrayList();
        test.grandparentRequiredOffFlags
            .add("AllScopeElementsPermissionsGranted");
        test.runTest();
    }
    
  // ============================== CAN CREATE =============================
  public void testCanCreateRequirement() throws Exception
  {
  	PlannedScopeElementSecurityTestCanCreateLocal test = new PlannedScopeElementSecurityTestCanCreateLocal(
  			RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
  			"ID", "CanCreateRequirements");
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanCreateChangeRequest() throws Exception
  {
  	PlannedScopeElementSecurityTestCanCreateLocal test = new PlannedScopeElementSecurityTestCanCreateLocal(
  			ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
  			"ID", "CanCreateChangeRequests");
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanCreateServiceRequest() throws Exception
  {
  	PlannedScopeElementSecurityTestCanCreateLocal test = new PlannedScopeElementSecurityTestCanCreateLocal(
  			ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
  			"ID", "CanCreateServiceRequests");
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanCreateRisk() throws Exception
  {
  	PlannedScopeElementSecurityTestCanCreateLocal test = new PlannedScopeElementSecurityTestCanCreateLocal(
  			RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
  			"ID", "CanCreateRisks");
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanCreateDefect() throws Exception
  {
  	PlannedScopeElementSecurityTestCanCreateLocal test = new PlannedScopeElementSecurityTestCanCreateLocal(
  			DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
  			"ID", "CanCreateDefect");
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanCreateIssue() throws Exception
  {
  	PlannedScopeElementSecurityTestCanCreateLocal test = new PlannedScopeElementSecurityTestCanCreateLocal(
  			IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
  			"ID", "CanCreateIssues");
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanCreateAction() throws Exception
  {
  	PlannedScopeElementSecurityTestCanCreateLocal test = new PlannedScopeElementSecurityTestCanCreateLocal(
  			ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
  			"ID", "CanCreateActions");
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanCreateScopeElementFolder() throws Exception
  {
  	PlannedScopeElementSecurityTestCanCreateLocal test = new PlannedScopeElementSecurityTestCanCreateLocal(
  			FolderSecurityRole.class, new ScopeFolder(), new Proposal(), testObjectScope,
  			"ID", "CanCreateScopeElementsFolders");
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  //=============================== CAN ASSIGN ============================
  public void testCanAssignResourceToDefect() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignResource",AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanAssignResourceToAction() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignResource",AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanAssignResourceToRequirement() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignResource",AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanAssignResourceToServiceRequest() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignResource",AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanAssignResourceToRisk() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignResource",AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanAssignResourceToChangeRequest() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignResource",AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanAssignResourceToIssue() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignResource",AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanAssignParticipantToDefect() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanAssignParticipantToAction() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }

  public void testCanAssignParticipantToRequirement() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }

  public void testCanAssignParticipantToServiceRequest() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }

  public void testCanAssignParticipantToRisk() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }

  public void testCanAssignParticipantToChangeRequest() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }

  public void testCanAssignParticipantToIssue() throws Exception
  {
  	PlannedScopeElementSecurityTestCanAssignLocal test = new PlannedScopeElementSecurityTestCanAssignLocal(
  			IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  //===================================== CAN REMOVE ============================
  public void testCanRemoveParticipantToAction() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanRemoveParticipantToDefect() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanRemoveParticipantToRequirement() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }

  public void testCanRemoveParticipantToServiceRequest() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanRemoveParticipantToRisk() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanRemoveParticipantToChangeRequest() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanRemoveParticipantToIssue() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.PARTICIPANT);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanRemoveResourceToAction() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanRemoveResourceToDefect() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanRemoveResourceToRequirement() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanRemoveResourceToServiceRequest() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanRemoveResourceToRisk() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanRemoveResourceToChangeRequest() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  
  public void testCanRemoveResourceToIssue() throws Exception
  {
  	PlannedScopeElementSecurityTestCanRemoveLocal test = new PlannedScopeElementSecurityTestCanRemoveLocal(
  			IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
  			"ResourceTaskAssignments","CanRemoveResourceOrParticipant", AbstractPlannedSecurityTestLocal.RESOURCE);
  	test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  //-------------------------------------------------------------------------------------
  public void testCanEditDuplicateNumberWithChangeRequest() throws Exception
  {
  	testObjectScope.setDuplicates(true);
  	testObjectScope.setParent(new ScopeElementScope());
      PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
          ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
          "Duplicates", "CanEditDuplicateNumbers");
      test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  public void testCanEditDuplicateNumberWithServiceRequest() throws Exception
  {
  	testObjectScope.setDuplicates(true);
  	testObjectScope.setParent(new ScopeElementScope());
      PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
          ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
          "Duplicates", "CanEditDuplicateNumbers");
      test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  public void testCanEditDuplicateNumberWithRequirement() throws Exception
  {
  	testObjectScope.setDuplicates(true);
  	testObjectScope.setParent(new ScopeElementScope());
      PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
          RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
          "Duplicates", "CanEditDuplicateNumbers");
      test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  public void testCanEditDuplicateNumberWithIssue() throws Exception
  {
  	testObjectScope.setDuplicates(true);
  	testObjectScope.setParent(new ScopeElementScope());
      PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
          IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
          "Duplicates", "CanEditDuplicateNumbers");
      test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  public void testCanEditDuplicateNumberWithDefect() throws Exception
  {
  	testObjectScope.setDuplicates(true);
  	testObjectScope.setParent(new ScopeElementScope());
      PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
          DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
          "Duplicates", "CanEditDuplicateNumbers");
      test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  public void testCanEditDuplicateNumberWithRisk() throws Exception
  {
  	testObjectScope.setDuplicates(true);
  	testObjectScope.setParent(new ScopeElementScope());
      PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
          RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
          "Duplicates", "CanEditDuplicateNumbers");
      test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
  public void testCanEditDuplicateNumberWithAction() throws Exception
  {
  	testObjectScope.setDuplicates(true);
  	testObjectScope.setParent(new ScopeElementScope());
      PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
          ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
          "Duplicates", "CanEditDuplicateNumbers");
      test.grandparentRequiredOffFlags = new ArrayList();
      test.grandparentRequiredOffFlags
          .add("AllScopeElementsPermissionsGranted");
      test.runTest();
  }
public void testCanViewClientNameWithIssue() throws Exception
{
	  testObjectScope.setClientCostCenter(true);
    PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
        "ClientCostCenter", "CanViewClientName");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}    
public void testCanViewClientNameWithDefect() throws Exception
{
	  testObjectScope.setClientCostCenter(true);
    PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
        "ClientCostCenter", "CanViewClientName");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}  
public void testCanViewClientNameWithAction() throws Exception
{
	  testObjectScope.setClientCostCenter(true);
    PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
        "ClientCostCenter", "CanViewClientName");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}  
public void testCanViewClientNameWithRisk() throws Exception
{
	  testObjectScope.setClientCostCenter(true);
    PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
        "ClientCostCenter", "CanViewClientName");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}  
public void testCanViewClientNameWithRequirement() throws Exception
{
	  testObjectScope.setClientCostCenter(true);
    PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
        "ClientCostCenter", "CanViewClientName");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}  
public void testCanViewClientNameWithChangeRequest() throws Exception
{
	  testObjectScope.setClientCostCenter(true);
    PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
        "ClientCostCenter", "CanViewClientName");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}  
public void testCanViewClientNameWithServiceRequest() throws Exception
{
	  testObjectScope.setClientCostCenter(true);
    PlannedScopeElementSecurityTestCanViewLocal test = new PlannedScopeElementSecurityTestCanViewLocal(
        ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
        "ClientCostCenter", "CanViewClientName");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}  
//TestCases for CanClose

public void testCanCloseWithIssue() throws Exception
{
	testObjectScope.setState(true);
	PlannedScopeElementSecurityTestCanCloseLocal test = new PlannedScopeElementSecurityTestCanCloseLocal(
        IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope, "State", "CanCloseElement");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanCloseWithRisk() throws Exception
{
	testObjectScope.setState(true);
	PlannedScopeElementSecurityTestCanCloseLocal test = new PlannedScopeElementSecurityTestCanCloseLocal(
        RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope, "State", "CanCloseElement");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanCloseWithDefect() throws Exception
{
	testObjectScope.setState(true);
	PlannedScopeElementSecurityTestCanCloseLocal test = new PlannedScopeElementSecurityTestCanCloseLocal(
        DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope, "State", "CanCloseElement");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanCloseWithAction() throws Exception
{
	testObjectScope.setState(true);
	PlannedScopeElementSecurityTestCanCloseLocal test = new PlannedScopeElementSecurityTestCanCloseLocal(
        ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope, "State", "CanCloseElement");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanCloseWithRequirement() throws Exception
{
	testObjectScope.setState(true);
	PlannedScopeElementSecurityTestCanCloseLocal test = new PlannedScopeElementSecurityTestCanCloseLocal(
        RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope, "State", "CanCloseElement");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanCloseWithServiceRequest() throws Exception
{
	testObjectScope.setState(true);
	PlannedScopeElementSecurityTestCanCloseLocal test = new PlannedScopeElementSecurityTestCanCloseLocal(
        ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope, "State", "CanCloseElement");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanCloseWithChangeRequest() throws Exception
{
	testObjectScope.setState(true);
	PlannedScopeElementSecurityTestCanCloseLocal test = new PlannedScopeElementSecurityTestCanCloseLocal(
        ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope, "State", "CanCloseElement");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
//TestCases for CanChangeScopeElementsItemTypes
public void testCanChangeScopeElementsItemTypesWithChangeRequest() throws Exception
{
	  PlannedScopeElementSecurityTestCanChangeTypeLocal test = new PlannedScopeElementSecurityTestCanChangeTypeLocal(
        ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope, "Name","CanChangeScopeElementsItemTypes");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanChangeScopeElementsItemTypesWithServiceRequest() throws Exception
{
	  PlannedScopeElementSecurityTestCanChangeTypeLocal test = new PlannedScopeElementSecurityTestCanChangeTypeLocal(
        ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope, "Name","CanChangeScopeElementsItemTypes");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanChangeScopeElementsItemTypesWithRequirement() throws Exception
{
	  PlannedScopeElementSecurityTestCanChangeTypeLocal test = new PlannedScopeElementSecurityTestCanChangeTypeLocal(
        RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope, "Name", "CanChangeScopeElementsItemTypes");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanChangeScopeElementsItemTypesWithIssue() throws Exception
{
	  PlannedScopeElementSecurityTestCanChangeTypeLocal test = new PlannedScopeElementSecurityTestCanChangeTypeLocal(
        IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope, "Name","CanChangeScopeElementsItemTypes");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanChangeScopeElementsItemTypesWithDefect() throws Exception
{
	  PlannedScopeElementSecurityTestCanChangeTypeLocal test = new PlannedScopeElementSecurityTestCanChangeTypeLocal(
        DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope, "Name","CanChangeScopeElementsItemTypes");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanChangeScopeElementsItemTypesWithRisk() throws Exception
{
	  PlannedScopeElementSecurityTestCanChangeTypeLocal test = new PlannedScopeElementSecurityTestCanChangeTypeLocal(
        RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope, "Name","CanChangeScopeElementsItemTypes");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanChangeScopeElementsItemTypesWithAction() throws Exception
{
	  PlannedScopeElementSecurityTestCanChangeTypeLocal test = new PlannedScopeElementSecurityTestCanChangeTypeLocal(
        ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope, "Name","CanChangeScopeElementsItemTypes");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
//TestCases for CanDeleteScopeElements
public void testCanDeleteWithAction() throws Exception
{
	  PlannedScopeElementSecurityTestCanDeleteLocal test = new PlannedScopeElementSecurityTestCanDeleteLocal(
        ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope, "Deleted", "CanDeleteScopeElements");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanDeleteWithIssue() throws Exception
{
	  PlannedScopeElementSecurityTestCanDeleteLocal test = new PlannedScopeElementSecurityTestCanDeleteLocal(
        IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope, "Deleted", "CanDeleteScopeElements");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanDeleteWithRisk() throws Exception
{
	  PlannedScopeElementSecurityTestCanDeleteLocal test = new PlannedScopeElementSecurityTestCanDeleteLocal(
        RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope, "Deleted", "CanDeleteScopeElements");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanDeleteWithDefect() throws Exception
{
	  PlannedScopeElementSecurityTestCanDeleteLocal test = new PlannedScopeElementSecurityTestCanDeleteLocal(
        DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope, "Deleted", "CanDeleteScopeElements");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanDeleteWithRequirement() throws Exception
{
	  PlannedScopeElementSecurityTestCanDeleteLocal test = new PlannedScopeElementSecurityTestCanDeleteLocal(
        RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope, "Deleted", "CanDeleteScopeElements");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanDeleteWithChangeRequest() throws Exception
{
	  PlannedScopeElementSecurityTestCanDeleteLocal test = new PlannedScopeElementSecurityTestCanDeleteLocal(
        ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope, "Deleted", "CanDeleteScopeElements");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanDeleteWithServiceRequest() throws Exception
{
	  PlannedScopeElementSecurityTestCanDeleteLocal test = new PlannedScopeElementSecurityTestCanDeleteLocal(
        ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope, "Deleted", "CanDeleteScopeElements");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanDeleteWithScopeFolder() throws Exception
{
	  PlannedScopeElementSecurityTestCanDeleteLocal test = new PlannedScopeElementSecurityTestCanDeleteLocal(
			  FolderSecurityRole.class, new ScopeFolder(), new Proposal(), testObjectScope, "Deleted", "CanDeleteScopeElements");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
//Testcase for CanSetAsOrCancelDefault
public void testCanSetAsOrCancelDefaultWithServiceRequest() throws Exception
{
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
        ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
        "DefaultScope", "CanSetAsOrCancelDefault");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanSetAsOrCancelDefaultWithChangeRequest() throws Exception
{
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
        ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
        "DefaultScope", "CanSetAsOrCancelDefault");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanSetAsOrCancelDefaultWithRequirement() throws Exception
{
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
        RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
        "DefaultScope", "CanSetAsOrCancelDefault");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanSetAsOrCancelDefaultWithIssue() throws Exception
{
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
        IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
        "DefaultScope", "CanSetAsOrCancelDefault");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanSetAsOrCancelDefaultWithRisk() throws Exception
{
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
        RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
        "DefaultScope", "CanSetAsOrCancelDefault");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanSetAsOrCancelDefaultWithDefect() throws Exception
{
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
        DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
        "DefaultScope", "CanSetAsOrCancelDefault");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanSetAsOrCancelDefaultWithAction() throws Exception
{
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
        ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
        "DefaultScope", "CanSetAsOrCancelDefault");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
//Testcases for CanTransferunderWBSRoot
public void testCanTransferUnderWBSWithAction() throws Exception
{
	  PlannedScopeElementSecurityTestCanTransferLocal test = new PlannedScopeElementSecurityTestCanTransferLocal(
        ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
        "Name", "CanTransferScopeElementsToWBSView");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanTransferUnderWBSWithIssue() throws Exception
{
	  PlannedScopeElementSecurityTestCanTransferLocal test = new PlannedScopeElementSecurityTestCanTransferLocal(
        IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
        "Name", "CanTransferScopeElementsToWBSView");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanTransferUnderWBSWithDefect() throws Exception
{
	  PlannedScopeElementSecurityTestCanTransferLocal test = new PlannedScopeElementSecurityTestCanTransferLocal(
        DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
        "Name", "CanTransferScopeElementsToWBSView");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanTransferUnderWBSWithRisk() throws Exception
{
	  PlannedScopeElementSecurityTestCanTransferLocal test = new PlannedScopeElementSecurityTestCanTransferLocal(
        RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
        "Name", "CanTransferScopeElementsToWBSView");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanTransferUnderWBSWithRequirement() throws Exception
{
	  PlannedScopeElementSecurityTestCanTransferLocal test = new PlannedScopeElementSecurityTestCanTransferLocal(
        RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
        "Name", "CanTransferScopeElementsToWBSView");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanTransferUnderWBSWithServiceRequest() throws Exception
{
	  PlannedScopeElementSecurityTestCanTransferLocal test = new PlannedScopeElementSecurityTestCanTransferLocal(
        ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
        "Name", "CanTransferScopeElementsToWBSView");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}
public void testCanTransferUnderWBSWithChangeRequest() throws Exception
{
	  PlannedScopeElementSecurityTestCanTransferLocal test = new PlannedScopeElementSecurityTestCanTransferLocal(
        ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
        "Name", "CanTransferScopeElementsToWBSView");
    test.grandparentRequiredOffFlags = new ArrayList();
    test.grandparentRequiredOffFlags
        .add("AllScopeElementsPermissionsGranted");
    test.runTest();
}

public void testCanEditResourceProfileRatesWithIssue() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileRates");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}
public void testCanEditResourceProfileRatesWithDefect() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileRates");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}  public void testCanEditResourceProfileRatesWithRisk() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileRates");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}  public void testCanEditResourceProfileRatesWithAction() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileRates");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}  public void testCanEditResourceProfileRatesWithRequirement() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileRates");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}  public void testCanEditResourceProfileRatesWithChangeRequest() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileRates");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}  public void testCanEditResourceProfileRatesWithServiceRequest() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileRates");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}
//-------------------------------------------------------------------------------------
public void testCanEditResourceProfileCostWithIssue() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      IssueSecurityRole.class, new Issue(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileCost");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}
public void testCanEditResourceProfileCostWithServiceRequest() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      ServiceRequestSecurityRole.class, new ServiceRequest(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileCost");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}  public void testCanEditResourceProfileCostWithChangeRequest() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      ChangeRequestSecurityRole.class, new ChangeRequest(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileCost");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}  public void testCanEditResourceProfileCostWithRequirement() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      RequirementSecurityRole.class, new Requirement(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileCost");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}  public void testCanEditResourceProfileCostWithAction() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      ActionItemSecurityRole.class, new Action(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileCost");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}  public void testCanEditResourceProfileCostWithRisk() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      RiskSecurityRole.class, new Risk(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileCost");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}  public void testCanEditResourceProfileCostWithDefect() throws Exception
{
	  ResourceTaskAssignmentScope rtas = new ResourceTaskAssignmentScope();
	  rtas.setParent(new ScopeElementScope());
	  ResourceScope rs = new ResourceScope();
	  rs.setCalendar(new CalendarScope());
	  rtas.setResource(rs);
	  rtas.setTaskAssignment(new TaskAssignmentScope());
	  testObjectScope.setResourceTaskAssignments(rtas);
	  PlannedScopeElementSecurityTestCanEditLocal test = new PlannedScopeElementSecurityTestCanEditLocal(
	      DefectSecurityRole.class, new Defect(), new Proposal(), testObjectScope,
	      "ResourceTaskAssignments", "CanEditResourceProfileCost");
	  test.grandparentRequiredOffFlags = new ArrayList();
	  test.grandparentRequiredOffFlags
	      .add("AllScopeElementsPermissionsGranted");
	  test.runTest();
}

  
}
