package com.ibm.rpm.client.junit.security.testcases.role;



import com.ibm.rpm.security.containers.DeliverableSecurityRole;
import com.ibm.rpm.security.containers.ProjectSecurityRole;
import com.ibm.rpm.security.containers.TaskSecurityRole;
import com.ibm.rpm.wbs.containers.Deliverable;
import com.ibm.rpm.wbs.containers.Milestone;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.containers.SummaryTask;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.containers.WorkOrganization;
import com.ibm.rpm.wbs.containers.WorkProduct;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class TestWorkElementSecurityLocal extends BaseRoleSecurityTestLocal
{
    private WorkElementScope testObjectScope;

    protected void setUp() throws Exception
    {
        super.setUp();
        testObjectScope = new WorkElementScope();
    }
    
    public void testCanEditAssignmentTypeWithProject() throws Exception
    {
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
            "AssignmentType", "CanEditAssignmentType");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithProject() throws Exception
    {
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanViewReferenceNumber");
        test.runTest();
    }
    
    public void testCanViewWBSPriorityWithDeliverable() throws Exception
    {
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            DeliverableSecurityRole.class, new Deliverable(), new Proposal(),
            testObjectScope, "Priority", "CanViewWBSPriority");
        test.runTest();
    }

    public void testCanViewWBSPriorityWithProject() throws Exception
    {
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
            "Priority", "CanViewWBSPriority");
        test.runTest();
    }

    public void testCanViewWBSPriorityWithProposal() throws Exception
    {
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,
            "Priority", "CanViewWBSPriority");
        test.runTest();
    }

    public void testCanViewWBSPriorityWithWorkOrganization() throws Exception
    {
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope, "Priority", "CanViewWBSPriority");
        test.runTest();
    }

    public void testCanViewWBSPriorityWithSummaryTask() throws Exception
    {
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
            "Priority", "CanViewWBSPriority");
        test.runTest();
    }

    public void testCanViewWBSPriorityWithWorkProduct() throws Exception
    {
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
            "Priority", "CanViewWBSPriority");
        test.runTest();
    }

    public void testCanViewWBSPriorityWithMilestone() throws Exception
    {
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            TaskSecurityRole.class, new Milestone(), new Proposal(), testObjectScope,
            "Priority", "CanViewWBSPriority");
        test.runTest();
    }

    public void testCanViewWBSPriorityWithTask() throws Exception
    {
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            TaskSecurityRole.class, new Task(), new Proposal(), testObjectScope,
            "Priority", "CanViewWBSPriority");
        test.runTest();
    }
    
    public void testCanViewTimeCodesWithSummaryTask() throws Exception
    {
        WorkElementScope allScope = new WorkElementScope();
        allScope.setTimeCodeAssignments(true);
        allScope.setContainingProject(new WorkElementScope());
        allScope.setParent(new WorkElementScope());
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
        		DeliverableSecurityRole.class, new SummaryTask(), new Proposal(),
            allScope, "TimeCodeAssignments", "CanViewTimeCodes");
        test.runTest();
    }

    public void testCanViewDefaultTimeCodesWithDeliverable() throws Exception
    {
        testObjectScope.setParent(new WorkElementScope());
        testObjectScope.setTimeCodes(true);
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            DeliverableSecurityRole.class, new Deliverable(), new Proposal(),
            testObjectScope, "TimeCode1", "CanViewDefaultTimeCodes");
        test.runTest();
    }

    public void testCanEditReferenceNumberWithProject() throws Exception
    {
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanEditReferenceNumber");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithProposal() throws Exception
    {
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,
            "ReferenceNumber", "CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewReferenceNumberWithWorkOrganization() throws Exception
    {
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope, "ReferenceNumber", "CanViewReferenceNumber");
        test.runTest();
    }

    public void testCanViewEstimatedStartDateWithProject() throws Exception
    {
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
                ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanViewESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanViewEstimatedStartDateWithDeliverable() throws Exception
    {
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
        		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,
        		"EstimatedStartDate", "CanViewESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanViewEstimatedStartDateWithProposal() throws Exception
    {
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanViewESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanViewEstimatedStartDateWithWorkOrganization() throws Exception
    {
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope, "EstimatedStartDate", "CanViewESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanViewEstimatedStartDateWithSummaryTask() throws Exception
    {
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanViewESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanViewEstimatedStartDateWithWorkProduct() throws Exception
    {
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanViewESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanViewEstimatedFinishDateWithProject() throws Exception
    {
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
                ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanViewESTStartAndESTFinish");
        test.runTest();
    }
    

    public void testCanViewEstimatedFinishDateWithDeliverable() throws Exception
    {
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
        		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanViewESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanViewEstimatedFinishDateWithProposal() throws Exception
    {
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanViewESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanViewEstimatedFinishDateWithWorkOrganization() throws Exception
    {
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope, "EstimatedFinishDate", "CanViewESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanViewEstimatedFinishDateWithSummaryTask() throws Exception
    {
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanViewESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanViewEstimatedFinishDateWithWorkProduct() throws Exception
    {
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanViewESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanEditEstimatedStartDateWithProject() throws Exception
    {
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
                ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanEditEstimatedStartDateWithDeliverable() throws Exception
    {
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
        		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanEditEstimatedStartDateWithProposal() throws Exception
    {
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanEditEstimatedStartDateWithWorkOrganization() throws Exception
    {
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope, "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanEditEstimatedStartDateWithSummaryTask() throws Exception
    {
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanEditEstimatedStartDateWithWorkProduct() throws Exception
    {
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
            "EstimatedStartDate", "CanEditESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanEditEstimatedFinishDateWithProject() throws Exception
    {
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
                ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.runTest();
    }
    

    public void testCanEditEstimatedFinishDateWithDeliverable() throws Exception
    {
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
        		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanEditEstimatedFinishDateWithProposal() throws Exception
    {
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanEditEstimatedFinishDateWithWorkOrganization() throws Exception
    {
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope, "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanEditEstimatedFinishDateWithSummaryTask() throws Exception
    {
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanEditEstimatedFinishDateWithWorkProduct() throws Exception
    {
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
            "EstimatedFinishDate", "CanEditESTStartAndESTFinish");
        test.runTest();
    }

    public void testCanEditAttributesWithProject() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanEditAttributes");
        test.runTest();
    }

    public void testCanEditAttributesWithDeliverable() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
        		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanEditAttributes");
        test.runTest();
    }

    public void testCanEditAttributesWithProposal() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanEditAttributes");
        test.runTest();
    }

    public void testCanEditAttributesWithWorkOrganization() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope, "attributeAssignments", "CanEditAttributes");
        test.runTest();
    }

    public void testCanEditAttributesWithSummaryTask() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanEditAttributes");
        test.runTest();
    }

    public void testCanEditAttributesWithWorkProduct() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
    			DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanEditAttributes");
        test.runTest();
    }

    public void testCanEditAttributesWithMilestone() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            TaskSecurityRole.class, new Milestone(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanEditAttributes");
        test.runTest();
    }

    public void testCanEditAttributesWithTask() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
        		TaskSecurityRole.class, new Task(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanEditAttributes");
        test.runTest();
    }

    public void testCanEditStateWithProject() throws Exception
    {
    	testObjectScope.setState(true);
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.runTest();
    }

    public void testCanEditStateWithDeliverable() throws Exception
    {
    	testObjectScope.setState(true);
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
        		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.runTest();
    }
    
    public void testCanEditStateWithProposal() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.runTest();
    }

    public void testCanEditStateWithWorkOrganization() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope, "State", "CanEditState");
        test.runTest();
    }

    public void testCanEditStateWithSummaryTask() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.runTest();
    }

    public void testCanEditStateWithWorkProduct() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
    			DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.runTest();
    }

    public void testCanEditStateWithMilestone() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
            TaskSecurityRole.class, new Milestone(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.runTest();
    }
    
    public void testCanEditStateWithTask() throws Exception
    {
    	testObjectScope.setState(true);
        PlannedWorkElementSecurityTestCanEditLocal test = new PlannedWorkElementSecurityTestCanEditLocal(
        		TaskSecurityRole.class, new Task(), new Proposal(), testObjectScope,
            "State", "CanEditState");
        test.runTest();
    }
    
    public void testCanViewAttributesWithProject() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
        PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanViewAttributes");
        test.runTest();
    }

    public void testCanViewAttributesWithDeliverable() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
        		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanViewAttributes");
        test.runTest();
    }

    public void testCanViewAttributesWithProposal() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanViewAttributes");
        test.runTest();
    }

    public void testCanViewAttributesWithWorkOrganization() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope, "attributeAssignments", "CanViewAttributes");
        test.runTest();
    }

    public void testCanViewAttributesWithSummaryTask() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanViewAttributes");
        test.runTest();
    }

    public void testCanViewAttributesWithWorkProduct() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
    			DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanViewAttributes");
        test.runTest();
    }

    public void testCanViewAttributesWithMilestone() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
            TaskSecurityRole.class, new Milestone(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanViewAttributes");
        test.runTest();
    }

    public void testCanViewAttributesWithTask() throws Exception
    {
    	testObjectScope.setAttributeAssignments(true);
    	PlannedWorkElementSecurityTestCanViewLocal test = new PlannedWorkElementSecurityTestCanViewLocal(
        		TaskSecurityRole.class, new Task(), new Proposal(), testObjectScope,
            "attributeAssignments", "CanViewAttributes");
        test.runTest();
    }

    public void testCanCloseElementWithProject() throws Exception
    {
    	testObjectScope.setState(true);
        PlannedWorkElementSecurityTestCanCloseLocal test = new PlannedWorkElementSecurityTestCanCloseLocal(
            ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
            "CanCloseElement");
        test.runTest();
    }

    public void testCanCloseElementWithDeliverable() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedWorkElementSecurityTestCanCloseLocal test = new PlannedWorkElementSecurityTestCanCloseLocal(
        		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,
            "CanCloseElement");
        test.runTest();
    }

    
    public void testCanCloseElementWithProposal() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedWorkElementSecurityTestCanCloseLocal test = new PlannedWorkElementSecurityTestCanCloseLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,
            "CanCloseElement");
        test.runTest();
    }

    public void testCanCloseElementWithWorkOrganization() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedWorkElementSecurityTestCanCloseLocal test = new PlannedWorkElementSecurityTestCanCloseLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope, "CanCloseElement");
        test.runTest();
    }

    public void testCanCloseElementWithSummaryTask() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedWorkElementSecurityTestCanCloseLocal test = new PlannedWorkElementSecurityTestCanCloseLocal(
            DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
            "CanCloseElement");
        test.runTest();
    }

    public void testCanCloseElementWithWorkProduct() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedWorkElementSecurityTestCanCloseLocal test = new PlannedWorkElementSecurityTestCanCloseLocal(
    			DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
            "CanCloseElement");
        test.runTest();
    }

    public void testCanCloseElementWithMilestone() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedWorkElementSecurityTestCanCloseLocal test = new PlannedWorkElementSecurityTestCanCloseLocal(
            TaskSecurityRole.class, new Milestone(), new Proposal(), testObjectScope,
            "CanCloseElement");
        test.runTest();
    }
    
    public void testCanCloseElementWithTask() throws Exception
    {
    	testObjectScope.setState(true);
    	PlannedWorkElementSecurityTestCanCloseLocal test = new PlannedWorkElementSecurityTestCanCloseLocal(
        		TaskSecurityRole.class, new Task(), new Proposal(), testObjectScope,
            "CanCloseElement");
        test.runTest();
    }

    public void testCanAddRemoveDependencyWithProject() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
            ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,"Dependencies",
        "CanAddRemoveDependency");
        test.runTest();
    }

    public void testCanAddRemoveDependencyWithDeliverable() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
        		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,"Dependencies",
        "CanAddRemoveDependency");
        test.runTest();
    }

    
    public void testCanAddRemoveDependencyWithProposal() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,"Dependencies",
        "CanAddRemoveDependency");
        test.runTest();
    }

    public void testCanAddRemoveDependencyWithWorkOrganization() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope,"Dependencies","CanAddRemoveDependency");
        test.runTest();
    }

    public void testCanAddRemoveDependencyWithSummaryTask() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
            DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,"Dependencies",
    	"CanAddRemoveDependency");
        test.runTest();
    }

    public void testCanAddRemoveDependencyWithWorkProduct() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
    			DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,"Dependencies",
        "CanAddRemoveDependency");
        test.runTest();
    }

    public void testCanAddRemoveDependencyWithMilestone() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
    			TaskSecurityRole.class, new Milestone(), new Proposal(), testObjectScope,"Dependencies",
            "CanAddRemoveDependency");
        test.runTest();
    }

    public void testCanAddRemoveDependencyWithTask() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
        		TaskSecurityRole.class, new Task(), new Proposal(), testObjectScope,"Dependencies",
            "CanAddRemoveDependency");
        test.runTest();
    	
    }

    public void testCanAddRemoveAttributesWithProject() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
            ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,"AttributeAssignments",
        "CanAddRemoveAttributes");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithDeliverable() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
        		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,"AttributeAssignments",
        "CanAddRemoveAttributes");
        test.runTest();
    }

    
    public void testCanAddRemoveAttributesWithProposal() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,"AttributeAssignments",
        "CanAddRemoveAttributes");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithWorkOrganization() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope,"AttributeAssignments","CanAddRemoveAttributes");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithSummaryTask() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
            DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,"AttributeAssignments",
    	"CanAddRemoveAttributes");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithWorkProduct() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
    			DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,"AttributeAssignments",
        "CanAddRemoveAttributes");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithMilestone() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
    			TaskSecurityRole.class, new Milestone(), new Proposal(), testObjectScope,"AttributeAssignments",
            "CanAddRemoveAttributes");
        test.runTest();
    }

    public void testCanAddRemoveAttributesWithTask() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
        		TaskSecurityRole.class, new Task(), new Proposal(), testObjectScope,"AttributeAssignments",
            "CanAddRemoveAttributes");
        test.runTest();
    }

    public void testCanAddRemoveTimeCodesWithProject() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
            ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,"TimeCodeAssignments",
        "CanAddRemoveTimeCodes");
        test.runTest();
    }

    public void testCanAddRemoveTimeCodesWithDeliverable() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
        		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,"TimeCodeAssignments",
        "CanAddRemoveTimeCodes");
        test.runTest();
    }

    
    public void testCanAddRemoveTimeCodesWithProposal() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
            ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,"TimeCodeAssignments",
        "CanAddRemoveTimeCodes");
        test.runTest();
    }

    public void testCanAddRemoveTimeCodesWithWorkOrganization() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
            ProjectSecurityRole.class, new WorkOrganization(), new Proposal(),
            testObjectScope,"TimeCodeAssignments","CanAddRemoveTimeCodes");
        test.runTest();
    }

    public void testCanAddRemoveTimeCodesWithSummaryTask() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
            DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,"TimeCodeAssignments",
    	"CanAddRemoveTimeCodes");
        test.runTest();
    }

    public void testCanAddRemoveTimeCodesWithWorkProduct() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
    			DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,"TimeCodeAssignments",
        "CanAddRemoveTimeCodes");
        test.runTest();
    }

    public void testCanAddRemoveTimeCodesWithMilestone() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
    			TaskSecurityRole.class, new Milestone(), new Proposal(), testObjectScope,"TimeCodeAssignments",
            "CanAddRemoveTimeCodes");
        test.runTest();
    }

    
    public void testCanAddRemoveTimeCodesWithTask() throws Exception
    {
    	PlannedWorkElementSecurityTestCanAddRemoveLocal test = new PlannedWorkElementSecurityTestCanAddRemoveLocal(
        		TaskSecurityRole.class, new Task(), new Proposal(), testObjectScope,"TimeCodeAssignments",
            "CanAddRemoveTimeCodes");
        test.runTest();
    }
    
  //==================================== CAN ASSIGN ======================================
    
       public void testCanAssignResourceToDeliverable() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignResource",AbstractPlannedSecurityTestLocal.RESOURCE);
            test.runTest();
        }
       
        public void testCanAssignResourceToSummaryTask() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignResource",AbstractPlannedSecurityTestLocal.RESOURCE);
            test.runTest();
        }
       
        public void testCanAssignResourceToWorkProduct() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignResource",AbstractPlannedSecurityTestLocal.RESOURCE);
            test.runTest();
        }
       
        public void testCanAssignResourceToMilestone() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		TaskSecurityRole.class, new Milestone(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignResource",AbstractPlannedSecurityTestLocal.RESOURCE);
            test.runTest();
        }
       
        public void testCanAssignResourceToTask() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		TaskSecurityRole.class, new Task(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignResource",AbstractPlannedSecurityTestLocal.RESOURCE);
            test.runTest();
        }
       
        public void testCanAssignParticipantToDeliverable() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
       
        public void testCanAssignParticipantToSummaryTask() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
       
        public void testCanAssignParticipantToWorkProduct() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
       
        public void testCanAssignParticipantToMilestone() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		TaskSecurityRole.class, new Milestone(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
       
        public void testCanAssignParticipantToTask() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		TaskSecurityRole.class, new Task(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
        
        public void testCanAssignParticipantToProject() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
        
        public void testCanAssignParticipantToProposal() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
        
        public void testCanAssignParticipantToWorkOrganization() throws Exception
        {
        	PlannedWorkElementSecurityTestCanAssignLocal test = new PlannedWorkElementSecurityTestCanAssignLocal(
            		ProjectSecurityRole.class, new WorkOrganization(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanAssignParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
        
        //============================ CAN REMOVE ==================================
        
        public void testCanRemoveParticipantToDeliverable() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		DeliverableSecurityRole.class, new Task(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
        
        public void testCanRemoveParticipantToSummaryTask() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
        
        public void testCanRemoveParticipantToWorkProduct() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
        
        public void testCanRemoveParticipantToMilestone() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		TaskSecurityRole.class, new Milestone(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
        
        public void testCanRemoveParticipantToTask() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		TaskSecurityRole.class, new Task(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
        
        public void testCanRemoveParticipantToProject() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		ProjectSecurityRole.class, new Project(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
        
        public void testCanRemoveParticipantToProposal() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		ProjectSecurityRole.class, new Proposal(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
        
        public void testCanRemoveParticipantToWorkOrganization() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		ProjectSecurityRole.class, new WorkOrganization(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.PARTICIPANT);
            test.runTest();
        }
        
        public void testCanRemoveResourceToDeliverable() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		DeliverableSecurityRole.class, new Deliverable(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.RESOURCE);
            test.runTest();
        }
        
        public void testCanRemoveResourceToSummaryTask() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		DeliverableSecurityRole.class, new SummaryTask(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.RESOURCE);
            test.runTest();
        }
        
        public void testCanRemoveResourceToWorkProduct() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		DeliverableSecurityRole.class, new WorkProduct(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.RESOURCE);
            test.runTest();
        }
        
        public void testCanRemoveResourceToMilestone() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		TaskSecurityRole.class, new Milestone(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.RESOURCE);
            test.runTest();
        }
        
        public void testCanRemoveResourceToTask() throws Exception
        {
        	PlannedWorkElementSecurityTestCanRemoveLocal test = new PlannedWorkElementSecurityTestCanRemoveLocal(
            		TaskSecurityRole.class, new Task(), new Proposal(), testObjectScope,
                "ResourceTaskAssignments", "CanRemoveResourceOrParticipant",AbstractPlannedSecurityTestLocal.RESOURCE);
            test.runTest();
        }
}
