/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2005.  All Rights Reserved.                    |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.role.fixes;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import com.ibm.rpm.client.junit.scopemanagement.fixtures.ScopeElementFixture;
import com.ibm.rpm.client.junit.security.testcases.role.BaseRoleSecurityTestLocal;
import com.ibm.rpm.framework.InternalSecuredArrayResult;
import com.ibm.rpm.framework.security.ContainerSecurityDescriptor;
import com.ibm.rpm.scopemanagement.containers.ScopeElement;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.containers.ScopeTask;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.security.containers.ProjectSecurityRole;
import com.ibm.rpm.wbs.containers.GenericProject;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Yasser Lulu
 *
 */
public class Test65467Local extends BaseRoleSecurityTestLocal
{

    public void test() throws Exception
    {

        WorkElementScope projectScope = new WorkElementScope();
        projectScope.setScopeElement(new ScopeElementScope());
        ProjectSecurityRole projectSecurityRole = (ProjectSecurityRole) prepareSecurityRole(
            Project.class, true);
        GenericProject testProject = (GenericProject) prepareContainer(
            new Project(), null, projectScope, getCurrentUser(),
            projectSecurityRole);

        ScopeFolder scopeFolder = (ScopeFolder) testProject.getScopeElement();

        ScopeElementScope scope = new ScopeElementScope();
        scope.setRtfAssignments(true);

        ScopeElement parent = ScopeElementFixture.createChangeRequestFixture(
            new ScopeElementScope(), 0, scopeFolder, this);
        parent = (ScopeElement) save(parent, null).getRpmObject();

        ScopeTask scopetask = ScopeElementFixture.createScopeTaskFixture(scope,
            0, parent, this);

        scopetask = (ScopeTask) save(scopetask, scope).getRpmObject();

        InternalSecuredArrayResult result = loadInternalSecuredArrayResultFromXpath(
            "/ScopeTask[id='" + scopetask.getID() + "']", scope);
        Iterator it = result.getContainerSecurityDescriptorsMap().entrySet()
            .iterator();
        List scopeTasks = new ArrayList();
        while (it.hasNext())
        {
            Map.Entry entry = (Map.Entry) it.next();
            if (entry.getKey() instanceof ScopeTask)
            {
                scopeTasks.add(entry);
            }
        }

        assertFalse(scopeTasks.isEmpty());

        it = scopeTasks.iterator();
        while (it.hasNext())
        {
            Map.Entry entry = (Map.Entry) it.next();
            ContainerSecurityDescriptor descr = (ContainerSecurityDescriptor) entry
                .getValue();
            assertFalse(descr.getRTFSecurityDescriptors().isEmpty());
        }

    }

}
