/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2005.  All Rights Reserved.                    |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
package com.ibm.rpm.client.junit.security.testcases.role.fixes;

import com.ibm.rpm.client.junit.security.testcases.role.BaseRoleSecurityTestLocal;
import com.ibm.rpm.document.scope.DocumentScope;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.security.containers.ProjectSecurityRole;
import com.ibm.rpm.wbs.containers.GenericProject;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/**
 * @author Yasser Lulu
 *
 */
public class Test65657Local extends BaseRoleSecurityTestLocal
{

    public void test() throws Exception
    {

        
    	WorkElementScope projectScope = new WorkElementScope();
        ProjectSecurityRole projectSecurityRole = (ProjectSecurityRole) prepareSecurityRole(
            Project.class, true);

        projectSecurityRole = (ProjectSecurityRole) updateSecurityRole(projectSecurityRole);

        GenericProject testProject = (GenericProject) prepareContainer(
            new Project(), null, projectScope, securityTestUser,
            projectSecurityRole);
        
        projectScope.setDocumentFolder(new DocumentScope());
        projectScope.setScopeElement(new ScopeElementScope());

        testProject = (GenericProject) loadFromID(testProject, projectScope);
        assertNotNull(testProject.getScopeElement());
        assertNotNull(testProject.getDocumentFolder());

        projectSecurityRole.setCanViewProjectDescription(Boolean.FALSE);
        projectSecurityRole = (ProjectSecurityRole) updateSecurityRole(projectSecurityRole);
        testProject = (GenericProject) loadFromID(testProject, projectScope);
        assertNotNull(testProject.getScopeElement());
        assertNotNull(testProject.getDocumentFolder());        

        projectSecurityRole.setCanViewProjectDescription(Boolean.TRUE);
        projectSecurityRole = (ProjectSecurityRole) updateSecurityRole(projectSecurityRole);
        testProject = (GenericProject) loadFromID(testProject, projectScope);
        assertNotNull(testProject.getScopeElement());
        assertNotNull(testProject.getDocumentFolder());
    }

}
