package com.ibm.rpm.client.junit.security.testcases.role.scopemanagement;

import com.ibm.rpm.applicationadministration.containers.DatafieldRTF;
import com.ibm.rpm.applicationadministration.containers.RtfAssignment;
import com.ibm.rpm.client.junit.applicationadministration.fixtures.RtfAssignmentFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.scopemanagement.containers.Action;
import com.ibm.rpm.security.containers.ActionItemSecurityRole;

/**
 *
 * @author SandeepS
 *
 */
public class TestActionSecurityTestLocal extends AbstractTestScopeSecurityTestLocal {

	protected void setUp() throws Exception
    {
		testClass = TEST_ACTION;
        super.setUp();

        prepareSecurityRole(Action.class);
    }

    public void testEditRtfs() throws Exception
    {
    	resetScopeElementScope();
    	scopeElementScope.setRtfAssignments(true);
    	createSaveScopeElementWithSecurity(new Action());

    	createRtfAssignments();

        /* This Update should Fail */
    	updateRTFs(false);

    	/* This update should Succeed */
    	updateRTFs(true);

    	RtfAssignment[] assignments  = ((Action)testScopeElement).getRtfAssignments();
    	assertNotNull(testScopeElement);
    	assertNotNull(assignments);
    	assertTrue(assignments.length > 0);

    	for(int i=0; i<assignments.length; i++)
    	{
    		assertNotNull(assignments[i]);
    	}
    }

    public void testViewExternalReference() throws Exception
    {
    	resetScopeElementScope();
    	createSaveScopeElementWithSecurity(new Action());

    	runViewExternalReference();
    }

    public void testEditExternalReference() throws Exception
    {
    	resetScopeElementScope();
    	createSaveScopeElementWithSecurity(new Action());

    	runEditExternalReference();
    }

    public void testEditQuantificationImpact() throws Exception
    {
    	resetScopeElementScope();
    	scopeElementScope.setImpact(true);

    	createSaveScopeElementWithSecurity(new Action());

    	runEditQuantificationImpact();
    }

    private void createRtfAssignments() throws Exception
    {
    	RPMObject rpmObject[] = loadFromXpath("/ActionRTF", null);
    	RtfAssignment[] assignments  = new RtfAssignment[rpmObject.length];
    	DatafieldRTF rtf;

    	for(int i=0; i<rpmObject.length; i++)
    	{
    		rtf = (DatafieldRTF)rpmObject[i];
    		assignments[i] = RtfAssignmentFixture.createAssignmentFixture(testScopeElement, rtf.getName(), rtf, this);
    		assignments[i].setValue(assignments[0].getValue()+"_MOD");
    	}

    	((Action)testScopeElement).setRtfAssignments(assignments);
    }

    private void updateRTFs(boolean isSecurityFlagOn) throws Exception
    {
    	Boolean[] values = new Boolean[10];
        for (int i = 0; i < 10; i++)
            values[i] = new Boolean(isSecurityFlagOn);

        ((ActionItemSecurityRole)scopeElementSecurityRole).setCanEditActionRTFs(values);
        saveScopeElementAndSecurityRoleUpdates(isSecurityFlagOn);
    }
}
