package com.ibm.rpm.client.junit.timesheet.fixtures;

import java.util.ArrayList;
import java.util.Arrays;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.fixtures.RPMObjectFixture;
import com.ibm.rpm.timesheet.containers.AdministrativeTask;

/**
 * @author gmeloche
 *  
 */
public class AdministrativeTaskFixture extends RPMObjectFixture
{

    protected static ArrayList localSkipSetters, localSkipGetters;

    static
    {

        //Setters
        localSkipSetters = new ArrayList();
        localSkipSetters.addAll(skipSetters);

        localSkipGetters = new ArrayList();
        localSkipGetters.addAll(skipGetters);
        //read-only fields
        localSkipGetters.add("getFinishDate");
        localSkipGetters.add("getStartDate");
    }

    public static AdministrativeTask updateFixture(AdministrativeTask adminTask,
            ClientTestController ctc) throws Exception
    {

        adminTask.setActual(new Double(2.0));
        
        return adminTask;

    }

    public static void compare(AdministrativeTask t1, AdministrativeTask t2)
            throws AssertionFailedError, Exception
    {
        RPMObjectFixture.compareWithSkip(t1, t2, localSkipGetters);
    }

    public static void compare(AdministrativeTask[] pArray1,
            AdministrativeTask[] pArray2)
            throws AssertionFailedError, Exception
    {
        pArray1 = removeDeletedObject(pArray1);

        sortWithComparator(pArray1, RPMObjectNameAndIDComparator.INSTANCE);
        sortWithComparator(pArray2, RPMObjectNameAndIDComparator.INSTANCE);

        RPMObjectFixture.compare(pArray1, pArray2);
        if (pArray1 == null)
            return;

        for (int i = 0; i < pArray1.length; i++)
        {
            AdministrativeTaskFixture.compare(pArray1[i], pArray2[i]);
        }
    }

    public static AdministrativeTask[] removeDeletedObject(
            AdministrativeTask[] pArray)
    {

        AdministrativeTask[] newArray = null;

        ArrayList temp = new ArrayList(Arrays.asList(pArray));

        temp = removeNullAndDeletedRPMObjects(temp);

        if (temp != null && temp.size() > 0)
        {
            newArray = new AdministrativeTask[temp.size()];
            temp.toArray(newArray);
        }

        return newArray;

    }

}
