package com.ibm.rpm.client.junit.timesheet.testcases.fixes;

import com.ibm.rpm.client.junit.framework.testcases.GenericValidation;
import com.ibm.rpm.client.junit.framework.testcases.RPMExceptionMock;
import com.ibm.rpm.framework.constants.ErrorCodes;
import com.ibm.rpm.timesheet.containers.SummaryTimesheet;
import com.ibm.rpm.wbs.containers.TaskAssignment;

/**
 * @author gmeloche
 *
 */
public class Test54905 extends GenericValidation
{

    public void testLoadSummaryTimesheetWithIncompletePrimaryKey()
            throws Exception
    {

        SummaryTimesheet summaryTimesheet = new SummaryTimesheet();
        summaryTimesheet.setTaskAssignment(new TaskAssignment());
        summaryTimesheet.setID(null);
        summaryTimesheet.setWeekOf(null);
        
        RPMExceptionMock expectedExceptions = createRPMException(
            ErrorCodes.MISSING_PRIMARY_KEY, summaryTimesheet.getClass().getName());

        verifyLoadFromIDMustFail(summaryTimesheet, null, expectedExceptions);

    }

}
