package com.ibm.rpm.client.junit.timesheet.testcases.fixes;

import java.util.Calendar;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.timesheet.fixtures.StepFixture;
import com.ibm.rpm.client.junit.timesheet.fixtures.SummaryTimesheetFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.util.DateUtil;
import com.ibm.rpm.timesheet.containers.Step;
import com.ibm.rpm.timesheet.containers.SummaryTimesheet;
import com.ibm.rpm.timesheet.scope.StepScope;
import com.ibm.rpm.timesheet.scope.SummaryTimesheetScope;
import com.ibm.rpm.wbs.containers.GenericProject;
import com.ibm.rpm.wbs.containers.TaskAssignment;

/**
 * @author gmeloche
 *  
 */
public class Test55287 extends ClientTestController
{

    GenericProject project = null;
    
    TaskAssignment taskAssignment = null;

    String weekOf = null;

    public void testJoinConditionBetweenTaskAssignmentAndActivity()
            throws Exception
    {
        String xpath = "Step[@stepTimesheets"
                + "[@weekOf>='" + weekOf + "' and @weekOf <= '" + weekOf
                + "']]/taskAssignment";

        RPMObject[] objs = loadFromXpath(xpath, null);
        assertNotNull(objs);

    }

    public void testSubJoinConditionBetweenTaskAssignmentAndActivity()
            throws Exception
    {
        String xpath = "/Step"
                + "[@taskAssignment[@id='" + taskAssignment.getID() + "'] and @stepTimesheets[@weekOf>='" + weekOf
                + "' and @weekOf <= '" + weekOf + "']]";

        RPMObject[] objs = loadFromXpath(xpath, null);
        assertNotNull(objs);
    }
    
    public void testSubJoinConditionBetweenActivityAndTimesheetDetails()
            throws Exception
    {
        String xpath = "/Step"
                + "/@stepTimesheets[@weekOf>='" + weekOf
                + "' and @weekOf <= '" + weekOf + "']";

        RPMObject[] objs = loadFromXpath(xpath, null);
        assertNotNull(objs);
    }
    
    public void testJoinConditionBetweenActivityAndTimesheetDetails()
            throws Exception
    {
        String xpath = "/Step"
                + "/@stepTimesheets[@weekOf>='" + weekOf
                + "' and @weekOf <= '" + weekOf + "']";

        RPMObject[] objs = loadFromXpath(xpath, null);
        assertNotNull(objs);
    }

    protected void setUp() throws Exception
    {

        super.setUp();

        SummaryTimesheetScope scope = SummaryTimesheetFixture.createScope(false, false, true, true, true);
        
        SummaryTimesheet summaryTimesheet  = SummaryTimesheetFixture.createSaveFixture(null, null, scope, false, this);

        project = summaryTimesheet.getProject();
        taskAssignment = (TaskAssignment)summaryTimesheet.getTaskAssignment();

        StepScope stepScope = new StepScope();
        stepScope.setTimesheets(true);

        Step activity = StepFixture.createSaveFixture(taskAssignment,
            stepScope, null, this);
        Calendar week = activity.getStepTimesheets()[0].getWeekOf();

        weekOf = DateUtil.convertToString(week);

    }

}
