/*
 * Created on May 1, 2007
 */
package com.ibm.rpm.client.junit.timesheet.testcases.fixes;

import java.util.Calendar;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.timesheet.fixtures.SummaryTimesheetFixture;
import com.ibm.rpm.client.junit.timesheet.fixtures.TimesheetTestUtil;
import com.ibm.rpm.client.junit.wbs.fixtures.TaskAssignmentFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.timesheet.containers.SummaryTimesheet;
import com.ibm.rpm.wbs.containers.TaskAssignment;
import com.ibm.rpm.wbs.scope.TaskAssignmentScope;

/**
 * @author cobber
 */

public class Test60667 extends ClientTestController
{
    public void test() throws Exception
    {
        // Create a TaskAssignment
        TaskAssignmentScope taskAssignmentScope = TaskAssignmentFixture
            .createScope(true, false, false, false);
        TaskAssignment taskAssignment = TaskAssignmentFixture.createSaveFixture(
            taskAssignmentScope, this);
        assertNotNull(taskAssignment);

        // create a SummaryTimesheet
        Calendar weekOf = TimesheetTestUtil.getValidWeekOf(taskAssignment
            .getAssignmentStartDate(), TimesheetTestUtil.CURRENT_WEEK);
        SummaryTimesheet summaryTimesheet = SummaryTimesheetFixture.createSaveFixture(
            taskAssignment, weekOf, null, false, this);
        assertNotNull(summaryTimesheet);
        
        // load summaryTimesheet
        RPMObject rpmObject = this.loadFromID(summaryTimesheet, null);
        assertNotNull(rpmObject);
        assertTrue(rpmObject instanceof SummaryTimesheet);
        summaryTimesheet = (SummaryTimesheet)rpmObject;
        assertFalse(this.isCheckedOut(summaryTimesheet));
        
        // check out
        this.disableAutomaticCheckout();
        this.checkOut(summaryTimesheet);
        assertTrue(this.isCheckedOut(summaryTimesheet));
        
        // forceCheckin
        this.forceCheckinOnRPMObjectCheckOut(summaryTimesheet);
        
        // check status
        assertFalse(this.isCheckedOut(summaryTimesheet));
    }
}
