package com.ibm.rpm.client.junit.timesheet.testcases.validation;

import java.util.Calendar;

import com.ibm.rpm.client.junit.framework.testcases.GenericValidation;
import com.ibm.rpm.client.junit.timesheet.fixtures.SummaryTimesheetFixture;
import com.ibm.rpm.client.junit.timesheet.fixtures.TimesheetTestUtil;
import com.ibm.rpm.client.junit.wbs.fixtures.TaskAssignmentFixture;
import com.ibm.rpm.timesheet.containers.SummaryTimesheet;
import com.ibm.rpm.wbs.containers.TaskAssignment;

public class TestRATLC00257880 extends GenericValidation{
	private SummaryTimesheet summaryTimesheet = null;

	private TaskAssignment taskAssignment = null;

	public void testZeroEETCWithNewActuals() throws AssertionError, Exception
	{
		taskAssignment = TaskAssignmentFixture.createSaveFixture(null, this);
		assertNotNull(taskAssignment);
		Calendar weekOf = TimesheetTestUtil.getValidWeekOf(taskAssignment.getAssignmentStartDate(),
				TimesheetTestUtil.TIMESHEET1_WEEK);
		summaryTimesheet = SummaryTimesheetFixture.createSaveFixture(taskAssignment, weekOf, null, false, this);
		assertNotNull(summaryTimesheet);
		assertNotNull(summaryTimesheet.getTaskAssignment());
		taskAssignment = (TaskAssignment)summaryTimesheet.getTaskAssignment();
		TimesheetTestUtil.setWorkedHours(summaryTimesheet, 5, 0);
		taskAssignment.setEETCHours(new Double(0));
		taskAssignment.setActualWork(null);
		summaryTimesheet.setTaskAssignment(taskAssignment);		
		summaryTimesheet = (SummaryTimesheet)saveMustSucceed(summaryTimesheet, summaryTimesheet.getClass(), null);
		assertNotNull(summaryTimesheet);
		assertNotNull(summaryTimesheet.getTaskAssignment());
		taskAssignment = (TaskAssignment)summaryTimesheet.getTaskAssignment();
		assertNotNull(taskAssignment.getEETCHours());
		assertTrue(taskAssignment.getEETCHours().doubleValue() != 0);
	}

	public void testZeroEETCWithActualsAlreadyPresent() throws AssertionError, Exception
	{
		taskAssignment = TaskAssignmentFixture.createSaveFixture(null, this);
		assertNotNull(taskAssignment);
		Calendar weekOf = TimesheetTestUtil.getValidWeekOf(taskAssignment.getAssignmentStartDate(),
				TimesheetTestUtil.TIMESHEET1_WEEK);
		summaryTimesheet = SummaryTimesheetFixture.createSaveFixture(taskAssignment, weekOf, null, false, this);
		TimesheetTestUtil.setWorkedHours(summaryTimesheet, 3, 0);
		summaryTimesheet = (SummaryTimesheet)save(summaryTimesheet,null).getRpmObject();
		assertNotNull(summaryTimesheet);
		assertNotNull(summaryTimesheet.getTaskAssignment());

		taskAssignment = (TaskAssignment)summaryTimesheet.getTaskAssignment();
		taskAssignment.setEETCHours(new Double(0));
		summaryTimesheet.setTaskAssignment(taskAssignment);
		summaryTimesheet = (SummaryTimesheet)saveMustSucceed(summaryTimesheet, summaryTimesheet.getClass(), null);
		assertNotNull(summaryTimesheet);
		assertNotNull(summaryTimesheet.getTaskAssignment());
		taskAssignment = (TaskAssignment)summaryTimesheet.getTaskAssignment();
		assertNotNull(taskAssignment.getEETCHours());
		assertTrue(taskAssignment.getEETCHours().doubleValue() != 0);
	}
	
	public void testNullPointerException() throws Exception
	{
		taskAssignment = TaskAssignmentFixture.createSaveFixture(null, this);
		assertNotNull(taskAssignment);
		Calendar weekOf = TimesheetTestUtil.getValidWeekOf(taskAssignment.getAssignmentStartDate(),
				TimesheetTestUtil.TIMESHEET1_WEEK);
		summaryTimesheet = SummaryTimesheetFixture.createSaveFixture(taskAssignment, weekOf, null, false, this);
		assertNotNull(summaryTimesheet);
		assertNotNull(summaryTimesheet.getTaskAssignment());
		taskAssignment = (TaskAssignment)summaryTimesheet.getTaskAssignment();
		TimesheetTestUtil.setWorkedHours(summaryTimesheet, 5, 0);
		summaryTimesheet.setRegularMonday(null);
		summaryTimesheet.setSpecialMonday(null);
		taskAssignment.setEETCHours(new Double(0));
		summaryTimesheet.setTaskAssignment(taskAssignment);		
		summaryTimesheet = (SummaryTimesheet)saveMustSucceed(summaryTimesheet, summaryTimesheet.getClass(), null);
		assertNotNull(summaryTimesheet);
	}
}
