/*
 * Created on Oct 26, 2005
 *
 */
package com.ibm.rpm.client.junit.wbs.testcases;

import junit.framework.AssertionFailedError;

import com.ibm.rpm.applicationadministration.containers.AssetFinancialCategory;
import com.ibm.rpm.applicationadministration.containers.AssignmentStatus;
import com.ibm.rpm.applicationadministration.containers.AttributeCategory;
import com.ibm.rpm.applicationadministration.containers.DeliverableRTF;
import com.ibm.rpm.applicationadministration.containers.DeliverableState;
import com.ibm.rpm.applicationadministration.containers.MilestoneRTF;
import com.ibm.rpm.applicationadministration.containers.ProjectRTF;
import com.ibm.rpm.applicationadministration.containers.State;
import com.ibm.rpm.applicationadministration.containers.SummaryTaskRTF;
import com.ibm.rpm.applicationadministration.containers.TaskRTF;
import com.ibm.rpm.applicationadministration.containers.TaskState;
import com.ibm.rpm.applicationadministration.containers.WorkLocation;
import com.ibm.rpm.applicationadministration.containers.WorkProductRTF;
import com.ibm.rpm.client.junit.customfield.fixtures.CustomFieldFixture;
import com.ibm.rpm.client.junit.framework.testcases.ModuleTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.WbsModuleFixture;
import com.ibm.rpm.customfield.containers.CustomFieldCategory;
import com.ibm.rpm.customfield.scope.CustomFieldScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.containers.AbstractModule;
import com.ibm.rpm.scorecard.containers.ScorecardFolder;
import com.ibm.rpm.wbs.containers.GenericProject;
import com.ibm.rpm.wbs.containers.Portfolio;
import com.ibm.rpm.wbs.containers.WbsModule;
import com.ibm.rpm.wbs.scope.WbsModuleScope;



/**
 * @author karim
 *  
 */
public class TestWbsModule extends ModuleTestController
{
    public TestWbsModule(String testName)
    {
        setName(testName);
    }

    public void setUp() throws Exception
    {
        logger.info("setUp");
        super.setUp();

        mainScope = WbsModuleFixture.createFullScope();        
        moduleContaineName = "WBSMODULE";
    }

    
    
    public void tearDown() throws Exception
    {
        super.tearDown();
    }

    public void testXPathAllCustomFields() throws Exception
    {
        ((WbsModuleScope) mainScope).getCustomFieldCategories().setChildren(new CustomFieldScope());
        
        WbsModule module = (WbsModule) createFixture(mainScope);
        save(module, mainScope);

        RPMObjectScope scope = CustomFieldFixture.createCustomFieldScope(2);
        RPMObject[] objs = loadFromXpath("/WBSModule/CustomFieldCategory/CustomField", scope);
        assertNotNull(objs);
    }
    
    public RPMObject load(AbstractModule aModule, RPMObjectScope aScope)
            throws Exception
    {

        WbsModule module = (WbsModule) aModule;
        WbsModuleScope scope = (WbsModuleScope) aScope;

        WbsModule loadedModule = new WbsModule();
        
        if (scope != null)
        {
            if (scope.getPortfolios() != null)
            {
                //loadPortfolios
                Portfolio[] portfolios = (Portfolio[]) loadElements( 
                		module.getPortfolios(),
        				scope.getPortfolios(),
        				Portfolio.class);
                loadedModule.setPortfolios(portfolios);
            }
            if (scope.getGenericProjects() != null)
            {
                //loadGenericProjects
                GenericProject[] genericProjects = loadGenericProjects( 
                		module.getGenericProjects(),
        				scope.getGenericProjects());
                loadedModule.setGenericProjects(genericProjects);
            }
            if (scope.getAttributeCategories() != null)
            {
                //loadAttributeCategories
                AttributeCategory[] attributeCategories = loadAttributeCategories(
                        module.getAttributeCategories(), scope.getAttributeCategories());
                loadedModule.setAttributeCategories(attributeCategories);
            }
            if (scope.isAssetFinancialCategories())
            {
                //loadAssetFinancialCategories
                AssetFinancialCategory[] assetFinancialCategories = (AssetFinancialCategory[]) loadDatafields(
                		module.getAssetFinancialCategories(), 
        				scope.isAssetFinancialCategories(),
        				AssetFinancialCategory.class);
                loadedModule.setAssetFinancialCategories(assetFinancialCategories);
            }
            if (scope.isAssignmentStatus())
            {
                //loadAssignmentStatus
                AssignmentStatus[] assignmentStatus = (AssignmentStatus[]) loadDatafields(
                		module.getAssignmentStatus(), 
        				scope.isAssignmentStatus(),
        				AssignmentStatus.class);
                loadedModule.setAssignmentStatus(assignmentStatus);
            }
            if (scope.isWorkLocations())
            {
                //loadWorkLocations        
                WorkLocation[] workLocations = (WorkLocation[]) loadDatafields(
                		module.getWorkLocations(), 
        				scope.isWorkLocations(),
        				WorkLocation.class);
                loadedModule.setWorkLocations(workLocations);
            }
            if (scope.isStates())
            {
                //loadStates        
                State[] states = (State[]) loadDatafields(
                		module.getStates(), 
        				scope.isStates(),
        				State.class);
                loadedModule.setStates(states);
            }
            if (scope.isDeliverableStates())
            {
                //loadDeliverableState        
                DeliverableState[] deliverableStates = (DeliverableState[]) loadDatafields(
                		module.getDeliverableStates(), 
        				scope.isDeliverableStates(),
        				DeliverableState.class);
                loadedModule.setDeliverableStates(deliverableStates);
            }
            if (scope.isTaskStates())
            {
                //loadTaskState        
                TaskState[] taskStates = (TaskState[]) loadDatafields(
                		module.getTaskStates(), 
        				scope.isTaskStates(),
        				TaskState.class);
                loadedModule.setTaskStates(taskStates);
            }
            if (scope.isProjectRtfs())
            {
                //loadProjectRTF        
                ProjectRTF[] projectRTFs = (ProjectRTF[]) loadDatafields(
                		module.getProjectRtfs(), 
        				scope.isProjectRtfs(),
        				ProjectRTF.class);
                loadedModule.setProjectRtfs(projectRTFs);
            }
            if (scope.isDeliverableRtfs())
            {
                //loadProjectRTF        
                DeliverableRTF[] deliverableRTFs = (DeliverableRTF[]) loadDatafields(
                		module.getDeliverableRtfs(), 
        				scope.isDeliverableRtfs(),
        				DeliverableRTF.class);
                loadedModule.setDeliverableRtfs(deliverableRTFs);
            }
            if (scope.isWorkProductRtfs())
            {
                //loadWorkProductRTF        
                WorkProductRTF[] workProductRTFs = (WorkProductRTF[]) loadDatafields(
                		module.getWorkProductRtfs(), 
        				scope.isWorkProductRtfs(),
        				WorkProductRTF.class);
                loadedModule.setWorkProductRtfs(workProductRTFs);
            }
            if (scope.isSummaryTaskRtfs())
            {
                //loadSummaryTaskRTF        
                SummaryTaskRTF[] summaryTaskRTFs = (SummaryTaskRTF[]) loadDatafields(
                		module.getSummaryTaskRtfs(), 
        				scope.isSummaryTaskRtfs(),
        				SummaryTaskRTF.class);
                loadedModule.setSummaryTaskRtfs(summaryTaskRTFs);
            }
            if (scope.isMilestoneRtfs())
            {
                //loadMilestoneRTF
                MilestoneRTF[] milestoneRTFs = (MilestoneRTF[]) loadDatafields(
                		module.getMilestoneRtfs(),
        				scope.isMilestoneRtfs(),
        				MilestoneRTF.class);
                loadedModule.setMilestoneRtfs(milestoneRTFs);
            }
            if (scope.isTaskRtfs())
            {
                //loadTaskRTF
                TaskRTF[] taskRTFs = (TaskRTF[]) loadDatafields(
                		module.getTaskRtfs(),
        				scope.isTaskRtfs(),
        				TaskRTF.class);
                loadedModule.setTaskRtfs(taskRTFs);
            }
            if (scope.getScorecardFolders() != null)
            {
                //loadScorecardFolders
                ScorecardFolder[] scorecardFolders = (ScorecardFolder[]) loadElements( 
                		module.getScorecardFolders(),
        				scope.getScorecardFolders(),
        				ScorecardFolder.class);
                loadedModule.setScorecardFolders(scorecardFolders);
            }
            if (scope.getCustomFieldCategories() != null)
            {
                //loadCustomFieldCategories
                CustomFieldCategory[] customFieldCategories = (CustomFieldCategory[]) loadElements(
                        module.getCustomFieldCategories(), scope
                                .getCustomFieldCategories(), CustomFieldCategory.class);
                loadedModule.setCustomFieldCategories(customFieldCategories);
            }
        }

        return loadedModule;
    }
    
    protected void deleteModule(AbstractModule aModule, RPMObjectScope aScope)
            throws AssertionError, Exception
    {

        WbsModule module = (WbsModule) aModule;
        WbsModuleScope scope = (WbsModuleScope) aScope;

        //delete the element
        if (module != null && scope != null)
        {
            if (module.getPortfolios() != null && scope.getPortfolios()!=null)
            {
                delete(module.getPortfolios());
            }
            if (module.getGenericProjects() != null && scope.getGenericProjects()!=null)
            {
                delete(module.getGenericProjects());
            }
            if (module.getAttributeCategories() != null && scope.getAttributeCategories()!=null)
            {
                delete(module.getAttributeCategories());
            }
            if (module.getScorecardFolders() != null && scope.getScorecardFolders()!=null)
            {
                delete(module.getScorecardFolders());
            }
        	if (module.getCustomFieldCategories() != null && scope.getCustomFieldCategories()!=null)
        	{
        	    delete(module.getCustomFieldCategories());
        	}
        	
            //reload the deleted element
            WbsModule deletedModule = (WbsModule) loadDeletedModule(module, scope);

            //Validate the deleted element
            if (scope.getPortfolios() != null)
            {
                assertNull(deletedModule.getPortfolios());
            }
            if (scope.getGenericProjects() != null)
            {
                assertNull(deletedModule.getGenericProjects());
            }
            if (scope.getAttributeCategories() != null)
            {
                assertNull(deletedModule.getAttributeCategories());
            }
            if (scope.getScorecardFolders() != null)
            {
                assertNull(deletedModule.getScorecardFolders());
            }
            if (scope.getCustomFieldCategories() != null)
            {
                assertNull(deletedModule.getCustomFieldCategories());
            }
        }
    }

    protected AbstractModule createFixture(RPMObjectScope scope)
            throws Exception
    {
        return WbsModuleFixture.createFixture((WbsModuleScope) scope, this);
    }

    protected AbstractModule updateFixture(AbstractModule module,
            RPMObjectScope scope) throws Exception
    {
        return WbsModuleFixture.updateFixture((WbsModule) module, (WbsModuleScope) scope, this);
    }

    protected void compare(AbstractModule module,
            AbstractModule returnedModule, RPMObjectScope scope)
            throws AssertionFailedError, Exception
    {
        WbsModuleFixture.compare((WbsModule) module,
            (WbsModule) returnedModule, (WbsModuleScope) scope);
    }
}
