/*
 * Created on Nov 28, 2006
 * @author mmatwiy
 * 
 * Test methods for defect 49573
 * Unable to execute following XPath:
 * "/project[@name='RPM Program']/ScopeFolder"
 */
package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class Test49573 extends ClientTestController
{
    Project project = null;

    ScopeFolder scopeFolder = null;

    public void setUp() throws Exception
    {
        super.setUp();

        project = (Project) WorkElementFixture.createSaveFixture(new Project(),
            null, this);
    }

    public void testJoinCondition() throws Exception
    {
        RPMObject[] rpmObjects = loadFromXpath("/Project[@name='"
                + project.getName() + "']/ScopeFolder", null);
        assertNotNull(rpmObjects);
        assertNotNull(rpmObjects[0]);
        assertTrue(rpmObjects[0] instanceof ScopeFolder);
        ScopeFolder reloaded = (ScopeFolder) rpmObjects[0];

        assertTrue(reloaded.getName().equals(project.getName()));
    }

    public void testSubJoinCondition() throws Exception
    {
        WorkElementScope scope = new WorkElementScope();
        scope.setScopeElement(new ScopeElementScope());
        
        RPMObject[] rpmObjects = loadFromXpath("/Project[ScopeFolder[@name='"
                + project.getName() + "']]", scope);
        assertNotNull(rpmObjects);
        assertNotNull(rpmObjects[0]);
        assertTrue(rpmObjects[0] instanceof Project);
        
        Project reloaded = (Project) rpmObjects[0];
        assertNotNull(reloaded.getScopeElement());

        assertTrue(reloaded.getScopeElement().getName().equals(
            project.getName()));
    }
}
