/*
 * Created on Nov 28, 2006
 * @author mmatwiy
 * 
 * Test methods for defect 57265.
 * When trying to access the opportunity of the proposal after the creation 
 * by template of the proposal, the following error message is thrown:
 * WbsManager.getJoinCondition is not implemented for the manager OpportunityManager
 */
package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.wbs.containers.Opportunity;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class Test57265 extends ClientTestController
{
    Project project = null;

    public void setUp() throws Exception
    {
        super.setUp();

        WorkElementScope scope = new WorkElementScope();
        scope.setOpportunity(true);

        project = (Project) WorkElementFixture.createSaveFixture(new Project(),
            scope, this);
    }

    public void testJoinCondition() throws Exception
    {
        RPMObject[] rpmObjects = loadFromXpath("/Project[@id='"
                + project.getID() + "']/Opportunity", null);
        assertNotNull(rpmObjects);
        assertNotNull(rpmObjects[0]);
        assertTrue(rpmObjects[0] instanceof Opportunity);
    }

    public void testSubJoinCondition() throws Exception
    {
        RPMObject[] rpmObjects = loadFromXpath("/Project[Opportunity[@id='"
                + project.getOpportunity().getID() + "']]", null);
        assertNotNull(rpmObjects);
        assertNotNull(rpmObjects[0]);
        assertTrue(rpmObjects[0] instanceof Project);
    }
}
