package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.wbs.fixtures.PortfolioFixture;
import com.ibm.rpm.framework.ReloadType;
import com.ibm.rpm.framework.SaveResult;
import com.ibm.rpm.wbs.containers.Deliverable;
import com.ibm.rpm.wbs.containers.GenericProject;
import com.ibm.rpm.wbs.containers.Portfolio;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.containers.WorkElement;
import com.ibm.rpm.wbs.containers.WorkProduct;
import com.ibm.rpm.wbs.scope.PortfolioScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;
import com.ibm.rpm.wbs.types.AssignmentType;

public class Test57523 extends ClientTestController
{
    public void testChildrenLoad() throws Exception
    {
        PortfolioScope pfScope = new PortfolioScope();      
        pfScope.setProjects(new WorkElementScope());
        Portfolio rootPortfolio = PortfolioFixture.createFixture(1, 2, pfScope, this);    
        rootPortfolio = (Portfolio) save(rootPortfolio, pfScope).getRpmObject();
        
        rootPortfolio = (Portfolio) loadFromXpath("/Portfolio[@name='" + 
            rootPortfolio.getName() + "']", null)[0];
        
        Proposal proposal = new Proposal();
        proposal.setName(HelperTestUtilities.createName());
        proposal.setAssignmentType(AssignmentType.Work);
        rootPortfolio.setProjects(new GenericProject[] {proposal});
        
        pfScope.setProjects(new WorkElementScope());
        
        Deliverable deliv = new Deliverable();
        deliv.setName(HelperTestUtilities.createName());
        WorkProduct wp = new WorkProduct();
        wp.setName(HelperTestUtilities.createName());
        
        proposal.setChildren(new WorkElement[] {deliv, wp});
        pfScope.getProjects().setChildren(new WorkElementScope());
        
        SaveResult sr = save(rootPortfolio, pfScope, ReloadType.SavedResult);
        rootPortfolio = (Portfolio) sr.getRpmObject();
        assertTrue(sr.isSuccessful());
        
        assertTrue("Projects length  : " + rootPortfolio.getProjects().length, 
            rootPortfolio.getProjects().length == 1);
    }
}