/*
 * Created on Nov 24, 2006
 * @author mmatwiy
 * 
 * Test method for defect 57828:
 * 1- Load a TaskAssignmnet object with the following scope:
 *    RPMObjectScope scope = new RPMObjectScope();
 *    scope.setParent(scope);
 * 2- set taskAssignmnet.sellingRatePerHour and taskAssignmnet.specialCostPerHour to some values.
 * 3- save the object.
 * 4- A NullPointerException is thrown:
 */
package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.TaskAssignmentFixture;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.wbs.containers.TaskAssignment;

public class Test57828 extends ClientTestController
{
    TaskAssignment taskAssignment = null;

    public void setUp() throws Exception
    {
        super.setUp();
        taskAssignment = TaskAssignmentFixture.createSaveFixture(null, this);
    }
    
    public void test() throws Exception
    {
        RPMObjectScope scope = new RPMObjectScope();
        scope.setParent(scope);
        
        TaskAssignment reloaded = (TaskAssignment) loadFromID(taskAssignment, scope);
        reloaded.setSellingRatePerHour(new Double(15.0));
        reloaded.setSpecialCostPerHour(new Double(10.0));
        
        save(reloaded, scope);
        
    }
}
