/*
 * Created on Dec 6, 2006
 * @author mmatwiy
 * 
 * "/AggregateScope [id = 'B804A606EBF0497DABB6302C89653BDF']/AggregateScope 
 * [name = 'PR7: All other screens shall have customer information updated from the 
 * Customer Information Screen.'] "
 * 
 * This is the Exception thrown:
 * Internal error: com.ibm.db2.jcc.c.SqlException: An unexpected token "WHERE" was found 
 * following "formation Screen.'))". Expected tokens may include: "AND".
 * 
 * The problem here is that the 'from' in the name of the container is causing the pattern matcher
 * to believe that it should add a 'where' instead of an 'and'. 
 * 
 * Fix: Remove contents between quotes prior to sending the where clause to the pattern 
 * matcher in AbstractRPMObjectManager.
 */
package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.scopemanagement.containers.Defect;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.scopemanagement.scope.ScopeElementScope;
import com.ibm.rpm.wbs.containers.Project;

public class Test58749 extends ClientTestController
{
    private final static String name = HelperTestUtilities.unitTestPrefix
            + "PR7: All other screens shall have customer information updated from the Customer Information Screen.";

    public void test2() throws Exception
    {
        Project project = new Project();
        project.setName(HelperTestUtilities.createName());
        save(project, null);

        RPMObject[] rpmObjects = loadFromXpath("/ScopeFolder[name='"
                + project.getName() + "']", new ScopeElementScope());
        ScopeFolder scopeFolder = (ScopeFolder) rpmObjects[0];

        Defect defect = new Defect();
        defect.setName(name);
        defect.setParent(scopeFolder);
        save(defect, null);

        RPMObject[] objects = loadFromXpath("/ScopeFolder/Defect[name ='"
                + defect.getName() + "']", null);

        assertNotNull(objects);
        assertNotNull(objects[0]);
        assertTrue(objects[0] instanceof Defect);
    }

}
