/*
 * Created on 2-Jan-07
 * @author mmatwiy
 * 
 * Defect 59700: Xpath below returns null result. 
 * The NOT was not being appended to the select.
 * 
 * Resolution: Appended "NOT" when OpCode = OP_NOT_EQUALS in 
 * AbstractRPMObjectManager.buildFieldCondition.
 */
package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.helpers.HelperTestUtilities;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.scopemanagement.containers.Requirement;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.types.ProjectPublishedType;

public class Test59700 extends ClientTestController
{
    public void test() throws Exception
    {
        Project project = (Project) WorkElementFixture.retrieveStaticFixture(
            new Project(), this);
        RPMObject[] objects = loadFromXpath(
            "/ScopeFolder[@name='" + project.getName() + "']", null);
        assertNotNull(objects);
        assertNotNull(objects[0]);
        ScopeFolder scopeFolder = (ScopeFolder) objects[0];

        Requirement req = new Requirement();
        req.setName(HelperTestUtilities.createName());
        req.setParent(scopeFolder);
        save(req, null);

        RPMObject[] loadResult = loadFromXpath("/Requirement[@id='" + req.getID()
                + "' and @published !='" + ProjectPublishedType.ToTemplate
                + "']", null);
        assertNotNull(loadResult);
        assertNotNull(loadResult[0]);
    }
}
