package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.scope.ElementDependencyScope;
import com.ibm.rpm.wbs.scope.WorkElementScope;

public class Test60661 extends ClientTestController
{
    /*
     * Description I create an Element Dependency between two work element and
     * set an amount value to it. After a save on the Element Dependency, the
     * amount value isn't correctly retrieved:
     * 
     * For example:
     * 
     * Start Value  End Value 23.38 becomes 23.26; 23.02 becomes 23.01; 23.03 becomes 23.0
     */
    public void testAmountValueReadWrite() throws Exception
    {   
        WorkElementScope wkScope = new WorkElementScope();
        ElementDependencyScope depScope = new ElementDependencyScope();
        wkScope.setDependencies(depScope);
        Task tsk = (Task) WorkElementFixture.createFixture(new Task(), wkScope,
            initTestController());
        
        assertNotNull(tsk.getDependencies());
        
        Task savedTsk = (Task) save(tsk, wkScope).getRpmObject();
        
        WorkElementFixture.compare(savedTsk, tsk, wkScope);
    }
}
