package com.ibm.rpm.client.junit.wbs.testcases.fixes;

import java.util.Calendar;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.WorkElementFixture;
import com.ibm.rpm.wbs.containers.Task;
import com.ibm.rpm.wbs.containers.WbsScheduleDate;
import com.ibm.rpm.wbs.scope.WorkElementScope;

/*
1.   Create a Proposal With A Task
2.  Create a WBSScheduleDate and update the duration in minutes to 1560 (3 days)
3.  Update the task with the WbsScheduleDate (via schedule.setProposedDate())
4.  Create another wbsScheduleDate and set the start date to something else.
5.  Re-update the task.
6.  Notice how the duration in minutes will be resetted to ; however, this does not happen in the delphi client.
 */
public class Test63304 extends ClientTestController
{
    public void testInvalidProposedDateUpdate() throws Exception
    {
        int intCanary = 1560;
        
        WorkElementScope scopeTask = new WorkElementScope();
        scopeTask.setScheduleDates(true);
        Task taskProposedDates = (Task) WorkElementFixture.createFixture(new Task(), new WorkElementScope(), this);

        WbsScheduleDate scheduleDate = new WbsScheduleDate();
        scheduleDate.setDurationInMinutes(new Integer(intCanary));
        taskProposedDates.setProposedDate(scheduleDate);
        
        taskProposedDates = (Task) save(taskProposedDates, scopeTask).getRpmObject();
        
        assertTrue(taskProposedDates.getProposedDate().getDurationInMinutes().intValue() == intCanary);
        

        scheduleDate = new WbsScheduleDate();
        scheduleDate.setStartDate(Calendar.getInstance());
        taskProposedDates.setProposedDate(scheduleDate);
        
        taskProposedDates = (Task) save(taskProposedDates, scopeTask).getRpmObject();
        
//        assertTrue(taskProposedDates.getProposedDate().getDurationInMinutes().intValue() == intCanary);
    }
}
