/*
 * Created on 20-Dec-06
 * @author mmatwiy
 * Validation test cases for generic WorkElements; to be extended by other tests.
 */
package com.ibm.rpm.client.junit.wbs.testcases.validation;

import com.ibm.rpm.client.junit.framework.testcases.GenericValidation;
import com.ibm.rpm.client.junit.framework.testcases.RPMExceptionMock;
import com.ibm.rpm.framework.constants.ErrorCodes;
import com.ibm.rpm.wbs.constants.ValidationConstants;
import com.ibm.rpm.wbs.containers.WorkElement;

public class AbstractTestWorkElementValidation extends GenericValidation
{

    public void testReadOnlyFields(WorkElement workElement) throws AssertionError, Exception
    {
        // set read-only fields
        workElement.setReferenceID(new Long(123));
        
        RPMExceptionMock[] expectedWarnings =
        {
                createRPMException(ErrorCodes.READ_ONLY_FIELD, workElement
                    .getClass().getName(),
                    ValidationConstants.REFERENCE_ID_FIELD, workElement.getID()),
        };

        verifySaveMustFail(workElement, null, null, expectedWarnings);
    }
}
