/*
 * Created on 4-Jan-07
 * @author mmatwiy
 * 
 * Testing join conditions where the manager join specifies a field name. Eg:
 * TimecodeManager.getSubTableJoinCondition:
 *      if (manager instanceof SummaryTimesheetManager)
        {
            if ("timecode1".equalsIgnoreCase(container.getFieldName()))
            {

 * For subJoins, the getFieldName had to be modified to getPreviousFieldName
 * because we now store the field name on the parent table for an xpath query (see XpathUtil).
 * 
 * Some of these tests already existed and aren't duplicated here.
 *  
 */
package com.ibm.rpm.client.junit.xpath.testcases.fixes;

import com.ibm.rpm.client.junit.ClientTestController;
import com.ibm.rpm.client.junit.wbs.fixtures.TaskAssignmentFixture;
import com.ibm.rpm.financial.scope.ChargeCodeScope;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.wbs.containers.TaskAssignment;
import com.ibm.rpm.wbs.scope.TaskAssignmentScope;

public class TestJoinsOnSpecificFields extends ClientTestController
{
    public void testLoadTaskAssignmentSubJoinCostLaborCode() throws Exception
    {
        TaskAssignmentScope scope = new TaskAssignmentScope();
        scope.setCostLaborCode(new ChargeCodeScope());

        TaskAssignment taskAssignment = TaskAssignmentFixture
            .createSaveFixture(scope, this);

        RPMObject loadedObjects[] = loadFromXpath(
            "/TaskAssignment[@costLaborCode[id='"
                    + taskAssignment.getCostLaborCode().getID() + "']]", scope);
        assertNotNull(loadedObjects);
        assertNotNull(loadedObjects[0]);
    }

    public void testLoadTaskAssignmentJoinCostLaborCode() throws Exception
    {
        TaskAssignmentScope scope = new TaskAssignmentScope();
        scope.setCostLaborCode(new ChargeCodeScope());

        TaskAssignment taskAssignment = TaskAssignmentFixture
            .createSaveFixture(scope, this);

        RPMObject loadedObjects[] = loadFromXpath(
            "/TaskAssignment/@costLaborCode[id='"
                    + taskAssignment.getCostLaborCode().getID() + "']", null);
        assertNotNull(loadedObjects);
        assertNotNull(loadedObjects[0]);
    }

}
