/*
 * Created on Nov 3, 2005 
 * @author mmatwiy 
 * Contains the validation common to all containers in the Client/Cost Center section
 */
package com.ibm.rpm.clientcostcenters.checkpoints;

import java.util.List;

import com.ibm.rpm.clientcostcenters.constants.ValidationConstants;
import com.ibm.rpm.clientcostcenters.containers.GenericClient;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.util.GenericValidator;

public class GenericClientCheckpoint extends AbstractCheckpoint
{
    public void validateSave(RPMObject rpmObject, MessageContext msgCtx,
            boolean parentRequired, List validParentTypes)
    {

        super
            .isValidParent(rpmObject, msgCtx, parentRequired, validParentTypes);

        // Field validation of name (common to ClientFolder, Division, and
        // ClientCostCenter)
        GenericClient genericClient = (GenericClient) rpmObject;

        GenericValidator
        .validateMandatory(genericClient,
            ValidationConstants.NAME_FIELD, genericClient.getName(),
            msgCtx);
        
        if (genericClient.testNameModified())
        {
            GenericValidator.validateMinLength(genericClient,
                ValidationConstants.NAME_FIELD, genericClient.getName(),
                ValidationConstants.NAME_MIN, msgCtx);
            
            GenericValidator.validateMaxLength(genericClient,
                ValidationConstants.NAME_FIELD, genericClient.getName(),
                ValidationConstants.NAME_MAX, msgCtx);
        }        
    }    
    
}
