package com.ibm.rpm.communications.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class CommunicationsFolder implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected CommunicationsFolder(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Inbox = "Inbox";
	public static final CommunicationsFolder Inbox = new CommunicationsFolder(_Inbox);
	
		
	public static final String _Sent = "Sent";
	public static final CommunicationsFolder Sent = new CommunicationsFolder(_Sent);
	
		
	public static final String _Archived = "Archived";
	public static final CommunicationsFolder Archived = new CommunicationsFolder(_Archived);
	
		
	public static final String _Deleted = "Deleted";
	public static final CommunicationsFolder Deleted = new CommunicationsFolder(_Deleted);
	
		
	public static final String _NotVisible = "NotVisible";
	public static final CommunicationsFolder NotVisible = new CommunicationsFolder(_NotVisible);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static CommunicationsFolder fromValue(String value) throws IllegalStateException {
		CommunicationsFolder retVal = (CommunicationsFolder) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static CommunicationsFolder fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof CommunicationsFolder && ordinal == ((CommunicationsFolder)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((CommunicationsFolder)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final CommunicationsFolder[] VALUES = {Inbox, Sent, Archived, Deleted, NotVisible};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}