package com.ibm.rpm.communications.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class WorkflowState implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected WorkflowState(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Initial = "Initial";
	public static final WorkflowState Initial = new WorkflowState(_Initial);
	
		
	public static final String _Open = "Open";
	public static final WorkflowState Open = new WorkflowState(_Open);
	
		
	public static final String _Closed = "Closed";
	public static final WorkflowState Closed = new WorkflowState(_Closed);
	
		
	public static final String _Suspended = "Suspended";
	public static final WorkflowState Suspended = new WorkflowState(_Suspended);
	
		
	public static final String _Hanged = "Hanged";
	public static final WorkflowState Hanged = new WorkflowState(_Hanged);
	
		
	public static final String _Canceled = "Canceled";
	public static final WorkflowState Canceled = new WorkflowState(_Canceled);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static WorkflowState fromValue(String value) throws IllegalStateException {
		WorkflowState retVal = (WorkflowState) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static WorkflowState fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof WorkflowState && ordinal == ((WorkflowState)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((WorkflowState)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final WorkflowState[] VALUES = {Initial, Open, Closed, Suspended, Hanged, Canceled};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}