/*
 * Created on Dec 21, 2005
 * @author mmatwiy
 * Checkpoint validation of container GenericContract.
 */
package com.ibm.rpm.contract.checkpoints;

import java.util.List;

import com.ibm.rpm.contract.constants.ValidationConstants;
import com.ibm.rpm.contract.containers.GenericContract;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.util.GenericValidator;

public class GenericContractCheckpoint extends AbstractCheckpoint
{
    protected void validateSave(RPMObject rpmObject, MessageContext msgCtx,
            boolean parentRequired, List validParentTypes)
    {
        super.isValidParent(rpmObject, msgCtx, parentRequired,
            validParentTypes);

        GenericContract contract = (GenericContract) rpmObject;

        // validate name
        GenericValidator.validateMandatory(contract,
            ValidationConstants.NAME_FIELD, contract.getName(), msgCtx);
        
        if (contract.testNameModified())
        {
            GenericValidator.validateMinLength(contract,
                ValidationConstants.NAME_FIELD, contract.getName(),
                ValidationConstants.NAME_MIN, msgCtx);
            
            GenericValidator.validateMaxLength(contract,
                ValidationConstants.NAME_FIELD, contract.getName(),
                ValidationConstants.NAME_MAX, msgCtx);
        }
    }
    
}
