package com.ibm.rpm.contract.managers;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.text.ParseException;
import java.util.Calendar;
import java.util.HashMap;
import java.util.HashSet;

import com.ibm.rpm.contract.containers.Contract;
import com.ibm.rpm.contract.containers.ContractChargeSchedule;
import com.ibm.rpm.contract.scope.ContractScope;
import com.ibm.rpm.framework.AbstractRPMObjectManager;
import com.ibm.rpm.framework.JoinCondition;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RPMManagerFactory;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectManager;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.constants.ErrorCodes;
import com.ibm.rpm.framework.types.SeverityLevel;
import com.ibm.rpm.framework.util.ContextUtil;
import com.ibm.rpm.framework.util.DateUtil;
import com.ibm.rpm.framework.util.ExceptionUtil;
import com.ibm.rpm.framework.util.FieldValueMap;
import com.ibm.rpm.framework.util.StringUtil;



public class ContractChargeScheduleManager extends AbstractRPMObjectManager{

    private static final HashMap FIELDPROPERTYMAP = new HashMap();

    private static final HashSet CONTAINERS = new HashSet();

    static{
        

        
        //CONTAINERS.add(Container.class.getName());
    	
    	CONTAINERS.add(ContractChargeScheduleManager.class.getName());								// By SANDY
		CONTAINERS.add(ContractChargeSchedule.class.getName());			// By SANDY

        String[] objs = new String[CONTAINERS.size()];
            CONTAINERS.toArray(objs);
            for (int i = 0; i < objs.length; i++) {
                RPMManagerFactory.getInstance().addContainerToMap(objs[i],
                ContractChargeScheduleManager.class);
        }
    }
    /**
     * Column ELEMENT_ID of type Types.CHAR mapped to String.
     */
    public static final int ID_ELEMENT_ID = 1;
    public static final int TYPE_ELEMENT_ID = Types.CHAR;
    public static final String NAME_ELEMENT_ID = "CONTRACT_BREAKDOWN.ELEMENT_ID";
    //uncomment and replace PROPERTYNAME with the container property loaded from this column in upper case.
    public static final String PROPERTY_ELEMENT_ID = "ID";
    static{ FIELDPROPERTYMAP.put(PROPERTY_ELEMENT_ID,NAME_ELEMENT_ID);}

    /**
     * Column CONTRACT_ID of type Types.CHAR mapped to String.
     */
    public static final int ID_CONTRACT_ID = 2;
    public static final int TYPE_CONTRACT_ID = Types.CHAR;
    public static final String NAME_CONTRACT_ID = "CONTRACT_BREAKDOWN.CONTRACT_ID";
    //uncomment and replace PROPERTYNAME with the container property loaded from this column in upper case.
    //public static final String PROPERTY_CONTRACT_ID = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_CONTRACT_ID,NAME_CONTRACT_ID);}

    /**
     * Column CHARGE_DATE of type Types.DATE mapped to java.util.Date.
     */
    public static final int ID_CHARGE_DATE = 3;
    public static final int TYPE_CHARGE_DATE = Types.DATE;
    public static final String NAME_CHARGE_DATE = "CONTRACT_BREAKDOWN.CHARGE_DATE";
    public static final String PROPERTY_CHARGE_DATE = "SCHEDULEDATE";
    static{ FIELDPROPERTYMAP.put(PROPERTY_CHARGE_DATE,NAME_CHARGE_DATE);}

    /**
     * Column CHARGE_AMOUNT of type Types.DECIMAL mapped to java.math.BigDecimal.
     */
    public static final int ID_CHARGE_AMOUNT = 4;
    public static final int TYPE_CHARGE_AMOUNT = Types.DECIMAL;
    public static final String NAME_CHARGE_AMOUNT = "CONTRACT_BREAKDOWN.CHARGE_AMOUNT";
    public static final String PROPERTY_CHARGE_AMOUNT = "AMOUNT";
    static{ FIELDPROPERTYMAP.put(PROPERTY_CHARGE_AMOUNT,NAME_CHARGE_AMOUNT);}

    /**
     * Column REC_USER of type Types.CHAR mapped to String.
     */
    public static final int ID_REC_USER = 5;
    public static final int TYPE_REC_USER = Types.CHAR;
    public static final String NAME_REC_USER = "CONTRACT_BREAKDOWN.REC_USER";
    //uncomment and replace PROPERTYNAME with the container property loaded from this column in upper case.
    //public static final String PROPERTY_REC_USER = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_REC_USER,NAME_REC_USER);}

    /**
     * Column REC_STATUS of type Types.CHAR mapped to String.
     */
    public static final int ID_REC_STATUS = 6;
    public static final int TYPE_REC_STATUS = Types.CHAR;
    public static final String NAME_REC_STATUS = "CONTRACT_BREAKDOWN.REC_STATUS";
    //uncomment and replace PROPERTYNAME with the container property loaded from this column in upper case.
    //public static final String PROPERTY_REC_STATUS = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_REC_STATUS,NAME_REC_STATUS);}

    /**
     * Column REC_DATETIME of type Types.TIMESTAMP mapped to java.util.Date.
     */
    public static final int ID_REC_DATETIME = 7;
    public static final int TYPE_REC_DATETIME = Types.TIMESTAMP;
    public static final String NAME_REC_DATETIME = "CONTRACT_BREAKDOWN.REC_DATETIME";
    //uncomment and replace PROPERTYNAME with the container property loaded from this column in upper case.
    //public static final String PROPERTY_REC_DATETIME = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_REC_DATETIME,NAME_REC_DATETIME);}

    private static final String TABLE_NAME = "CONTRACT_BREAKDOWN";

    /**
     * Create an array of type string containing all the fields of the CONTRACT_BREAKDOWN table.
     */
    private static final String[] FIELD_NAMES = 
    {
         NAME_ELEMENT_ID
        ,NAME_CONTRACT_ID
        ,NAME_CHARGE_DATE
        ,NAME_CHARGE_AMOUNT
        ,NAME_REC_USER
        ,NAME_REC_STATUS
        ,NAME_REC_DATETIME
    };

    private static final String ALL_FIELDS;
    static{
        StringBuffer fieldcat = new StringBuffer(FIELD_NAMES[0]);
        for(int i = 1 ; i < FIELD_NAMES.length; i++)
        {
            fieldcat.append(",");
            fieldcat.append(FIELD_NAMES[i]);
        }
        ALL_FIELDS= fieldcat.toString();
    }

    /**
     * Creates a new ContractChargeScheduleManager instance.
     * @return ContractChargeScheduleManager
     */   
    public ContractChargeScheduleManager(){
        super();
    }

    public String getTableName() {
        return TABLE_NAME;
    }

    protected String[] getFieldsNames(){
        return FIELD_NAMES;
    }

    protected String getAllFields() {
        return ALL_FIELDS;
    }  

    public String getPrimaryKey() {
        
        return NAME_ELEMENT_ID;			//BY SANDY
        //return null;					//BY SANDY
    }  

    protected HashMap getPropertiesMap() {
        return FIELDPROPERTYMAP;
    }  

    protected JoinCondition getJoinCondition(RPMObjectManager manager, String condition,
            int level, String containerName, String contextName) throws RPMException
    {
    	JoinCondition joinCondition = null;
    	
    	
    	if (manager == null)
        {
            joinCondition = new JoinCondition();
            joinCondition.setTableName(getTableName());
            if (condition != null)
            {
                joinCondition.setCondition(condition);
            }
        } else if (manager instanceof ContractChargeScheduleManager) {
        	
			joinCondition = new JoinCondition();

			StringBuffer where = new StringBuffer();
			int rankLenght = 4 * level;

			String rank = TABLE_NAME + ".RANK";

			where.append("(LEVEL_ID >= ");
			where.append(level);
			where.append(") AND SUBSTR(");
			where.append(rank);
			where.append(",1,LENGTH(");
			where.append(rank);
			where.append(")- ");
			where.append(rankLenght);
			where.append(") IN (SELECT ");
			where.append(rank);
			where.append(" FROM ");
			where.append(TABLE_NAME);
			if (condition != null) {
				where.append(" WHERE ");
				where.append(condition);
			}

			joinCondition.setCondition(where.toString());
			
        } else
	    {
            ExceptionUtil.handleUnsupportedJoinCondition(this, manager,
                    ExceptionUtil.JOIN);
        }
		return joinCondition;
	}

    protected JoinCondition getSubTableJoinCondition(RPMObjectManager manager,
            String condition, int level, String containerName,
            String contextName) throws RPMException
    {
    	
    	return null;
    	/*
        
        //     supported containers
        JoinCondition joinCondition = null;

        ExceptionUtil.handleUnsupportedJoinCondition(this, manager,
                ExceptionUtil.SUB_TABLE_JOIN);

        return joinCondition;*/
    }

    protected Integer getContainerType(ResultSet resultSet) throws RPMException, SQLException {

        return new Integer(0);
    }  

    protected RPMObject createContainer(int typeId) throws RPMException {

         RPMObject object = new ContractChargeSchedule();
         return object;
     }

    protected RPMObject decodeRow(ResultSet rs, RPMObject rpmObject,
            boolean isDelta) throws RPMException, SQLException, ParseException
    {

    	ContractChargeSchedule chrgScdl = (ContractChargeSchedule) rpmObject;
        chrgScdl.setID(rs.getString(ID_ELEMENT_ID));
        if (isDelta)
        {
            chrgScdl.deltaAmount(new Double(rs.getDouble(ID_CHARGE_AMOUNT)));
            chrgScdl.deltaScheduleDate(DateUtil.convertToCalendar(rs.getDate(ID_CHARGE_DATE)));
        }
        else
        {
        	chrgScdl.setAmount(new Double(rs.getDouble(ID_CHARGE_AMOUNT)));
        	chrgScdl.setScheduleDate(DateUtil.convertToCalendar(rs.getDate(ID_CHARGE_DATE)));
        }
        return rpmObject;

    }

    protected FieldValueMap decodeRelatedFields(ResultSet resultSet,
            FieldValueMap relatedFields, int index) throws RPMException,
            SQLException
    {
    	String parentId = resultSet.getString(ID_CONTRACT_ID);
    	relatedFields.put(index, ID_CONTRACT_ID, parentId);
    	return relatedFields;
    	
    }

    protected RPMObject loadRelatedObjects(RPMObject rpmObject,
            RPMObjectScope rpmScope, MessageContext messageContext,
            FieldValueMap relatedFields, int index, boolean isDelta)
            throws RPMException, SQLException, ParseException
    {
    	if (rpmScope != null) {
    	 
			ContractScope scope = (ContractScope) rpmScope;
			
			//Parent
			if (scope.getParent() != null) {
				String oldParentId = (String) relatedFields.get(index,ID_CONTRACT_ID);
				RPMObject newParent = null;
				if (isDelta) {
					newParent = rpmObject.getParent();
					RPMObject oldParent = null;
					if (oldParentId != null) {
						oldParent = new Contract();
						oldParent.setID(oldParentId);
						oldParent.setContextName(getContextName(oldParent));
						if (newParent != null && newParent.getID() != null
								&& newParent.getID().equals(oldParentId)) {
							ContractManager manager = (ContractManager) RPMManagerFactory
				            .getInstance()
				            .getRPMObjectManager(Contract.class.getName());
							oldParent = (Contract)manager.loadByPrimaryKey(newParent, scope
									.getParent(), messageContext, true);
						} else {
							oldParent = loadByPrimaryKey(oldParent, null,
									messageContext, false);
						}
					}
					rpmObject.deltaParent(oldParent);
				} else {
					if (oldParentId != null) {
						if (newParent == null) {
							newParent = new Contract();
							newParent.setID(oldParentId);
							newParent.setContextName(getContextName(newParent));
							
							ContractManager manager = (ContractManager) RPMManagerFactory
				            .getInstance()
				            .getRPMObjectManager(Contract.class.getName());
				        
				            newParent = (Contract) manager.loadByPrimaryKey(newParent, scope.getParent(), messageContext, false);
						}
						rpmObject.setParent(newParent);
					}
				}
			}
    	}
    	
    	 return rpmObject;
    }

    private String getContextName(RPMObject rpmObject) throws RPMException {
		return ContextUtil.getInstance().getContextName(rpmObject);
	}

	protected JoinCondition getForeignKeyCondition(RPMObjectManager manager,
            String extraWhere, String contextName) throws RPMException
    {
        
		JoinCondition joinCondition = null;

        if (manager instanceof ContractChargeScheduleManager)
        {
            //where clause of the join condition
            StringBuffer condition = new StringBuffer();
            condition.append(getPrimaryKey());
            condition.append(" = ?");

            joinCondition = getJoinCondition(manager, condition.toString(), 1, null, null);
            if (extraWhere != null && extraWhere.length() > 0)
            {
                StringBuffer sb = new StringBuffer();
                sb.append(joinCondition.getCondition());
                sb.append(" AND ");
                sb.append(extraWhere);
                joinCondition.setCondition(sb.toString());
            }
            joinCondition.setTableName(getTableName());
        } else if (manager instanceof ContractManager) {
            
            StringBuffer sb = new StringBuffer();
            sb.append(" CONTRACT_ID = ? ");
            joinCondition = new JoinCondition();
            joinCondition.setCondition(sb.toString());
            joinCondition.setTableName(getTableName());

        }
        else{
            ExceptionUtil.handleUnsupportedJoinCondition(this, manager,
                ExceptionUtil.FOREIGN_KEY);
        }
        return joinCondition;
    }

    public void saveObjectParents(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext messageContext) throws RPMException, SQLException,
            ParseException
    {
        
        //Nothing 

    }

    public void createObject(RPMObject rpmObject, MessageContext messageContext)
            throws RPMException, SQLException, ParseException
    {
        // Set default values
        if (((ContractChargeSchedule)rpmObject).getAmount() == null)
            ((ContractChargeSchedule)rpmObject).setAmount(new Double(0.00));
        
        if (((ContractChargeSchedule)rpmObject).getScheduleDate() == null)
        {
            // Set the scheduleDate field to the first day of the current month
            Calendar presentDate = DateUtil.getCalendarInstance();
            int year = presentDate.get(Calendar.YEAR);
            int month = presentDate.get(Calendar.MONTH);
            
            Calendar scheduleDate = DateUtil.getCalendarInstance();
            scheduleDate.set(Calendar.YEAR, year);
            scheduleDate.set(Calendar.MONTH, month);
            scheduleDate.set(Calendar.DATE, 1);
            
            ((ContractChargeSchedule)rpmObject).setScheduleDate(scheduleDate);
        }
                        
			rpmObject.setID(SP_I_CONTRACT_CCB((ContractChargeSchedule) rpmObject,
					messageContext));
    }

    public RPMObject updateObject(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext messageContext) throws RPMException, SQLException,
            ParseException
    {
   	    SP_U_CONTRACT_CCB((ContractChargeSchedule) rpmObject, messageContext);

   	    return rpmObject;
    }

    protected void doDelete(RPMObject rpmObject, MessageContext messageContext)
            throws RPMException, SQLException, ParseException
    {
    	
    	
    			if (rpmObject != null) {
    				SP_D_CONTRACT_CCB((ContractChargeSchedule)rpmObject, messageContext);}
    	
        
    }

    private String SP_I_CONTRACT_CCB(ContractChargeSchedule rpmObject,
			MessageContext messageContext) throws SQLException, RPMException {
		String name = "SP_I_CONTRACT_CCB";
		Object args[] = new Object[2];
		args[0] = rpmObject.getParent().getID();
		args[1] = getUser(messageContext).getID();
		return executeProcedure(messageContext, name, args);
	}
    
    private String SP_U_CONTRACT_CCB(ContractChargeSchedule rpmObject,
			MessageContext messageContext) throws SQLException, RPMException {
		String name = "SP_U_CONTRACT_CCB";
		Object args[] = new Object[4];
		args[0] = rpmObject.getID();
		args[1] = DateUtil.convertToString(rpmObject.getScheduleDate());
		args[2] = rpmObject.getAmount();
		args[3] = getUser(messageContext).getID();
		
		return executeProcedure(messageContext, name, args);
	}
    
    private String SP_D_CONTRACT_CCB(ContractChargeSchedule rpmObject,
			MessageContext messageContext) throws SQLException, RPMException {
		String name = "SP_D_CONTRACT_CCB";
		Object args[] = new Object[2];
		args[0] = rpmObject.getID();
		args[1] = getUser(messageContext).getID();
		
		String retVal = null;
        try
        {
            retVal = executeProcedure(messageContext, name, args);
        }
        catch (RPMException e)
        {
            if (e.getErrorID() == 100)
            {
                String[] errorParams =
	            {
	                    StringUtil.getShortClassName(rpmObject.getClass()),
	                    args[0].toString()
	            };
	            
                // TODO better exception message
	            RPMException x = new RPMException(
	                    ErrorCodes.AM_INVALID_RPMOBJECTID, errorParams,
	                    rpmObject.getClass().getName(), null, args[0].toString());
                x.setSeverity(SeverityLevel.SevereError);
                messageContext.addException(x);
            }
        }

        return retVal;
	}
   // 2006-03-01
}