package com.ibm.rpm.customfield.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class CustomPortletCategoryGroupType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected CustomPortletCategoryGroupType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _ProjectGroup = "ProjectGroup";
	public static final CustomPortletCategoryGroupType ProjectGroup = new CustomPortletCategoryGroupType(_ProjectGroup);
	
		
	public static final String _DeliverableGroup = "DeliverableGroup";
	public static final CustomPortletCategoryGroupType DeliverableGroup = new CustomPortletCategoryGroupType(_DeliverableGroup);
	
		
	public static final String _TaskGroup = "TaskGroup";
	public static final CustomPortletCategoryGroupType TaskGroup = new CustomPortletCategoryGroupType(_TaskGroup);
	
		
	public static final String _ScopeGroup = "ScopeGroup";
	public static final CustomPortletCategoryGroupType ScopeGroup = new CustomPortletCategoryGroupType(_ScopeGroup);
	
		
	public static final String _DocumentGroup = "DocumentGroup";
	public static final CustomPortletCategoryGroupType DocumentGroup = new CustomPortletCategoryGroupType(_DocumentGroup);
	
		
	public static final String _ResourceGroup = "ResourceGroup";
	public static final CustomPortletCategoryGroupType ResourceGroup = new CustomPortletCategoryGroupType(_ResourceGroup);
	
		
	public static final String _ClientGroup = "ClientGroup";
	public static final CustomPortletCategoryGroupType ClientGroup = new CustomPortletCategoryGroupType(_ClientGroup);
	
		
	public static final String _AssetGroup = "AssetGroup";
	public static final CustomPortletCategoryGroupType AssetGroup = new CustomPortletCategoryGroupType(_AssetGroup);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static CustomPortletCategoryGroupType fromValue(String value) throws IllegalStateException {
		CustomPortletCategoryGroupType retVal = (CustomPortletCategoryGroupType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static CustomPortletCategoryGroupType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof CustomPortletCategoryGroupType && ordinal == ((CustomPortletCategoryGroupType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((CustomPortletCategoryGroupType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final CustomPortletCategoryGroupType[] VALUES = {ProjectGroup, DeliverableGroup, TaskGroup, ScopeGroup, DocumentGroup, ResourceGroup, ClientGroup, AssetGroup};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}