package com.ibm.rpm.customfield.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class FieldInputType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected FieldInputType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Text = "Text";
	public static final FieldInputType Text = new FieldInputType(_Text);
	
		
	public static final String _Currency = "Currency";
	public static final FieldInputType Currency = new FieldInputType(_Currency);
	
		
	public static final String _Date = "Date";
	public static final FieldInputType Date = new FieldInputType(_Date);
	
		
	public static final String _Numeric = "Numeric";
	public static final FieldInputType Numeric = new FieldInputType(_Numeric);
	
		
	public static final String _Datafield = "Datafield";
	public static final FieldInputType Datafield = new FieldInputType(_Datafield);
	
		
	public static final String _Checkbox = "Checkbox";
	public static final FieldInputType Checkbox = new FieldInputType(_Checkbox);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static FieldInputType fromValue(String value) throws IllegalStateException {
		FieldInputType retVal = (FieldInputType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static FieldInputType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof FieldInputType && ordinal == ((FieldInputType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((FieldInputType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final FieldInputType[] VALUES = {Text, Currency, Date, Numeric, Datafield, Checkbox};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}