/*
 * Created on 15-Nov-2005
 */
package com.ibm.rpm.document.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.clientcostcenters.containers.ClientCostCenter;
import com.ibm.rpm.document.containers.DocumentFolder;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.scopemanagement.containers.AbstractScope;
import com.ibm.rpm.wbs.containers.WorkElement;

/**
 * @author dominiqu
 */
public class DocumentFolderCheckpoint extends DocumentElementCheckpoint
{
    private static final List DOCUMENTFOLDER_PARENTS = new ArrayList();

    static
    {
        DOCUMENTFOLDER_PARENTS.add(DocumentFolder.class);
        DOCUMENTFOLDER_PARENTS.add(Asset.class);
        DOCUMENTFOLDER_PARENTS.add(ClientCostCenter.class);
        DOCUMENTFOLDER_PARENTS.add(WorkElement.class);
        DOCUMENTFOLDER_PARENTS.add(Resource.class);
        DOCUMENTFOLDER_PARENTS.add(AbstractScope.class);
        DOCUMENTFOLDER_PARENTS.add(Pool.class);
        //TODO Add other possible parents
    }

    protected static DocumentFolderCheckpoint instance = new DocumentFolderCheckpoint();

    public static DocumentFolderCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, msgCtx, true, DOCUMENTFOLDER_PARENTS);
    }
    
}
