package com.ibm.rpm.document.managers;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.text.ParseException;
import java.util.HashMap;
import java.util.HashSet;

import com.ibm.rpm.document.containers.DocumentBlobDetails;
import com.ibm.rpm.framework.AbstractRPMObjectManager;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RPMManagerFactory;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

public class DocumentBlobDetailManager extends AbstractRPMObjectManager
{


    public static final String TABLE_NAME = "DOCUMENT_BLOBS";
    
    private static final HashMap FIELDPROPERTYMAP = new HashMap();
    
    private static final HashSet CONTAINERS = new HashSet();

    // bind managers to containers.
    static
    {
        CONTAINERS.add(DocumentBlobDetails.class.getName());

        String[] objs = new String[CONTAINERS.size()];
        CONTAINERS.toArray(objs);
        for (int i = 0; i < objs.length; i++)
        {
            RPMManagerFactory.getInstance().addContainerToMap(objs[i],
                    DocumentBlobDetailManager.class);
        }
    }
    
    
    /**
     * Column ELEMENT_ID of type Types.CHAR mapped to String.
     */
    public static final int ID_ELEMENT_ID = 1;

    public static final int TYPE_ELEMENT_ID = Types.CHAR;

    public static final String NAME_ELEMENT_ID = "ELEMENT_ID";

    public static final String PROPERTY_ELEMENT_ID = "ID";
    static {
        FIELDPROPERTYMAP.put(PROPERTY_ELEMENT_ID, NAME_ELEMENT_ID);
    }
    
    /**
     * Column ATTACHMENT of type Types.VARCHAR mapped to String.
     */
    public static final int ID_ATTACHMENT = 2;

    public static final int TYPE_ATTACHMENT = Types.CHAR;

    public static final String NAME_ATTACHMENT = "ATTACHEMENT";

    public static final String PROPERTY_ATTACHMENT = "ID";
    static {
        FIELDPROPERTYMAP.put(PROPERTY_ATTACHMENT, NAME_ATTACHMENT);
    }
    
    /**
     * Used for determining which columns will be loaded by SELECT statements
     */
    private static final String[] FIELD_NAMES =
    {
        NAME_ELEMENT_ID, NAME_ATTACHMENT,
    };

    private static final String ALL_FIELDS;
    static
    {
        StringBuffer fieldcat = new StringBuffer(FIELD_NAMES[0]);
        for (int i = 1; i < FIELD_NAMES.length; i++)
        {
            fieldcat.append(",");
            fieldcat.append(FIELD_NAMES[i]);
        }
        ALL_FIELDS = fieldcat.toString();
    }

    
    
    public DocumentBlobDetailManager()
    {
        super();
    }


    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.managers.AbstractRPMObjectManager#getPropertiesMap()
     */
    protected HashMap getPropertiesMap()
    {
        return FIELDPROPERTYMAP;
    }

  
    protected RPMObject createContainer(int typeId) throws RPMException
    {
        RPMObject object = new DocumentBlobDetails();

        return object;
    }
    
    
    
    
    public void createObject(RPMObject rpmObject, MessageContext messageContext)
            throws SQLException, RPMException, ParseException
    {
        // Parent stored procedures insert rows in this table via SP_I_ stored procedures.
        // We don't insert rows from this Manager.
    }

    public String getPrimaryKey() throws RPMException
    {
        return NAME_ELEMENT_ID;
    }
    
    protected RPMObject decodeRow(ResultSet rs, RPMObject rpmObject,
            boolean isDelta) throws RPMException, SQLException, ParseException
    {
        DocumentBlobDetails file = new DocumentBlobDetails();
        
        file.setID(rs.getString(ID_ELEMENT_ID));
        file.setFilename(rs.getString(ID_ATTACHMENT));
        
        return file;
    }

    protected void doDelete(RPMObject rpmObject, MessageContext messageContext)
            throws RPMException, SQLException, ParseException
    {
        // Parent stored procedures insert rows in this table via SP_I_ stored procedures.
        // We don't insert rows from this Manager.
    }

    /**
     * Return the list of all columns to be loaded from the table.
     */
    protected String getAllFields()
    {
        return ALL_FIELDS;
    }

    protected String[] getFieldsNames()
    {
        return FIELD_NAMES;
    }

    public String getTableName()
    {
        return TABLE_NAME;
    }

    public RPMObject updateObject(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext messageContext) throws SQLException, RPMException,
            ParseException
    {
        // This table is uploaded indirectly by related stored procedures
        return null;
    }
}
