package com.ibm.rpm.document.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class DocumentStatusType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected DocumentStatusType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _CheckedOut = "CheckedOut";
	public static final DocumentStatusType CheckedOut = new DocumentStatusType(_CheckedOut);
	
		
	public static final String _NotCheckedOut = "NotCheckedOut";
	public static final DocumentStatusType NotCheckedOut = new DocumentStatusType(_NotCheckedOut);
	
		
	public static final String _Locked = "Locked";
	public static final DocumentStatusType Locked = new DocumentStatusType(_Locked);
	
		
	public static final String _Deleted = "Deleted";
	public static final DocumentStatusType Deleted = new DocumentStatusType(_Deleted);
	
		
	public static final String _Template = "Template";
	public static final DocumentStatusType Template = new DocumentStatusType(_Template);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static DocumentStatusType fromValue(String value) throws IllegalStateException {
		DocumentStatusType retVal = (DocumentStatusType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static DocumentStatusType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof DocumentStatusType && ordinal == ((DocumentStatusType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((DocumentStatusType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final DocumentStatusType[] VALUES = {CheckedOut, NotCheckedOut, Locked, Deleted, Template};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}