package com.ibm.rpm.document.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class ElementSecurityType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected ElementSecurityType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _ProjectLevel = "ProjectLevel";
	public static final ElementSecurityType ProjectLevel = new ElementSecurityType(_ProjectLevel);
	
		
	public static final String _ByInvitation = "ByInvitation";
	public static final ElementSecurityType ByInvitation = new ElementSecurityType(_ByInvitation);
	
		
	public static final String _Unrestricted = "Unrestricted";
	public static final ElementSecurityType Unrestricted = new ElementSecurityType(_Unrestricted);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static ElementSecurityType fromValue(String value) throws IllegalStateException {
		ElementSecurityType retVal = (ElementSecurityType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static ElementSecurityType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof ElementSecurityType && ordinal == ((ElementSecurityType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((ElementSecurityType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final ElementSecurityType[] VALUES = {ProjectLevel, ByInvitation, Unrestricted};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}