package com.ibm.rpm.expense.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class InvoiceStatus implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected InvoiceStatus(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Committed = "Committed";
	public static final InvoiceStatus Committed = new InvoiceStatus(_Committed);
	
		
	public static final String _Incurred = "Incurred";
	public static final InvoiceStatus Incurred = new InvoiceStatus(_Incurred);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static InvoiceStatus fromValue(String value) throws IllegalStateException {
		InvoiceStatus retVal = (InvoiceStatus) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static InvoiceStatus fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof InvoiceStatus && ordinal == ((InvoiceStatus)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((InvoiceStatus)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final InvoiceStatus[] VALUES = {Committed, Incurred};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}