package com.ibm.rpm.factory;

import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.Name;
import javax.naming.RefAddr;
import javax.naming.Reference;
import javax.naming.spi.ObjectFactory;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class StringFactory implements ObjectFactory {
    static Log logger = LogFactory.getLog(StringFactory.class);

    public StringFactory() {
       
    }

    public Object getObjectInstance(Object obj, Name name, Context nameCtx,
            Hashtable environment) throws Exception {
        String newobj = null;
        StringBuffer jndiName = new StringBuffer();
        for(int i=0; i<name.size();i++) {
        	jndiName.append(name.get(i)); if (i<(name.size()-1)) jndiName.append("/");
        }
        if (obj instanceof Reference) {
            Reference ref = (Reference) obj;
            if (ref.size()==0) {
            	// No custom properties have been found. Log a warning and return null;
            	logger.warn("No custom property have been defines for "+jndiName);
            } else {
	            RefAddr refAddr = null;
	            int pos = name.size()-1;
	            String addr = name.get(pos);
	            // Try to find a custom property name that is equal to the last part of the JNDI name
	            refAddr = ref.get(addr);
	            if (refAddr==null) {
	            	String warnText = "Could not find a custom property name that is equal to the last part of the JNDI name ("+addr+"). ";
	            	// if there is only one property, use it
	            	if (ref.size()==1){
	                	refAddr = ref.get(0);
	            		logger.warn(warnText+"The property named "+refAddr.getType()+" will be used.");
	            	} else {
	            		// There is more than one property defined, may be because a property was defined at
	            		// the StringProvider level. Assume the first one is the one we need and log a warning.
	            		refAddr = ref.get(0); 
	            		logger.warn(warnText+"More than one custom property have been found."+
	            			" The property named "+refAddr.getType()+" will be used.   " +
	            			"If custom properties have been defined at the StringProvider level, they should be removed if possible.");
	            	}
	            }
	            if ((refAddr!=null) && (refAddr.getContent()!=null)) {
		            String content = refAddr.getContent().toString();
		            newobj = new String(content);
	            }
            }
        }
        return newobj;
    }

}
