/**
 * Created on Mar 13, 2006
 * @author shahla
 */
package com.ibm.rpm.financial.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.financial.containers.ChargeCodeCategory;
import com.ibm.rpm.financial.containers.FinancialModule;
import com.ibm.rpm.financial.containers.GenericChargeCode;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;


public class ChargeCodeCategoryCheckpoint extends GenericChargeCodeCheckpoint
{
    private static final List CHARGE_CODE_PARENT_LIST = new ArrayList();
    
    static
    {
        CHARGE_CODE_PARENT_LIST.add(ChargeCodeCategory.class);
        CHARGE_CODE_PARENT_LIST.add(FinancialModule.class);
    }
    
    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        GenericValidator.validateInstance(rpmObject, ChargeCodeCategory.class,
            msgCtx);
        super.validateSave(rpmObject, rpmScope, msgCtx);
        

        if (isChargeCodePartOfDefaultChargeCodeList(rpmObject.getID()))
        {
            GenericValidator.validateReadOnlyError(rpmObject,
                ((ChargeCodeCategory) rpmObject).getName(), msgCtx);
        }

        isValidParent(rpmObject, msgCtx, false, false, CHARGE_CODE_PARENT_LIST);
    }
    
    public void validateDelete(RPMObject rpmObject,
            MessageContext messageContext)
    {
        super.validateDelete(rpmObject, messageContext);

        ChargeCodeCategory chargeCodeCC = (ChargeCodeCategory) rpmObject;

        // should not be able to delete a chargecode that is a
        // system_chargecode.
        if (chargeCodeCC.getID() != null
                && isChargeCodePartOfDefaultChargeCodeList(chargeCodeCC.getID()))
        {
            GenericValidator.validateCannotDelete(chargeCodeCC, messageContext);
        }
    }

}

