/*
 * Created on April 3, 2006 
 * @author mmatwiy 
 * Checkpoint validation of the Reconciliation checkpoint.
 */
package com.ibm.rpm.financial.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.wbs.containers.GenericProject;

public class ProjectReconciliationCheckpoint extends AbstractCheckpoint
{
    private static final List RECONCILIATION_PARENT_LIST = new ArrayList();

    protected static ProjectReconciliationCheckpoint instance = new ProjectReconciliationCheckpoint();

    static
    {
        RECONCILIATION_PARENT_LIST.add(GenericProject.class);
    }

    public static ProjectReconciliationCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.isValidParent(rpmObject, msgCtx, true, RECONCILIATION_PARENT_LIST);

        //TODO remove if we decide to support ProjectReconciliation
        RPMException e = new RPMException(
            com.ibm.rpm.framework.constants.ErrorCodes.NOT_IMPLEMENTED,
            new String[]{"ProjectReconciliation not implemented."});
        
        msgCtx.addExceptionNoThrow(e);
        
        
        /*ProjectReconciliation reconciliation = (ProjectReconciliation) rpmObject;

        if (reconciliation.testInvoiceNumberModified())
        {
            GenericValidator.validateReadOnly(reconciliation,
                ValidationConstants.INVOICE_NUMBER_FIELD, msgCtx);
            //            GenericValidator.validateMaxLength(reconciliation,
            //                ValidationConstants.INVOICE_NUMBER_FIELD, reconciliation
            //                    .getInvoiceNumber(),
            //                ValidationConstants.INVOICE_NUMBER_MAX, msgCtx);
        }

        if (reconciliation.testReconciliationReasonModified())
        {
            GenericValidator.validateReadOnly(reconciliation,
                ValidationConstants.RECONCILIATION_REASON_FIELD, msgCtx);
        }

        if (reconciliation.testDoneByModified())
        {
            GenericValidator.validateReadOnly(reconciliation,
                ValidationConstants.DONE_BY_FIELD, msgCtx);
        }

        if (reconciliation.testLastEditDateModified())
        {
            GenericValidator.validateReadOnly(reconciliation,
                ValidationConstants.LAST_EDIT_DATE_FIELD, msgCtx);
        }

        if (reconciliation.testTimesheetApprovalStatusModified())
        {
            GenericValidator.validateReadOnly(reconciliation,
                ValidationConstants.TIMESHEET_APPROVAL_STATUS_FIELD, msgCtx);
        }

        if (reconciliation.testStateModified())
        {
            if (!(reconciliation.getState() == ReconciliationState.Accepted || reconciliation
                .getState() == ReconciliationState.Rejected))
            {
                String[] errorParams =
                {
                        StringUtil.getShortClassName(reconciliation.getClass())
                                + reconciliation.getState(),
                        ReconciliationState._Accepted,
                        ReconciliationState._Rejected
                };
                RPMException e = new RPMException(
                    ErrorCodes.INVALID_PROJECT_RECONCILIATION_STATE,
                    errorParams, reconciliation.getClass().getName(),
                    ValidationConstants.RECONCILIATION_STATE_FIELD,
                    reconciliation.getID());
                addException(e, msgCtx);
            }
        }
        */
    }
}
