/**
 * Created on Feb 3, 2006
 * @author shahla
 */
package com.ibm.rpm.financial.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.financial.constants.ValidationConstants;
import com.ibm.rpm.financial.containers.TimeCodeAssignment;
import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.wbs.containers.WorkElement;


public class TimeCodeAssignmentCheckpoint extends AbstractCheckpoint
{
    private static final List TIME_CODE_ASSIGNMENT_PARENT_LIST = new ArrayList();
    protected static TimeCodeAssignmentCheckpoint instance = 
        new TimeCodeAssignmentCheckpoint();
    
    static
    {
        TIME_CODE_ASSIGNMENT_PARENT_LIST.add(WorkElement.class);
    }
    
    public static TimeCodeAssignmentCheckpoint getInstance()
    {
        return instance;
    }
    
    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        // validate the parent and the instance
        if (!super.isValidParent(rpmObject, msgCtx, true,
            TIME_CODE_ASSIGNMENT_PARENT_LIST)
                || !GenericValidator.validateInstance(rpmObject,
                    TimeCodeAssignment.class, msgCtx))
        {
            return;
        }

        // Initialize
        TimeCodeAssignment assignment = (TimeCodeAssignment) rpmObject;

        GenericValidator.validateMandatoryID(assignment,
            ValidationConstants.TIME_CODE_FIELD, assignment.getTimeCode(),
            msgCtx);
        
    }
}
