/**
 * Created on Feb 3, 2006
 * @author shahla
 */
package com.ibm.rpm.financial.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.financial.containers.TimeCodeCategory;
import com.ibm.rpm.financial.containers.TimeCodeGroup;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;

public class TimeCodeCategoryCheckpoint extends AbstractTimeCodeCheckpoint
{
    private static final List TIME_CODE_PARENT_LIST = new ArrayList();
    protected static TimeCodeCategoryCheckpoint instance = 
        new TimeCodeCategoryCheckpoint();
    
    static
    {
        TIME_CODE_PARENT_LIST.add(TimeCodeCategory.class);
        TIME_CODE_PARENT_LIST.add(TimeCodeGroup.class);
    }
    
    public static TimeCodeCategoryCheckpoint getInstance()
    {
        return instance;
    }
    
    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, rpmScope, msgCtx);
        super.isValidParent(rpmObject, msgCtx, true, TIME_CODE_PARENT_LIST);
        GenericValidator.validateInstance(rpmObject,
                    TimeCodeCategory.class, msgCtx);
    }
}
