package com.ibm.rpm.financial.constants;

public class ErrorCodes
{

    /**
     * Error codes for financials containers.
     * Error code range: 410,001 - 411,000
     * 410,001 - 410,299: validation codes
     * 410,300 - 410,499: xpath codes
     * 410,500 + : manager codes
     * 
     * These error messages usually have the container name at the beginning. 
     * The className of the RPMException will be a container.
     * All validation errors that can be thrown to an end user should
     * be of this type.
     */
    
    // validation codes
    public final static int SYSTEM_FINANCIAL_CATEGORY = 410001;

    public final static int FINANCIAL_CATEGORY_MISMATCH = 410002;
    
    public final static int FINANCIAL_FTE_READONLY = 410003;

    public final static int FINANCIAL_WBS_READONLY = 410004;
    
    public final static int TIMEPHASED_ID_REQUIRED = 410005;
    
    public final static int INVALID_PROJECT_RECONCILIATION_STATE = 410006;
    
    public final static int TIMEPHASED_INDIVIDUAL_MODIFICATION_REQUIRED = 410007;
    
    public final static int FINANCIAL_BENEFITS_CATEGORY = 410008;    
    
   
    
}