package com.ibm.rpm.financial.managers;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.text.ParseException;
import java.util.HashMap;
import java.util.HashSet;

import com.ibm.rpm.framework.AbstractRPMObjectManager;
import com.ibm.rpm.framework.JoinCondition;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RPMManagerFactory;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectManager;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.constants.ErrorCodes;
import com.ibm.rpm.framework.util.ExceptionUtil;
import com.ibm.rpm.framework.util.Manager;
import com.ibm.rpm.framework.util.SqlUtil;
import com.ibm.rpm.wbs.managers.WbsManager;
import com.ibm.rpm.xpathparser.XPathContainer;

public class ProjectReconciliationStatusManager extends
        AbstractRPMObjectManager
{

    private static final HashMap FIELDPROPERTYMAP = new HashMap();

    private static final HashSet CONTAINERS = new HashSet();

    static
    {
        //TODO remove comments to implement ProjectReconciliation
        //CONTAINERS.add(ProjectReconciliationStatus.class.getName());

        String[] objs = new String[CONTAINERS.size()];
        CONTAINERS.toArray(objs);
        for (int i = 0; i < objs.length; i++)
        {
            RPMManagerFactory.getInstance().addContainerToMap(objs[i],
                    ProjectReconciliationStatusManager.class);
        }
    }

    /**
     * Column PROJECT_ID of type Types.CHAR mapped to String.
     */
    public static final int ID_PROJECT_ID = 1;

    public static final int TYPE_PROJECT_ID = Types.CHAR;

    public static final String NAME_PROJECT_ID = "PROJECT_DETAILS.PROJECT_ID";

    public static final String PROPERTY_PROJECT_ID = "ID";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_PROJECT_ID, NAME_PROJECT_ID);
    }

    /**
     * Column RECON_FLAG of type Types.SMALLINT mapped to Integer.
     */
    public static final int ID_RECON_FLAG = 2;

    public static final int TYPE_RECON_FLAG = Types.SMALLINT;

    public static final String NAME_RECON_FLAG = "PROJECT_DETAILS.RECON_FLAG";

    public static final String PROPERTY_RECON_FLAG = "PROJECTSYNCHRONIZED";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_RECON_FLAG, SqlUtil.getBooleanValue(
                NAME_RECON_FLAG, 0));
    }

    public static final String TABLE_NAME = "PROJECT_DETAILS";

    /**
     * Create an array of type string containing all the fields of the
     * PROJECT_DETAILS table.
     */
    private static final String[] FIELD_NAMES =
    {
            NAME_PROJECT_ID, NAME_RECON_FLAG
    };

    private static final String ALL_FIELDS;
    static
    {
        StringBuffer fieldcat = new StringBuffer(FIELD_NAMES[0]);
        for (int i = 1; i < FIELD_NAMES.length; i++)
        {
            fieldcat.append(",");
            fieldcat.append(FIELD_NAMES[i]);
        }
        ALL_FIELDS = fieldcat.toString();
    };

    public ProjectReconciliationStatusManager()
    {
        super();
    }

    public String getTableName()
    {
        return TABLE_NAME;
    }

    protected String[] getFieldsNames()
    {
        return FIELD_NAMES;
    }

    protected String getAllFields()
    {
        return ALL_FIELDS;
    }

    public String getPrimaryKey()
    {

        return NAME_PROJECT_ID;
    }

    protected HashMap getPropertiesMap()
    {
        return FIELDPROPERTYMAP;
    }

    public JoinCondition getJoinCondition(RPMObjectManager manager,
            XPathContainer container, String contextName) throws RPMException
    {
        JoinCondition joinCondition = null;

        if (manager == null)
        {
            joinCondition = new JoinCondition();
            joinCondition.setTableName(getTableName());

            StringBuffer where = new StringBuffer();

            joinCondition.setCondition(where.toString());

        }
        else if (manager instanceof WbsManager)
        {

            joinCondition = new JoinCondition();
            joinCondition.appendSubSelect(WbsManager.NAME_ELEMENT_ID,
                    NAME_PROJECT_ID, getTableName(), null);
        }
        else
        {
            ExceptionUtil.handleUnsupportedJoinCondition(this, manager,
                    ExceptionUtil.JOIN);
        }

        return joinCondition;
    }

    /**
     *  
     */

    public JoinCondition getSubTableJoinCondition(RPMObjectManager manager,
            XPathContainer container, String contextName) throws RPMException
    {
        JoinCondition joinCondition = null;
        
        if (manager instanceof WbsManager)
        {

            joinCondition = new JoinCondition();
            joinCondition.appendSubSelect(WbsManager.NAME_ELEMENT_ID,
                    NAME_PROJECT_ID, getTableName(), null);
        }
        else
        {
            ExceptionUtil.handleUnsupportedJoinCondition(this, manager,
                    ExceptionUtil.JOIN);
        }

        return joinCondition;
    }

    protected RPMObject createContainer(int typeId) throws RPMException
    {
        //TODO remove comments to implement ProjectReconciliation
        //return new ProjectReconciliationStatus();
        return null;
    }

    protected RPMObject decodeRow(ResultSet rs, RPMObject rpmObject,
            boolean isDelta) throws RPMException, SQLException, ParseException
    {
        //TODO remove comments to implement ProjectReconciliation
/*        ProjectReconciliationStatus object = (ProjectReconciliationStatus) rpmObject;

        rpmObject.setID(rs.getString(ID_PROJECT_ID));

        // Note: the flag indicates that there is unsyncronized records.
        // Our field indicates that the project is synchronized which is the
        // opposite.
        Boolean isSynchronized = Boolean.FALSE;
        int sync = rs.getInt(ID_RECON_FLAG);
        if (sync == 0)
        {
            isSynchronized = Boolean.TRUE;
        }

        if (isDelta)
        {
            object.deltaProjectSynchronized(isSynchronized);
        }
        else
        {
            object.setProjectSynchronized(isSynchronized);
        }*/

        return rpmObject;
    }

    public void createObject(RPMObject rpmObject, MessageContext messageContext)
            throws RPMException, SQLException, ParseException
    {
        //do nothing
    }

    public RPMObject updateObject(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext messageContext) throws RPMException, SQLException,
            ParseException
    {
        //TODO remove comments to implement ProjectReconciliation
/*        ProjectReconciliationStatus object = (ProjectReconciliationStatus) rpmObject;

        //can only be updated to true
        if (object.testProjectSynchronizedModified()
                && object.getProjectSynchronized().booleanValue())
        {
            SP_SYNC_PRJ_RECON(object, messageContext);
        }*/

        return rpmObject;

    }
    //TODO remove comments to implement ProjectReconciliation
/*    private void SP_SYNC_PRJ_RECON(ProjectReconciliationStatus object,
            MessageContext messageContext) throws SQLException, RPMException
    {
        String name = "SP_SYNC_PRJ_RECON";

        Object args[] = new Object[3];
        if (object.getID() == null)
        {
            ExceptionUtil.handleRPMException(this, ErrorCodes.NO_ID);
        }
        args[0] = object.getID();
        args[1] = new Integer(0);
        args[2] = null;

        // we cannot use executeProcedure(messageContext, procedureName, args);
        // because SP_SYNC_PRJ_RECON does not return an error code
        Connection c = null;
        ResultSet rs = null;
        try
        {
            c = Manager.getConnection(messageContext);
            rs = Manager.executeStoredProcedure(c, name, args, true, messageContext);
            rs.next();
        }
        finally
        {
            Manager.close(rs);
            Manager.releaseConnection(c);
        }
    }
*/
    /**
     * @see com.ibm.rpm.framework.AbstractRPMObjectManager#doDelete(com.ibm.rpm.framework.RPMObject,
     *      com.ibm.rpm.framework.MessageContext)
     */
    protected void doDelete(RPMObject rpmObject, MessageContext messageContext)
            throws RPMException, SQLException, ParseException
    {
        ExceptionUtil.handleNoDelete(this, rpmObject);
    }

}
