package com.ibm.rpm.financial.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class RevenueRecognitionMethodType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected RevenueRecognitionMethodType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _NA = "NA";
	public static final RevenueRecognitionMethodType NA = new RevenueRecognitionMethodType(_NA);
	
		
	public static final String _Manual = "Manual";
	public static final RevenueRecognitionMethodType Manual = new RevenueRecognitionMethodType(_Manual);
	
		
	public static final String _Ratio = "Ratio";
	public static final RevenueRecognitionMethodType Ratio = new RevenueRecognitionMethodType(_Ratio);
	
		
	public static final String _FlowThru = "FlowThru";
	public static final RevenueRecognitionMethodType FlowThru = new RevenueRecognitionMethodType(_FlowThru);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static RevenueRecognitionMethodType fromValue(String value) throws IllegalStateException {
		RevenueRecognitionMethodType retVal = (RevenueRecognitionMethodType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static RevenueRecognitionMethodType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof RevenueRecognitionMethodType && ordinal == ((RevenueRecognitionMethodType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((RevenueRecognitionMethodType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final RevenueRecognitionMethodType[] VALUES = {NA, Manual, Ratio, FlowThru};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}