/*
 * Created on Jan 11, 2006
 */
package com.ibm.rpm.financial.util;

import java.util.HashMap;
import java.util.Map;

/**
 * @author ikusakov
 */
public class ChargeCodeUtil
{
    private static Map fteToHours = new HashMap();
    static {
        fteToHours.put("EXPENSE_FULL_TIME_EQUIVALENT", "EXPENSE_HOURS");
        fteToHours.put("CAPITAL_FULL_TIME_EQUIVALENT", "CAPITAL_HOURS");
        fteToHours.put("BENEFIT_FULL_TIME_EQUIVALENT", "BENEFIT_HOURS");
    }    
    
    /**
     * Checks if a given ChargeCode ID corresponds to system Charge Code 
     * FTE (Full Time Equivalent)
     * @param chargeCodeID
     * @return
     */
    public static boolean isFTEChargeCode(String chargeCodeID)
    {
        return chargeCodeID != null
                && (fteToHours.get(chargeCodeID.trim()) != null);
    }
    
    /**
     * Returns Hours system ChargeCode corresponding to the given FTE ChargeCode 
     * 
     * @param chargeCodeID
     * @return
     */
    public static String translateFTEChargeCodeToHours(String chargeCodeID)
    {
        return (String)fteToHours.get(chargeCodeID.trim());
    }
}
