package com.ibm.rpm.financial.util;

import java.sql.SQLException;
import java.text.ParseException;
import java.util.Calendar;
import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.ibm.rpm.financial.containers.AbstractFinancial;
import com.ibm.rpm.financial.containers.TimePhasedFinancial;
import com.ibm.rpm.financial.containers.WbsFinancial;
import com.ibm.rpm.financial.containers.WorksheetFinancial;
import com.ibm.rpm.financial.managers.WbsFinancialManager;
import com.ibm.rpm.financial.managers.WorksheetFinancialManager;
import com.ibm.rpm.framework.ManagerUtil;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RPMObjectManager;
import com.ibm.rpm.framework.util.ExceptionUtil;
import com.ibm.rpm.framework.util.SqlBuffer;
import com.ibm.rpm.wbs.containers.GenericProject;
import com.ibm.rpm.wbs.managers.WbsManager;



/**
 * Financials section contains certain abstract business rules, which are better
 * to store separately from the manager class, to avoid mixing with
 * persistence and framework code
 * 
 * @author ikusakov 
 */
public class FinancialBusinessLogicUtil
{
 
 //////////////////////////////////UTILITY METHOD FOR DEBUGGING///////////////////////////////////////////////////////
//////////////////////////////////WILL BE REMOVED BEFORE 7.1 RELEASES/////////////////////////////////////////   

    /**
     * This method may be used to print the financial matrix anytime required
     * @param result
     */
    public static void printResult(AbstractFinancial[] result, String fromTitle) //UTILITY METHOD
    {
        
//        AbstractFinancial[] financial = result;
//        String title = null;
//
//        
//        logger.debug("------------------------------------------------------------------------------------------------------");
//        logger.debug("        TITLE: "+fromTitle);
//        logger.debug("------------------------------------------------------------------------------------------------------");
//        logger.debug("  \t\tESTIMATE    \tACTUAL      \tREMAINING   \tETC     \tEAC");
//        logger.debug("------------------------------------------------------------------------------------------------------");
//
//        if (financial != null)
//        {
//            for (int i = 0; i < financial.length; i++)
//            {
//                if (financial[i] != null
//                        /*&& financial[i].getChargeCode() != null*/)
//                {
//                    Integer dbCode;
//                    try
//                    {
//                        if(financial[i].getChargeCode() != null)
//                        {
//                        dbCode = FinancialCategoryUtil.toDBCode(financial[i]
//                            .getChargeCode().getFinancialCategory());
//                        }
//                        else
//                        {
//                           dbCode = new Integer(-1); 
//                        }
//
//                        switch (dbCode.intValue())
//                        {
//                        case FinancialUtil.EXPENSE_HOUR:
//                            title = "HOU:   ";
//                            break;
//                        case FinancialUtil.EXPENSE_AVERAGE_COST:
//                            title = "AVG:   ";
//                            break;
//                        case FinancialUtil.EXPENSE_LABOR:
//                            title = "ELB:   ";
//                            break;
//                        case FinancialUtil.EXPENSE_FTE:
//                            title = "FTE:   ";
//                            break;
//
//                        default:
//                            if (financial[i].getChargeCode() != null
//                                    && financial[i].getChargeCode().getName() != null)
//                            {
//                                title = "["
//                                        + financial[i].getChargeCode()
//                                            .getName() + "] ";
//                            }
//                            else
//                            {
//                                title = "[CHARGECODE_ERROR";
//                            }
//                        }
//
//                        logger.debug(""
//                                + title
//                                + FinancialUtil.nullToZero(
//                                    financial[i].getEstimate()).doubleValue()
//                                + "        "
//                                + FinancialUtil.nullToZero(
//                                    financial[i].getActual()).doubleValue()
//                                + "      "
//                                + FinancialUtil.nullToZero(
//                                    financial[i].getRemaining()).doubleValue()
//                                + "       "
//                                + FinancialUtil.nullToZero(
//                                    financial[i].getETC()).doubleValue()
//                                + "         "
//                                + FinancialUtil.nullToZero(
//                                    financial[i].getEAC()).doubleValue()
//                                + " "
//                                + "\n"
//                                + printTimePhasedInfo(financial[i]
//                                    .getActualTimePhased(),
//                                    "[TIMEPHASED-ACTUAL] ")
//                                + "\n"
//                                + printTimePhasedInfo(financial[i]
//                                    .getEstimateTimePhased(),
//                                    "[TIMEPHASED-ESTIMATED] ") + " \n");
//
//                        logger.debug("____________________________________________________________________________________________________");
//
//                    }
//                    catch (RPMException e3)
//                    {
//                        e3.printStackTrace();
//                    }
//                }
//                else
//                {
//                    logger.debug("------------------------------------------------------------------------------------------------------");
//                    logger.debug("CHARGECODE IS NULL CHARGECODE IS NULL CHARGECODE IS NULL CHARGECODE IS NULL CHARGECODE IS NULL");
//                    logger.debug("------------------------------------------------------------------------------------------------------");
//                }
//
//            }
//        }
//        else
//        {
//            logger.debug("---------> FINANCIAL DATA IS NULL<-------------------");
//        }
//
    }
    
    private static String printTimePhasedInfo(TimePhasedFinancial[] tphased, String title)
    {
        StringBuffer buffer = new StringBuffer();
        
        if(tphased!=null && tphased.length >0)
        {
            for(int i=0; i< tphased.length; i++)
            {
                buffer.append(title+"YEAR: "+FinancialUtil.nullToZero(tphased[i].getYear()).intValue()+" "+
                                   "[JAN: "+FinancialUtil.nullToZero(tphased[i].getMonth01Value()).doubleValue()+" "+
                                   " FEB: "+FinancialUtil.nullToZero(tphased[i].getMonth02Value()).doubleValue()+" "+
                                   " MAR: "+FinancialUtil.nullToZero(tphased[i].getMonth03Value()).doubleValue()+" "+
                                   " APR: "+FinancialUtil.nullToZero(tphased[i].getMonth04Value()).doubleValue()+" "+
                                   " MAY: "+FinancialUtil.nullToZero(tphased[i].getMonth05Value()).doubleValue()+" "+
                                   " JUN: "+FinancialUtil.nullToZero(tphased[i].getMonth06Value()).doubleValue()+" "+
                                   " JUI: "+FinancialUtil.nullToZero(tphased[i].getMonth07Value()).doubleValue()+" "+
                                   " AOU: "+FinancialUtil.nullToZero(tphased[i].getMonth08Value()).doubleValue()+" "+
                                   " SEP: "+FinancialUtil.nullToZero(tphased[i].getMonth09Value()).doubleValue()+" "+
                                   " OCT: "+FinancialUtil.nullToZero(tphased[i].getMonth10Value()).doubleValue()+" "+
                                   " NOV: "+FinancialUtil.nullToZero(tphased[i].getMonth11Value()).doubleValue()+" "+
                                   " DEC: "+FinancialUtil.nullToZero(tphased[i].getMonth12Value()).doubleValue()+" "+
                                   " TOT: "+FinancialUtil.nullToZero(tphased[i].getTotalForYear()).doubleValue()+" ]");
                buffer.append(" \n");
            }
        }
        buffer.append(title+" --> NULL TIMEPHASED");
        
        return buffer.toString();
    }
    
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    

	private static final String FIELD_NAME = "minutes_per_day";

    private static final String TMT_WBS = "TMT_WBS";

    private static final String MINUTE_PER_DAY = "MINUTE_PER_DAY";
    
    private static Log logger = LogFactory.getLog(FinancialBusinessLogicUtil.class);
    

    public static void processSubElementCalculation(
            WorksheetFinancial[] financials, MessageContext messageContext)
            throws RPMException
    {
        WorksheetFinancial hourExpense = (WorksheetFinancial) FinancialUtil
            .getFinancialForChargeCode(FinancialUtil.EXPENSE_HOUR, financials);

        WorksheetFinancial laborExpense = (WorksheetFinancial) FinancialUtil
            .getFinancialForChargeCode(FinancialUtil.EXPENSE_LABOR, financials);

        WorksheetFinancial avgExpense = (WorksheetFinancial) FinancialUtil
            .getFinancialForChargeCode(FinancialUtil.EXPENSE_AVERAGE_COST,
                financials);

        WorksheetFinancial fteExpense = (WorksheetFinancial) FinancialUtil
            .getFinancialForChargeCode(FinancialUtil.EXPENSE_FTE, financials);

        if (hourExpense != null && avgExpense != null && laborExpense != null
                && fteExpense != null)
        {
            // --Fill-in line information: Remaining, EAC for HOUR and EL

            // SubElementExpenseLabor
            laborExpense.setSubElementRemaining(new Double(FinancialUtil
                .nullToZero(laborExpense.getSubElementEstimate()).doubleValue()
                    - FinancialUtil.nullToZero(
                        laborExpense.getSubElementActual()).doubleValue()));
            laborExpense.setSubElementEAC(new Double(FinancialUtil.nullToZero(
                laborExpense.getSubElementActual()).doubleValue()
                    + FinancialUtil.nullToZero(laborExpense.getSubElementETC())
                        .doubleValue()));

            // SubElementHour
            hourExpense.setSubElementRemaining(new Double(FinancialUtil
                .nullToZero(hourExpense.getSubElementEstimate()).doubleValue()
                    - FinancialUtil.nullToZero(
                        hourExpense.getSubElementActual()).doubleValue()));
            hourExpense.setSubElementEAC(new Double(FinancialUtil.nullToZero(
                hourExpense.getSubElementActual()).doubleValue()
                    + FinancialUtil.nullToZero(hourExpense.getSubElementETC())
                        .doubleValue()));

            // --Calculating AVG = EL / Hour
            // NB: Not using "FinancialUtil.nullToZero" here since it is already
            // done in the previous lines.

            // SubElementEstimate
            if (hourExpense.getSubElementEstimate().doubleValue() != 0)
            {
                avgExpense.setSubElementEstimate(new Double(laborExpense
                    .getSubElementEstimate().doubleValue()
                        / hourExpense.getSubElementEstimate().doubleValue()));
            }
            else
            {
                avgExpense.setSubElementEstimate(new Double(0));
            }

            // SubElementActual
            if (hourExpense.getSubElementActual().doubleValue() != 0)
            {
                avgExpense.setSubElementActual(new Double(laborExpense
                    .getSubElementActual().doubleValue()
                        / hourExpense.getSubElementActual().doubleValue()));
            }
            else
            {
                avgExpense.setSubElementActual(new Double(0));
            }

            // SubElementRemaining
            if (hourExpense.getSubElementRemaining().doubleValue() != 0)
            {
                avgExpense
                    .setSubElementRemaining(new Double(FinancialUtil
                        .nullToZero(laborExpense.getSubElementRemaining())
                        .doubleValue()
                            / FinancialUtil.nullToZero(
                                hourExpense.getSubElementRemaining())
                                .doubleValue()));
            }
            else
            {
                avgExpense.setSubElementRemaining(new Double(0));
            }

            // SubElementETC
            if (hourExpense.getSubElementETC().doubleValue() != 0)
            {
                avgExpense.setSubElementETC(new Double(laborExpense
                    .getSubElementETC().doubleValue()
                        / hourExpense.getSubElementETC().doubleValue()));
            }
            else
            {
                avgExpense.setSubElementETC(new Double(0));
            }

            // SubElementEAC
            if (hourExpense.getSubElementEAC().doubleValue() != 0)
            {
                avgExpense.setSubElementEAC(new Double(laborExpense
                    .getSubElementEAC().doubleValue()
                        / hourExpense.getSubElementEAC().doubleValue()));
            }
            else
            {
                avgExpense.setSubElementEAC(new Double(0));
            }

             validateFinancialMatrix(financials);

        }

    }
    //This Method will re-calculate the whole matrix based on new values that
    //were added from timephased infos. The first part is calculate Hour.Acual 
    //and Hour.Estimate by using the values of ELB and Average. Once that is done
    //we can use the usual equations to fill the rest.
    public static void processTimephasedUpdateCase(
            AbstractFinancial[] financials) throws RPMException
    {
        AbstractFinancial hourExpense = FinancialUtil
            .getFinancialForChargeCode(FinancialUtil.EXPENSE_HOUR, financials);

        AbstractFinancial laborExpense = FinancialUtil
            .getFinancialForChargeCode(FinancialUtil.EXPENSE_LABOR, financials);

        AbstractFinancial avgExpense = FinancialUtil.getFinancialForChargeCode(
            FinancialUtil.EXPENSE_AVERAGE_COST, financials);

        if (hourExpense != null && avgExpense != null && laborExpense != null)
        {
            //calculating Hour = EL / AVG for ESTIMATE
            if (FinancialUtil.nullToZero(avgExpense.getEstimate())
                .doubleValue() != 0)
            {
                hourExpense.setEstimate(new Double(FinancialUtil.nullToZero(
                    laborExpense.getEstimate()).doubleValue()
                        / FinancialUtil.nullToZero(avgExpense.getEstimate())
                            .doubleValue()));
            }
            else
            {
                hourExpense.setEstimate(new Double(0));
            }

            //calculating Hour = EL / AVG for ACTUAL
            if (FinancialUtil.nullToZero(avgExpense.getActual()).doubleValue() != 0)
            {
                hourExpense.setActual(new Double(FinancialUtil.nullToZero(
                    laborExpense.getActual()).doubleValue()
                        / FinancialUtil.nullToZero(avgExpense.getActual())
                            .doubleValue()));
            }
            else
            {
                hourExpense.setActual(new Double(0));
            }
            
            //--------This section will fiil-in missing values for the
            
            // financial matrix------||

            //Step1: Calculate ELB line

            //ELB Remaining = ELB Estimate - ELB Actual
            laborExpense.setRemaining(new Double(FinancialUtil.nullToZero(
                laborExpense.getEstimate()).doubleValue()
                    - FinancialUtil.nullToZero(laborExpense.getActual())
                        .doubleValue()));

            //ELB ETC = ELB Remaining -----> but if remaining <0 then etc = 0
            laborExpense.setETC(new Double(FinancialUtil
                .negative2Zero(FinancialUtil.nullToZero(
                    laborExpense.getRemaining()).doubleValue())));

            //ELB EAC = ELB Actual + ELB ETC
            laborExpense.setEAC(new Double(FinancialUtil.nullToZero(
                laborExpense.getActual()).doubleValue()
                    + FinancialUtil.nullToZero(laborExpense.getETC())
                        .doubleValue()));

            //Step2: Calculate Hour Line

            //Hour Remaining = Hour Estimate - Hour Actual
            hourExpense.setRemaining(new Double(FinancialUtil.nullToZero(
                hourExpense.getEstimate()).doubleValue()
                    - FinancialUtil.nullToZero(hourExpense.getActual())
                        .doubleValue()));

            //Hour ETC = Hour Remaining -----> but if remaining <0 then etc = 0
            hourExpense.setETC(new Double(FinancialUtil
                .negative2Zero(FinancialUtil.nullToZero(
                    hourExpense.getRemaining()).doubleValue())));

            //Hour EAC = Hour Actual + Hour ETC
            hourExpense.setEAC(new Double(FinancialUtil.nullToZero(
                hourExpense.getActual()).doubleValue()
                    + FinancialUtil.nullToZero(hourExpense.getETC())
                        .doubleValue()));

            //step3: Calculate AVG by using: AVG(x) = ELB(x) / Hour(x)

            //AVG Remaining
            if (FinancialUtil.nullToZero(hourExpense.getRemaining())
                .doubleValue() != 0)
            {
                avgExpense.setRemaining(new Double(FinancialUtil.nullToZero(
                    laborExpense.getRemaining()).doubleValue()
                        / FinancialUtil.nullToZero(hourExpense.getRemaining())
                            .doubleValue()));
            }
            else
            {
                avgExpense.setRemaining(new Double(0));
            }

            //AVG ETC
            if (FinancialUtil.nullToZero(hourExpense.getETC()).doubleValue() != 0)
            {//negative
                avgExpense.setETC(new Double(FinancialUtil
                    .negative2Zero(FinancialUtil.nullToZero(
                        laborExpense.getETC()).doubleValue()
                            / FinancialUtil.nullToZero(hourExpense.getETC())
                                .doubleValue())));
            }
            else
            {
                avgExpense.setETC(new Double(0));
            }

            //AVG EAC
            if (FinancialUtil.nullToZero(hourExpense.getEAC()).doubleValue() != 0)
            {
                avgExpense.setEAC(new Double(FinancialUtil.nullToZero(
                    laborExpense.getEAC()).doubleValue()
                        / FinancialUtil.nullToZero(hourExpense.getEAC())
                            .doubleValue()));
            }
            else
            {
                avgExpense.setEAC(new Double(0));
            }
            
            
            validateFinancialMatrix(financials);
        }
    }
    
    
    //This method will cycle through the worksheetFinancials and  update the DB
    // after re-calculating the worksheet matrix;
    public static void saveUpdateTimephasedToBD(AbstractFinancial[] financials,
            MessageContext messageContext, RPMObjectManager manager)
            throws SQLException, RPMException, ParseException
    {
        FinancialBusinessLogicUtil.printResult(financials,"saveUpdateTimephasedToBD: BEFORE");
        FinancialBusinessLogicUtil.processTimephasedUpdateCase(financials);
        FinancialBusinessLogicUtil.printResult(financials,"saveUpdateTimephasedToBD: AFTER");

        for (int i = 0; i < financials.length; i++)
        {
            if(manager instanceof WbsFinancialManager)
            {
                ((WbsFinancialManager)manager).SP_U_BUDGET(financials[i], messageContext);
            }
            else
            {
                ((WorksheetFinancialManager)manager).SP_U_BUDGET(financials[i], messageContext);
            }
        }

    }
    


    /**
     * This method will decode the calculated values when loading custom financials.
     * 
     * @param financial
     *            financial object to modify
     */
    public static void decodeCustomChargeCodeBusinessRules(AbstractFinancial financial)
    {    
        
               // Implementing GUI-level business rules
        financial
            .setRemaining(new Double(FinancialUtil.nullToZero(
                financial.getEstimate()).doubleValue()
                    - FinancialUtil.nullToZero(financial.getActual())
                        .doubleValue()));

        financial.setEAC(new Double(FinancialUtil.nullToZero(
            financial.getActual()).doubleValue()
                + FinancialUtil.nullToZero(financial.getETC()).doubleValue()));

        financial.setEACVariance(new Double(FinancialUtil.nullToZero(
            financial.getEAC()).doubleValue()
                - FinancialUtil.nullToZero(financial.getEstimate())
                    .doubleValue()));

        financial.setBaselineVariance(new Double(FinancialUtil.nullToZero(
            financial.getEstimate()).doubleValue()
                - FinancialUtil.nullToZero(financial.getBaseline())
                    .doubleValue()));

        // -----SubElement Calculations
        if(financial instanceof WorksheetFinancial)
        {
            WorksheetFinancial wfinancial = (WorksheetFinancial)financial;
            wfinancial
            .setSubElementRemaining(new Double(FinancialUtil.nullToZero(
                wfinancial.getSubElementEstimate()).doubleValue()
                    - FinancialUtil.nullToZero(wfinancial.getSubElementActual())
                        .doubleValue()));

            wfinancial.setSubElementEAC(new Double(FinancialUtil.nullToZero(
                wfinancial.getSubElementActual()).doubleValue()
                + FinancialUtil.nullToZero(wfinancial.getSubElementETC()).doubleValue()));
        }

        printResult(new AbstractFinancial[]{financial},"decodeCustomChargeCodeBusinessRules");
     }
    
    /**
     * This method will do some extra validation for the financial matrix
     * regarding rounding, null values etc.
     * 
     * @param financialArray
     */
    public static void validateFinancialMatrix(
            AbstractFinancial[] financialArray)
    {
        if (financialArray != null)
        {
            for (int i = 0; i < financialArray.length; i++)
            {
                AbstractFinancial financial = financialArray[i];

                if (financial != null)
                {
                    financial.setEstimate(FinancialUtil
                        .roundDouble2Dec(financial.getEstimate()));
                    
                    financial.setActual(FinancialUtil
                        .roundDouble2Dec(financial.getActual()));
                    
                    financial.setRemaining(FinancialUtil
                        .roundDouble2Dec(financial.getRemaining()));
                    
                    financial.setETC(FinancialUtil
                        .roundDouble2Dec(financial.getETC()));
                    
                    financial.setEAC(FinancialUtil
                        .roundDouble2Dec(financial.getEAC()));
                    
                    financial.setEACVariance(FinancialUtil
                        .roundDouble2Dec(financial.getEACVariance()));
                    
                    if(financial instanceof WorksheetFinancial)
                    {
                        WorksheetFinancial wfinancial = (WorksheetFinancial)financial;
                        
                        wfinancial.setSubElementEstimate(FinancialUtil
                            .roundDouble2Dec(wfinancial.getSubElementEstimate()));
                        
                        wfinancial.setSubElementActual(FinancialUtil
                            .roundDouble2Dec(wfinancial.getSubElementActual()));
                        
                        wfinancial.setSubElementRemaining(FinancialUtil
                            .roundDouble2Dec(wfinancial.getSubElementRemaining()));
                        
                        wfinancial.setSubElementETC(FinancialUtil
                            .roundDouble2Dec(wfinancial.getSubElementETC()));
                        
                        wfinancial.setSubElementEAC(FinancialUtil
                            .roundDouble2Dec(wfinancial.getSubElementEAC()));

                    }
                }
            }
        }
    }

    /**
     * This method is called when data is fetched from the DB and we need to
     * fill in the blanks or do some conversions.
     * 
     * @param financial
     * @throws RPMException
     */
    public static void decodeBusinessRulesForWFinancialsOnLoading(
            AbstractFinancial[] financial, MessageContext messageContext) throws RPMException
    {     
        if (financial != null)
        {
            AbstractFinancial hourExpense = FinancialUtil
                .getFinancialForChargeCode(FinancialUtil.EXPENSE_HOUR,
                    financial);

            AbstractFinancial laborExpense = FinancialUtil
                .getFinancialForChargeCode(FinancialUtil.EXPENSE_LABOR,
                    financial);

            AbstractFinancial avgExpense = FinancialUtil
                .getFinancialForChargeCode(FinancialUtil.EXPENSE_AVERAGE_COST,
                    financial);
            
            AbstractFinancial fteExpense = FinancialUtil
                .getFinancialForChargeCode(FinancialUtil.EXPENSE_FTE, 
                    financial);


            if (hourExpense != null && avgExpense != null
                    && laborExpense != null && fteExpense != null)
            {
                // HOUR-----------------------------------------------------|
                hourExpense.setRemaining(new Double(FinancialUtil.nullToZero(
                    hourExpense.getEstimate()).doubleValue()
                        - FinancialUtil.nullToZero(hourExpense.getActual())
                            .doubleValue()));

                //Negative ETC should be reset to Zero
                hourExpense.setETC(new Double(FinancialUtil
                    .negative2Zero(FinancialUtil.nullToZero(
                        hourExpense.getETC()).doubleValue())));
                
                hourExpense.setEAC(new Double(FinancialUtil.nullToZero(
                    hourExpense.getActual()).doubleValue()
                        + FinancialUtil.nullToZero(hourExpense.getETC())
                            .doubleValue()));

                hourExpense.setEACVariance(new Double(FinancialUtil.nullToZero(
                    hourExpense.getEAC()).doubleValue()
                        - FinancialUtil.nullToZero(hourExpense.getEstimate())
                            .doubleValue()));

                hourExpense.setBaselineVariance(new Double(FinancialUtil
                    .nullToZero(hourExpense.getEstimate()).doubleValue()
                        - FinancialUtil.nullToZero(hourExpense.getBaseline())
                            .doubleValue()));

                // LABOR-----------------------------------------------------|
                laborExpense.setRemaining(new Double(FinancialUtil.nullToZero(
                    laborExpense.getEstimate()).doubleValue()
                        - FinancialUtil.nullToZero(laborExpense.getActual())
                            .doubleValue()));

                //Negative ETC should be reset to Zero
                laborExpense.setETC(new Double(FinancialUtil
                    .negative2Zero(FinancialUtil.nullToZero(
                        laborExpense.getETC()).doubleValue())));

                laborExpense.setEAC(new Double(FinancialUtil.nullToZero(
                    laborExpense.getActual()).doubleValue()
                        + FinancialUtil.nullToZero(laborExpense.getETC())
                            .doubleValue()));

                laborExpense.setEACVariance(new Double(FinancialUtil
                    .nullToZero(laborExpense.getEAC()).doubleValue()
                        - FinancialUtil.nullToZero(laborExpense.getEstimate())
                            .doubleValue()));

                laborExpense.setBaselineVariance(new Double(FinancialUtil
                    .nullToZero(laborExpense.getEstimate()).doubleValue()
                        - FinancialUtil.nullToZero(laborExpense.getBaseline())
                            .doubleValue()));

                // AVG------------------------------------------------------|
                if (FinancialUtil.nullToZero(hourExpense.getRemaining())
                    .doubleValue() != 0)
                {
                    avgExpense.setRemaining(new Double(FinancialUtil
                        .nullToZero(laborExpense.getRemaining()).doubleValue()
                            / FinancialUtil.nullToZero(
                                hourExpense.getRemaining()).doubleValue()));
                }

                //Negative ETC should be reset to Zero
                avgExpense.setETC(new Double(FinancialUtil
                    .negative2Zero(FinancialUtil.nullToZero(
                        avgExpense.getETC()).doubleValue())));

                if (FinancialUtil.nullToZero(hourExpense.getEAC())
                    .doubleValue() != 0)
                {
                    avgExpense.setEAC(new Double(FinancialUtil.nullToZero(
                        laborExpense.getEAC()).doubleValue()
                            / FinancialUtil.nullToZero(hourExpense.getEAC())
                                .doubleValue()));
                }

                if (FinancialUtil.nullToZero(hourExpense.getEACVariance())
                    .doubleValue() != 0)
                {
                    avgExpense.setEACVariance(new Double(FinancialUtil
                        .nullToZero(laborExpense.getEACVariance())
                        .doubleValue()
                            / FinancialUtil.nullToZero(
                                hourExpense.getEACVariance()).doubleValue()));
                }

                if (FinancialUtil.nullToZero(hourExpense.getBaselineVariance())
                    .doubleValue() != 0)
                {
                    avgExpense.setBaselineVariance(new Double(FinancialUtil
                        .nullToZero(laborExpense.getBaselineVariance())
                        .doubleValue()
                            / FinancialUtil.nullToZero(
                                hourExpense.getBaselineVariance())
                                .doubleValue()));
                }

                //FTE----------------------------------------------------------| 
                // is a read-only financial and is calculated only on loading
                // Need to update financial fte which doesn't follow the same
                // rules...
                    calculateFTEUsingMinutesPerday(fteExpense,
                        hourExpense, messageContext);

                validateFinancialMatrix(financial);
            }

        }
    }
    


    /**
     * This method will scan for cell updates and fill in the entire line
     * NB: when saving the matrix we only need to calculate cells for
     * Estimate, Actual, ETC the others are calculated in the loading process.
     * 
     * @param financials
     * @throws RPMException
     */
    
    public static void processFinancialMatrixLines(
            AbstractFinancial[] financials) throws RPMException
    {
        if (financials != null)
        {

            AbstractFinancial hourExpense = FinancialUtil
                .getFinancialForChargeCode(FinancialUtil.EXPENSE_HOUR,
                    financials);

            AbstractFinancial avgExpense = FinancialUtil
                .getFinancialForChargeCode(FinancialUtil.EXPENSE_AVERAGE_COST,
                    financials);

            AbstractFinancial laborExpense = FinancialUtil
                .getFinancialForChargeCode(FinancialUtil.EXPENSE_LABOR,
                    financials);

            //we want to calculate the line for worksheetFinancial and wbsFinancial
            if ((hourExpense != null && avgExpense != null && laborExpense != null)
                    || (financials.length > 0 && financials[0] instanceof WbsFinancial))
            {
                Double newValue = null;

                for (int i = 0; i < financials.length; i++)
                {
                    AbstractFinancial financial = financials[i];

                    if ((financial.testEstimateModified() || financial
                        .testActualModified())
                            && (!financial.testETCModified()))
                    {
                        newValue = new Double(FinancialUtil
                            .negative2Zero(FinancialUtil.nullToZero(
                                financial.getEstimate()).doubleValue()
                                    - FinancialUtil.nullToZero(
                                        financial.getActual()).doubleValue()));
                        financial.deltaETC(newValue);
                        financial.setETC(newValue);
                    }
                }
                validateFinancialMatrix(financials);
            }
        }
    }
    
    /**
     * This method will fix the inconsistency for
     * Labor.Estimate - Labor.Actual != Hour.ETC*Hour.AVG
     * therefor we must do the following :
     * 
     * Labor.ETC = Labor.Estimate - Labor.Actual
     * Hour.ETC = Hour.Estimate - Hour.Actual
     * Avg.ETC = Labor.ETC / Hour.ETC
     * 
     * @param hourExpense
     * @param avgExpense
     * @param laborExpense
     */
    private static void processETCInconsistency(AbstractFinancial hourExpense,
            AbstractFinancial avgExpense, AbstractFinancial laborExpense)
    {
        Double newValue = null;

        newValue = new Double(FinancialUtil.nullToZero(
            laborExpense.getEstimate()).doubleValue()
                - FinancialUtil.nullToZero(laborExpense.getActual())
                    .doubleValue());
        laborExpense.deltaETC(newValue);
        laborExpense.setETC(newValue);

        newValue = new Double(FinancialUtil.nullToZero(
            hourExpense.getEstimate()).doubleValue()
                - FinancialUtil.nullToZero(hourExpense.getActual())
                    .doubleValue());
        hourExpense.deltaETC(newValue);
        hourExpense.setETC(newValue);

        if (FinancialUtil.nullToZero(hourExpense.getETC()).doubleValue() != 0)
        {
            newValue = new Double(FinancialUtil.nullToZero(
                laborExpense.getETC()).doubleValue()
                    / FinancialUtil.nullToZero(hourExpense.getETC())
                        .doubleValue());
            avgExpense.deltaETC(newValue);
            avgExpense.setETC(newValue);
        }
        else
        {
            newValue = new Double(0);
            avgExpense.deltaETC(newValue);
            avgExpense.setETC(newValue);
        }

    }
    
    public static void processFinancialMatrixColumns(
            AbstractFinancial[] financials) throws RPMException
    {
        AbstractFinancial hourExpense = FinancialUtil
            .getFinancialForChargeCode(FinancialUtil.EXPENSE_HOUR, financials);

        AbstractFinancial avgExpense = FinancialUtil.getFinancialForChargeCode(
            FinancialUtil.EXPENSE_AVERAGE_COST, financials);

        AbstractFinancial laborExpense = FinancialUtil
            .getFinancialForChargeCode(FinancialUtil.EXPENSE_LABOR, financials);

        if (hourExpense != null && avgExpense != null && laborExpense != null)
        {
            //-------Case  ESTIMATE COLUMN MODIFIED-------------------------|
            if (FinancialUtil.isFinancialColumnModified(
                FinancialUtil.COL_ESTIMATE, hourExpense, avgExpense,
                laborExpense))
            {
                processEstimateColumnModified(hourExpense, avgExpense, laborExpense);

            }
            else //-----Case Estimate ESTIMATE COLUMN NOT MODIFIED----------|
            {
                processEstimateColumnNotModified(hourExpense, avgExpense, laborExpense);
            }

            //---Case  ACTUAL COLUMN MODIFIED-----------------------------|
            if (FinancialUtil
                .isFinancialColumnModified(FinancialUtil.COL_ACTUAL,
                    hourExpense, avgExpense, laborExpense))
            {
                processActualColumnModified(hourExpense, avgExpense, laborExpense);

            }
            else//-----Case ACTUAL COLUMN  NOT MODIFIED-----------------------|
            {
                processActualColumnNotModified(hourExpense, avgExpense, laborExpense);

            }

            //-------Case ETC COLUMN MODIFIED-----------------------------|
            if (FinancialUtil.isFinancialColumnModified(FinancialUtil.COL_ETC,
                hourExpense, avgExpense, laborExpense))
            {
                processETCColumnModified(hourExpense, avgExpense, laborExpense);

            }
            else//---Case ETC COLUMN NOT MODIFIED-----------------------------|
            {
                processETCColumnNotModified(hourExpense, avgExpense, laborExpense);
            }
           
            printResult(financials,"processFinancialMatrixColumns");
            validateFinancialMatrix(financials);

        }
    }

    private static void processETCColumnNotModified(
            AbstractFinancial hourExpense, AbstractFinancial avgExpense,
            AbstractFinancial laborExpense)
    {
        Double newValue = null;
        
        //LOGIC: |---> L.Etc != H.Etc * A.Etc <--| 
        if (FinancialUtil.nullToZero(laborExpense.getETC())
            .doubleValue() != (FinancialUtil.nullToZero(
            hourExpense.getETC()).doubleValue() * FinancialUtil
            .nullToZero(avgExpense.getETC()).doubleValue()))
        {
            if (FinancialUtil.isFinancialLineModified(avgExpense)
                    && FinancialUtil.isFinancialLineModified(hourExpense)
                    && !FinancialUtil.isFinancialLineModified(laborExpense)
                    && !laborExpense.testETCModified())
            {
                newValue = new Double(FinancialUtil.nullToZero(
                    hourExpense.getETC()).doubleValue()
                        * FinancialUtil.nullToZero(avgExpense.getETC())
                            .doubleValue());
                laborExpense.deltaETC(newValue);
                laborExpense.setETC(newValue);
            }
            else if (FinancialUtil.isFinancialLineModified(avgExpense)
                    && FinancialUtil.isFinancialLineModified(laborExpense)
                    && !FinancialUtil.isFinancialLineModified(hourExpense)
                    && !hourExpense.testETCModified())
            {                
                if (FinancialUtil.nullToZero(avgExpense.getETC()).doubleValue() != 0)
                {
                    newValue = new Double(FinancialUtil.nullToZero(
                        laborExpense.getETC()).doubleValue()
                            / FinancialUtil.nullToZero(avgExpense.getETC())
                                .doubleValue());
                    hourExpense.deltaETC(newValue);
                    hourExpense.setETC(newValue);
                }
            }
            else if (FinancialUtil.isFinancialLineModified(hourExpense)
                    && FinancialUtil.isFinancialLineModified(laborExpense)
                    && !FinancialUtil.isFinancialLineModified(avgExpense)
                    && !avgExpense.testETCModified())
            {
                if (FinancialUtil.nullToZero(hourExpense.getETC())
                    .doubleValue() != 0)
                {
                    newValue = new Double(FinancialUtil.nullToZero(
                        laborExpense.getETC()).doubleValue()
                            / FinancialUtil.nullToZero(hourExpense.getETC())
                                .doubleValue());
                    avgExpense.deltaETC(newValue);
                    avgExpense.setETC(newValue);
                }
            }
        }
    }

    private static void processETCColumnModified(AbstractFinancial hourExpense,
            AbstractFinancial avgExpense, AbstractFinancial laborExpense)
    {
        Double newValue = null;
        
        //LOGIC: |---> L.E && [!H.E && !A.E] <--|d
        if (laborExpense.testETCModified()
                && (!hourExpense.testETCModified() && !avgExpense
                    .testETCModified()))
        {
            // Case: Labor is saved but Hour and Avg are already set so
            // we must calculate
            // hour = el /avg for Estimate and do the same thing if
            // LaborActual is modified too.
            // For ETC it's a little tricky since we must find the
            // correct Hour.ETC and AVG.ETC
            if (FinancialUtil.nullToZero(hourExpense.getETC())
                .doubleValue() != 0
                    && FinancialUtil.nullToZero(avgExpense.getETC())
                        .doubleValue() != 0
                    && (FinancialUtil.nullToZero(hourExpense.getETC())
                        .doubleValue() != FinancialUtil.nullToZero(
                        hourExpense.getEstimate()).doubleValue()
                            - FinancialUtil.nullToZero(
                                hourExpense.getActual()).doubleValue())
                    && (FinancialUtil.nullToZero(laborExpense.getETC())
                        .doubleValue() != FinancialUtil.nullToZero(
                        hourExpense.getETC()).doubleValue()
                            * FinancialUtil.nullToZero(
                                avgExpense.getETC()).doubleValue()))
            {
                // HOURetc = HOURestimate-HOURactual
                newValue = new Double(FinancialUtil.nullToZero(
                    hourExpense.getEstimate()).doubleValue()
                        - FinancialUtil.nullToZero(
                            hourExpense.getActual()).doubleValue());
                hourExpense.deltaETC(newValue);
                hourExpense.setETC(newValue);

                // AVGetc = ELetc / HOURetc
                newValue = new Double(FinancialUtil.nullToZero(
                    laborExpense.getETC()).doubleValue()
                        / FinancialUtil
                            .nullToZero(hourExpense.getETC())
                            .doubleValue());
                avgExpense.deltaETC(newValue);
                avgExpense.setETC(newValue);
            }
            else
            {
                if (FinancialUtil.nullToZero(avgExpense.getETC())
                    .doubleValue() != 0
                        && !hourExpense.testETCModified())
                {
                    newValue = new Double(FinancialUtil.nullToZero(
                        laborExpense.getETC()).doubleValue()
                            / FinancialUtil.nullToZero(
                                avgExpense.getETC()).doubleValue());
                    hourExpense.deltaETC(newValue);
                    hourExpense.setETC(newValue);
                }
                else if (!hourExpense.testETCModified())
                {
                    newValue = new Double(0);
                    hourExpense.deltaETC(newValue);
                    hourExpense.setETC(newValue);
                }
            }
        }

        //LOGIC: |---> L.E && [H.E && !A.E] <--|
        else if (laborExpense.testETCModified()
                && hourExpense.testETCModified()
                && !avgExpense.testETCModified())
        {
            if (FinancialUtil.nullToZero(hourExpense.getETC())
                .doubleValue() != 0
                    && !avgExpense.testETCModified())
            {
                newValue = new Double(FinancialUtil.nullToZero(
                    laborExpense.getETC()).doubleValue()
                        / FinancialUtil
                            .nullToZero(hourExpense.getETC())
                            .doubleValue());
                avgExpense.deltaETC(newValue);
                avgExpense.setETC(newValue);
            }
            else if (!avgExpense.testETCModified())
            {
                newValue = new Double(0);
                avgExpense.deltaETC(newValue);
                avgExpense.setETC(newValue);
            }

        }

        //LOGIC: |---> L.E && [!H.E && A.E] <--|
        else if (laborExpense.testETCModified()
                && avgExpense.testETCModified()
                && !hourExpense.testETCModified())
        {
            if (FinancialUtil.nullToZero(avgExpense.getETC())
                .doubleValue() != 0
                    && !hourExpense.testETCModified())
            {
                newValue = new Double(FinancialUtil.nullToZero(
                    laborExpense.getETC()).doubleValue()
                        / FinancialUtil.nullToZero(avgExpense.getETC())
                            .doubleValue());
                hourExpense.deltaETC(newValue);
                hourExpense.setETC(newValue);
            }
            else if (!hourExpense.testETCModified())
            {
                newValue = new Double(0);
                hourExpense.deltaETC(newValue);
                hourExpense.setETC(newValue);
            }
        }
        //LOGIC: |---> !L.E && [H.E && A.E] <--|
        else if (!laborExpense.testETCModified()
                && hourExpense.testETCModified()
                && avgExpense.testETCModified()
                && FinancialUtil.isFinancialColumnModified(
                    FinancialUtil.COL_ESTIMATE, hourExpense, avgExpense,
                    laborExpense)
                || FinancialUtil.isFinancialColumnModified(
                    FinancialUtil.COL_ACTUAL, hourExpense, avgExpense,
                    laborExpense)
                && FinancialUtil.isFinancialColumnModified(
                    FinancialUtil.COL_ETC, hourExpense, avgExpense,
                    laborExpense))
        {
            //Case: We are saving Hour, Average (Estimate, Actual, ETC)
            //      therefor we need not ot use [Estimate-Actual]
            if ((FinancialUtil.nullToZero(hourExpense.getETC()).doubleValue() != (FinancialUtil
                .nullToZero(hourExpense.getEstimate()).doubleValue() - FinancialUtil
                .nullToZero(hourExpense.getActual()).doubleValue())))

            {

                newValue = new Double(FinancialUtil.nullToZero(
                    hourExpense.getETC()).doubleValue()
                        * FinancialUtil.nullToZero(avgExpense.getETC())
                            .doubleValue());
                laborExpense.deltaETC(newValue);
                laborExpense.setETC(newValue);
            }
            //Case: We are saving Hour, Average (Estimate, Actual)
            else if ((FinancialUtil.nullToZero(hourExpense.getETC())
                .doubleValue() == (FinancialUtil.nullToZero(
                hourExpense.getEstimate()).doubleValue() - FinancialUtil
                .nullToZero(hourExpense.getActual()).doubleValue())))
            {
                // Case: Labor.Estimate - Labor.Actual != Hour.ETC*Hour.AVG
                if (FinancialUtil.nullToZero(laborExpense.getEstimate())
                    .doubleValue() != 0
                        && FinancialUtil.nullToZero(laborExpense.getActual())
                            .doubleValue() != 0
                        && (FinancialUtil
                            .nullToZero(laborExpense.getEstimate())
                            .doubleValue()
                                - FinancialUtil.nullToZero(
                                    laborExpense.getActual()).doubleValue() != 0))
                {
                    processETCInconsistency(hourExpense, avgExpense,
                        laborExpense);
                }
                else
                {
                    newValue = new Double(FinancialUtil.nullToZero(
                        hourExpense.getETC()).doubleValue()
                            * FinancialUtil.nullToZero(avgExpense.getETC())
                                .doubleValue());
                    laborExpense.deltaETC(newValue);
                    laborExpense.setETC(newValue);
                }

            }

        }
        else if (!FinancialUtil.isFinancialColumnModified(
            FinancialUtil.COL_ESTIMATE, hourExpense, avgExpense, laborExpense)
                && !FinancialUtil.isFinancialColumnModified(
                    FinancialUtil.COL_ACTUAL, hourExpense, avgExpense,
                    laborExpense)
                && FinancialUtil.isFinancialColumnModified(
                    FinancialUtil.COL_ETC, hourExpense, avgExpense,
                    laborExpense))
        {
         
            processETCColumnNotModified(hourExpense, avgExpense, laborExpense);
        }
        //Case: Only Average has been modified so EL = Hour x Avg
        else if(!FinancialUtil.isFinancialLineModified(hourExpense) &&
                FinancialUtil.isFinancialLineModified(laborExpense) &&
                FinancialUtil.isFinancialLineModified(avgExpense) &&
                avgExpense.testETCModified())
        {
            newValue = new Double(FinancialUtil.nullToZero(
                hourExpense.getETC()).doubleValue()
                    * FinancialUtil.nullToZero(avgExpense.getETC())
                        .doubleValue());
            laborExpense.deltaETC(newValue);
            laborExpense.setETC(newValue);

        }

    }

    private static void processActualColumnNotModified(
            AbstractFinancial hourExpense, AbstractFinancial avgExpense,
            AbstractFinancial laborExpense)
    {
        Double newValue = null;
        
        //LOGIC: |---> L.Act != H.Act * A.Act <--| 
        if (FinancialUtil.nullToZero(laborExpense.getActual())
            .doubleValue() != (FinancialUtil.nullToZero(
            hourExpense.getActual()).doubleValue() * FinancialUtil
            .nullToZero(avgExpense.getActual()).doubleValue()))
        {
            if (FinancialUtil.isFinancialLineModified(avgExpense)
                    && FinancialUtil.isFinancialLineModified(hourExpense)
                    && !FinancialUtil.isFinancialLineModified(laborExpense))
            {
                newValue = new Double(FinancialUtil.nullToZero(
                    hourExpense.getActual()).doubleValue()
                        * FinancialUtil.nullToZero(
                            avgExpense.getActual()).doubleValue());
                laborExpense.deltaActual(newValue);
                laborExpense.setActual(newValue);
            }
            else if (FinancialUtil.isFinancialLineModified(avgExpense)
                    && FinancialUtil.isFinancialLineModified(laborExpense)
                    && !FinancialUtil.isFinancialLineModified(hourExpense))
            {
                newValue = new Double(FinancialUtil.nullToZero(
                    laborExpense.getActual()).doubleValue()
                        / FinancialUtil.nullToZero(
                            avgExpense.getActual()).doubleValue());
                hourExpense.deltaActual(newValue);
                hourExpense.setActual(newValue);
            }
            else if (FinancialUtil.isFinancialLineModified(hourExpense)
                    && FinancialUtil.isFinancialLineModified(laborExpense)
                    && !FinancialUtil.isFinancialLineModified(avgExpense))
            {
                if (FinancialUtil.nullToZero(hourExpense.getActual())
                    .doubleValue() != 0)
                {
                    newValue = new Double(FinancialUtil.nullToZero(
                        laborExpense.getActual()).doubleValue()
                            / FinancialUtil.nullToZero(hourExpense.getActual())
                                .doubleValue());
                    avgExpense.deltaActual(newValue);
                    avgExpense.setActual(newValue);
                }
            }
        }
    }

    private static void processActualColumnModified(
            AbstractFinancial hourExpense, AbstractFinancial avgExpense,
            AbstractFinancial laborExpense)
    {
        Double newValue = null;
        
        //LOGIC: |---> L.E && [!H.E && !A.E] <--|
        if (laborExpense.testActualModified()
                && (!hourExpense.testActualModified() && !avgExpense
                    .testActualModified()))
        {
            // Case: Labor is saved but Hour and Avg are already set so
            // we must calculate
            // hour = el /avg for Estimate and do the same thing if
            // LaborActual is modified too.

            if (FinancialUtil.nullToZero(hourExpense.getActual())
                .doubleValue() != 0
                    && FinancialUtil.nullToZero(avgExpense.getActual())
                        .doubleValue() != 0)
            {
                // hour = el /avg;
                newValue = new Double(FinancialUtil.nullToZero(
                    laborExpense.getActual()).doubleValue()
                        / FinancialUtil.nullToZero(
                            avgExpense.getActual()).doubleValue());
                hourExpense.deltaActual(newValue);
                hourExpense.setActual(newValue);

            }
            else
            {

                if (FinancialUtil.nullToZero(avgExpense.getActual())
                    .doubleValue() != 0)
                {
                    newValue = new Double(FinancialUtil.nullToZero(
                        laborExpense.getActual()).doubleValue()
                            / FinancialUtil.nullToZero(
                                avgExpense.getActual()).doubleValue());
                    hourExpense.deltaActual(newValue);
                    hourExpense.setActual(newValue);
                }
                else
                {
                    newValue = new Double(0);
                    hourExpense.deltaActual(newValue);
                    hourExpense.setActual(newValue);
                }
            }
        }

        //LOGIC: |---> L.E && [H.E && !A.E] <--|
        else if (laborExpense.testActualModified()
                && hourExpense.testActualModified()
                && !avgExpense.testActualModified())
        {
            if (FinancialUtil.nullToZero(hourExpense.getActual())
                .doubleValue() != 0)
            {
                newValue = new Double(FinancialUtil.nullToZero(
                    laborExpense.getActual()).doubleValue()
                        / FinancialUtil.nullToZero(
                            hourExpense.getActual()).doubleValue());
                avgExpense.deltaActual(newValue);
                avgExpense.setActual(newValue);
            }
            else
            {
                newValue = new Double(0);
                avgExpense.deltaActual(newValue);
                avgExpense.setActual(newValue);
            }
        }

        //LOGIC: |---> L.E && [!H.E && A.E] <--|
        else if (laborExpense.testActualModified()
                && avgExpense.testActualModified()
                && !hourExpense.testActualModified())
        {
            if (FinancialUtil.nullToZero(avgExpense.getActual())
                .doubleValue() != 0)
            {
                newValue = new Double(FinancialUtil.nullToZero(
                    laborExpense.getActual()).doubleValue()
                        / FinancialUtil.nullToZero(
                            avgExpense.getActual()).doubleValue());
                hourExpense.deltaActual(newValue);
                hourExpense.setActual(newValue);
            }
            else
            {
                newValue = new Double(0);
                hourExpense.deltaActual(newValue);
                hourExpense.setActual(newValue);
            }
        }
        else //LOGIC: |---> Anything Else <--|
        {
            newValue = new Double(FinancialUtil.nullToZero(
                hourExpense.getActual()).doubleValue()
                    * FinancialUtil.nullToZero(avgExpense.getActual())
                        .doubleValue());
            laborExpense.deltaActual(newValue);
            laborExpense.setActual(newValue);
        }
    }

    private static void processEstimateColumnNotModified(
            AbstractFinancial hourExpense, AbstractFinancial avgExpense,
            AbstractFinancial laborExpense)
    {
        Double newValue = null;
        
        //LOGIC: |---> L.Est != H.Est * A.Est <--|                
        if (FinancialUtil.nullToZero(laborExpense.getEstimate())
            .doubleValue() != (FinancialUtil.nullToZero(
            hourExpense.getEstimate()).doubleValue() * FinancialUtil
            .nullToZero(avgExpense.getEstimate()).doubleValue()))
        {
            if (FinancialUtil.isFinancialLineModified(avgExpense)
                    && FinancialUtil.isFinancialLineModified(hourExpense)
                    && !FinancialUtil.isFinancialLineModified(laborExpense))
            {
                newValue = new Double(FinancialUtil.nullToZero(
                    hourExpense.getEstimate()).doubleValue()
                        * FinancialUtil.nullToZero(
                            avgExpense.getEstimate()).doubleValue());
                laborExpense.deltaEstimate(newValue);
                laborExpense.setEstimate(newValue);
            }
            else if (FinancialUtil.isFinancialLineModified(avgExpense)
                    && FinancialUtil.isFinancialLineModified(laborExpense)
                    && !FinancialUtil.isFinancialLineModified(hourExpense))
            {
                if (FinancialUtil.nullToZero(avgExpense.getEstimate())
                    .doubleValue() != 0)
                {
                    newValue = new Double(FinancialUtil.nullToZero(
                        laborExpense.getEstimate()).doubleValue()
                            / FinancialUtil
                                .nullToZero(avgExpense.getEstimate())
                                .doubleValue());
                    hourExpense.deltaEstimate(newValue);
                    hourExpense.setEstimate(newValue);
                }
            }
            else if (FinancialUtil.isFinancialLineModified(hourExpense)
                    && FinancialUtil.isFinancialLineModified(laborExpense)
                    && !FinancialUtil.isFinancialLineModified(avgExpense))
            {
                if (FinancialUtil.nullToZero(hourExpense.getEstimate())
                    .doubleValue() != 0)
                {
                    newValue = new Double(FinancialUtil.nullToZero(
                        laborExpense.getEstimate()).doubleValue()
                            / FinancialUtil.nullToZero(
                                hourExpense.getEstimate()).doubleValue());
                    avgExpense.deltaEstimate(newValue);
                    avgExpense.setEstimate(newValue);
                }
            }
        }
    }

    private static void processEstimateColumnModified(
            AbstractFinancial hourExpense, AbstractFinancial avgExpense,
            AbstractFinancial laborExpense)
    {
        Double newValue = null;
        
        //LOGIC: |---> L.E && [!H.E && !A.E] <--|
        if (laborExpense.testEstimateModified()
                && (!hourExpense.testEstimateModified() && !avgExpense
                    .testEstimateModified()))
        {
            // Case: Labor is saved but Hour and Avg are already set so
            // we must calculate
            // hour = el /avg for Estimate and do the same thing if
            // LaborActual is modified too.
            if (FinancialUtil.nullToZero(hourExpense.getEstimate())
                .doubleValue() != 0
                    && FinancialUtil.nullToZero(
                        avgExpense.getEstimate()).doubleValue() != 0)
            {
                // hour = el /avg;
                newValue = new Double(FinancialUtil.nullToZero(
                    laborExpense.getEstimate()).doubleValue()
                        / FinancialUtil.nullToZero(
                            avgExpense.getEstimate()).doubleValue());
                hourExpense.deltaEstimate(newValue);
                hourExpense.setEstimate(newValue);
            }
            else
            {
                if (FinancialUtil.nullToZero(avgExpense.getEstimate())
                    .doubleValue() != 0)
                {
                    newValue = new Double(FinancialUtil.nullToZero(
                        laborExpense.getEstimate()).doubleValue()
                            / FinancialUtil.nullToZero(
                                avgExpense.getEstimate()).doubleValue());
                    hourExpense.deltaEstimate(newValue);
                    hourExpense.setEstimate(newValue);
                }
                else
                {
                    newValue = new Double(0);
                    hourExpense.deltaEstimate(newValue);
                    hourExpense.setEstimate(newValue);
                }
            }
        }
        //LOGIC: |---> L.E && [H.E && !A.E] <--|
        else if (laborExpense.testEstimateModified()
                && hourExpense.testEstimateModified()
                && !avgExpense.testEstimateModified())
        {
            if (FinancialUtil.nullToZero(hourExpense.getEstimate())
                .doubleValue() != 0)
            {
                newValue = new Double(FinancialUtil.nullToZero(
                    laborExpense.getEstimate()).doubleValue()
                        / FinancialUtil.nullToZero(
                            hourExpense.getEstimate()).doubleValue());
                avgExpense.deltaEstimate(newValue);
                avgExpense.setEstimate(newValue);
            }
            else
            {
                newValue = new Double(0);
                avgExpense.deltaEstimate(newValue);
                avgExpense.setEstimate(newValue);
            }
        }
        
        //LOGIC: |---> L.E && [!H.E && A.E] <--|
        else if (laborExpense.testEstimateModified()
                && avgExpense.testEstimateModified()
                && !hourExpense.testEstimateModified())
        {
            if (FinancialUtil.nullToZero(avgExpense.getEstimate())
                .doubleValue() != 0)
            {
                newValue = new Double(FinancialUtil.nullToZero(
                    laborExpense.getEstimate()).doubleValue()
                        / FinancialUtil.nullToZero(
                            avgExpense.getEstimate()).doubleValue());
                hourExpense.deltaEstimate(newValue);
                hourExpense.setEstimate(newValue);
            }
            else
            {
                newValue = new Double(0);
                hourExpense.deltaEstimate(newValue);
                hourExpense.setEstimate(newValue);
            }
        }
        else //LOGIC: |---> Anything Else <--|
        {
            newValue = new Double(FinancialUtil.nullToZero(
                hourExpense.getEstimate()).doubleValue()
                    * FinancialUtil
                        .nullToZero(avgExpense.getEstimate())
                        .doubleValue());
            laborExpense.deltaEstimate(newValue);
            laborExpense.setEstimate(newValue);
        }
    }    
    
//        return state;
//    }

    /**
     * FTE (Full Time Equivalent) line is treated exclusively in RPM Client UI
     * The values from the DB are never displayed, but calculated values appear,
     * based on TMT_WBS table, SP_S_FTE() results and Financial object for Hours
     * 
     * Business rules are located in AssignBudgetViewFrame.pas see methods
     * LoadDataEx() and updateFTE()
     * 
     * @param fteFinancial
     * @param hoursFinancial
     * @param wbsTableData
     *            special columns from TMT_WBS and TMT_CRI
     * @param spData
     *            data from SP_S_FTE
     */
    public static void calculateFTEForWbsFinancial(WbsFinancial fteFinancial,
            WbsFinancial hoursFinancial, Map wbsTableData, Map spData,MessageContext messageContext)throws RPMException
    {
        // Retrieving variables
        double schedRemaining = ((Double) spData.get("SCHED_REMAINING"))
            .doubleValue();

        long fSchedRemaining = (long) schedRemaining;
        long fSchedDuration = (long) (((Double) wbsTableData
            .get("UNRESOLVED_DURATION")).doubleValue());
        long fActualDuration = (long) (((Double) wbsTableData
            .get("ACTUAL_DURATION")).doubleValue());
        long fSchedBaseline1Duration = (long) (((Double) wbsTableData
            .get("BASELINE1_DURATION")).doubleValue());
        long fSchedBaseline2Duration = (long) (((Double) wbsTableData
            .get("BASELINE2_DURATION")).doubleValue());
        long fSchedBaseline3Duration = (long) (((Double) wbsTableData
            .get("BASELINE3_DURATION")).doubleValue());

 
        // Calculating
        if (fSchedDuration != 0)
        {
            fteFinancial.setEstimate(new Double(FinancialUtil.nullToZero(
                hoursFinancial.getEstimate()).doubleValue()
                    * 60 / fSchedDuration));
        }
        if (fActualDuration != 0)
        {
            fteFinancial.setActual(new Double(FinancialUtil.nullToZero(
                hoursFinancial.getActual()).doubleValue()
                    * 60 / fActualDuration));
        }
        if (fSchedRemaining != 0)
        {
            fteFinancial.setRemaining(new Double(FinancialUtil.nullToZero(
                hoursFinancial.getRemaining()).doubleValue()
                    * 60 / fSchedRemaining));
        }
        if (fSchedRemaining != 0)
        {
            fteFinancial.setETC(new Double(FinancialUtil.nullToZero(
                hoursFinancial.getETC()).doubleValue()
                    * 60 / fSchedRemaining));
        }
        if (fSchedDuration != 0)
        {
            fteFinancial.setEAC(new Double(FinancialUtil.nullToZero(
                hoursFinancial.getEAC()).doubleValue()
                    * 60 / fSchedDuration));
        }

        if (fSchedBaseline1Duration != 0)
        {
            fteFinancial.setBaseline(new Double(FinancialUtil.nullToZero(
                hoursFinancial.getBaseline()).doubleValue()
                    * 60 / fSchedBaseline1Duration));
        }
        if (fSchedBaseline2Duration != 0)
        {
            fteFinancial.setBaselinePrevious(new Double(FinancialUtil
                .nullToZero(hoursFinancial.getBaselinePrevious()).doubleValue()
                    * 60 / fSchedBaseline2Duration));
        }
        if (fSchedBaseline3Duration != 0)
        {
            fteFinancial.setBaselineInitial(new Double(FinancialUtil
                .nullToZero(hoursFinancial.getBaselineInitial()).doubleValue()
                    * 60 / fSchedBaseline3Duration));
        }
        fteFinancial.setProbabilityAmount(new Double(0));
    }

    /**
     * FTE (Full Time Equivalent) line is treated exclusively in RPM Client UI
     * The values from the DB are never displayed, but calculated values appear,
     * based on TMT_WBS table, SP_S_FTE() results and Financial object for Hours
     * 
     * Business rules are located in AssignBudgetViewFrame.pas see methods
     * LoadDataEx() and updateFTE()
     * 
     * @param fteFinancial
     * @param hoursFinancial
     * @param wbsTableData
     *            special columns from TMT_WBS and TMT_CRI
     * @param spData
     *            data from SP_S_FTE
     * @throws RPMException 
     * @throws Exception 
     */
    public static void calculateFTEForWorksheetFinancial(
            WorksheetFinancial fteFinancial, WorksheetFinancial hoursFinancial,
            Map wbsTableData, Map spData,MessageContext messageContext) throws RPMException
    {
        
         // Retrieving variables
        double estRemaining = ((Double) spData.get("EST_REMAINING"))
            .doubleValue();

        long fEstRemaining = (long) estRemaining;
        long fEstBaseline1Duration = (long) (((Double) wbsTableData
            .get("ESTIMATED_BASELINE1_DURATION")).doubleValue());
        long fEstBaseline2Duration = (long) (((Double) wbsTableData
            .get("ESTIMATED_BASELINE2_DURATION")).doubleValue());
        long fEstBaseline3Duration = (long) (((Double) wbsTableData
            .get("ESTIMATED_BASELINE3_DURATION")).doubleValue());
        long fEstDuration = (long) (((Double) wbsTableData
            .get("START_FINISH_DURATION")).doubleValue());
        long fEstActual = fEstDuration - fEstRemaining;

        if (fEstActual == 0)
            fEstActual = 480; // MinutesPerDay

        calculateFTEUsingMinutesPerday(fteFinancial, hoursFinancial, messageContext);

        //-----| BaseLines 

        if (fEstBaseline1Duration != 0)
        {
            fteFinancial.setBaseline(new Double(FinancialUtil.nullToZero(
                hoursFinancial.getBaseline()).doubleValue()
                    * 60 / fEstBaseline1Duration));
        }
        if (fEstBaseline2Duration != 0)
        {
            fteFinancial.setBaselinePrevious(new Double(FinancialUtil
                .nullToZero(hoursFinancial.getBaselinePrevious()).doubleValue()
                    * 60 / fEstBaseline2Duration));
        }
        if (fEstBaseline3Duration != 0)
        {
            fteFinancial.setBaselineInitial(new Double(FinancialUtil
                .nullToZero(hoursFinancial.getBaselineInitial()).doubleValue()
                    * 60 / fEstBaseline3Duration));
        }

        //-----| Probability Amount
        fteFinancial.setProbabilityAmount(new Double(0));
    }

    private static void calculateFTEUsingMinutesPerday(
            AbstractFinancial fteFinancial, AbstractFinancial hoursFinancial,
            MessageContext messageContext) throws RPMException
    {
        double pDailyHour = 0;
        GenericProject parent = null;

        // FTE = Hours / Minutes_Per_day
        // Since the save might not have a calendar scope we must use the
        // utility
        // method: ManagerUtil.selectColumnValue() to get the data from the DB
        // by way of the parent.
        // The value in the DB is x60 so we must divide it by 60 to the get the
        // correct value.
        if (hoursFinancial.getParent() instanceof GenericProject)
        {
            parent = (GenericProject) hoursFinancial.getParent();
            
            if (parent.getCalendar() == null)
            {
                // Preparing SQL conditions and statements to do a select
                // We need to get the value of Minute_Per_day column from
                // TMT_WBS
                SqlBuffer condition = new SqlBuffer();
                condition.appendEqualQuestionMark(WbsManager.NAME_ELEMENT_ID);

                Object[] arguments = new Object[]
                {
                    parent.getID()
                };
                
                pDailyHour = ((Double) ManagerUtil.selectColumnValue(
                    Double.class, parent, FIELD_NAME, MINUTE_PER_DAY, TMT_WBS,
                    condition, arguments, messageContext)).doubleValue();                
            }
            else
            {
                pDailyHour = parent.getMinutesPerDay().doubleValue();
            }

           
            if (pDailyHour != 0)
            {
                pDailyHour = pDailyHour / 60;
                
                // ------| Estimate, Actual, Remaining, ETC, EAC
                if (pDailyHour != 0)
                {
                    fteFinancial.setEstimate(new Double(FinancialUtil
                        .nullToZero(hoursFinancial.getEstimate()).doubleValue()
                            / pDailyHour));
                }
                if (pDailyHour != 0)
                {
                    fteFinancial.setActual(new Double(FinancialUtil.nullToZero(
                        hoursFinancial.getActual()).doubleValue()
                            / pDailyHour));
                }
                if (pDailyHour != 0)
                {
                    fteFinancial.setRemaining(new Double(FinancialUtil
                        .nullToZero(hoursFinancial.getRemaining())
                        .doubleValue()
                            / pDailyHour));
                }
                if (pDailyHour != 0)
                {
                    fteFinancial.setETC(new Double(FinancialUtil.nullToZero(
                        hoursFinancial.getETC()).doubleValue()
                            / pDailyHour));
                }
                if (pDailyHour != 0)
                {
                    fteFinancial.setEAC(new Double(FinancialUtil.nullToZero(
                        hoursFinancial.getEAC()).doubleValue()
                            / pDailyHour));
                }
                
                //we need to take into acocunt the duration depending on
                //the start and finish dates.
                calculateFTEBasedOnStartFinishDate(fteFinancial, parent, messageContext); 
            }

        }
    }

    private static void calculateFTEBasedOnStartFinishDate(
            AbstractFinancial fteFinancial, GenericProject parent,
            MessageContext messageContext)
            throws RPMException
    {
        Calendar todayDate = null;
        Calendar startDate = null;
        Calendar finishDate = null;

        //today - end
        int remainingDuration = 0;
        //start - today
        int actualDuration = 0;
        //start - finish
        int estimateDuration = 0;

        try
        {
            todayDate = FinancialUtil.getTodayDate();

            startDate = parent.getEstimatedStartDate();

            finishDate = parent.getEstimatedFinishDate();
            
            if (todayDate != null && startDate != null && finishDate != null
                    && parent.getCalendar() != null
                    && todayDate.before(finishDate)
                    && (!startDate.equals(finishDate)))
            {
                //---Calculating Durations for estimate, actual, remaining

                remainingDuration = FinancialUtil.getCalWorkingDaysDuration(
                    parent.getCalendar(), todayDate, finishDate);

                //If the current time is after the working hour for the day
                //according to the calendar we must calculate duration from start
                // to today otherwise we calculate from start to yesterday.
                if (FinancialUtil.isEndOfDayCompareToCalendar(parent
                    .getCalendar(), messageContext.getFactory()
                    .getManagerCaller().getDatabaseTimestamp(messageContext)))
                {
                    actualDuration = FinancialUtil.getCalWorkingDaysDuration(
                        parent.getCalendar(), startDate, todayDate);
                }
                else
                {
                    actualDuration = FinancialUtil.getCalWorkingDaysDuration(
                        parent.getCalendar(), startDate, FinancialUtil
                            .getYesterdayDate());
                }

                estimateDuration = FinancialUtil.getCalWorkingDaysDuration(
                    parent.getCalendar(), startDate, finishDate);

                //-------Updating fte values

                //Remaining
                if (todayDate.before(finishDate) && remainingDuration != 0)
                {
                    fteFinancial.setRemaining(new Double(FinancialUtil
                        .nullToZero(fteFinancial.getRemaining()).doubleValue()
                            / remainingDuration));
                }

                //Actual
                if (todayDate.before(finishDate) && actualDuration != 0)
                {
                    fteFinancial.setActual(new Double(FinancialUtil.nullToZero(
                        fteFinancial.getActual()).doubleValue()
                            / actualDuration));
                }

                //Estimate
                if (todayDate.before(finishDate) && estimateDuration != 0)
                {
                    fteFinancial.setEstimate(new Double(FinancialUtil
                        .nullToZero(fteFinancial.getEstimate()).doubleValue()
                            / estimateDuration));
                }

                //ETC
                if (todayDate.before(finishDate) && remainingDuration != 0)
                {
                    fteFinancial.setETC(new Double(FinancialUtil.nullToZero(
                        fteFinancial.getETC()).doubleValue()
                            / remainingDuration));
                }

                //EAC
                if (todayDate.before(finishDate) && estimateDuration != 0)
                {
                    fteFinancial.setEAC(new Double(FinancialUtil.nullToZero(
                        fteFinancial.getEAC()).doubleValue()
                            / estimateDuration));
                }
            }

        }
        catch (Exception e)
        {
            ExceptionUtil.handleException(FinancialBusinessLogicUtil.class, e);
        }

    }
}
