package com.ibm.rpm.financial.util;

import java.util.HashMap;
import java.util.Map;

import com.ibm.rpm.financial.types.TimePhasedType;

/**
 * Converts TimePhasedType <--> BUDGETS.TIMEPHASED_FLAG and BUDGETS.AUTO_TIMEPHASED_FLAG 
 * 
 * @author ikusakov
 */
public class TimePhasedTypeToDBMap
{
    private static Map toDBMap;

    private static Map dbToType;

    static
    {
        toDBMap = new HashMap();
        dbToType = new HashMap();

        addToMap(TimePhasedType.NotTimephased, 0);
        addToMap(TimePhasedType.ProjectAssignment, 1);
        addToMap(TimePhasedType.AutoTimephased, 2);
        addToMap(TimePhasedType.ManuallyTimephased, 3);
    }

    private static void addToMap(TimePhasedType fc, int dbCode)
    {
        Long codeObject = new Long(dbCode);
        toDBMap.put(fc, codeObject);
        dbToType.put(codeObject, fc);
    }

    public static Long toDBCode(TimePhasedType fc)
    {
        Long value = (Long) toDBMap.get(fc);
        return value;
    }

    public static TimePhasedType toType(int dbCode)
    {
        Long key = new Long(dbCode);
        TimePhasedType value = (TimePhasedType) dbToType.get(key);
        return value;
    }
}
