/*
 * Created on Jul 20, 2006
 */
package com.ibm.rpm.framework;

import com.ibm.rpm.metadata.model.Container;
import com.ibm.rpm.metadata.model.MetadataStore;

/**
 * @author gosselin
 */
public class ContainerCheckoutModeType
{
    private String value;

    public static final String None = "None";

    public static final String Parent = "Parent";

    public static final String Self= "Self";

    public static final ContainerCheckoutModeType NoneType = 
        new ContainerCheckoutModeType(None);

    public static final ContainerCheckoutModeType ParentType = 
        new ContainerCheckoutModeType(Parent);

    public static final ContainerCheckoutModeType SelfType = 
        new ContainerCheckoutModeType(Self);
    
    protected ContainerCheckoutModeType(String value)
    {
        this.value = value;
    }
    
    public static ContainerCheckoutModeType getContainerCheckoutModeType(RPMObject rpmObject)
    {
        MetadataStore store = MetadataStore.getInstance();
        Container container = store.getContainerByJavaClass(rpmObject
            .getClass());
        String mode = container.getCheckoutModeType();
        return new ContainerCheckoutModeType(mode);
    }

    public String getValue()
    {
        return value;
    }
    public boolean equals(ContainerCheckoutModeType obj)
    {
        return this.value.equalsIgnoreCase(obj.getValue());
    }
    
    public boolean equals(String mode)
    {
        return this.value.equalsIgnoreCase(mode);
    }

    public String toString()
    {
        return value;
    }
}
