package com.ibm.rpm.framework.constants;

public class ErrorCodes
{
    /**
     * SQL error codes.
     */
    public final static int SQL_ERROR_ROW_NOT_FOUND = 100;
    
    /**
     * Middleware error codes
     */
    public final static int FAILED_LOGIN = 100009;
    
    /**
     * RPM Database error codes. 
     */
    public final static int RECORD_NOT_FOUND = 200058;
    
    public final static int USER_DOES_NOT_EXIST = 200005;
    
    /**
     * Validation error codes for containers These error messages usually have
     * the container name at the beginning The className of the RPMException
     * will be a container All validation errors that can be thrown to an end user should
     * be of this type
     * 
     * Error code range: 400,000 - 401,000
     * 400,001 - 400,299: validation codes
     * 400,300 - 400,499: xpath codes
     * 400,500 + : manager codes
     */

    public final static int MAX_LENGTH = 400001;

    public final static int MAX_SIZE = 400002;

    public final static int OUT_OF_RANGE = 400003;

    public final static int INVALID_DATES = 400004;

    public final static int INVALID_CHARS = 400005;

    public final static int MANDATORY = 400006;

    public final static int CONDITIONAL_MANDATORY = 400007;

    public final static int INVALID_CONDITIONAL_VALUE = 400008;

    public final static int NOT_EXISTING_ID = 400009;

    public final static int NOT_UNIQUE = 400010;

    public final static int NO_ID = 400011;

    public final static int MUST_BE_NULL = 400012;

    public final static int INVALID_RPMOBJECT_TYPE = 400013;

    public final static int INVALID_TYPE = 400014;

    public final static int WRONG_PARENT_TYPE = 400015;

    public final static int NO_PARENT_ID = 400017;

    public final static int NO_PARENT = 400018;

    public final static int EXCEEDS_MAX_NESTING_LEVEL = 400019;

    public final static int INVALID_SCOPE = 400025;

    public final static int UNAVAILABLE_CHECKIN_CHECKOUT = 400026;

    public final static int READ_ONLY_VALUE_EXISTS = 400030;

    public final static int READ_ONLY_VALUE_MISSING = 400031;

    public final static int NOT_VALID_VALUE_MISSING = 400032;

    public final static int NOT_ACTIVE = 400034;
    
    public final static int GREATER_THAN_OR_EQUAL_FIELD = 400037;
    
    public final static int LESS_THAN_OR_EQUAL = 400038;
    
    public final static int LEADING_SPACE = 400040;
    
    public final static int INVALID_VALUE = 400041;
    
    public final static int RELOAD_TYPE_INVALID = 400044;
    
    public final static int WRONG_NUMBER_OF_DEFAULTS = 400045;
    
    public final static int READ_ONLY_FIELD = 400046;
    
    public final static int GREATER_THAN_OR_EQUAL_VALUE = 400049;
    
    public final static int MORE_THAN_TWO_DECIMAL_DIGITS = 400051;
    
    public final static int INVALID_HOUR = 400052;
    
    public static final int TIMECODE_NOT_IN_TIME_CODE_CATEGORY = 400062;
    
    public final static int CANNOT_CLEAR_FIELD = 400065;
    
    public final static int CANNOT_SAVE_UNDER_A_STRUCTURE = 400067;
    
    public final static int MODULE_REQUIRED = 400070;
    
    public final static int MIN_LENGTH = 400073;
    
    //public final static int ... = 400074; 
    
    public final static int FIELDS_CANNOT_BE_THE_SAME = 400075;
    
    public final static int READ_ONLY_CONDITIONAL_VALUE_ZERO = 400076;
    
    public final static int READ_ONLY_CONDITIONAL_VALUES_SAME = 400077;
    
    public final static int NULL_REQUIRED_WHEN_FIELD_VALUE_EXISTS = 400079;
    
    public final static int CANNOT_DELETE_VALUE_EXISTS = 400080;
    
    public final static int CANNOT_UPDATE_FIELD_ON_CONTAINER_UPDATE = 400081;
    
    public final static int CANNOT_USE_WS_API = 400082;
    
    public final static int CANNOT_CREATE_OR_UPDATE = 400083;
    
    public final static int CONVERSION_FROM_TO_TYPE_INVALID = 400084;
    
    public final static int CONVERSION_FROM_TO_TYPE_INVALID_WITH_CHILDREN = 400085;
   
    public final static int MUST_BE_SAVED_AS_CHILD_OF = 400086;
    
    public final static int MUST_ALWAYS_BE_NULL = 400087;
    
    public final static int CHECKED_OUT_FROM_DELPHI_CLIENT = 400088;
  
    public final static int RPMOBJECT_CHECKED_OUT = 400089;
    
    public final static int ALREADY_CHECKED_OUT_WITH_SESSION = 400090;

    public final static int WAS_CHECKED_IN = 400091;

    public final static int EXTERNAL_AUTHENTICATION_CONFIGURATION_ERROR = 400092;
    
    public final static int WEB_SERVICES_DISABLED_ERROR = 400093;
    
    public final static int CANNOT_CREATE = 400094;

    public final static int FAILED_VERSION_COMPATIBILITY_TEST = 400095;
    
    public final static int CANNOT_FORCE_CHECKIN = 400096;
    
    public final static int CANNOT_SAVE_RTA_WITH_TA = 400097;
    
    public final static int DURATION_IN_MINUTES_ROUND_WARNING = 400098;

    /**
     * Error codes for xpath. All errors that can be thrown to an end user on a load from xpath should
     * be of this type
     */

    public final static int XPATH_INVALID_CONTAINER_OR_FIELD = 400300;
    
    public final static int XPATH_INVALID_FIELD = 400301;
    
    public final static int XPATH_UNSUPPORTED_FIELD = 400302;
    
    public final static int XPATH_NON_EXISTENT_FIELD = 400303;
    
    public final static int XPATH_UNSUPPORTED_FIELD_AS_CONTAINER = 400304;
    
    public final static int XPATH_MANDATORY_FIELD_NAME = 400305;
    
    public final static int XPATH_INVALID_JOIN = 400306;
    
    public final static int XPATH_INVALID_SUBJOIN = 400307;
    
    public final static int XPATH_MISSING_INFORMATION = 400308;
    
    public final static int XPATH_UNSUPPORTED_OPERATION = 400309;

    public final static int XPATH_UNSUPPORTED_CONTAINER = 400310;
    
    public final static int XPATH_UNSUPPORTED_OPERATION_CODE = 400311;
    
    public final static int XPATH_INVALID_STRING = 400312;
    
    public final static int XPATH_INVALID_GROUP = 400313;
    
    public final static int XPATH_INVALID_ARGUMENTS = 400314;
    
    public final static int XPATH_INVALID_NUMBER_OF_ARGUMENTS = 400315;
    
    public final static int XPATH_UNSUPPORTED_CONDITION = 400316;
    
    public final static int XPATH_UNSUPPORTED_ENUMERATED_TYPE = 400317;
    
    public final static int XPATH_INVALID_DATE_FORMAT = 400318;

    /**
     * Validation error codes for managers These error messages usually have the
     * manager name at the beginning The className of the RPMException MUST BE
     * NULL if it is not a container
     */

    public final static int MANDATORY_METHOD = 400500;

    public final static int NO_PARENT_MANAGER = 400501;

    public final static int NO_TYPEID = 400502;

    public final static int UNSUPPORTED_TYPEID = 400503;

    public final static int NOT_IMPLEMENTED_JOIN = 400504;

    public final static int INVALID_CONTAINER_NAME = 400505;

    public final static int AM_INVALID_PK = 400506;

    public final static int AM_INVALID_NULL_PK = 400507;

    public final static int AM_INVALID_MC = 400508;

    public final static int NO_CONTAINER_NAME = 400509;

    public final static int NO_ID_ON_LOAD = 400510;

    public final static int UNSUPPORTED_CONTEXT = 400511;

    public final static int UNSUPPORTED_METHOD = 400512;

    public final static int INVALID_VALUE_OF_ENUMERATEDTYPE = 400513;

    public final static int NOT_IMPLEMENTED = 400514;

    public final static int AM_NO_RESULT_SET = 400515;

    public final static int AM_NI_GETPRIMARY_KEY = 400516;

    public final static int AM_PROPERTY_MAPPING = 400517;

    public final static int AM_RIGHT_PREDICATE = 400518;

    public final static int AM_LEFT_PREDICATE = 400519;

    public final static int AM_INVALID_RPMOBJECTID = 400520;

    public final static int OVERRIDE_ISVALIDPK = 400521;

    public final static int MF_NO_CONSTRUCTOR = 400522;

    public final static int MF_CONSTRUCTOR_NOT_PUBLIC = 400523;

    public final static int MF_CANNOT_CREATE_INSTANCE = 400524;

    public final static int OBJECT_IS_NULL = 400525;
    
    public final static int REMOVE_FROM_CACHE_INVALID_PRIMARY_KEY = 400534;
    
    public final static int SAVE_ATTRIBUTES_WITH_NO_CONTEXT = 400535;
    
    public final static int DELETE_ATTRIBUTES_WITH_NO_CONTEXT = 400536;
    
    public final static int SAVED_OBJECT_NOT_RELOADED = 400537;
    
    public final static int MANAGER_NOT_IMPLEMENTED = 400544;
    
    public final static int INVALID_USER_TYPE = 400545;
    
    public final static int CONTEXT_INVALID = 400546;

    public final static int INVALID_SESSION_DB = 400547;
    
    public final static int INVALID_SESSION_ID = 400548;
    
    public final static int MISSING_PRIMARY_KEY = 400549;
    
    public final static int NO_DELETE = 400550;

    public final static int NO_CREATE = 400551;
    
    public final static int NO_PARENT_TYPE = 400552;
    
    public final static int NO_UPDATE = 400553;
    
    public final static int NOT_RPM_CONTAINER = 400554;
    
    public final static int PARENT_REFERENCE = 400555;

    public final static int UNSUPPORTED_API_CALL = 400556;

    public final static int INTERNAL_ERROR = 400557;
    
    public final static int MANUAL_CHECKOUT_UNAVAILABLE = 400558;
    
    public final static int MANUAL_CHECKOUT_REQUIRED = 400559;
    
    public final static int INVALID_WORKFLOW_ID = 400560;
    
    public final static int UNSUPPORTED_SUBTYPEID = 400561;
    
    public final static int NO_SAVE = 400562;
    
    public final static int INSUFFICIENT_SECURITY_RIGHTS = 400563;
    public final static int CHANGER_PASSWORD_NOT_SUPPORTED_ON_EXTERNAL_AUTHENTICATION = 400999;    
}