/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2005.  All Rights Reserved.                    |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
package com.ibm.rpm.framework.security;

/**
 * @author Yasser Lulu & Marc-Andr Lamothe
 *
 */
public abstract class BaseSecurityDescriptor extends AbstractSecurityDescriptor
{
    private String name;

    /**
     * @return the name
     */
    public String getName()
    {
        return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(String name)
    {
        this.name = name;
    }

    /**
     * @author Marc-Andr Lamothe
     */
    public int hashCode()
    {
        return (name != null) ? name.hashCode() : BaseSecurityDescriptor.class
            .hashCode();
    }

    /**
     * @author Marc-Andr Lamothe
     * @return this == param
     */
    public boolean equals(Object obj)
    {
        if (obj instanceof BaseSecurityDescriptor)
            return (name == null && ((BaseSecurityDescriptor) obj).name == null)
                    || ((name != null) && name
                        .equals(((BaseSecurityDescriptor) obj).name));
        return false;
    }
}
