/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2005.  All Rights Reserved.                    |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
package com.ibm.rpm.framework.security.controller.impl;

/**
 * @author Yasser Lulu
 *
 */
public abstract class CombinedSecurityFlags
{

    private int[] combinedFlags;

    public CombinedSecurityFlags(int[] combinedFlags)
    {
        this.combinedFlags = combinedFlags;
    }

    /**
     * @return the combinedFlags
     */
    public final int[] getCombinedFlags()
    {
        return combinedFlags;
    }

    public abstract CombinedSecurityFlags getALL_TRUE();

    public abstract CombinedSecurityFlags getALL_FALSE();

    public final boolean isALL_TRUE()
    {
        return this == getALL_TRUE();
    }

    public final boolean isALL_FALSE()
    {
        return this == getALL_FALSE();
    }

}
