/**
 * 
 */
package com.ibm.rpm.framework.security.controller.impl.resource;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.security.controller.SecurityValidationResult;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;
import com.ibm.rpm.framework.types.PublishedType;
import com.ibm.rpm.scopemanagement.containers.AbstractScope;

class ResourceBasedAbstractScopeMappingEntry extends FieldMappingEntry
{
    public ResourceBasedAbstractScopeMappingEntry(String fieldName,
            Class container)
    {
        super(fieldName, container);
    }

    public SecurityValidationResult canRead(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        return SecurityValidationResult.TRUE_RESULT;
    }

    public SecurityValidationResult canWrite(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        if (canWriteSecurityFlags != null)
        {
            AbstractScope abstractScope = (AbstractScope) rpmObject;
            PublishedType type = SecurityControllerUtil
                .loadAbstractScopePublishedType(abstractScope, messageContext);
            if (type != null)
            {
                if (type == PublishedType.ToTemplate
                        && abstractScope.getPublished() != PublishedType.ToTemplate)
                {
                    return SecurityControllerUtil.calculateFlagResult(
                        canWriteSecurityFlags[0], securityFlags,
                        getEditErrorMessage(), rpmObject.getClass());
                }
            }
            return SecurityValidationResult.TRUE_RESULT;
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }

}