package com.ibm.rpm.framework.security.controller.impl.resource;

import java.util.Map;

import com.ibm.rpm.asset.containers.Asset;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;

class ResourceBasedAssetSecurityController extends
        ResourceBasedGenericAssetSecurityController
{

    public Class getContainerClass()
    {
        return Asset.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("estimateCrossCharge",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("modelNumber", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("contactPhone", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("assetLife", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("assignedScorecard",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("geographicalAssignment",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("category", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("customFieldAssignments",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("serialNumber", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("statusUpdates", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("salvageValue", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("maintenanceToDate",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("documentFolder", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("initialCost", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("dispositionDate",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("capitalValue", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("warrantySLAExpiryDate",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("quantity", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("licenseExpiryDate",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("depreciationMethod",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("estimateMaintenance",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("contactEmail", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("crossChargeToDate",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("rtfAssignments", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("depreciationToDate",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("dateAcquired", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("contact", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("tracked", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("attributeAssignments",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("nextScheduleMaintenance",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("assetResourceAssignments",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("assetOrganizationalAssignment",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("WBSActivityFinish",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("currentValue", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("depreciationSchedules",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("state", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("barcodeNumber", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("crossChargeFinancials",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("WBSActivityStart",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("model", getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("maintenanceEstimates",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = readSecurityFlags;
        fieldInfo.canWriteSecurityFlags = writeSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

}
