/**
 * 
 */
package com.ibm.rpm.framework.security.controller.impl.resource;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.security.controller.SecurityValidationResult;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;

class ResourceBasedResourceMappingEntry extends FieldMappingEntry
{

    public ResourceBasedResourceMappingEntry(String fieldName, Class container)
    {
        super(fieldName, container);
    }

    public SecurityValidationResult canRead(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        if (canReadSecurityFlags != null)
        {
            if (rpmObject.getID() != null
                    && messageContext.getUser().getID().equals(
                        rpmObject.getID()))
            {
                return SecurityControllerUtil.calculateVirtualFlagResult(
                    canReadSecurityFlags[0], securityFlags,
                    getViewErrorMessage(), rpmObject.getClass());
            }
            else
            {
                return SecurityControllerUtil.calculateVirtualFlagResult(
                    canReadSecurityFlags[1], securityFlags,
                    getViewErrorMessage(), rpmObject.getClass());
            }
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }

    public SecurityValidationResult canWrite(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        if (canWriteSecurityFlags != null)
        {
            if (rpmObject.getID() != null
                    && messageContext.getUser().getID().equals(
                        rpmObject.getID()))
            {
                return SecurityControllerUtil.calculateVirtualFlagResult(
                    canWriteSecurityFlags[0], securityFlags,
                    getEditErrorMessage(), rpmObject.getClass());
            }
            else
            {
                return SecurityControllerUtil.calculateVirtualFlagResult(
                    canWriteSecurityFlags[1], securityFlags,
                    getEditErrorMessage(), rpmObject.getClass());
            }
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }
}