/**
 * 
 */
package com.ibm.rpm.framework.security.controller.impl.resource;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.security.controller.SecurityValidationResult;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;
import com.ibm.rpm.resource.containers.Resource;

class ResourceBasedResourceSecurityRightsMappingEntry extends FieldMappingEntry
{
    public ResourceBasedResourceSecurityRightsMappingEntry(String fieldName,
            Class container)
    {
        super(fieldName, container);
    }

    public SecurityValidationResult canRead(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        if (canReadSecurityFlags != null)
        {
            RPMObject parent = SecurityControllerUtil.loadParent(
                messageContext, rpmObject);
            if (parent instanceof Resource)
            {
                if (parent.getID() != null
                        && messageContext.getUser().getID().equals(
                            parent.getID()))
                {
                    return SecurityControllerUtil.calculateFlagResult(
                        canReadSecurityFlags[0], securityFlags,
                        getViewErrorMessage(), rpmObject.getClass());
                }
                else
                {
                    return SecurityControllerUtil.calculateFlagResult(
                        canReadSecurityFlags[1], securityFlags,
                        getViewErrorMessage(), rpmObject.getClass());
                }
            }
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }

    public SecurityValidationResult canWrite(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        if (canWriteSecurityFlags != null)
        {
            return SecurityControllerUtil.calculateFlagResult(
                canWriteSecurityFlags[0], securityFlags, getEditErrorMessage(),
                rpmObject.getClass());
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }
}