package com.ibm.rpm.framework.security.controller.impl.role;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.security.controller.SecurityValidationResult;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.OperationMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;

class OperationMappingEntryWithSuperFlag extends OperationMappingEntry
{
    final Integer superFlag;

    final OperationMappingEntry entry;

    OperationMappingEntryWithSuperFlag(Integer superFlag,
            OperationMappingEntry entry)
    {
        super(entry.name, entry.container);
        this.superFlag = superFlag;
        this.entry = entry;
    }

    public SecurityValidationResult canPerform(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        SecurityValidationResult result = SecurityControllerUtil
            .calculateFlagResult(superFlag, securityFlags, getErrorMessage(),
                rpmObject.getClass());
        if (result.type == SecurityValidationResult.TRUE)
        {
            return result; // super flag is true, then allow it
        }
        return entry.canPerform(rpmObject, securityFlags, messageContext);
    }
}
