package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.scopemanagement.containers.AbstractRequest;

class RoleBasedAbstractRequestSecurityController extends
        RoleBasedAbstractScopeSecurityController
{

    public Class getContainerClass()
    {
        return AbstractRequest.class;
    }

    protected void doGenerateFieldMappingEntries(Map mappingEntryMap)
    {
        super.doGenerateFieldMappingEntries(mappingEntryMap);
        FieldMappingEntry fieldInfo = null;      

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("approvedCostBenefits",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
                ROLE.CanViewApprovedCostBenefits, 
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
                ROLE.CanEditApprovedCostBenefits,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("numberTimesReassigned", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
                ROLE.CanViewTimesReassigned,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
                ROLE.CanEditTimesReassigned,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("occuredDateTime", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
                ROLE.CanViewOccurredDateTime,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
                ROLE.CanEditOccurredDateTime,
   
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

}
