package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;
import com.ibm.rpm.framework.security.controller.impl.ViewOperationMappingEntry;
import com.ibm.rpm.scorecard.containers.AssignedScorecardCategory;

class RoleBasedAssignedScorecardCategorySecurityController extends
        RoleBasedAbstractScorecardCategorySecurityController
{

    public Class getContainerClass()
    {
        return AssignedScorecardCategory.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);

        Integer[] canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewAssignedScorecard,//It is the same as SecurityFlags.CanViewProjectScorecard

        };
        Integer[] canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditAssignedScorecard,//It is the same as SecurityFlags.CanEditProjectScorecard
        };

        SecurityControllerUtil.replaceFieldMappingEntryFlags(
            canReadSecurityFlags, canWriteSecurityFlags, mappingEntryMap);

        FieldMappingEntry fieldInfo = null;
        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("assignedScorecardQuestions",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = canReadSecurityFlags;
        fieldInfo.canWriteSecurityFlags = canWriteSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("score", getContainerClass());
        fieldInfo.canReadSecurityFlags = canReadSecurityFlags;
        fieldInfo.canWriteSecurityFlags = canWriteSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

    protected ViewOperationMappingEntry generateViewOperationMappingEntry()
    {
        ViewOperationMappingEntry viewEntry = new ViewOperationMappingEntry(
            getContainerClass());
        viewEntry.securityFlag = ROLE.CanViewAssignedScorecard;
        return viewEntry;
    }

}
