package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

import com.ibm.rpm.framework.security.controller.impl.CheckOutOperationMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.CreationOperationMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.DeletionOperationMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.OperationMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.ViewOperationMappingEntry;

abstract class RoleBasedContainerSecurityControllerWithSuperFlag extends
        RoleBasedContainerSecurityController
{

    protected abstract Integer getSuperFlag();

    protected final void generateCreationOperationMappingEntries(
            Map mappingEntryMap)
    {
        doGenerateCreationOperationMappingEntries(mappingEntryMap);
        //replace with super-flag decorator
        Iterator it = mappingEntryMap.entrySet().iterator();
        while (it.hasNext())
        {
            Entry entry = (Entry) it.next();
            entry.setValue(new CreationOperationMappingEntryWithSuperFlag(
                getSuperFlag(), (CreationOperationMappingEntry) entry
                    .getValue()));
        }
    }

    protected void doGenerateCreationOperationMappingEntries(Map mappingEntryMap)
    {

    }

    protected final ViewOperationMappingEntry generateViewOperationMappingEntry()
    {
        return new ViewOperationMappingEntryWithSuperFlag(getSuperFlag(),
            doGenerateViewOperationMappingEntry());
    }

    protected ViewOperationMappingEntry doGenerateViewOperationMappingEntry()
    {
        return super.generateViewOperationMappingEntry();
    }

    protected CheckOutOperationMappingEntry generateCheckOutOperationMappingEntry()
    {
        return new CheckOutOperationMappingEntryWithSuperFlag(getSuperFlag(),
            doGenerateCheckOutOperationMappingEntry());
    }

    protected CheckOutOperationMappingEntry doGenerateCheckOutOperationMappingEntry()
    {
        return super.generateCheckOutOperationMappingEntry();
    }

    protected final DeletionOperationMappingEntry generateDeletionOperationMappingEntry()
    {
        return new DeletionOperationMappingEntryWithSuperFlag(getSuperFlag(),
            doGenerateDeletionOperationMappingEntry());
    }

    protected DeletionOperationMappingEntry doGenerateDeletionOperationMappingEntry()
    {
        return super.generateDeletionOperationMappingEntry();
    }

    protected final void generateFieldMappingEntries(Map mappingEntryMap)
    {
        doGenerateFieldMappingEntries(mappingEntryMap);

        //replace with super-flag decorator
        Iterator it = mappingEntryMap.entrySet().iterator();
        while (it.hasNext())
        {
            Entry entry = (Entry) it.next();
            entry.setValue(new FieldMappingEntryWithSuperFlag(getSuperFlag(),
                (FieldMappingEntry) entry.getValue()));
        }
    }

    protected void doGenerateFieldMappingEntries(Map mappingEntryMap)
    {

    }

    protected final void generateOperationMappingEntries(Map mappingEntryMap)
    {
        doGenerateOperationMappingEntries(mappingEntryMap);
        //replace with super-flag decorator
        Iterator it = mappingEntryMap.entrySet().iterator();
        while (it.hasNext())
        {
            Entry entry = (Entry) it.next();
            entry.setValue(new OperationMappingEntryWithSuperFlag(
                getSuperFlag(), (OperationMappingEntry) entry.getValue()));
        }
    }

    protected void doGenerateOperationMappingEntries(Map mappingEntryMap)
    {

    }

}
