package com.ibm.rpm.framework.security.controller.impl.role;

import com.ibm.rpm.financial.containers.AbstractFinancial;
import com.ibm.rpm.financial.containers.ChargeCode;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.security.controller.SecurityValidationResult;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;

class RoleBasedCreateBudgetCostRevenueChargeCodeMappingEntry extends
        RoleBasedCreateChargeCodeCategoryChargeCodeMappingEntry
{

    public RoleBasedCreateBudgetCostRevenueChargeCodeMappingEntry(
            String operationName, Class container, Class childrenClass)
    {
        super(operationName, container, childrenClass);
    }

    public SecurityValidationResult canPerform(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags,
            MessageContext messageContext)
    {
        ChargeCode chargeCode = ((AbstractFinancial) rpmObject)
            .getChargeCode();
        if (chargeCode != null)
        {
            return super.canPerform(chargeCode, securityFlags, messageContext);
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }

}
