/**
 * 
 */
package com.ibm.rpm.framework.security.controller.impl.role;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.SecurityValidationResult;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;

class RoleBasedDocumentPropertiesMappingEntry extends FieldMappingEntry
{
    public RoleBasedDocumentPropertiesMappingEntry(String fieldName, Class container)
    {
        super(fieldName, container);
    }

    public SecurityValidationResult canRead(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        SecurityValidationResult result = SecurityControllerUtil
            .calculateFlagResult(ROLE.CanViewDocumentProperties,
                securityFlags, getViewErrorMessage(), rpmObject.getClass());
        if (result.type == SecurityValidationResult.FALSE)
        {
            return result; // Cannot view the document's properties
        }
        return super.canRead(rpmObject, securityFlags, messageContext);
    }

    public SecurityValidationResult canWrite(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        SecurityValidationResult result = SecurityControllerUtil
            .calculateFlagResult(ROLE.CanViewDocumentProperties,
                securityFlags, getEditErrorMessage(), rpmObject.getClass());
        if (result.type == SecurityValidationResult.FALSE)
        {
            return result; // Cannot view the document's properties
        }
        return super.canWrite(rpmObject, securityFlags, messageContext);
    }
}