/**
 * 
 */
package com.ibm.rpm.framework.security.controller.impl.role;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.security.controller.SecurityValidationResult;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;
import com.ibm.rpm.wbs.containers.WorkElement;
import com.ibm.rpm.wbs.types.ProjectPublishedType;

class RoleBasedGenericProjectMappingEntry extends FieldMappingEntry
{
    public RoleBasedGenericProjectMappingEntry(String fieldName,
            Class container)
    {
        super(fieldName, container);
    }

    public SecurityValidationResult canRead(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags,
            MessageContext messageContext)
    {
        return SecurityValidationResult.TRUE_RESULT;
    }

    public SecurityValidationResult canWrite(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags,
            MessageContext messageContext)
    {
        if (canWriteSecurityFlags != null)
        {
            WorkElement original = null;
            try
            {
                original = (WorkElement) rpmObject.getClass().newInstance();
            }
            catch (Exception e)
            {
            }
            if (original != null)
            {
                original.setID(rpmObject.getID());
                original = (WorkElement) SecurityControllerUtil.loadObject(
                    messageContext, original, null);
                if (original != null
                        && original.getPublished() != ProjectPublishedType.ToTeam
                        && ((WorkElement) rpmObject).getPublished() == ProjectPublishedType.ToTeam)
                {
                    return SecurityControllerUtil.calculateFlagResult(
                        canWriteSecurityFlags[0], securityFlags,
                        getEditErrorMessage(), rpmObject.getClass());
                }
            }
            return SecurityValidationResult.TRUE_RESULT;
        }
        return SecurityValidationResult.UNDEFINED_RESULT;
    }
    
}