package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.scopemanagement.containers.OrderOfMagnitudeCostBenefits;

class RoleBasedOrderOfMagnitudeCostBenefitsSecurityController extends
        RoleBasedContainerSecurityController
{

    public Class getContainerClass()
    {
        return OrderOfMagnitudeCostBenefits.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        FieldMappingEntry fieldInfo = null;

        Integer[] canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewOrderOfMagnitudeCostBenefits,
        };
        Integer[] canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditOrderOfMagnitudeCostBenefits,
        };

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("orderOfMagnitudeCost",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = canReadSecurityFlags;
        fieldInfo.canWriteSecurityFlags = canWriteSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("orderOfMagnitudeHigh",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = canReadSecurityFlags;
        fieldInfo.canWriteSecurityFlags = canWriteSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry(
            "orderOfMagnitudeNonBillableBenefits",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = canReadSecurityFlags;
        fieldInfo.canWriteSecurityFlags = canWriteSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("orderOfMagnitudeBillableRevenue",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = canReadSecurityFlags;
        fieldInfo.canWriteSecurityFlags = canWriteSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("orderOfMagnitudeLow",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = canReadSecurityFlags;
        fieldInfo.canWriteSecurityFlags = canWriteSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

}
