/**
 * 
 */
package com.ibm.rpm.framework.security.controller.impl.role;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.security.controller.SecurityValidationResult;
import com.ibm.rpm.framework.security.controller.impl.CombinedSecurityFlags;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;

class RoleBasedProjectDescriptionMappingEntry extends FieldMappingEntry
{
    FieldMappingEntry subEntry;
    
    public RoleBasedProjectDescriptionMappingEntry(String fieldName,
            Class container, FieldMappingEntry subEntry)
    {
        super(fieldName, container);
        this.subEntry = subEntry;
    }

    public SecurityValidationResult canRead(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        if (canReadSecurityFlags != null)
        {
            SecurityValidationResult result = SecurityControllerUtil.calculateFlagResultUsingOr(
                canReadSecurityFlags, securityFlags, getViewErrorMessage(), rpmObject.getClass());
            if (result.type == SecurityValidationResult.FALSE)
            {
                return result;  // Cannot view the project's description
            }
        }
        return subEntry.canRead(rpmObject, securityFlags, messageContext);
    }

    public SecurityValidationResult canWrite(RPMObject rpmObject,
            CombinedSecurityFlags securityFlags, MessageContext messageContext)
    {
        if (canWriteSecurityFlags != null)
        {
            SecurityValidationResult result = SecurityControllerUtil.calculateFlagResultUsingOr(
                canWriteSecurityFlags, securityFlags, getEditErrorMessage(), rpmObject.getClass());
            if (result.type == SecurityValidationResult.FALSE)
            {
                return result;  // Cannot view the project's description
            }
        }
        return subEntry.canWrite(rpmObject, securityFlags, messageContext);
    }
}