package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.DeletionOperationMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.ViewOperationMappingEntry;
import com.ibm.rpm.wbs.containers.ProjectOrganizationalAssignment;

class RoleBasedProjectOrganizationalAssignmentSecurityController extends
        RoleBasedContainerSecurityController
{
    public Class getContainerClass()
    {
        return ProjectOrganizationalAssignment.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        fieldInfo = new RoleBasedProjectOrganizationalAssignmentMappingEntry(
            "organizational", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewAssignedOrganizations,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditAssignedOrganizations,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedProjectOrganizationalAssignmentMappingEntry(
            "organizationType", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewAssignedOrganizations,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditAssignedOrganizations,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

    protected ViewOperationMappingEntry generateViewOperationMappingEntry()
    {
        ViewOperationMappingEntry viewEntry = new ViewOperationMappingEntry(
            getContainerClass());
        viewEntry.securityFlag = ROLE.CanViewAssignedOrganizations;
        return viewEntry;
    }    
    
    protected DeletionOperationMappingEntry generateDeletionOperationMappingEntry()
    {
        DeletionOperationMappingEntry deleteEntry = new DeletionOperationMappingEntry(
            getContainerClass());
        deleteEntry.securityFlag = ROLE.CanEditAssignedOrganizations;
        return deleteEntry;
    }

}
