package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.DeletionOperationMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.SecurityControllerUtil;
import com.ibm.rpm.framework.security.controller.impl.ViewOperationMappingEntry;
import com.ibm.rpm.scorecard.containers.Scorecard;

class RoleBasedScorecardSecurityController extends
        RoleBasedAbstractScorecardSecurityController
{

    public Class getContainerClass()
    {
        return Scorecard.class;
    }

    protected DeletionOperationMappingEntry generateDeletionOperationMappingEntry()
    {
        DeletionOperationMappingEntry deletionEntry = new DeletionOperationMappingEntry(
            getContainerClass());
        deletionEntry.securityFlag = ROLE.CanAddRemoveDefaultScorecards;
        return deletionEntry;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);

        Integer[] canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewDefaultScorecards,
        };
        Integer[] canWriteSecurityFlags = null;

        SecurityControllerUtil.replaceFieldMappingEntryFlags(
            canReadSecurityFlags, canWriteSecurityFlags, mappingEntryMap);

        FieldMappingEntry fieldInfo = null;
        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("active", getContainerClass());
        fieldInfo.canReadSecurityFlags = canReadSecurityFlags;
        fieldInfo.canWriteSecurityFlags = canWriteSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("scorecardCategories",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = canReadSecurityFlags;
        fieldInfo.canWriteSecurityFlags = canWriteSecurityFlags;
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

    protected ViewOperationMappingEntry generateViewOperationMappingEntry()
    {
        ViewOperationMappingEntry viewEntry = new ViewOperationMappingEntry(
            getContainerClass());
        viewEntry.securityFlag = ROLE.CanViewDefaultScorecards;
        return viewEntry;
    }

}
