package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

import com.ibm.rpm.applicationadministration.containers.State;
import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;

class RoleBasedStateSecurityController extends
        RoleBasedDatafieldStateSecurityController
{

    public Class getContainerClass()
    {
        return State.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);
        FieldMappingEntry fieldInfo = null;
        
        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("proposal", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
        
        //--------------------------------------------------------
        //Override all parent's entries by adding this edit flag
        Iterator it = mappingEntryMap.entrySet().iterator();
        while (it.hasNext())
        {
            Entry entry = (Entry) it.next();
            fieldInfo = (FieldMappingEntry) entry.getValue();
            fieldInfo.canWriteSecurityFlags = new Integer[]
            {
                ROLE.CanEditState,
            };
        }

    }

}
