package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.financial.containers.TimeCodeAssignment;
import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.DeletionOperationMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.ViewOperationMappingEntry;

class RoleBasedTimeCodeAssignmentSecurityController extends
        RoleBasedContainerSecurityController
{

    public Class getContainerClass()
    {
        return TimeCodeAssignment.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("timeCode", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewTimeCodes,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

    protected ViewOperationMappingEntry generateViewOperationMappingEntry()
    {
        ViewOperationMappingEntry viewEntry = new ViewOperationMappingEntry(
            getContainerClass());
        viewEntry.securityFlag = ROLE.CanViewTimeCodes;
        return viewEntry;
    }
    
    protected DeletionOperationMappingEntry generateDeletionOperationMappingEntry()    
    {        
        DeletionOperationMappingEntry deletionEntry = new DeletionOperationMappingEntry(getContainerClass());        
        deletionEntry.securityFlag = ROLE.CanAddRemoveTimeCodes;        
        return deletionEntry;    
    }

}
