package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.financial.containers.TimePhasedFinancial;
import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.ViewOperationMappingEntry;

class RoleBasedTimePhasedFinancialSecurityController extends
        RoleBasedContainerSecurityController
{

    public Class getContainerClass()
    {
        return TimePhasedFinancial.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "month08Value", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "month02Value", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "month11Value", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "month06Value", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry("budgetType",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "month05Value", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry("year",
            getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "month04Value", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "month12Value", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "month01Value", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "totalForYear", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "month09Value", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "month07Value", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "month03Value", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);

        // --------------------------------------------------------
        fieldInfo = new RoleBasedTimePhasedFinancialMappingEntry(
            "month10Value", getContainerClass());
        fieldInfo.canReadSecurityFlags = new Integer[]
        {
            ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing,
        };
        fieldInfo.canWriteSecurityFlags = new Integer[]
        {
            ROLE.CanEditBudgetCostRevenueFinancialsTimePhasing,
        };
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

    protected ViewOperationMappingEntry generateViewOperationMappingEntry()
    {
        ViewOperationMappingEntry viewEntry = new ViewOperationMappingEntry(
            getContainerClass());
        viewEntry.securityFlag = ROLE.CanViewBudgetCostRevenueFinancialsTimePhasing;
        return viewEntry;
    }

}
