package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;

import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.ViewOperationMappingEntry;
import com.ibm.rpm.wbs.containers.WbsScheduleDate;

class RoleBasedWbsScheduleDateSecurityController extends
        RoleBasedScheduleDateSecurityController
{

    public Class getContainerClass()
    {
        return WbsScheduleDate.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);

        // --------------------------------------------------------
        // Override all parent's entries by adding these flags
        // RULES: every field of the parent class must be added to the
        // map by the parent controller with no flags inside 

        Map canReadSecurityFlagsMap = new HashMap();
        Map canWriteSecurityFlagsMap = new HashMap();

        // --------------------------------------------------------
        // WbsScheduleDate.ACTUAL
        Integer[] flags = new Integer[]
        {
            ROLE.CanViewScheduleInformation,
        };
        canReadSecurityFlagsMap.put(WbsScheduleDate.ACTUAL, flags);
        flags = new Integer[]
        {
            ROLE.CanEditDatesActual,
        };
        canWriteSecurityFlagsMap.put(WbsScheduleDate.ACTUAL, flags);

        // --------------------------------------------------------
        // WbsScheduleDate.BASELINE
        flags = new Integer[]
        {
            ROLE.CanViewDatesBaseline,
        };
        canReadSecurityFlagsMap.put(WbsScheduleDate.BASELINE, flags);
        flags = null;
        canWriteSecurityFlagsMap.put(WbsScheduleDate.BASELINE, flags);

        // --------------------------------------------------------
        // WbsScheduleDate.EXPECTED
        flags = new Integer[]
        {
            ROLE.CanViewScheduleInformation,
        };
        canReadSecurityFlagsMap.put(WbsScheduleDate.EXPECTED, flags);
        flags = null;
        canWriteSecurityFlagsMap.put(WbsScheduleDate.EXPECTED, flags);

        // --------------------------------------------------------
        // WbsScheduleDate.FORECAST
        flags = new Integer[]
        {
            ROLE.CanViewScheduleInformation,
        };
        canReadSecurityFlagsMap.put(WbsScheduleDate.FORECAST, flags);
        flags = null;
        canWriteSecurityFlagsMap.put(WbsScheduleDate.FORECAST, flags);

        // --------------------------------------------------------
        // WbsScheduleDate.INITIALBASELINE
        flags = new Integer[]
        {
            ROLE.CanViewScheduleInformation,
        };
        canReadSecurityFlagsMap.put(WbsScheduleDate.INITIALBASELINE, flags);
        flags = null;
        canWriteSecurityFlagsMap.put(WbsScheduleDate.INITIALBASELINE, flags);

        // --------------------------------------------------------
        // WbsScheduleDate.PLAN
        flags = new Integer[]
        {
            ROLE.CanViewScheduleInformation,
        };
        canReadSecurityFlagsMap.put(WbsScheduleDate.PLAN, flags);
        flags = new Integer[]
        {
            ROLE.CanEditDatesPlan,
        };
        canWriteSecurityFlagsMap.put(WbsScheduleDate.PLAN, flags);

        // --------------------------------------------------------
        // WbsScheduleDate.PREVIOUSBASELINE
        flags = new Integer[]
        {
            ROLE.CanViewScheduleInformation,
        };
        canReadSecurityFlagsMap.put(WbsScheduleDate.PREVIOUSBASELINE, flags);
        flags = null;
        canWriteSecurityFlagsMap.put(WbsScheduleDate.PREVIOUSBASELINE, flags);

        // --------------------------------------------------------
        // WbsScheduleDate.PROPOSED
        flags = new Integer[]
        {
            ROLE.CanViewScheduleInformation,
        };
        canReadSecurityFlagsMap.put(WbsScheduleDate.PROPOSED, flags);
        flags = new Integer[]
        {
        		ROLE.CanEditDatesProposed,
        };
        canWriteSecurityFlagsMap.put(WbsScheduleDate.PROPOSED, flags);

        // --------------------------------------------------------
        // Replace all the inherited field entries with the new ones 
        Iterator it = mappingEntryMap.entrySet().iterator();
        while (it.hasNext())
        {
            Entry entry = (Entry) it.next();
            entry.setValue(new RoleBasedScheduleDateMappingEntry((String) entry
                .getKey(), getContainerClass(), canReadSecurityFlagsMap,
                canWriteSecurityFlagsMap));
        }
    }

    protected ViewOperationMappingEntry generateViewOperationMappingEntry()
    {
        // TODO Validate this is correct ...
        ViewOperationMappingEntry viewEntry = new ViewOperationMappingEntry(
            getContainerClass());
        viewEntry.securityFlag = ROLE.CanViewScheduleInformation;
        return viewEntry;
    }

}
