package com.ibm.rpm.framework.security.controller.impl.role;

import java.util.Map;

import com.ibm.rpm.framework.security.SecuredOperations;
import com.ibm.rpm.framework.security.SecurityFlags.ROLE;
import com.ibm.rpm.framework.security.controller.impl.FieldMappingEntry;
import com.ibm.rpm.framework.security.controller.impl.OperationMappingEntry;
import com.ibm.rpm.workflow.containers.WorkflowProcess;

class RoleBasedWorkflowProcessSecurityController extends
        RoleBasedGenericWorkflowSecurityController
{

    public Class getContainerClass()
    {
        return WorkflowProcess.class;
    }

    protected void generateFieldMappingEntries(Map mappingEntryMap)
    {
        super.generateFieldMappingEntries(mappingEntryMap);
        FieldMappingEntry fieldInfo = null;

        // --------------------------------------------------------
        fieldInfo = new FieldMappingEntry("active", getContainerClass());
        mappingEntryMap.put(fieldInfo.name, fieldInfo);
    }

    protected void generateOperationMappingEntries(Map mappingEntryMap)
    {
        super.generateOperationMappingEntries(mappingEntryMap);

        OperationMappingEntry operationInfo = new OperationMappingEntry(
            SecuredOperations.EditWorkflowElementsAssociations,
            getContainerClass());
        operationInfo.securityFlag = ROLE.CanEditWorkflowElementsAssociations;
        mappingEntryMap.put(operationInfo.name, operationInfo);

        //--------------------------------------------------------
        //NOTE: Starting a workflow through the API is always manual (i.e., it is done 
        //by user and not other triggers)
        operationInfo = new OperationMappingEntry(
            SecuredOperations.StartWorkflow, getContainerClass());
        operationInfo.securityFlag = ROLE.CanStartManualWorkflow;
        mappingEntryMap.put(operationInfo.name, operationInfo);
    }

}
