package com.ibm.rpm.framework.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class DateType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected DateType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Actual = "Actual";
	public static final DateType Actual = new DateType(_Actual);
	
		
	public static final String _Forecasted = "Forecasted";
	public static final DateType Forecasted = new DateType(_Forecasted);
	
		
	public static final String _Planned = "Planned";
	public static final DateType Planned = new DateType(_Planned);
	
		
	public static final String _Proposed = "Proposed";
	public static final DateType Proposed = new DateType(_Proposed);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static DateType fromValue(String value) throws IllegalStateException {
		DateType retVal = (DateType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static DateType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof DateType && ordinal == ((DateType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((DateType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final DateType[] VALUES = {Actual, Forecasted, Planned, Proposed};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}