/**
 * Created on Aug 15, 2006
 * @author Christian Gosselin
 */
package com.ibm.rpm.framework.util;

import java.util.Iterator;
import java.util.List;

import com.ibm.rpm.framework.ContainerCheckoutModeType;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;

public class CheckoutSerializer extends RPMObjectSerializer
{
    public CheckoutSerializer(RPMObject object, RPMObjectScope rpmScope)
            throws RPMException
    {
        super(object, rpmScope);
    }

    // ContainerCheckoutModeType.getContainerCheckoutModeType(
    // rpmObject).equals(ContainerCheckoutModeType.Self)

    private RPMObject browseForParentToCheckout(RPMObject rpmObject)
    {
        if (rpmObject != null)
        {
            if (ContainerCheckoutModeType.getContainerCheckoutModeType(
                rpmObject).equals(ContainerCheckoutModeType.Self))
            {
                return rpmObject;
            }
            else if(ContainerCheckoutModeType
                        .getContainerCheckoutModeType(rpmObject).equals(
                            ContainerCheckoutModeType.Parent))
            {
                return browseForParentToCheckout(rpmObject.getParent());
            }
        }
        return null;
    }

    protected void serialize(RPMObject rpmObject, RPMObjectScope rpmScope)
            throws RPMException
    {
        try
        {
            ValidateSerializer validateSerializer = new ValidateSerializer(
                rpmObject, rpmScope);
            List vs = validateSerializer.getArrayList();

            if (vs != null && !vs.isEmpty())
            {
                //Will only traverse the list of RPMObjects that are in scope.
                //But will look for checkout "enabled" parent wherever in 
                //the structure attached to the rpmObject.
                RPMObject obj = null;
                Iterator iter = vs.iterator();
                while (iter.hasNext())
                {
                    obj = (RPMObject) iter.next();
                    if (ContainerCheckoutModeType.getContainerCheckoutModeType(
                        obj).equals(ContainerCheckoutModeType.Self))
                    {
                        addObject(obj, null);
                    }
                    else if (ContainerCheckoutModeType
                        .getContainerCheckoutModeType(obj).equals(
                            ContainerCheckoutModeType.Parent))
                    {
                        RPMObject parent = browseForParentToCheckout(obj);
                        if (parent != null && !getArrayList().contains(parent))
                        {
                            addObject(parent, null);
                        }
                    }
                }
            }
        }
        catch (Exception e)
        {
            throw new RPMException(e);
        }
    }
}
