package com.ibm.rpm.framework.util;

import java.util.ArrayList;
import java.util.Collection;

public class CollectionUtil
{
    /**
     * Returns <code>true</code> if <code>collection</code> is
     * <code>null</code> or empty.
     * 
     * @param array
     *            Array to be tested.
     * @return True if empty.
     */
    public static boolean isEmpty(Collection collection)
    {
        return collection == null || collection.size() == 0;
    }

    /**
     * Returns <code>null</code> if <code>list</code> is empty or
     * <code>null</code>. Otherwise, returns <code>list</code>.
     * 
     * @param list List to be nullified.
     * @return Nullified list.
     */
    public static ArrayList nullify(ArrayList list)
    {
        if (isEmpty(list))
        {
            list = null;
        }
        return list;
    }
}
