package com.ibm.rpm.framework.util;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Iterator;
import java.util.List;

import com.ibm.rpm.framework.RPMObject;

public class CompareUtil
{

    /**
     * Repces the overriden equals method of RPMObject. Return value can be
     * wrong if ID is not the primaryKey of the object.
     * 
     * @param obj1
     * @param obj2
     * @return
     */
    public static boolean rpmObjectsEquals(Object obj1, Object obj2)
    {

        boolean isEqual = false;

        if (obj1 instanceof RPMObject && obj2 instanceof RPMObject)
        {
            if (((RPMObject) obj2).getID() != null)
            {
                isEqual = (((RPMObject) obj2).getID().equals(((RPMObject) obj1)
                    .getID()));
            }
        }
        else if (obj1 instanceof Calendar && obj2 instanceof Calendar)
        {
             isEqual = ((Calendar) obj1).getTimeInMillis() == ((Calendar) obj2)
                .getTimeInMillis();
        }
        else
        {
            isEqual = obj1.equals(obj2);
        }

        return isEqual;
    }
    
    
    public static boolean equals(Object o1, Object o2)
    {
        boolean equals = false;
        if ((o1 != null && o2 != null && rpmObjectsEquals(o1,o2))
                || (o1 == null && o2 == null))
        {
            equals = true;
        }
        return equals;
    }

    public static boolean equals(Object[] o1, Object[] o2)
    {
        boolean equals = false;
        if (o1 == null && o2 == null)
        {
            equals = true;
        }
        else
        {
            List newlist = new ArrayList(Arrays
                    .asList(o2 == null ? new Object[0] : o2));
            if (compareArrayProperty(Arrays.asList((o1 == null ? new Object[0]
                    : o1)), newlist))
            {
                equals = true;
            }
        }
        return equals;
    }

    private static boolean compareArrayProperty(List origlist, List newlist)
    {

        Iterator iter = origlist.iterator();
        Iterator newIter = newlist.iterator();
        boolean identical = true;
        //remove null objects from newlist
        while (newIter.hasNext())
        {
            if (newIter.next() == null)
            {
                newIter.remove();
            }
        }
        while (iter.hasNext())
        {
            Object obj = iter.next();
            if (!newlist.contains(obj))
            {
                identical = false;
                newlist.add(obj);
            }
        }
        boolean retVal = false;
        if (identical && (origlist.size() == newlist.size()))
            retVal = true;

        return retVal;
    }
    public static boolean equals(Boolean[] o1, Boolean[] o2)
    {
        boolean equals = false;
        if (o1 == null && o2 == null)
        {
            equals = true;
        }
        else if(o1 != null && o2 != null)
        {
        	equals = true;
        	int l1 = o1.length;
        	int l2 = o2.length;
        	if(l1 != l2)
        	{
        		equals = false;
        	}
        	for(int i = 0; i<l1 && equals; i++)
        	{
        		equals = o1[i] == o2[i];
        	}
        }
        return equals;
    }
}
