/*
 * Created on Apr 19, 2005
 *
 */

package com.ibm.rpm.framework.util;

import java.util.HashMap;

/**
 * @author Genevieve
 *  
 */
public class LevelMap {

    private HashMap levels = new HashMap();

    /**
     *  
     */
    public LevelMap() {
        super();
        levels = new HashMap();
    }

    /**
     * Return the next level of an object in a table. Used to build select statement
     * when we are searching for a child object in the same table as the parent.
     * @param tableName
     * @return 
     */
    public int getNextTableLevel(String tableName) {

        int level = 0;

        Object obj = levels.get(tableName);
        if (obj != null) {
            level = ((Integer) obj).intValue();
            level +=1;
        } else {
            level = 1;
        }
        levels.put(tableName, new Integer(level));

        return level;
    }

    /**
     * verify if the the level map contains a reference to a table
     * @param tableName
     * @return 
     */
    public boolean containsKey(String tableName) {

        return levels.containsKey(tableName);

    }
    
    /**
     * Add tableName in the levelMap in case if future self join.
     * @param tableName
     */
    public void initTable(String tableName) {
        levels.put(tableName, new Integer(0));
    }    
}
