package com.ibm.rpm.framework.util;

import com.ibm.rpm.framework.containers.ScheduleDate;

/**
 * @author gmeloche
 *
 */
public class ScheduleDateUtil
{

    public ScheduleDateUtil()
    {
        super();
    }
    
    public static boolean isEmpty(ScheduleDate scheduleDate)
    {

        boolean isEmpty = true;
        
        if (scheduleDate.getStartDate() != null
                || scheduleDate.getFinishDate() != null)
        {
            isEmpty = false;
        }
        
        if(scheduleDate.getDurationInMinutes() != null && scheduleDate.getDurationInMinutes().intValue() != 0){
            isEmpty = false;
        }
        
        if(scheduleDate.getWorkHours() != null && scheduleDate.getWorkHours().doubleValue() != 0){
            isEmpty = false;
        }
        

        return isEmpty;

    }
    
    /*
     * Returns durationInMinutes rounded up to the nearest quarter-hour.
     */
    public static int roundDurationUpToQuarterHour(Integer durationInMinutes)
    {
        int inputDuration = durationInMinutes == null ? 0 : durationInMinutes
            .intValue();

        int minutes = inputDuration % 60; // number of minutes left after dividing into hours
        int hours = inputDuration - minutes;

        if (minutes > 45)
        {
            minutes = 60;
        }
        else if (minutes > 30)
        {
            minutes = 45;
        }
        else if (minutes > 15)
        {
            minutes = 30;
        }
        else if (minutes > 0)
        {
            minutes = 15;
        }

        // return the new durationInMinutes, rounded up to the nearest 15 minute increment
        return hours + minutes;
    }

}
