/*
 * Created on Oct 31, 2006
 *
 */
package com.ibm.rpm.interfaces;

import java.util.ArrayList;

import com.ibm.rpm.framework.ArrayResult;
import com.ibm.rpm.framework.InternalSecuredArrayResult;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.Result;
import com.ibm.rpm.interfaces.impl.ManagerCaller;
import com.ibm.rpm.interfaces.impl.ServerFactory;

/**
 * @author karim
 *
 */
public class InternalServices 
{
    private ServerFactory factory;
	
    public InternalServices()
    {
        this(ServerFactory.getInstance());
    }
    
    private ManagerCaller getManagerCaller()
    {
        return factory.getManagerCaller();
    }
    
    public InternalServices(ServerFactory factoryToUse)
    {
        factory = factoryToUse;
    }
    
    public InternalSecuredArrayResult loadFromXpath(String sessionID,
			String xpath, RPMObjectScope scope, Integer idsType,
			String idsList, String attributesIdsList, Integer viewType,
			Integer inclusions, Integer startIndex, Integer endIndex,
			String extraWhere, String orderBy, boolean buildSecurity)
    {
        return getManagerCaller().load(sessionID, xpath, scope, idsType,
				idsList, attributesIdsList, viewType, inclusions, startIndex,
				endIndex, extraWhere, orderBy, buildSecurity)
				.toInternalSecuredArrayResult();
    }
    
    public ArrayResult searchTimeCodes(String sessionID, String workElementID,
            String scopeElementID, boolean isTimeCode1)
    {
        return getManagerCaller().searchTimeCodes(sessionID, workElementID,
            scopeElementID, isTimeCode1).toArrayResult();
    }
    
    public Result executeProcedure(String sessionID, Class callerClass, String procedureName,
            Object[] args)
    {
        return getManagerCaller().executeProcedure(sessionID, callerClass, procedureName,
            args).toResult();
    }
    
    public Result executeSqlUpdate(String sessionID, String updateString,
            Object[] args)
    {
        return getManagerCaller().executeSqlUpdate(sessionID, updateString, args)
            .toResult();
    }
    
    public ArrayList executeSqlQuery(String sessionID, String query,
            Object[] args) throws RPMException
    {
        return getManagerCaller().executeSqlQuery(sessionID, query, args);
    }
}
