package com.ibm.rpm.interfaces.impl;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.axis.Constants;
import org.apache.axis.encoding.DeserializerFactory;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class DotNetCalendarDeserializerFactory implements DeserializerFactory
{

    private static final long serialVersionUID = -7957604156832538171L;

    protected static Log logger = LogFactory.getLog(DotNetCalendarDeserializerFactory.class);
    
    private static List mechanisms;

    public DotNetCalendarDeserializerFactory()
    {
        logger.debug("Creating DotNetCalendarDeserializerFactory.");
    }

    public javax.xml.rpc.encoding.Deserializer getDeserializerAs(
            String mechanismType)
    {
        return new DotNetCalendarDeserializer();
    }

    public Iterator getSupportedMechanismTypes()
    {
        if (mechanisms == null)
        {
            mechanisms = new ArrayList(2);
            mechanisms.add(Constants.AXIS_SAX);
        }
        return mechanisms.iterator();
    }
}
