/*
 * Created on 8-Nov-2005
 */
package com.ibm.rpm.resource.checkpoints;

import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.resource.containers.ResourceCostCenterAssignment;

/**
 * @author dominiqu
 */
public class ResourceCostCenterAssignmentCheckpoint extends AbstractCheckpoint
{
    private static final Class RESOURCECOSTCENTERASSIGNMENT_PARENTS = Resource.class;

    protected static ResourceCostCenterAssignmentCheckpoint instance = new ResourceCostCenterAssignmentCheckpoint();

    public static ResourceCostCenterAssignmentCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.isValidParent(rpmObject, msgCtx, true,
            RESOURCECOSTCENTERASSIGNMENT_PARENTS);

        if (!GenericValidator.validateInstance(rpmObject,
            ResourceCostCenterAssignment.class, msgCtx))
            return;

        // Initialize
        ResourceCostCenterAssignment mainCCCA = (ResourceCostCenterAssignment) rpmObject;

        // Field validation: clientCostCenter
        GenericValidator.validateMandatoryID(mainCCCA, "clientCostCenter",
            mainCCCA.getClientCostCenter(), msgCtx);
    }
}
