package com.ibm.rpm.resource.constants;

public class ErrorCodes
{

    /**
     * Error codes for resource containers.
     * Error code range: 403,001 - 404,000
     * 403,001 - 403,299: validation codes
     * 403,300 - 403,499: xpath codes
     * 403,500 + : manager codes
     * 
     * These error messages usually have the container name at the beginning. 
     * The className of the RPMException will be a container.
     * All validation errors that can be thrown to an end user should
     * be of this type.
     */
    
    // validation codes
    public final static int REVERIFIEDBY_SPECIFIED_WITHOUT_A_VERIFIEDBY_RESOURCE = 403001;
    public final static int NOT_RESOURCE_MANAGER = 403002;
    
    // manager codes
    public final static int INVALID_PROFICIENCY_LEVEL = 403500;
    
    public final static int WARNING_NAME_OVERRIDEN_BY_PROFICIENCY_LEVEL = 403501;
    
    public final static int INVALID_COMPTENCY_PROFICIENCY_LEVEL = 403502;
    
    public final static int INVALID_SKILL_PROFICIENCY_LEVEL = 403503;
}