/*
 * Created on 21-Dec-2005
 */
package com.ibm.rpm.scopemanagement.checkpoints;

import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scopemanagement.constants.ValidationConstants;
import com.ibm.rpm.scopemanagement.containers.MitigationFactor;
import com.ibm.rpm.scopemanagement.containers.MitigationTrigger;

/**
 * @author dominiqu
 */
public class MitigationTriggerCheckpoint extends AbstractCheckpoint
{
    private static final Class MITIGATIONTRIGGER_PARENTS = MitigationFactor.class;

    protected static MitigationTriggerCheckpoint instance = new MitigationTriggerCheckpoint();

    public static MitigationTriggerCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.isValidParent(rpmObject, msgCtx, false, false, MITIGATIONTRIGGER_PARENTS);

        if (!GenericValidator.validateInstance(rpmObject, MitigationTrigger.class, msgCtx))
            return;

        // Initialize
        MitigationTrigger mainMitigationTrigger = (MitigationTrigger) rpmObject;

        // Field validation: description
        if (mainMitigationTrigger.testDescriptionModified())
        {
            GenericValidator.validateMaxLength(mainMitigationTrigger,
                ValidationConstants.DESCRIPTION_FIELD, mainMitigationTrigger.getDescription(),
                ValidationConstants.MITIGATIONTRIGGER_DESCRIPTION_MAX, msgCtx);
        }
    }
}
