/*
 * Created on 7-Dec-2005
 */
package com.ibm.rpm.scopemanagement.checkpoints;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMContainer;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scopemanagement.constants.ValidationConstants;
import com.ibm.rpm.scopemanagement.containers.OrderOfMagnitudeCostBenefits;

/**
 * @author dominiqu
 */
public class OrderOfMagnitudeCostBenefitsCheckpoint
{
    protected static OrderOfMagnitudeCostBenefitsCheckpoint instance = new OrderOfMagnitudeCostBenefitsCheckpoint();

    public static OrderOfMagnitudeCostBenefitsCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMContainer rpmContainer, MessageContext msgCtx)
    {
        // Initialize
        OrderOfMagnitudeCostBenefits mainOOMCB = (OrderOfMagnitudeCostBenefits) rpmContainer;

        // Note: setModified does not set the inner fields of children classes
        // as modified so we cannot check if they have been modified before
        // validating

        // Field validation: orderOfMagnitudeHigh
        GenericValidator
            .validateRange(
                mainOOMCB,
                ValidationConstants.ORDEROFMAGNITUDECOSTBENEFITS_ORDER_OF_MAGNITUDE_HIGH_FIELD,
                mainOOMCB.getOrderOfMagnitudeHigh(),
                ValidationConstants.OOMCB_OOMHIGH_MIN,
                ValidationConstants.OOMCB_OOMHIGH_MAX, msgCtx);

        // Field validation: orderOfMagnitudeLow
        GenericValidator
            .validateRange(
                mainOOMCB,
                ValidationConstants.ORDEROFMAGNITUDECOSTBENEFITS_ORDER_OF_MAGNITUDE_LOW_FIELD,
                mainOOMCB.getOrderOfMagnitudeLow(),
                ValidationConstants.OOMCB_OOMLOW_MIN,
                ValidationConstants.OOMCB_OOMLOW_MAX, msgCtx);

        // Field validation: orderOfMagnitudeCost
        GenericValidator
            .validateRange(
                mainOOMCB,
                ValidationConstants.ORDEROFMAGNITUDECOSTBENEFITS_ORDER_OF_MAGNITUDE_COST_FIELD,
                mainOOMCB.getOrderOfMagnitudeCost(),
                ValidationConstants.OOMCB_OOMCOST_MIN,
                ValidationConstants.OOMCB_OOMCOST_MAX, msgCtx);

        // Field validation: orderOfMagnitudeBillableRevenue
        GenericValidator
            .validateRange(
                mainOOMCB,
                ValidationConstants.ORDEROFMAGNITUDECOSTBENEFITS_ORDER_OF_MAGNITUDE_BILLABLE_REVENUE_FIELD,
                mainOOMCB.getOrderOfMagnitudeBillableRevenue(),
                ValidationConstants.OOMCB_OOMBILLABLEREVENUE_MIN,
                ValidationConstants.OOMCB_OOMBILLABLEREVENUE_MAX, msgCtx);

        // Field validation: orderOfMagnitudeNonBillableBenefits
        GenericValidator
            .validateRange(
                mainOOMCB,
                ValidationConstants.ORDEROFMAGNITUDECOSTBENEFITS_ORDER_OF_MAGNITUDE_NON_BILLABLE_BENEFITS_FIELD,
                mainOOMCB.getOrderOfMagnitudeNonBillableBenefits(),
                ValidationConstants.OOMCB_OOMNONBILLABLEBENEFITS_MIN,
                ValidationConstants.OOMCB_OOMNONBILLABLEBENEFITS_MAX, msgCtx);
    }
}