/*
 * Created on Aug 18, 2006
 *
 */
package com.ibm.rpm.scopemanagement.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scopemanagement.constants.ValidationConstants;
import com.ibm.rpm.scopemanagement.containers.ReqProIntegrationFolder;
import com.ibm.rpm.scopemanagement.containers.ScopeFolder;

/**
 * @author karim
 *
 */
public class ReqProIntegrationFolderCheckpoint extends ScopeFolderCheckpoint {

    private static final List REQPROINTEGRATIONFOLDER_PARENTS = new ArrayList();

    static
    {
        REQPROINTEGRATIONFOLDER_PARENTS.add(ScopeFolder.class);
    }

    protected static ReqProIntegrationFolderCheckpoint instance = new ReqProIntegrationFolderCheckpoint();

    public static ScopeFolderCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, msgCtx, true, REQPROINTEGRATIONFOLDER_PARENTS);

        // Initialize
        ReqProIntegrationFolder reqProIntegrationFolder = (ReqProIntegrationFolder) rpmObject;
        
        // Field validation: name
        if (reqProIntegrationFolder.getID() == null)
        {
            //In creation mode, the ReqProConnection field is mandatory
			GenericValidator.validateMandatory(reqProIntegrationFolder,
					ValidationConstants.REQPRO_CONNECTION_FIELD,
					reqProIntegrationFolder.getReqProConnection(), msgCtx);
        	
        	if (reqProIntegrationFolder.testNameModified())
            {
                GenericValidator.validateMinLength(reqProIntegrationFolder,
                    ValidationConstants.SCOPEELEMENT_NAME_FIELD,
                    reqProIntegrationFolder.getName(), ValidationConstants.NAME_MIN,
                    msgCtx);
            }
        }
    }

	
}
