/*
 * Created on 11-May-2006
 */
package com.ibm.rpm.scopemanagement.checkpoints;

import com.ibm.rpm.applicationadministration.containers.ServiceRequestState;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scopemanagement.constants.ValidationConstants;
import com.ibm.rpm.scopemanagement.containers.ServiceRequest;

/**
 * @author cobber
 */
public class ServiceRequestCheckpoint extends AbstractRequestCheckpoint
{
    protected static ServiceRequestCheckpoint instance = new ServiceRequestCheckpoint();

    public static ServiceRequestCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, rpmScope, msgCtx);

        // Initialize
        ServiceRequest mainServiceRequest = (ServiceRequest) rpmObject;

        // Field validation: state
        if (mainServiceRequest.testStateModified()
                && mainServiceRequest.getState() != null)
        {
            GenericValidator.validateType(mainServiceRequest,
                ServiceRequestState.class,
                ValidationConstants.ABSTRACTSCOPE_STATE_FIELD,
                mainServiceRequest.getState(), msgCtx);
        }
    }
}