/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| (C) Copyright IBM Corp. 2005.  All Rights Reserved.                    |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
package com.ibm.rpm.scopemanagement.util;

import com.ibm.rpm.framework.security.ContainerSecurityDescriptor;
import com.ibm.rpm.framework.util.FieldSecurityDescriptorHandler;
import com.ibm.rpm.scopemanagement.containers.ReqProScopeFolder;

/**
 * @author Yasser Lulu
 *
 */
public class ReqProScopeFolderFieldSecurityDescriptorHandler extends
        FieldSecurityDescriptorHandler
{
    public ReqProScopeFolderFieldSecurityDescriptorHandler()
    {
        super(ReqProScopeFolder.class);
    }

    protected void applyReadOnlyRestrictions(
            ContainerSecurityDescriptor containerDescr)
    {
        super.applyReadOnlyRestrictions(containerDescr);
        setReadOnly(getFieldSecurityDescriptors(containerDescr), "name");
    }

}
