/*
 * Created on Sep 8, 2006
 *
 */
package com.ibm.rpm.scopemanagement.util;

import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.scopemanagement.containers.ReqProIntegrationFolder;
import com.ibm.rpm.scopemanagement.containers.ReqProRequirement;
import com.ibm.rpm.scopemanagement.containers.ReqProScopeFolder;

/**
 * @author karim
 *
 */
public class ReqProUtil {

	public static Integer getSubTypeIDFromParent(RPMObject rpmObject)
	{
		RPMObject parent = rpmObject.getParent();
		if(parent !=null)
		{
			if(isReqProIntegrationFolder(parent))
			{
				return new Integer(ReqProIntegrationFolder.SUB_TYPE_ID);
			}
			else if(isReqProScopeFolder(parent))
			{
				return new Integer(ReqProScopeFolder.SUB_TYPE_ID);
			}
			else if(isReqProRequirement(parent))
			{
				return new Integer(ReqProRequirement.SUB_TYPE_ID);
			}
		}
		return null;
	}
	
    public static boolean isReqProObject(RPMObject rpmObject)
    {
    	return isReqProIntegrationFolder(rpmObject)
				|| isReqProScopeFolder(rpmObject)
				|| isReqProRequirement(rpmObject);
    }
    public static  boolean isReqProIntegrationFolder(RPMObject rpmObject)
    {
    	return rpmObject instanceof ReqProIntegrationFolder;
    }
    public static  boolean isReqProScopeFolder(RPMObject rpmObject)
    {
    	return rpmObject instanceof ReqProScopeFolder;
    }
    public static  boolean isReqProRequirement(RPMObject rpmObject)
    {
    	return rpmObject instanceof ReqProRequirement;
    }
    
    public static boolean isReqProObject(Integer subTypeID)
    {
    	return isReqProIntegrationFolder(subTypeID)
				|| isReqProScopeFolder(subTypeID)
				|| isReqProRequirement(subTypeID);
    }
    public static  boolean isReqProIntegrationFolder(Integer subTypeID)
    {
    	return subTypeID!=null && subTypeID.intValue() == ReqProIntegrationFolder.SUB_TYPE_ID;
    }
    public static  boolean isReqProScopeFolder(Integer subTypeID)
    {
    	return subTypeID!=null && subTypeID.intValue() == ReqProScopeFolder.SUB_TYPE_ID;
    }
    public static  boolean isReqProRequirement(Integer subTypeID)
    {
    	return subTypeID!=null && subTypeID.intValue() == ReqProRequirement.SUB_TYPE_ID;
    }
	
}
