/*
 * Created on Feb 27, 2006
 * @author mmatwiy
 * Utility methods for Scope Management specific validation.
 */
package com.ibm.rpm.scopemanagement.util;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scopemanagement.managers.ScopeManager;


public class ScopeManagementValidator extends GenericValidator
{

    /**
     * @return Returns true if the the two ScopeElements are in the same project.
     * Otherwise, returns false.
     */
    public static boolean isInSameProject(MessageContext msgCtx,
            RPMObject element1, RPMObject element2)
    {
        RPMObject parent = element1;
        
        while (parent != null && parent.getID() == null)
        {
            parent = parent.getParent();
        }
        
        String parentID = parent.getID();
                   
        String selectStmt = "SELECT count(*) from TMT_CRI WHERE " +
                ScopeManager.NAME_ELEMENT_ID + " = ? AND " +
                ScopeManager.NAME_PROJECT_ID + " IN (SELECT " + 
                ScopeManager.NAME_PROJECT_ID + " FROM TMT_CRI WHERE " + 
                ScopeManager.NAME_ELEMENT_ID + " = ? ) " +
                " AND " + ScopeManager.NAME_REC_STATUS + " != 'D'";
        
        Object[] params = new Object[]
        {
            element2.getID(),
            parentID
        };
        
        return executeStatement(msgCtx, selectStmt, params);
    }
}
