/*
 * Created on Dec 5, 2005
 * @author mmatwiy
 * Checkpoint validation of container AssignedScorecardCategory.
 */
package com.ibm.rpm.scorecard.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scorecard.constants.ValidationConstants;
import com.ibm.rpm.scorecard.containers.AssignedScorecard;
import com.ibm.rpm.scorecard.containers.AssignedScorecardCategory;

public class AssignedScorecardCategoryCheckpoint extends
        AbstractAssignedScorecardElementCheckpoint
{
    protected static AssignedScorecardCategoryCheckpoint instance = new AssignedScorecardCategoryCheckpoint();

    private static final List PARENT_LIST = new ArrayList();

    static
    {
        PARENT_LIST.add(AssignedScorecard.class);
    }

    public static AssignedScorecardCategoryCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, rpmScope, msgCtx, true, PARENT_LIST);

        AssignedScorecardCategory category = (AssignedScorecardCategory) rpmObject;

        // On update, the score and probabilityType fields cannot be cleared
        GenericValidator.validateDefaultValueUpdate(category,
            ValidationConstants.SCORE_FIELD, category.getScore(), msgCtx);

        GenericValidator.validateDefaultValueUpdate(category,
            ValidationConstants.PROBABILITY_TYPE_FIELD, category
                .getProbabilityType(), msgCtx);
    }
}
