/*
 * Created on Dec 4, 2005
 * @author mmatwiy
 * Checkpoint validation of container ScorecardCategory.
 */
package com.ibm.rpm.scorecard.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.scorecard.constants.ValidationConstants;
import com.ibm.rpm.scorecard.containers.Scorecard;
import com.ibm.rpm.scorecard.containers.ScorecardCategory;

public class ScorecardCategoryCheckpoint extends
        AbstractScorecardElementCheckpoint
{
    private static final List SCORECARDCATEGORY_PARENT_LIST = new ArrayList();

    protected static ScorecardCategoryCheckpoint instance = new ScorecardCategoryCheckpoint();

    static
    {
        SCORECARDCATEGORY_PARENT_LIST.add(Scorecard.class);
    }

    public static ScorecardCategoryCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, msgCtx, true,
            SCORECARDCATEGORY_PARENT_LIST);

        ScorecardCategory category = (ScorecardCategory) rpmObject;

        // On update, the probabilityType field cannot be cleared
        GenericValidator.validateDefaultValueUpdate(category,
            ValidationConstants.PROBABILITY_TYPE_FIELD, category
                .getProbabilityType(), msgCtx);
        
        // Field validation of weight
        if (category.testWeightModified())
        {
            GenericValidator.validateRange(category,
                ValidationConstants.WEIGHT_FIELD, category.getWeight(),
                ValidationConstants.WEIGHT_MIN, ValidationConstants.WEIGHT_MAX,
                msgCtx);
        }
    }

}
