package com.ibm.rpm.scorecard.managers;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.HashMap;
import java.util.HashSet;

import com.ibm.rpm.framework.AbstractRPMObjectManager;
import com.ibm.rpm.framework.JoinCondition;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.framework.RPMManagerFactory;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectManager;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.ExceptionUtil;
import com.ibm.rpm.scorecard.checkpoints.AssignedScorecardCheckpoint;
import com.ibm.rpm.scorecard.containers.AbstractScorecard;
import com.ibm.rpm.scorecard.containers.AssignedScorecard;
import com.ibm.rpm.scorecard.containers.AssignedScorecardState;
import com.ibm.rpm.scorecard.scope.AbstractScorecardScope;

public class ScorecardAssignmentManager extends AbstractRPMObjectManager
{

    private static final HashMap FIELDPROPERTYMAP = new HashMap();

    private static final HashSet CONTAINERS = new HashSet();

    static
    {
        CONTAINERS.add(AssignedScorecardState.class.getName());

        String[] objs = new String[CONTAINERS.size()];
        CONTAINERS.toArray(objs);
        for (int i = 0; i < objs.length; i++)
        {
            RPMManagerFactory.getInstance().addContainerToMap(objs[i],
                ScorecardAssignmentManager.class);
        }
    }

    /**
     * Column LEVEL_ID of type Types.INTEGER mapped to Integer.
     */
    //    public static final int ID_LEVEL_ID = 1;
    //
    //    public static final int TYPE_LEVEL_ID = Types.INTEGER;
    //
    //    public static final String NAME_LEVEL_ID =
    // "TMT_ASSIGNED_SCORECARDS.LEVEL_ID";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_LEVEL_ID = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_LEVEL_ID,NAME_LEVEL_ID);}
    /**
     * Column TYPE_ID of type Types.INTEGER mapped to Integer.
     */
    public static final int ID_TYPE_ID = 1;

    public static final int TYPE_TYPE_ID = Types.INTEGER;

    public static final String NAME_TYPE_ID = "TMT_ASSIGNED_SCORECARDS.TYPE_ID";

    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_TYPE_ID = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_TYPE_ID,NAME_TYPE_ID);}

    /**
     * Column MAX_RANK of type Types.INTEGER mapped to Integer.
     */
    //    public static final int ID_MAX_RANK = 3;
    //
    //    public static final int TYPE_MAX_RANK = Types.INTEGER;
    //
    //    public static final String NAME_MAX_RANK =
    // "TMT_ASSIGNED_SCORECARDS.MAX_RANK";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_MAX_RANK = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_MAX_RANK,NAME_MAX_RANK);}
    /**
     * Column CHILD_COUNT of type Types.INTEGER mapped to Integer.
     */
    //    public static final int ID_CHILD_COUNT = 4;
    //
    //    public static final int TYPE_CHILD_COUNT = Types.INTEGER;
    //
    //    public static final String NAME_CHILD_COUNT =
    // "TMT_ASSIGNED_SCORECARDS.CHILD_COUNT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_CHILD_COUNT = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_CHILD_COUNT,NAME_CHILD_COUNT);}
    /**
     * Column DELETED_COUNT of type Types.INTEGER mapped to Integer.
     */
    //    public static final int ID_DELETED_COUNT = 5;
    //
    //    public static final int TYPE_DELETED_COUNT = Types.INTEGER;
    //
    //    public static final String NAME_DELETED_COUNT =
    // "TMT_ASSIGNED_SCORECARDS.DELETED_COUNT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_DELETED_COUNT = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_DELETED_COUNT,NAME_DELETED_COUNT);}
    /**
     * Column PROJECT_ID of type Types.CHAR mapped to String.
     */
    //    public static final int ID_PROJECT_ID = 6;
    //
    //    public static final int TYPE_PROJECT_ID = Types.CHAR;
    //
    //    public static final String NAME_PROJECT_ID =
    // "TMT_ASSIGNED_SCORECARDS.PROJECT_ID";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_PROJECT_ID = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_PROJECT_ID,NAME_PROJECT_ID);}
    /**
     * Column ELEMENT_ID of type Types.CHAR mapped to String.
     */
    public static final int ID_ELEMENT_ID = 2;

    public static final int TYPE_ELEMENT_ID = Types.CHAR;

    public static final String NAME_ELEMENT_ID = "TMT_ASSIGNED_SCORECARDS.ELEMENT_ID";

    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    public static final String PROPERTY_ELEMENT_ID = "ID";
    static
    {
        FIELDPROPERTYMAP.put(PROPERTY_ELEMENT_ID, NAME_ELEMENT_ID);
    }

    /**
     * Column ELEMENT_NAME of type Types.VARCHAR mapped to String.
     */
    //    public static final int ID_ELEMENT_NAME = 8;
    //
    //    public static final int TYPE_ELEMENT_NAME = Types.VARCHAR;
    //
    //    public static final String NAME_ELEMENT_NAME =
    // "TMT_ASSIGNED_SCORECARDS.ELEMENT_NAME";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_ELEMENT_NAME = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_ELEMENT_NAME,NAME_ELEMENT_NAME);}
    /**
     * Column PARENT_ID of type Types.CHAR mapped to String.
     */
    public static final int ID_PARENT_ID = 9;

    public static final int TYPE_PARENT_ID = Types.CHAR;

    public static final String NAME_PARENT_ID = "TMT_ASSIGNED_SCORECARDS.PARENT_ID";

    //public static final String PROPERTY_PARENT_ID = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_PARENT_ID,NAME_PARENT_ID);}
    /**
     * Column RANK of type Types.VARCHAR mapped to String.
     */
    //    public static final int ID_RANK = 10;
    //
    //    public static final int TYPE_RANK = Types.VARCHAR;
    //
    //    public static final String NAME_RANK = "TMT_ASSIGNED_SCORECARDS.RANK";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_RANK = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_RANK,NAME_RANK);}
    /**
     * Column PARENT_RANK of type Types.VARCHAR mapped to String.
     */
    //    public static final int ID_PARENT_RANK = 11;
    //
    //    public static final int TYPE_PARENT_RANK = Types.VARCHAR;
    //
    //    public static final String NAME_PARENT_RANK =
    // "TMT_ASSIGNED_SCORECARDS.PARENT_RANK";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_PARENT_RANK = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_PARENT_RANK,NAME_PARENT_RANK);}
    /**
     * Column PARENT_TYPE_ID of type Types.INTEGER mapped to Integer.
     */
    //    public static final int ID_PARENT_TYPE_ID = 12;
    //
    //    public static final int TYPE_PARENT_TYPE_ID = Types.INTEGER;
    //
    //    public static final String NAME_PARENT_TYPE_ID =
    // "TMT_ASSIGNED_SCORECARDS.PARENT_TYPE_ID";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_PARENT_TYPE_ID = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_PARENT_TYPE_ID,NAME_PARENT_TYPE_ID);}
    /**
     * Column CREATED_BY of type Types.CHAR mapped to String.
     */
    //    public static final int ID_CREATED_BY = 13;
    //
    //    public static final int TYPE_CREATED_BY = Types.CHAR;
    //
    //    public static final String NAME_CREATED_BY =
    // "TMT_ASSIGNED_SCORECARDS.CREATED_BY";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_CREATED_BY = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_CREATED_BY,NAME_CREATED_BY);}
    /**
     * Column REC_USER of type Types.CHAR mapped to String.
     */
    //    public static final int ID_REC_USER = 14;
    //
    //    public static final int TYPE_REC_USER = Types.CHAR;
    //
    //    public static final String NAME_REC_USER =
    // "TMT_ASSIGNED_SCORECARDS.REC_USER";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_REC_USER = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_REC_USER,NAME_REC_USER);}
    /**
     * Column REC_STATUS of type Types.CHAR mapped to String.
     */
    //    public static final int ID_REC_STATUS = 15;
    //
    //    public static final int TYPE_REC_STATUS = Types.CHAR;
    //
    //    public static final String NAME_REC_STATUS =
    // "TMT_ASSIGNED_SCORECARDS.REC_STATUS";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_REC_STATUS = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_REC_STATUS,NAME_REC_STATUS);}
    /**
     * Column REC_DATETIME of type Types.TIMESTAMP mapped to java.util.Date.
     */
    //    public static final int ID_REC_DATETIME = 16;
    //
    //    public static final int TYPE_REC_DATETIME = Types.TIMESTAMP;
    //
    //    public static final String NAME_REC_DATETIME =
    // "TMT_ASSIGNED_SCORECARDS.REC_DATETIME";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_REC_DATETIME = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_REC_DATETIME,NAME_REC_DATETIME);}
    /**
     * Column LAST_WF_TYPE of type Types.VARCHAR mapped to String.
     */
    //    public static final int ID_LAST_WF_TYPE = 17;
    //
    //    public static final int TYPE_LAST_WF_TYPE = Types.VARCHAR;
    //
    //    public static final String NAME_LAST_WF_TYPE =
    // "TMT_ASSIGNED_SCORECARDS.LAST_WF_TYPE";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_LAST_WF_TYPE = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_LAST_WF_TYPE,NAME_LAST_WF_TYPE);}
    /**
     * Column LAST_WF_BY of type Types.CHAR mapped to String.
     */
    //    public static final int ID_LAST_WF_BY = 18;
    //
    //    public static final int TYPE_LAST_WF_BY = Types.CHAR;
    //
    //    public static final String NAME_LAST_WF_BY =
    // "TMT_ASSIGNED_SCORECARDS.LAST_WF_BY";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_LAST_WF_BY = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_LAST_WF_BY,NAME_LAST_WF_BY);}
    /**
     * Column LAST_WF_DT of type Types.TIMESTAMP mapped to java.util.Date.
     */
    //    public static final int ID_LAST_WF_DT = 19;
    //
    //    public static final int TYPE_LAST_WF_DT = Types.TIMESTAMP;
    //
    //    public static final String NAME_LAST_WF_DT =
    // "TMT_ASSIGNED_SCORECARDS.LAST_WF_DT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_LAST_WF_DT = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_LAST_WF_DT,NAME_LAST_WF_DT);}
    /**
     * Column MAJOR_REVISION of type Types.SMALLINT mapped to Integer.
     */
    //    public static final int ID_MAJOR_REVISION = 20;
    //
    //    public static final int TYPE_MAJOR_REVISION = Types.SMALLINT;
    //
    //    public static final String NAME_MAJOR_REVISION =
    // "TMT_ASSIGNED_SCORECARDS.MAJOR_REVISION";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_MAJOR_REVISION = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_MAJOR_REVISION,NAME_MAJOR_REVISION);}
    /**
     * Column MINOR_REVISION of type Types.SMALLINT mapped to Integer.
     */
    //    public static final int ID_MINOR_REVISION = 21;
    //
    //    public static final int TYPE_MINOR_REVISION = Types.SMALLINT;
    //
    //    public static final String NAME_MINOR_REVISION =
    // "TMT_ASSIGNED_SCORECARDS.MINOR_REVISION";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_MINOR_REVISION = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_MINOR_REVISION,NAME_MINOR_REVISION);}
    /**
     * Column REVISION_IMPACT of type Types.INTEGER mapped to Integer.
     */
    //    public static final int ID_REVISION_IMPACT = 22;
    //
    //    public static final int TYPE_REVISION_IMPACT = Types.INTEGER;
    //
    //    public static final String NAME_REVISION_IMPACT =
    // "TMT_ASSIGNED_SCORECARDS.REVISION_IMPACT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_REVISION_IMPACT = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_REVISION_IMPACT,NAME_REVISION_IMPACT);}
    /**
     * Column REVISION_TYPE of type Types.INTEGER mapped to Integer.
     */
    //    public static final int ID_REVISION_TYPE = 23;
    //
    //    public static final int TYPE_REVISION_TYPE = Types.INTEGER;
    //
    //    public static final String NAME_REVISION_TYPE =
    // "TMT_ASSIGNED_SCORECARDS.REVISION_TYPE";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_REVISION_TYPE = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_REVISION_TYPE,NAME_REVISION_TYPE);}
    /**
     * Column REVISION_HISTORY of type Types.VARCHAR mapped to String.
     */
    //    public static final int ID_REVISION_HISTORY = 24;
    //
    //    public static final int TYPE_REVISION_HISTORY = Types.VARCHAR;
    //
    //    public static final String NAME_REVISION_HISTORY =
    // "TMT_ASSIGNED_SCORECARDS.REVISION_HISTORY";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_REVISION_HISTORY = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_REVISION_HISTORY,NAME_REVISION_HISTORY);}
    /**
     * Column DESCRIPTION of type Types.VARCHAR mapped to String.
     */
    //    public static final int ID_DESCRIPTION = 25;
    //
    //    public static final int TYPE_DESCRIPTION = Types.VARCHAR;
    //
    //    public static final String NAME_DESCRIPTION =
    // "TMT_ASSIGNED_SCORECARDS.DESCRIPTION";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_DESCRIPTION = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_DESCRIPTION,NAME_DESCRIPTION);}
    /**
     * Column ORIGINAL_ID of type Types.CHAR mapped to String.
     */
    //    public static final int ID_ORIGINAL_ID = 26;
    //
    //    public static final int TYPE_ORIGINAL_ID = Types.CHAR;
    //
    //    public static final String NAME_ORIGINAL_ID =
    // "TMT_ASSIGNED_SCORECARDS.ORIGINAL_ID";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_ORIGINAL_ID = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_ORIGINAL_ID,NAME_ORIGINAL_ID);}
    /**
     * Column SCORE of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_SCORE = 27;
    //
    //    public static final int TYPE_SCORE = Types.BIGINT;
    //
    //    public static final String NAME_SCORE = "TMT_ASSIGNED_SCORECARDS.SCORE";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_SCORE = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_SCORE,NAME_SCORE);}
    /**
     * Column WEIGHT of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_WEIGHT = 28;
    //
    //    public static final int TYPE_WEIGHT = Types.BIGINT;
    //
    //    public static final String NAME_WEIGHT =
    // "TMT_ASSIGNED_SCORECARDS.WEIGHT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_WEIGHT = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_WEIGHT,NAME_WEIGHT);}
    /**
     * Column CONVERTED_SCORE of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_CONVERTED_SCORE = 29;
    //
    //    public static final int TYPE_CONVERTED_SCORE = Types.BIGINT;
    //
    //    public static final String NAME_CONVERTED_SCORE =
    // "TMT_ASSIGNED_SCORECARDS.CONVERTED_SCORE";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_CONVERTED_SCORE = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_CONVERTED_SCORE,NAME_CONVERTED_SCORE);}
    /**
     * Column CONVERTED_WEIGHT of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_CONVERTED_WEIGHT = 30;
    //
    //    public static final int TYPE_CONVERTED_WEIGHT = Types.BIGINT;
    //
    //    public static final String NAME_CONVERTED_WEIGHT =
    // "TMT_ASSIGNED_SCORECARDS.CONVERTED_WEIGHT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_CONVERTED_WEIGHT = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_CONVERTED_WEIGHT,NAME_CONVERTED_WEIGHT);}
    /**
     * Column LAST_CHECKIN of type Types.TIMESTAMP mapped to java.util.Date.
     */
    //    public static final int ID_LAST_CHECKIN = 31;
    //
    //    public static final int TYPE_LAST_CHECKIN = Types.TIMESTAMP;
    //
    //    public static final String NAME_LAST_CHECKIN =
    // "TMT_ASSIGNED_SCORECARDS.LAST_CHECKIN";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_LAST_CHECKIN = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_LAST_CHECKIN,NAME_LAST_CHECKIN);}
    /**
     * Column CREATION_DATE of type Types.DATE mapped to java.util.Date.
     */
    //    public static final int ID_CREATION_DATE = 32;
    //
    //    public static final int TYPE_CREATION_DATE = Types.DATE;
    //
    //    public static final String NAME_CREATION_DATE =
    // "TMT_ASSIGNED_SCORECARDS.CREATION_DATE";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_CREATION_DATE = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_CREATION_DATE,NAME_CREATION_DATE);}
    /**
     * Column PUBLISHED_DT of type Types.TIMESTAMP mapped to java.util.Date.
     */
    //    public static final int ID_PUBLISHED_DT = 33;
    //
    //    public static final int TYPE_PUBLISHED_DT = Types.TIMESTAMP;
    //
    //    public static final String NAME_PUBLISHED_DT =
    // "TMT_ASSIGNED_SCORECARDS.PUBLISHED_DT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_PUBLISHED_DT = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_PUBLISHED_DT,NAME_PUBLISHED_DT);}
    /**
     * Column ACTIVE of type Types.CHAR mapped to String.
     */
    public static final int ID_ACTIVE = 3;

    public static final int TYPE_ACTIVE = Types.CHAR;

    public static final String NAME_ACTIVE = "TMT_ASSIGNED_SCORECARDS.ACTIVE";

    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_ACTIVE = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_ACTIVE,NAME_ACTIVE);}

    /**
     * Column PUBLISHED of type Types.CHAR mapped to String.
     */
    public static final int ID_PUBLISHED = 4;

    public static final int TYPE_PUBLISHED = Types.CHAR;

    public static final String NAME_PUBLISHED = "TMT_ASSIGNED_SCORECARDS.PUBLISHED";

    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_PUBLISHED = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_PUBLISHED,NAME_PUBLISHED);}

    /**
     * Column STAGE_ID of type Types.INTEGER mapped to Integer.
     */
    //    public static final int ID_STAGE_ID = 36;
    //
    //    public static final int TYPE_STAGE_ID = Types.INTEGER;
    //
    //    public static final String NAME_STAGE_ID =
    // "TMT_ASSIGNED_SCORECARDS.STAGE_ID";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_STAGE_ID = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_STAGE_ID,NAME_STAGE_ID);}
    /**
     * Column PREVIOUS_WKF_STEP of type Types.VARCHAR mapped to String.
     */
    //    public static final int ID_PREVIOUS_WKF_STEP = 37;
    //
    //    public static final int TYPE_PREVIOUS_WKF_STEP = Types.VARCHAR;
    //
    //    public static final String NAME_PREVIOUS_WKF_STEP =
    // "TMT_ASSIGNED_SCORECARDS.PREVIOUS_WKF_STEP";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_PREVIOUS_WKF_STEP = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_PREVIOUS_WKF_STEP,NAME_PREVIOUS_WKF_STEP);}
    /**
     * Column zPRIVATE of type Types.CHAR mapped to String.
     */
    //    public static final int ID_ZPRIVATE = 38;
    //
    //    public static final int TYPE_ZPRIVATE = Types.CHAR;
    //
    //    public static final String NAME_ZPRIVATE =
    // "TMT_ASSIGNED_SCORECARDS.zPRIVATE";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_ZPRIVATE = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_ZPRIVATE,NAME_ZPRIVATE);}
    /**
     * Column VISIBLE_AT_PARENT of type Types.CHAR mapped to String.
     */
    //    public static final int ID_VISIBLE_AT_PARENT = 39;
    //
    //    public static final int TYPE_VISIBLE_AT_PARENT = Types.CHAR;
    //
    //    public static final String NAME_VISIBLE_AT_PARENT =
    // "TMT_ASSIGNED_SCORECARDS.VISIBLE_AT_PARENT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_VISIBLE_AT_PARENT = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_VISIBLE_AT_PARENT,NAME_VISIBLE_AT_PARENT);}
    /**
     * Column ASSIGN_NAMES of type Types.VARCHAR mapped to String.
     */
    //    public static final int ID_ASSIGN_NAMES = 40;
    //
    //    public static final int TYPE_ASSIGN_NAMES = Types.VARCHAR;
    //
    //    public static final String NAME_ASSIGN_NAMES =
    // "TMT_ASSIGNED_SCORECARDS.ASSIGN_NAMES";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_ASSIGN_NAMES = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_ASSIGN_NAMES,NAME_ASSIGN_NAMES);}
    /**
     * Column SCOPE_SCORE of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_SCOPE_SCORE = 41;
    //
    //    public static final int TYPE_SCOPE_SCORE = Types.BIGINT;
    //
    //    public static final String NAME_SCOPE_SCORE =
    // "TMT_ASSIGNED_SCORECARDS.SCOPE_SCORE";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_SCOPE_SCORE = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_SCOPE_SCORE,NAME_SCOPE_SCORE);}
    /**
     * Column SCOPE_WEIGHT of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_SCOPE_WEIGHT = 42;
    //
    //    public static final int TYPE_SCOPE_WEIGHT = Types.BIGINT;
    //
    //    public static final String NAME_SCOPE_WEIGHT =
    // "TMT_ASSIGNED_SCORECARDS.SCOPE_WEIGHT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_SCOPE_WEIGHT = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_SCOPE_WEIGHT,NAME_SCOPE_WEIGHT);}
    /**
     * Column SCHEDULE_SCORE of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_SCHEDULE_SCORE = 43;
    //
    //    public static final int TYPE_SCHEDULE_SCORE = Types.BIGINT;
    //
    //    public static final String NAME_SCHEDULE_SCORE =
    // "TMT_ASSIGNED_SCORECARDS.SCHEDULE_SCORE";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_SCHEDULE_SCORE = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_SCHEDULE_SCORE,NAME_SCHEDULE_SCORE);}
    /**
     * Column SCHEDULE_WEIGHT of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_SCHEDULE_WEIGHT = 44;
    //
    //    public static final int TYPE_SCHEDULE_WEIGHT = Types.BIGINT;
    //
    //    public static final String NAME_SCHEDULE_WEIGHT =
    // "TMT_ASSIGNED_SCORECARDS.SCHEDULE_WEIGHT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_SCHEDULE_WEIGHT = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_SCHEDULE_WEIGHT,NAME_SCHEDULE_WEIGHT);}
    /**
     * Column QUALITY_SCORE of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_QUALITY_SCORE = 45;
    //
    //    public static final int TYPE_QUALITY_SCORE = Types.BIGINT;
    //
    //    public static final String NAME_QUALITY_SCORE =
    // "TMT_ASSIGNED_SCORECARDS.QUALITY_SCORE";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_QUALITY_SCORE = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_QUALITY_SCORE,NAME_QUALITY_SCORE);}
    /**
     * Column QUALITY_WEIGHT of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_QUALITY_WEIGHT = 46;
    //
    //    public static final int TYPE_QUALITY_WEIGHT = Types.BIGINT;
    //
    //    public static final String NAME_QUALITY_WEIGHT =
    // "TMT_ASSIGNED_SCORECARDS.QUALITY_WEIGHT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_QUALITY_WEIGHT = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_QUALITY_WEIGHT,NAME_QUALITY_WEIGHT);}
    /**
     * Column COST_SCORE of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_COST_SCORE = 47;
    //
    //    public static final int TYPE_COST_SCORE = Types.BIGINT;
    //
    //    public static final String NAME_COST_SCORE =
    // "TMT_ASSIGNED_SCORECARDS.COST_SCORE";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_COST_SCORE = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_COST_SCORE,NAME_COST_SCORE);}
    /**
     * Column COST_WEIGHT of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_COST_WEIGHT = 48;
    //
    //    public static final int TYPE_COST_WEIGHT = Types.BIGINT;
    //
    //    public static final String NAME_COST_WEIGHT =
    // "TMT_ASSIGNED_SCORECARDS.COST_WEIGHT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_COST_WEIGHT = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_COST_WEIGHT,NAME_COST_WEIGHT);}
    /**
     * Column BENEFIT_SCORE of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_BENEFIT_SCORE = 49;
    //
    //    public static final int TYPE_BENEFIT_SCORE = Types.BIGINT;
    //
    //    public static final String NAME_BENEFIT_SCORE =
    // "TMT_ASSIGNED_SCORECARDS.BENEFIT_SCORE";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_BENEFIT_SCORE = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_BENEFIT_SCORE,NAME_BENEFIT_SCORE);}
    /**
     * Column BENEFIT_WEIGHT of type Types.BIGINT mapped to Long.
     */
    //    public static final int ID_BENEFIT_WEIGHT = 50;
    //
    //    public static final int TYPE_BENEFIT_WEIGHT = Types.BIGINT;
    //
    //    public static final String NAME_BENEFIT_WEIGHT =
    // "TMT_ASSIGNED_SCORECARDS.BENEFIT_WEIGHT";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_BENEFIT_WEIGHT = "PROPERTYNAME";
    //static{
    // FIELDPROPERTYMAP.put(PROPERTY_BENEFIT_WEIGHT,NAME_BENEFIT_WEIGHT);}
    /**
     * Column ROLLUP_BITS of type Types.INTEGER mapped to Integer.
     */
    //    public static final int ID_ROLLUP_BITS = 51;
    //
    //    public static final int TYPE_ROLLUP_BITS = Types.INTEGER;
    //
    //    public static final String NAME_ROLLUP_BITS =
    // "TMT_ASSIGNED_SCORECARDS.ROLLUP_BITS";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_ROLLUP_BITS = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_ROLLUP_BITS,NAME_ROLLUP_BITS);}
    /**
     * Column REPORT_FLAG of type Types.SMALLINT mapped to Integer.
     */
    //    public static final int ID_REPORT_FLAG = 52;
    //
    //    public static final int TYPE_REPORT_FLAG = Types.SMALLINT;
    //
    //    public static final String NAME_REPORT_FLAG =
    // "TMT_ASSIGNED_SCORECARDS.REPORT_FLAG";
    //uncomment and replace PROPERTYNAME with the container property loaded
    // from this column in upper case.
    //public static final String PROPERTY_REPORT_FLAG = "PROPERTYNAME";
    //static{ FIELDPROPERTYMAP.put(PROPERTY_REPORT_FLAG,NAME_REPORT_FLAG);}
    private static final String TABLE_NAME = "TMT_ASSIGNED_SCORECARDS";

    /**
     * Create an array of type string containing all the fields of the
     * TMT_ASSIGNED_SCORECARDS table.
     */
    private static final String[] FIELD_NAMES =
    {
            //NAME_LEVEL_ID,
            NAME_TYPE_ID,
            // NAME_MAX_RANK, NAME_CHILD_COUNT,
            //NAME_DELETED_COUNT, NAME_PROJECT_ID,
            NAME_ELEMENT_ID,
            //NAME_ELEMENT_NAME, NAME_PARENT_ID, NAME_RANK, NAME_PARENT_RANK,
            //NAME_PARENT_TYPE_ID, NAME_CREATED_BY, NAME_REC_USER,
            //NAME_REC_STATUS, NAME_REC_DATETIME, NAME_LAST_WF_TYPE,
            //NAME_LAST_WF_BY, NAME_LAST_WF_DT, NAME_MAJOR_REVISION,
            //NAME_MINOR_REVISION, NAME_REVISION_IMPACT, NAME_REVISION_TYPE,
            //NAME_REVISION_HISTORY, NAME_DESCRIPTION, NAME_ORIGINAL_ID,
            //NAME_SCORE, NAME_WEIGHT, NAME_CONVERTED_SCORE,
            //NAME_CONVERTED_WEIGHT, NAME_LAST_CHECKIN, NAME_CREATION_DATE,
            //NAME_PUBLISHED_DT,
            NAME_ACTIVE, NAME_PUBLISHED,
    //            NAME_STAGE_ID,
    //            NAME_PREVIOUS_WKF_STEP, NAME_ZPRIVATE, NAME_VISIBLE_AT_PARENT,
    //            NAME_ASSIGN_NAMES, NAME_SCOPE_SCORE, NAME_SCOPE_WEIGHT,
    //            NAME_SCHEDULE_SCORE, NAME_SCHEDULE_WEIGHT, NAME_QUALITY_SCORE,
    //            NAME_QUALITY_WEIGHT, NAME_COST_SCORE, NAME_COST_WEIGHT,
    //            NAME_BENEFIT_SCORE, NAME_BENEFIT_WEIGHT, NAME_ROLLUP_BITS,
    //            NAME_REPORT_FLAG
    };

    private static final String ALL_FIELDS;
    static
    {
        StringBuffer fieldcat = new StringBuffer(FIELD_NAMES[0]);
        for (int i = 1; i < FIELD_NAMES.length; i++)
        {
            fieldcat.append(",");
            fieldcat.append(FIELD_NAMES[i]);
        }
        ALL_FIELDS = fieldcat.toString();
    }

    /**
     * Creates a new ScorecardAssignmentManager instance.
     *
     * @return ScorecardAssignmentManager
     */
    public ScorecardAssignmentManager()
    {
        super();
    }

    public String getTableName()
    {
        return TABLE_NAME;
    }

    protected String[] getFieldsNames()
    {
        return FIELD_NAMES;
    }

    protected String getAllFields()
    {
        return ALL_FIELDS;
    }

    public String getPrimaryKey()
    {
        return NAME_ELEMENT_ID;
    }

    protected Integer getContainerType(ResultSet resultSet) throws SQLException
    {

        int typeId = resultSet.getInt(ID_TYPE_ID);
        return new Integer(typeId);

    }

    protected HashMap getPropertiesMap()
    {
        return FIELDPROPERTYMAP;
    }

    protected RPMObject createContainer(int typeId) throws RPMException
    {

        RPMObject object = null;

        switch (typeId)
        {

        case AbstractScorecard.TYPE_ID:
            return new AssignedScorecardState();

        default:
            ExceptionUtil.handleUnsupportedTypeId(this, typeId);
        }
        return object;
    }

    /**
     *
     */

    public void createObject(RPMObject rpmObject, MessageContext messageContext)
    {
        //No need to implement
    }

    /**
     *
     */

    protected RPMObject decodeRow(ResultSet rs, RPMObject rpmObject,
            boolean isDelta) throws RPMException, SQLException
    {
        int typeId = rpmObject.retrieveTypeID().intValue();

        rpmObject.setID(rs.getString(ID_ELEMENT_ID));

        switch (typeId)
        {
        case AssignedScorecard.TYPE_ID:
            AssignedScorecardState state = (AssignedScorecardState) rpmObject;

            final Boolean active = new Boolean(rs.getString(ID_ACTIVE)
                .charAt(0) == '0' ? false : true);
            final Boolean published = new Boolean(rs.getString(ID_PUBLISHED)
                .charAt(0) == 'N' ? false : true);

            if (isDelta)
            {
                state.deltaActive(active);
                state.deltaPublished(published);
            }
            else
            {
                state.setActive(active);
                state.setPublished(published);
            }

            break;

        default:
            ExceptionUtil.handleUnsupportedTypeId(this, typeId);
        }

        return rpmObject;

    }

    /**
     *
     */

    protected void doDelete(RPMObject rpmObject, MessageContext messageContext)
    {
    }

    /**
     *
     */

    protected JoinCondition getForeignKeyCondition(RPMObjectManager manager,
            String extraWhere, String contextName) throws RPMException
    {
        return getSubTableJoinCondition(manager, extraWhere, 0, null,
            contextName);
    }

    /**
     *
     */

    protected JoinCondition getJoinCondition(RPMObjectManager manager,
            String condition, int level, String containerName,
            String contextName) throws RPMException
    {
        JoinCondition joinCondition = null;

        if (manager == null)
        {
            joinCondition = new JoinCondition();
            joinCondition.setTableName(getTableName());

            StringBuffer where = new StringBuffer();
            if (condition != null)
            {
                where.append(condition);
            }

            joinCondition.setCondition(where.toString());

        }
        else
        {
            ExceptionUtil.handleUnsupportedJoinCondition(this, manager,
                ExceptionUtil.JOIN);
        }
        return joinCondition;
    }

    /**
     * @see com.ibm.rpm.framework.RPMObjectManager#getFilter()
     */
    public String getFilter()
    {
        return NAME_TYPE_ID + "=" + AssignedScorecard.TYPE_ID;
    }

    protected JoinCondition getSubTableJoinCondition(RPMObjectManager manager,
            String condition, int level, String containerName,
            String contextName) throws RPMException
    {
        JoinCondition joinCondition = null;

        if (manager instanceof AssignedScorecard)
        {
            StringBuffer where = new StringBuffer();
            where.append(PublishedScorecardManager.NAME_ELEMENT_ID).append("=");
            where.append(NAME_ELEMENT_ID).append(" and ");
            where.append(NAME_TYPE_ID).append("=").append(
                AssignedScorecard.TYPE_ID);
            if (condition != null)
            {
                where.append(" AND ").append(condition);
            }

            joinCondition.setCondition(where.toString());
            joinCondition.setTableName(getTableName());
        }
        else
            ExceptionUtil.handleUnsupportedJoinCondition(this, manager,
                ExceptionUtil.FOREIGN_KEY);

        return joinCondition;
    }

    /**
     * @throws SQLException
     *
     */

    public RPMObject updateObject(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext messageContext) throws SQLException
    {
        if (((AssignedScorecardState) rpmObject).testActiveModified())
        {
            SP_U_SC_ACTIVE((AssignedScorecardState) rpmObject, messageContext);
        }

        return rpmObject;
    }

    public void publishScorecard(AssignedScorecard assignedScorecard,AbstractScorecardScope scorecardScope,
            MessageContext messageContext) throws RPMException, SQLException
    {
        if (AssignedScorecardCheckpoint.getInstance().canPublishScorecard(
            assignedScorecard, scorecardScope, messageContext))
        {
            RPMObjectManager manager = RPMManagerFactory.getInstance()
                .getRPMObjectManager(assignedScorecard.getParent());

            if (!manager.isCheckedOut(messageContext, assignedScorecard
                .getParent()))
            {
                manager.checkoutObject(assignedScorecard.getParent(),
                    messageContext);
            }

            SP_PUB_SC(assignedScorecard, messageContext);

            if (manager.isCheckedOut(messageContext, assignedScorecard
                .getParent()))
            {
                manager.checkinObject(assignedScorecard.getParent(),
                    messageContext);
            }
        }

    }

    private void SP_U_SC_ACTIVE(AssignedScorecardState state,
            MessageContext context) throws SQLException
    {
        if (state.getActive() == null)
            return;

        String name = "SP_U_SC_ACTIVE";
        Object args[] = new Object[3];
        args[0] = state.getID();
        args[1] = state.getActive().booleanValue() ? "1" : "0";
        args[2] = getUser(context).getID();

        try
        {
            executeProcedure(context, name, args);
        }
        catch (RPMException e)
        {
            // TODO: find the reason
        }
    }

    private void SP_PUB_SC(AssignedScorecard assignedScorecard,
            MessageContext context) throws SQLException, RPMException
    {
        String name = "SP_PUB_SC";
        Object args[] = new Object[3];
        args[0] = ScorecardUtil
            .getTableType(assignedScorecard.getContextName());
        args[1] = assignedScorecard.getID();
        args[2] = getUser(context).getID();

        executeProcedure(context, name, args);
    }

}