package com.ibm.rpm.scorecard.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class ProbabilityType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected ProbabilityType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _None = "None";
	public static final ProbabilityType None = new ProbabilityType(_None);
	
		
	public static final String _CustomerSatisfaction = "CustomerSatisfaction";
	public static final ProbabilityType CustomerSatisfaction = new ProbabilityType(_CustomerSatisfaction);
	
		
	public static final String _ProjectBenefits = "ProjectBenefits";
	public static final ProbabilityType ProjectBenefits = new ProbabilityType(_ProjectBenefits);
	
		
	public static final String _ProjectCosts = "ProjectCosts";
	public static final ProbabilityType ProjectCosts = new ProbabilityType(_ProjectCosts);
	
		
	public static final String _ProjectRisk = "ProjectRisk";
	public static final ProbabilityType ProjectRisk = new ProbabilityType(_ProjectRisk);
	
		
	public static final String _ProjectSchedule = "ProjectSchedule";
	public static final ProbabilityType ProjectSchedule = new ProbabilityType(_ProjectSchedule);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static ProbabilityType fromValue(String value) throws IllegalStateException {
		ProbabilityType retVal = (ProbabilityType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static ProbabilityType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof ProbabilityType && ordinal == ((ProbabilityType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((ProbabilityType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final ProbabilityType[] VALUES = {None, CustomerSatisfaction, ProjectBenefits, ProjectCosts, ProjectRisk, ProjectSchedule};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}