package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class ActionItemSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected ActionItemSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _ActionItemGroup = "Action Item Group";
	public static final ActionItemSecurityRoleType ActionItemGroup = new ActionItemSecurityRoleType(_ActionItemGroup);
	
		
	public static final String _ActionItemParticipant = "Action Item Participant";
	public static final ActionItemSecurityRoleType ActionItemParticipant = new ActionItemSecurityRoleType(_ActionItemParticipant);
	
		
	public static final String _ActionItemResponsible = "Action Item Responsible";
	public static final ActionItemSecurityRoleType ActionItemResponsible = new ActionItemSecurityRoleType(_ActionItemResponsible);
	
		
	public static final String _ActionItemTeamMember = "Action Item Team Member";
	public static final ActionItemSecurityRoleType ActionItemTeamMember = new ActionItemSecurityRoleType(_ActionItemTeamMember);
	
		
	public static final String _ActionItemVisitor = "Action Item Visitor";
	public static final ActionItemSecurityRoleType ActionItemVisitor = new ActionItemSecurityRoleType(_ActionItemVisitor);
	
		
	public static final String _ActionItemWorkflowVisitor = "Action Item Workflow Visitor";
	public static final ActionItemSecurityRoleType ActionItemWorkflowVisitor = new ActionItemSecurityRoleType(_ActionItemWorkflowVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static ActionItemSecurityRoleType fromValue(String value) throws IllegalStateException {
		ActionItemSecurityRoleType retVal = (ActionItemSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static ActionItemSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof ActionItemSecurityRoleType && ordinal == ((ActionItemSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((ActionItemSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final ActionItemSecurityRoleType[] VALUES = {ActionItemGroup, ActionItemParticipant, ActionItemResponsible, ActionItemTeamMember, ActionItemVisitor, ActionItemWorkflowVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}