package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class ChangeRequestSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected ChangeRequestSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _ChangeRequestGroup = "Change Request Group";
	public static final ChangeRequestSecurityRoleType ChangeRequestGroup = new ChangeRequestSecurityRoleType(_ChangeRequestGroup);
	
		
	public static final String _ChangeRequestParticipant = "Change Request Participant";
	public static final ChangeRequestSecurityRoleType ChangeRequestParticipant = new ChangeRequestSecurityRoleType(_ChangeRequestParticipant);
	
		
	public static final String _ChangeRequestResponsible = "Change Request Responsible";
	public static final ChangeRequestSecurityRoleType ChangeRequestResponsible = new ChangeRequestSecurityRoleType(_ChangeRequestResponsible);
	
		
	public static final String _ChangeRequestTeamMember = "Change Request Team Member";
	public static final ChangeRequestSecurityRoleType ChangeRequestTeamMember = new ChangeRequestSecurityRoleType(_ChangeRequestTeamMember);
	
		
	public static final String _ChangeRequestVisitor = "Change Request Visitor";
	public static final ChangeRequestSecurityRoleType ChangeRequestVisitor = new ChangeRequestSecurityRoleType(_ChangeRequestVisitor);
	
		
	public static final String _ChangeRequestWorkflowVisitor = "Change Request Workflow Visitor";
	public static final ChangeRequestSecurityRoleType ChangeRequestWorkflowVisitor = new ChangeRequestSecurityRoleType(_ChangeRequestWorkflowVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static ChangeRequestSecurityRoleType fromValue(String value) throws IllegalStateException {
		ChangeRequestSecurityRoleType retVal = (ChangeRequestSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static ChangeRequestSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof ChangeRequestSecurityRoleType && ordinal == ((ChangeRequestSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((ChangeRequestSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final ChangeRequestSecurityRoleType[] VALUES = {ChangeRequestGroup, ChangeRequestParticipant, ChangeRequestResponsible, ChangeRequestTeamMember, ChangeRequestVisitor, ChangeRequestWorkflowVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}