package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class DefectSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected DefectSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _DefectGroup = "Defect Group";
	public static final DefectSecurityRoleType DefectGroup = new DefectSecurityRoleType(_DefectGroup);
	
		
	public static final String _DefectParticipant = "Defect Participant";
	public static final DefectSecurityRoleType DefectParticipant = new DefectSecurityRoleType(_DefectParticipant);
	
		
	public static final String _DefectResponsible = "Defect Responsible";
	public static final DefectSecurityRoleType DefectResponsible = new DefectSecurityRoleType(_DefectResponsible);
	
		
	public static final String _DefectTeamMember = "Defect Team Member";
	public static final DefectSecurityRoleType DefectTeamMember = new DefectSecurityRoleType(_DefectTeamMember);
	
		
	public static final String _DefectVisitor = "Defect Visitor";
	public static final DefectSecurityRoleType DefectVisitor = new DefectSecurityRoleType(_DefectVisitor);
	
		
	public static final String _DefectWorkflowVisitor = "Defect Workflow Visitor";
	public static final DefectSecurityRoleType DefectWorkflowVisitor = new DefectSecurityRoleType(_DefectWorkflowVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static DefectSecurityRoleType fromValue(String value) throws IllegalStateException {
		DefectSecurityRoleType retVal = (DefectSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static DefectSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof DefectSecurityRoleType && ordinal == ((DefectSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((DefectSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final DefectSecurityRoleType[] VALUES = {DefectGroup, DefectParticipant, DefectResponsible, DefectTeamMember, DefectVisitor, DefectWorkflowVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}