package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class DeliverableSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected DeliverableSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _DeliverableGroup = "Deliverable Group";
	public static final DeliverableSecurityRoleType DeliverableGroup = new DeliverableSecurityRoleType(_DeliverableGroup);
	
		
	public static final String _DeliverableManager = "Deliverable Manager";
	public static final DeliverableSecurityRoleType DeliverableManager = new DeliverableSecurityRoleType(_DeliverableManager);
	
		
	public static final String _DeliverableParticipant = "Deliverable Participant";
	public static final DeliverableSecurityRoleType DeliverableParticipant = new DeliverableSecurityRoleType(_DeliverableParticipant);
	
		
	public static final String _DeliverableResponsible = "Deliverable Responsible";
	public static final DeliverableSecurityRoleType DeliverableResponsible = new DeliverableSecurityRoleType(_DeliverableResponsible);
	
		
	public static final String _DeliverableWorkflowVisitor = "Deliverable Workflow Visitor";
	public static final DeliverableSecurityRoleType DeliverableWorkflowVisitor = new DeliverableSecurityRoleType(_DeliverableWorkflowVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static DeliverableSecurityRoleType fromValue(String value) throws IllegalStateException {
		DeliverableSecurityRoleType retVal = (DeliverableSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static DeliverableSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof DeliverableSecurityRoleType && ordinal == ((DeliverableSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((DeliverableSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final DeliverableSecurityRoleType[] VALUES = {DeliverableGroup, DeliverableManager, DeliverableParticipant, DeliverableResponsible, DeliverableWorkflowVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}