package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class IssueSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected IssueSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _IssueGroup = "Issue Group";
	public static final IssueSecurityRoleType IssueGroup = new IssueSecurityRoleType(_IssueGroup);
	
		
	public static final String _IssueParticipant = "Issue Participant";
	public static final IssueSecurityRoleType IssueParticipant = new IssueSecurityRoleType(_IssueParticipant);
	
		
	public static final String _IssueResponsible = "Issue Responsible";
	public static final IssueSecurityRoleType IssueResponsible = new IssueSecurityRoleType(_IssueResponsible);
	
		
	public static final String _IssueTeamMember = "Issue Team Member";
	public static final IssueSecurityRoleType IssueTeamMember = new IssueSecurityRoleType(_IssueTeamMember);
	
		
	public static final String _IssueVisitor = "Issue Visitor";
	public static final IssueSecurityRoleType IssueVisitor = new IssueSecurityRoleType(_IssueVisitor);
	
		
	public static final String _IssueWorkflowVisitor = "Issue Workflow Visitor";
	public static final IssueSecurityRoleType IssueWorkflowVisitor = new IssueSecurityRoleType(_IssueWorkflowVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static IssueSecurityRoleType fromValue(String value) throws IllegalStateException {
		IssueSecurityRoleType retVal = (IssueSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static IssueSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof IssueSecurityRoleType && ordinal == ((IssueSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((IssueSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final IssueSecurityRoleType[] VALUES = {IssueGroup, IssueParticipant, IssueResponsible, IssueTeamMember, IssueVisitor, IssueWorkflowVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}