package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class NotesMinutesSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected NotesMinutesSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _NotesMinutesGroup = "Notes Minutes Group";
	public static final NotesMinutesSecurityRoleType NotesMinutesGroup = new NotesMinutesSecurityRoleType(_NotesMinutesGroup);
	
		
	public static final String _NotesMinutesParticipant = "Notes Minutes Participant";
	public static final NotesMinutesSecurityRoleType NotesMinutesParticipant = new NotesMinutesSecurityRoleType(_NotesMinutesParticipant);
	
		
	public static final String _NotesMinutesResponsible = "Notes Minutes Responsible";
	public static final NotesMinutesSecurityRoleType NotesMinutesResponsible = new NotesMinutesSecurityRoleType(_NotesMinutesResponsible);
	
		
	public static final String _NotesMinutesVisitor = "Notes Minutes Visitor";
	public static final NotesMinutesSecurityRoleType NotesMinutesVisitor = new NotesMinutesSecurityRoleType(_NotesMinutesVisitor);
	
		
	public static final String _NotesMinutesWorkflowVisitor = "Notes Minutes Workflow Visitor";
	public static final NotesMinutesSecurityRoleType NotesMinutesWorkflowVisitor = new NotesMinutesSecurityRoleType(_NotesMinutesWorkflowVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static NotesMinutesSecurityRoleType fromValue(String value) throws IllegalStateException {
		NotesMinutesSecurityRoleType retVal = (NotesMinutesSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static NotesMinutesSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof NotesMinutesSecurityRoleType && ordinal == ((NotesMinutesSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((NotesMinutesSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final NotesMinutesSecurityRoleType[] VALUES = {NotesMinutesGroup, NotesMinutesParticipant, NotesMinutesResponsible, NotesMinutesVisitor, NotesMinutesWorkflowVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}