package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class PoolSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected PoolSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _PoolGroup = "Pool Group";
	public static final PoolSecurityRoleType PoolGroup = new PoolSecurityRoleType(_PoolGroup);
	
		
	public static final String _PoolParticipant = "Pool Participant";
	public static final PoolSecurityRoleType PoolParticipant = new PoolSecurityRoleType(_PoolParticipant);
	
		
	public static final String _ResourceManager = "Resource Manager";
	public static final PoolSecurityRoleType ResourceManager = new PoolSecurityRoleType(_ResourceManager);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static PoolSecurityRoleType fromValue(String value) throws IllegalStateException {
		PoolSecurityRoleType retVal = (PoolSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static PoolSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof PoolSecurityRoleType && ordinal == ((PoolSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((PoolSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final PoolSecurityRoleType[] VALUES = {PoolGroup, PoolParticipant, ResourceManager};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}