package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class ProjectSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected ProjectSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _ProjectGroup = "Project Group";
	public static final ProjectSecurityRoleType ProjectGroup = new ProjectSecurityRoleType(_ProjectGroup);
	
		
	public static final String _CoFinance = "Co-Finance";
	public static final ProjectSecurityRoleType CoFinance = new ProjectSecurityRoleType(_CoFinance);
	
		
	public static final String _CoManager = "Co-Manager";
	public static final ProjectSecurityRoleType CoManager = new ProjectSecurityRoleType(_CoManager);
	
		
	public static final String _Finance = "Finance";
	public static final ProjectSecurityRoleType Finance = new ProjectSecurityRoleType(_Finance);
	
		
	public static final String _MethodAuthor = "Method Author";
	public static final ProjectSecurityRoleType MethodAuthor = new ProjectSecurityRoleType(_MethodAuthor);
	
		
	public static final String _ProjectAssignment = "Project Assignment";
	public static final ProjectSecurityRoleType ProjectAssignment = new ProjectSecurityRoleType(_ProjectAssignment);
	
		
	public static final String _ProjectManager = "Project Manager";
	public static final ProjectSecurityRoleType ProjectManager = new ProjectSecurityRoleType(_ProjectManager);
	
		
	public static final String _ProjectOffice = "Project Office";
	public static final ProjectSecurityRoleType ProjectOffice = new ProjectSecurityRoleType(_ProjectOffice);
	
		
	public static final String _ProjectParticipant = "Project Participant";
	public static final ProjectSecurityRoleType ProjectParticipant = new ProjectSecurityRoleType(_ProjectParticipant);
	
		
	public static final String _ProjectVisitor = "Project Visitor";
	public static final ProjectSecurityRoleType ProjectVisitor = new ProjectSecurityRoleType(_ProjectVisitor);
	
		
	public static final String _ProjectWorkflowVisitor = "Project Workflow Visitor";
	public static final ProjectSecurityRoleType ProjectWorkflowVisitor = new ProjectSecurityRoleType(_ProjectWorkflowVisitor);
	
		
	public static final String _ExecutiveRoles = "Executive Roles";
	public static final ProjectSecurityRoleType ExecutiveRoles = new ProjectSecurityRoleType(_ExecutiveRoles);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static ProjectSecurityRoleType fromValue(String value) throws IllegalStateException {
		ProjectSecurityRoleType retVal = (ProjectSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static ProjectSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof ProjectSecurityRoleType && ordinal == ((ProjectSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((ProjectSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final ProjectSecurityRoleType[] VALUES = {ProjectGroup, CoFinance, CoManager, Finance, MethodAuthor, ProjectAssignment, ProjectManager, ProjectOffice, ProjectParticipant, ProjectVisitor, ProjectWorkflowVisitor, ExecutiveRoles};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}