package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class RequirementSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected RequirementSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _RequirementGroup = "Requirement Group";
	public static final RequirementSecurityRoleType RequirementGroup = new RequirementSecurityRoleType(_RequirementGroup);
	
		
	public static final String _RequirementParticipant = "Requirement Participant";
	public static final RequirementSecurityRoleType RequirementParticipant = new RequirementSecurityRoleType(_RequirementParticipant);
	
		
	public static final String _RequirementResponsible = "Requirement Responsible";
	public static final RequirementSecurityRoleType RequirementResponsible = new RequirementSecurityRoleType(_RequirementResponsible);
	
		
	public static final String _RequirementTeamMember = "Requirement Team Member";
	public static final RequirementSecurityRoleType RequirementTeamMember = new RequirementSecurityRoleType(_RequirementTeamMember);
	
		
	public static final String _RequirementVisitor = "Requirement Visitor";
	public static final RequirementSecurityRoleType RequirementVisitor = new RequirementSecurityRoleType(_RequirementVisitor);
	
		
	public static final String _RequirementWorkflowVisitor = "Requirement Workflow Visitor";
	public static final RequirementSecurityRoleType RequirementWorkflowVisitor = new RequirementSecurityRoleType(_RequirementWorkflowVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static RequirementSecurityRoleType fromValue(String value) throws IllegalStateException {
		RequirementSecurityRoleType retVal = (RequirementSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static RequirementSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof RequirementSecurityRoleType && ordinal == ((RequirementSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((RequirementSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final RequirementSecurityRoleType[] VALUES = {RequirementGroup, RequirementParticipant, RequirementResponsible, RequirementTeamMember, RequirementVisitor, RequirementWorkflowVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}