package com.ibm.rpm.security.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class TaskSecurityRoleType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected TaskSecurityRoleType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _TaskGroup = "Task Group";
	public static final TaskSecurityRoleType TaskGroup = new TaskSecurityRoleType(_TaskGroup);
	
		
	public static final String _TaskParticipant = "Task Participant";
	public static final TaskSecurityRoleType TaskParticipant = new TaskSecurityRoleType(_TaskParticipant);
	
		
	public static final String _TaskResponsible = "Task Responsible";
	public static final TaskSecurityRoleType TaskResponsible = new TaskSecurityRoleType(_TaskResponsible);
	
		
	public static final String _TaskTeamMember = "Task Team Member";
	public static final TaskSecurityRoleType TaskTeamMember = new TaskSecurityRoleType(_TaskTeamMember);
	
		
	public static final String _TaskWorkflowVisitor = "Task Workflow Visitor";
	public static final TaskSecurityRoleType TaskWorkflowVisitor = new TaskSecurityRoleType(_TaskWorkflowVisitor);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static TaskSecurityRoleType fromValue(String value) throws IllegalStateException {
		TaskSecurityRoleType retVal = (TaskSecurityRoleType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static TaskSecurityRoleType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof TaskSecurityRoleType && ordinal == ((TaskSecurityRoleType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((TaskSecurityRoleType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final TaskSecurityRoleType[] VALUES = {TaskGroup, TaskParticipant, TaskResponsible, TaskTeamMember, TaskWorkflowVisitor};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}