package com.ibm.rpm.timesheet.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.resource.containers.Pool;
import com.ibm.rpm.timesheet.constants.ValidationConstants;
import com.ibm.rpm.timesheet.containers.DefaultAdministrativeTask;

public class DefaultAdministrativeTaskCheckpoint extends TimesheetElementCheckpoint
{
    private static final List ADMINISTRATIVETASK_PARENT_LIST = new ArrayList();

    protected static DefaultAdministrativeTaskCheckpoint instance = new DefaultAdministrativeTaskCheckpoint();

    static
    {
        ADMINISTRATIVETASK_PARENT_LIST.add(Pool.class);
    }

    public static DefaultAdministrativeTaskCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        DefaultAdministrativeTask adminTask = (DefaultAdministrativeTask) rpmObject;

        super.validateSave(rpmObject, msgCtx, true,
            ADMINISTRATIVETASK_PARENT_LIST);
        
        if (adminTask.testNameModified())
        {
            // Check that the name doesn't exceed the max length
            GenericValidator.validateMaxLength(adminTask,
                ValidationConstants.NAME_FIELD, adminTask.getName(),
                ValidationConstants.ADMIN_TASK_NAME_CHARACTER_LIMIT, msgCtx);
        }
    }
}
