package com.ibm.rpm.timesheet.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.resource.containers.Resource;
import com.ibm.rpm.timesheet.constants.ValidationConstants;
import com.ibm.rpm.timesheet.containers.PersonalProject;

public class PersonalProjectCheckpoint extends TimesheetElementCheckpoint
{
    private static final List PERSONALPROJECT_PARENT_LIST = new ArrayList();

    protected static PersonalProjectCheckpoint instance = new PersonalProjectCheckpoint();

    static
    {
        PERSONALPROJECT_PARENT_LIST.add(Resource.class);
    }

    public static PersonalProjectCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        PersonalProject personalProject = (PersonalProject) rpmObject;

        super.isValidParent(rpmObject, msgCtx, false,
            PERSONALPROJECT_PARENT_LIST);

        if (!msgCtx.isSuccessful())
        {
            return;
        }

        //cannot create
        GenericValidator.validateCannotCreate(personalProject,
            msgCtx);

        if (personalProject.testNameModified())
        {
            GenericValidator.validateReadOnly(personalProject,
                ValidationConstants.NAME_FIELD, msgCtx);
        }

    }

}
