package com.ibm.rpm.timesheet.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class TimesheetStatus implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected TimesheetStatus(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Submitted = "Submitted";
	public static final TimesheetStatus Submitted = new TimesheetStatus(_Submitted);
	
		
	public static final String _Approved = "Approved";
	public static final TimesheetStatus Approved = new TimesheetStatus(_Approved);
	
		
	public static final String _Rejected = "Rejected";
	public static final TimesheetStatus Rejected = new TimesheetStatus(_Rejected);
	
		
	public static final String _ApprovedByProjectManager = "ApprovedByProjectManager";
	public static final TimesheetStatus ApprovedByProjectManager = new TimesheetStatus(_ApprovedByProjectManager);
	
		
	public static final String _RejectedByProjectManager = "RejectedByProjectManager";
	public static final TimesheetStatus RejectedByProjectManager = new TimesheetStatus(_RejectedByProjectManager);
	
		
	public static final String _ApprovedByResourceManager = "ApprovedByResourceManager";
	public static final TimesheetStatus ApprovedByResourceManager = new TimesheetStatus(_ApprovedByResourceManager);
	
		
	public static final String _RejectedByResourceManager = "RejectedByResourceManager";
	public static final TimesheetStatus RejectedByResourceManager = new TimesheetStatus(_RejectedByResourceManager);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static TimesheetStatus fromValue(String value) throws IllegalStateException {
		TimesheetStatus retVal = (TimesheetStatus) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static TimesheetStatus fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof TimesheetStatus && ordinal == ((TimesheetStatus)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((TimesheetStatus)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final TimesheetStatus[] VALUES = {Submitted, Approved, Rejected, ApprovedByProjectManager, RejectedByProjectManager, ApprovedByResourceManager, RejectedByResourceManager};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}