/**
 * Created on Dec 9, 2005
 * @author shahla
 */
package com.ibm.rpm.timesheet.util;

import java.util.HashMap;

import com.ibm.rpm.security.types.ProjectSecurityRoleType;

public class RoleTypeUtility
{
    private static HashMap indexByRoleType = new HashMap();
    private static HashMap roleTypeByIndex = new HashMap();

    static
    {
        indexByRoleType.put(ProjectSecurityRoleType.ProjectAssignment, new Integer(1));
        indexByRoleType.put(ProjectSecurityRoleType.ProjectManager, new Integer(2));
        // TODO activate this once Personal Task is implemented
        //indexByRoleType.put(ProjectSecurityRoleType.ResourceManager, new Integer(3));
        

        roleTypeByIndex.put(new Integer(1), ProjectSecurityRoleType.ProjectAssignment);
        roleTypeByIndex.put(new Integer(2), ProjectSecurityRoleType.ProjectManager);
        // TODO activate this once Personal Task is implemented
//        roleTypeByIndex.put("3", ProjectSecurityRoleType.ResourceManager);
    }

    public static Integer getIndexByRoleType(
            ProjectSecurityRoleType roleType)
    {
        if (roleType == null)
            return null;
        return (Integer) indexByRoleType.get(roleType);
    }

    public static ProjectSecurityRoleType getRoleTypeByIndex(Integer index)
    {
        if (index == null)
            return null;
        return (ProjectSecurityRoleType) roleTypeByIndex.get(index);
    }
}
