/**
 * Created on Dec 9, 2005
 * 
 * @author shahla
 */
package com.ibm.rpm.timesheet.util;

import java.util.ArrayList;
import java.util.HashMap;

import com.ibm.rpm.timesheet.types.TimesheetStatus;

public class TimesheetStatusUtil
{
    private static HashMap indexByTimesheetStatus = new HashMap();

    private static HashMap timesheetStatusByIndex = new HashMap();

    static
    {
        indexByTimesheetStatus.put(TimesheetStatus.Submitted, new Integer(12));
        indexByTimesheetStatus.put(TimesheetStatus.Approved, new Integer(1));
        indexByTimesheetStatus.put(TimesheetStatus.Rejected, new Integer(2));
        indexByTimesheetStatus.put(TimesheetStatus.ApprovedByProjectManager,
            new Integer(5));
        indexByTimesheetStatus.put(TimesheetStatus.ApprovedByResourceManager,
            new Integer(9));
        indexByTimesheetStatus.put(TimesheetStatus.RejectedByProjectManager,
            new Integer(14));
        indexByTimesheetStatus.put(TimesheetStatus.RejectedByResourceManager,
            new Integer(18));

        timesheetStatusByIndex.put(new Integer(12), TimesheetStatus.Submitted);
        timesheetStatusByIndex.put(new Integer(1), TimesheetStatus.Approved);
        timesheetStatusByIndex.put(new Integer(2), TimesheetStatus.Rejected);
        timesheetStatusByIndex.put(new Integer(5),
            TimesheetStatus.ApprovedByProjectManager);
        timesheetStatusByIndex.put(new Integer(9),
            TimesheetStatus.ApprovedByResourceManager);
        timesheetStatusByIndex.put(new Integer(14),
            TimesheetStatus.RejectedByProjectManager);
        timesheetStatusByIndex.put(new Integer(18),
            TimesheetStatus.RejectedByResourceManager);
    }

    public static Integer getIndexByTimesheetStatus(TimesheetStatus status)
    {
        if (status == null)
            return null;
        return (Integer) indexByTimesheetStatus.get(status);
    }

    public static TimesheetStatus getTimesheetStatusByIndex(Integer index)
    {
        if (index == null)
            return null;
        return (TimesheetStatus) timesheetStatusByIndex.get(index);
    }

    public static ArrayList getTimesheetStatusValues()
    {
        return new ArrayList(timesheetStatusByIndex.values());
    }
}
