/*
 * Created on Nov 15, 2005 
 * @author mmatwiy 
 * Checkpoint for common fields of project activities Deliverable, 
 * WorkProduct, SummaryTask.
 */
package com.ibm.rpm.wbs.checkpoints;

import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.wbs.constants.ValidationConstants;
import com.ibm.rpm.wbs.containers.WorkElement;

public abstract class AbstractProjectActivityCheckpoint extends
        AbstractAggregateNodeCheckpoint
{
    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx, boolean parentRequired, List validParentTypes)
    {
        super.validateSave(rpmObject, rpmScope, msgCtx, parentRequired,
            validParentTypes);

        WorkElement workElement = (WorkElement) rpmObject;

        if (workElement.testNameModified())
        {
            // Check that the name doesn't exceed the max length
            GenericValidator.validateMaxLength(workElement,
                ValidationConstants.NAME_FIELD, workElement.getName(),
                ValidationConstants.PROJECT_ACTIVITY_NAME_CHARACTER_LIMIT,
                msgCtx);
        }

        if (workElement.testReferenceNumberModified())
        {
            // Check that the reference number doesn't exceed the max length
            GenericValidator
                .validateMaxLength(
                    workElement,
                    ValidationConstants.REFERENCE_NUMBER_FIELD,
                    workElement.getReferenceNumber(),
                    ValidationConstants.PROJECT_ACTIVITY_REFERENCE_NUMBER_CHARACTER_LIMIT,
                    msgCtx);
        }

    }
}
