/*
 * Created on Nov 17, 2005 
 * @author mmatwiy 
 * Checkpoint validation for WBS container Milestone.
 */
package com.ibm.rpm.wbs.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.wbs.containers.Deliverable;
import com.ibm.rpm.wbs.containers.Project;
import com.ibm.rpm.wbs.containers.Proposal;
import com.ibm.rpm.wbs.containers.SummaryTask;
import com.ibm.rpm.wbs.containers.WorkOrganization;
import com.ibm.rpm.wbs.containers.WorkProduct;

public class MilestoneCheckpoint extends SimpleNodeCheckpoint
{
    private static final List MILESTONE_PARENT_LIST = new ArrayList();

    protected static MilestoneCheckpoint instance = new MilestoneCheckpoint();

    static
    {
        MILESTONE_PARENT_LIST.add(Proposal.class);
        MILESTONE_PARENT_LIST.add(Project.class);
        MILESTONE_PARENT_LIST.add(WorkOrganization.class);
        MILESTONE_PARENT_LIST.add(Deliverable.class);
        MILESTONE_PARENT_LIST.add(WorkProduct.class);
        MILESTONE_PARENT_LIST.add(SummaryTask.class);
    }

    public static MilestoneCheckpoint getInstance()
    {
        return instance;
    }

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        super.validateSave(rpmObject, rpmScope, msgCtx, true, MILESTONE_PARENT_LIST);
    }

}
