package com.ibm.rpm.wbs.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class LeadLagType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected LeadLagType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Lead = "Lead";
	public static final LeadLagType Lead = new LeadLagType(_Lead);
	
		
	public static final String _Lag = "Lag";
	public static final LeadLagType Lag = new LeadLagType(_Lag);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static LeadLagType fromValue(String value) throws IllegalStateException {
		LeadLagType retVal = (LeadLagType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static LeadLagType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof LeadLagType && ordinal == ((LeadLagType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((LeadLagType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final LeadLagType[] VALUES = {Lead, Lag};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}