package com.ibm.rpm.wbs.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class ProjectPublishedType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected ProjectPublishedType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _None = "None";
	public static final ProjectPublishedType None = new ProjectPublishedType(_None);
	
		
	public static final String _ToTeam = "ToTeam";
	public static final ProjectPublishedType ToTeam = new ProjectPublishedType(_ToTeam);
	
		
	public static final String _ToTemplate = "ToTemplate";
	public static final ProjectPublishedType ToTemplate = new ProjectPublishedType(_ToTemplate);
	
		
	public static final String _ToPartialTemplate = "ToPartialTemplate";
	public static final ProjectPublishedType ToPartialTemplate = new ProjectPublishedType(_ToPartialTemplate);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static ProjectPublishedType fromValue(String value) throws IllegalStateException {
		ProjectPublishedType retVal = (ProjectPublishedType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static ProjectPublishedType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof ProjectPublishedType && ordinal == ((ProjectPublishedType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((ProjectPublishedType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final ProjectPublishedType[] VALUES = {None, ToTeam, ToTemplate, ToPartialTemplate};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}