package com.ibm.rpm.wbs.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class ResourceType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected ResourceType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _Resource = "Resource";
	public static final ResourceType Resource = new ResourceType(_Resource);
	
		
	public static final String _Profile = "Profile";
	public static final ResourceType Profile = new ResourceType(_Profile);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static ResourceType fromValue(String value) throws IllegalStateException {
		ResourceType retVal = (ResourceType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static ResourceType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof ResourceType && ordinal == ((ResourceType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((ResourceType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final ResourceType[] VALUES = {Resource, Profile};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}