package com.ibm.rpm.wbs.types;

import java.io.Serializable;
import java.io.ObjectStreamException;
import java.util.HashMap;
import java.util.Map;

public class ScopeElementSecurityType implements Comparable, Serializable {

	private final transient String value;
	
	private static Map values= new HashMap();
	
	/**
	 * Default constructor
	 */
	protected ScopeElementSecurityType(String value) {
		this.value = value;
		values.put(value, this);
	}
	
		
	public static final String _ProjectLevel = "ProjectLevel";
	public static final ScopeElementSecurityType ProjectLevel = new ScopeElementSecurityType(_ProjectLevel);
	
		
	public static final String _ByInvitation = "ByInvitation";
	public static final ScopeElementSecurityType ByInvitation = new ScopeElementSecurityType(_ByInvitation);
	
		
	public java.lang.String getValue() {
		return value;
	}
	
	public static ScopeElementSecurityType fromValue(String value) throws IllegalStateException {
		ScopeElementSecurityType retVal = (ScopeElementSecurityType) values.get(value);
		if (retVal == null) throw new IllegalStateException();
		return retVal;
	}
	
	public static ScopeElementSecurityType fromString(String value) throws IllegalStateException {
		return fromValue(value);
	}
	
	public String toString() {
		return value;
	}
	
	public final boolean equals(Object obj) {
		return obj instanceof ScopeElementSecurityType && ordinal == ((ScopeElementSecurityType)obj).ordinal;
	}
	
	public final int hashCode() {
		return ordinal;
	}
	
	public int compareTo(Object obj) {
		return ordinal - ((ScopeElementSecurityType)obj).ordinal;
	}
	
	// Code to ensure that the serialization will not create duplicate members
	private static int nextOrdinal = 0;
	private final int ordinal = nextOrdinal++;
	private static final ScopeElementSecurityType[] VALUES = {ProjectLevel, ByInvitation};

	Object readResolves() throws ObjectStreamException {
		return VALUES[ordinal];
	}
    
}