/*
 * Created on 04-Dec-2006
 * @author vikasbs
 */
package com.ibm.rpm.workflow.checkpoints;

import java.util.ArrayList;
import java.util.List;

import com.ibm.rpm.framework.AbstractCheckpoint;
import com.ibm.rpm.framework.MessageContext;
import com.ibm.rpm.workflow.constants.ValidationConstants;
import com.ibm.rpm.framework.RPMObject;
import com.ibm.rpm.framework.RPMObjectScope;
import com.ibm.rpm.framework.util.GenericValidator;
import com.ibm.rpm.workflow.containers.ExternalActionCategory;

public class ExternalActionCategoryCheckpoint extends AbstractCheckpoint
{
    private static final List EXTERNAL_ACTION_PARENT_LIST = new ArrayList();

    public void validateSave(RPMObject rpmObject, RPMObjectScope rpmScope,
            MessageContext msgCtx)
    {
        // validate the instance and the parent
        if (!GenericValidator.validateInstance(rpmObject,
                ExternalActionCategory.class, msgCtx)
                || !isValidParent(rpmObject, msgCtx, false, EXTERNAL_ACTION_PARENT_LIST))
        {
            return;
        }
        validateName((ExternalActionCategory) rpmObject, msgCtx);        
    }

    private void validateName(ExternalActionCategory externalActionCat,
            MessageContext msgCtx)
    {
        boolean valid = GenericValidator.validateMandatory(externalActionCat,
                ValidationConstants.NAME_FIELD, externalActionCat.getName(),
                msgCtx);
        if (valid && externalActionCat.testNameModified())
        {
            GenericValidator.validateMaxLength(externalActionCat,
                    ValidationConstants.NAME_FIELD, externalActionCat.getName(),
                    ValidationConstants.EXTERNAL_ACTION_NAME_MAX, msgCtx);
            GenericValidator.validateMinLength(externalActionCat,
                    ValidationConstants.NAME_FIELD, externalActionCat.getName(),
                    ValidationConstants.EXTERNAL_ACTION_NAME_MIN, msgCtx);
        }
    }    
}
