package com.ibm.rpm.workflow.constants;

public class ErrorCodes
{

    /**
     * Error codes for workflow containers.
     * Error code range: 408,001 - 409,000
     * 408,001 - 408,299: validation codes
     * 408,300 - 408,499: xpath codes
     * 408,500 + : manager codes
     * 
     * These error messages usually have the container name at the beginning. 
     * The className of the RPMException will be a container.
     * All validation errors that can be thrown to an end user should
     * be of this type.
     */
    
    public final static int HANGED_PROCESS = 200340;
    
    public final static int INVALID_WORKFLOW_PARAMS = 408001;
    
    public final static int INACTIVE_WORKFLOW = 408002;
    
    public final static int WORKFLOW_PROCESS_NOT_ASSOCIATED = 408003;
    
    public final static int WORKFLOW_DEFAULT_WITHOUT_ASSOCIATE = 408004;
    
    public final static int INVALID_STATE_TRANSITION = 408005;
    
    public final static int INVALID_WORKFLOW_ROLE_MAPPING = 408006;

}