package com.ibm.rpm.xpathparser;


public class Predicate implements Cloneable
{  
    /**
     *
     */
    
    private Condition leftCondition = null;

    private Condition rightCondition = null;

    private Predicate leftPredicate = null;

    private Predicate rightPredicate = null;
    
    private int type = CONDITION;

    public static final int CONDITION = 0;

    public Predicate(int type)
    {
        this.type = type;
    }

    public int getType()
    {
        return type;
    }
    
    public void setType(int newType)
    {
        this.type = newType;
    }

    public Condition getLeftCondition()
    {
        return leftCondition;
    }

    public Condition getRightCondition()
    {
        return rightCondition;
    }

    public Predicate getRightPredicate()
    {
        return rightPredicate;
    }

    public Predicate getLeftPredicate()
    {
        return leftPredicate;
    }

    /**
     * @param condition
     */
    public void add(Condition condition)
    {	
        if (leftCondition != null || leftPredicate != null)
        {
            if (rightCondition == null)
            {
                rightCondition = condition;
            }
        }
        else
        {
            leftCondition = condition;
        }
    }

    /**
     * @param newpred
     */
    public void add(Predicate predicate)
    {       
        if (leftPredicate != null || leftCondition != null)
        {
            if (rightPredicate == null)
            {
                rightPredicate = predicate;
            }
        }
        else
        {
            leftPredicate = predicate;
        }
    }

    public String getStringType()
    {

        String operator = null;

        if (type == CONDITION)
        {
            operator = null;
        }
        else if (type == ReflectOpCodes.OP_AND)
        {
            operator = " AND ";
        }
        else if (type == ReflectOpCodes.OP_OR)
        {
            operator = " OR ";
        }
        
        return operator;
    }

    public String toString()
    {
        StringBuffer returnbuf = new StringBuffer("[Type:" + getStringType()
                + "\n");
        returnbuf.append("\nLeft Condition: ");
        if (leftCondition != null)
            returnbuf.append(leftCondition.toString());
        returnbuf.append("\nLeft Predicate: \n");
        if (leftPredicate != null)
            returnbuf.append(leftPredicate.toString() + "\n");
        returnbuf.append("\nRight Condition: ");
        if (rightCondition != null)
            returnbuf.append(rightCondition.toString());
        returnbuf.append("\nRight Predicate: \n");
        if (rightPredicate != null)
            returnbuf.append(rightPredicate.toString() + "\n");
        return returnbuf.toString();
    }
    
    public Object clone() throws CloneNotSupportedException
    {        
        Predicate p = null;

        try
        {
            p = (Predicate) super.clone();
            if(leftCondition != null){
                leftCondition = (Condition)leftCondition.clone();
            }
            if(rightCondition != null){
                rightCondition = (Condition)rightCondition.clone();
            }
            if(leftPredicate != null){
                leftPredicate = (Predicate)leftPredicate.clone();
            }
            if(rightPredicate != null){
                rightPredicate = (Predicate)rightPredicate.clone();
            }
        }
        catch (CloneNotSupportedException e)
        {
            //Do nothing
        }

        return p;
    }

}
