
package com.ibm.rpm.xpathparser;

import java.lang.reflect.Field;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.xpath.compiler.FunctionTable;

public class ReflectFunctionTable
{
    
    private static Class FUNCTION_TABLE_CLASS = FunctionTable.class;

    /** The 'current()' id. */
    public static final int FUNC_CURRENT = loadConstant("FUNC_CURRENT");

    /** The 'last()' id. */
    public static final int FUNC_LAST = loadConstant("FUNC_LAST");

    /** The 'position()' id. */
    public static final int FUNC_POSITION = loadConstant("FUNC_POSITION");

    /** The 'count()' id. */
    public static final int FUNC_COUNT = loadConstant("FUNC_COUNT");

    /** The 'id()' id. */
    public static final int FUNC_ID = loadConstant("FUNC_ID");

    /** The 'key()' id (XSLT). */
    public static final int FUNC_KEY = loadConstant("FUNC_KEY");

    /** The 'local-name()' id. */
    public static final int FUNC_LOCAL_PART = loadConstant("FUNC_LOCAL_PART");

    /** The 'namespace-uri()' id. */
    public static final int FUNC_NAMESPACE = loadConstant("FUNC_NAMESPACE");

    /** The 'name()' id. */
    public static final int FUNC_QNAME = loadConstant("FUNC_QNAME");

    /** The 'generate-id()' id. */
    public static final int FUNC_GENERATE_ID = loadConstant("FUNC_GENERATE_ID");

    /** The 'not()' id. */
    public static final int FUNC_NOT = loadConstant("FUNC_NOT");

    /** The 'true()' id. */
    public static final int FUNC_TRUE = loadConstant("FUNC_TRUE");

    /** The 'false()' id. */
    public static final int FUNC_FALSE = loadConstant("FUNC_FALSE");

    /** The 'boolean()' id. */
    public static final int FUNC_BOOLEAN = loadConstant("FUNC_BOOLEAN");

    /** The 'number()' id. */
    public static final int FUNC_NUMBER = loadConstant("FUNC_NUMBER");

    /** The 'floor()' id. */
    public static final int FUNC_FLOOR = loadConstant("FUNC_FLOOR");

    /** The 'ceiling()' id. */
    public static final int FUNC_CEILING = loadConstant("FUNC_CEILING");

    /** The 'round()' id. */
    public static final int FUNC_ROUND = loadConstant("FUNC_ROUND");

    /** The 'sum()' id. */
    public static final int FUNC_SUM = loadConstant("FUNC_SUM");

    /** The 'string()' id. */
    public static final int FUNC_STRING = loadConstant("FUNC_STRING");

    /** The 'starts-with()' id. */
    public static final int FUNC_STARTS_WITH = loadConstant("FUNC_STARTS_WITH");

    /** The 'contains()' id. */
    public static final int FUNC_CONTAINS = loadConstant("FUNC_CONTAINS");

    /** The 'substring-before()' id. */
    public static final int FUNC_SUBSTRING_BEFORE = loadConstant("FUNC_SUBSTRING_BEFORE");

    /** The 'substring-after()' id. */
    public static final int FUNC_SUBSTRING_AFTER = loadConstant("FUNC_SUBSTRING_AFTER");

    /** The 'normalize-space()' id. */
    public static final int FUNC_NORMALIZE_SPACE = loadConstant("FUNC_NORMALIZE_SPACE");

    /** The 'translate()' id. */
    public static final int FUNC_TRANSLATE = loadConstant("FUNC_TRANSLATE");

    /** The 'concat()' id. */
    public static final int FUNC_CONCAT = loadConstant("FUNC_CONCAT");

    /** The 'substring()' id. */
    public static final int FUNC_SUBSTRING = loadConstant("FUNC_SUBSTRING");

    /** The 'string-length()' id. */
    public static final int FUNC_STRING_LENGTH = loadConstant("FUNC_STRING_LENGTH");

    /** The 'system-property()' id. */
    public static final int FUNC_SYSTEM_PROPERTY = loadConstant("FUNC_SYSTEM_PROPERTY");

    /** The 'lang()' id. */
    public static final int FUNC_LANG = loadConstant("FUNC_LANG");

    /** The 'function-available()' id (XSLT). */
    public static final int FUNC_EXT_FUNCTION_AVAILABLE = loadConstant("FUNC_EXT_FUNCTION_AVAILABLE");

    /** The 'element-available()' id (XSLT). */
    public static final int FUNC_EXT_ELEM_AVAILABLE = loadConstant("FUNC_EXT_ELEM_AVAILABLE");

    /** The 'unparsed-entity-uri()' id (XSLT). */
    public static final int FUNC_UNPARSED_ENTITY_URI = loadConstant("FUNC_UNPARSED_ENTITY_URI");

    // Proprietary

    /** The 'document-location()' id (Proprietary). */
    public static final int FUNC_DOCLOCATION = loadConstant("FUNC_DOCLOCATION");


    private static int loadConstant(String string)
    {
        int retVal = 0;
        try
        {
            Field field = FUNCTION_TABLE_CLASS.getField(string);
            Integer value = (Integer) field.get(null);
            retVal = value.intValue();
        }
        catch (Exception e)
        {
            //Can only happen if class is not in sync with FunctionTable class.
            Log logger = LogFactory.getLog(ReflectOpCodes.class);
            logger.error(e);
            e.printStackTrace();
        }

        return retVal;
    }
    
  
}
