
package com.ibm.rpm.xpathparser.steps;

import org.apache.xml.utils.ObjectVector;
import org.apache.xpath.XPathException;
import org.apache.xpath.compiler.OpMapVector;

import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.xpathparser.ReflectOpCodes;

/**
 * @author kuschel
 * 
 * [OP_ARGUMENT] (Function argument.) [length] {expression}
 * 
 * returns: XNodeSet XNumber XString XBoolean XRTree XObject
 * @xsl.usage advanced
 */
public class Argument extends XPathStep
{

    /**
     * @param op_xpath
     * @param opMap
     * @param tokenQueue
     * @param parent
     */
    public Argument(OpMapVector opMap, ObjectVector tokenQueue, XPathStep parent)
    {
        super(ReflectOpCodes.OP_ARGUMENT, opMap, tokenQueue, parent);
        // TODO Auto-generated constructor stub
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.xpathparser.steps.XPathStep#notifyPostBuild(com.ibm.rpm.xpathparser.steps.XPathStep)
     */
    protected void notifyPostBuild(XPathStep predicate)
    {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.xpathparser.steps.XPathStep#notifyPreBuild(com.ibm.rpm.xpathparser.steps.XPathStep)
     */
    protected void notifyPreBuild(XPathStep predicate)
    {
        // TODO Auto-generated method stub

    }

    public int build(int position) throws XPathException, RPMException
    {
        setLength(opMap.elementAt(++position) - 2);
        notifyPreBuild(this);
        position = super.build(++position);
        notifyPostBuild(this);
        return position;
    }
}
