package com.ibm.rpm.xpathparser.steps;

import org.apache.xml.utils.ObjectVector;
import org.apache.xpath.XPathException;
import org.apache.xpath.compiler.OpMapVector;

import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.xpathparser.ReflectOpCodes;
import com.ibm.rpm.xpathparser.Table;

/**
 * @author kuschel
 * 
 * [FROM_stepType] [length, including predicates] [length of just the step,
 * without the predicates] {node test} {predicates}?
 * 
 * returns: XBoolean
 * @xsl.usage advanceds
 */
public abstract class From extends XPathStep
{
    private static final boolean INLINE_PREDICATES = true;

    private Table table = null;
    
    private boolean subPredicate = false;

    /**
     * @param op_xpath
     * @param opMap
     * @param tokenQueue
     */
    protected From(int op_xpath, OpMapVector opMap, ObjectVector tokenQueue,
            XPathStep step)
    {
        super(op_xpath, opMap, tokenQueue, step);
        // TODO Auto-generated constructor stub
    }

    public int build(int position) throws XPathException, RPMException
    {
        if (INLINE_PREDICATES)
        {
            setLength(opMap.elementAt(++position) - 3);
            notifyPreBuild(this);
            position = super.build(position += 2);
            notifyPostBuild(this);
        }
        else
        {
            setLength(opMap.elementAt(position += 2) - 3);
            notifyPreBuild(this);
            position = super.build(++position);
            notifyPostBuild(this);

        }
        return position;
    }

    /**
     * @return Returns the table.
     */
    public Table getTable()
    {
        return table;
    }

    /**
     * @param table
     *            The table to set.
     */
    protected void setTable(Table table)
    {
        this.table = table;
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.xpathparser.steps.XPathStep#notifyPostBuild(com.ibm.rpm.xpathparser.steps.Predicate)
     */
    protected void notifyPostBuild(XPathStep predicate)
    {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.xpathparser.steps.XPathStep#notifyPreBuild(com.ibm.rpm.xpathparser.steps.Predicate)
     */
    protected void notifyPreBuild(XPathStep predicate)
    {
        XPathStep parent = getParent();
        XPathStep[] children = parent.getChildren();
        
        //count fromChildren
        int nbChild = 0;
        int i = 0;
        while(i < children.length){
            if(children[i].getOperation() == ReflectOpCodes.FROM_CHILDREN){
                nbChild++;
            }
            i++;
        }
        
        if(nbChild <= 1){
            subPredicate = true;
        }

    }
    /**
     * @return Returns the subPredicate.
     */
    public boolean isSubPredicate()
    {
        return subPredicate;
    }
}
