package com.ibm.rpm.xpathparser.steps;

import org.apache.xml.utils.ObjectVector;
import org.apache.xpath.XPathException;
import org.apache.xpath.compiler.OpMapVector;

import com.ibm.rpm.framework.RPMException;
import com.ibm.rpm.xpathparser.ReflectOpCodes;

/**
 * @author kuschel
 * 
 * [OP_LOCATIONPATH] [length] {FROM_stepType} | {function} {predicate} [ENDOP]
 * 
 * (Note that element and attribute namespaces and names can be wildcarded '*'.)
 * 
 * returns: XNodeSet
 * @xsl.usage advanced
 */
public class LocationPath extends XPathStep
{

    /**
     * @param op_xpath
     * @param opMap
     * @param tokenQueue
     * @param step
     */
    protected LocationPath(OpMapVector opMap, ObjectVector tokenQueue,
            XPathStep step)
    {
        super(ReflectOpCodes.OP_LOCATIONPATH, opMap, tokenQueue, step);
        // TODO Auto-generated constructor stub
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.xpathparser.steps.XPathStep#notifyPostBuild(com.ibm.rpm.xpathparser.steps.Predicate)
     */
    protected void notifyPostBuild(XPathStep predicate)
    {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.rpm.xpathparser.steps.XPathStep#notifyPreBuild(com.ibm.rpm.xpathparser.steps.Predicate)
     */
    protected void notifyPreBuild(XPathStep predicate)
    {
        // TODO Auto-generated method stub

    }

    public int build(int position) throws XPathException, RPMException
    {
        setLength(opMap.elementAt(++position) - 2);
        notifyPreBuild(this);
        position = super.build(++position);
        notifyPostBuild(this);
        return position;
    }
}
