package com.ibm.rpm.xpathparser.steps;

import org.apache.xml.utils.ObjectVector;
import org.apache.xpath.compiler.OpMapVector;

public abstract class TokenedXPathStep extends XPathStep
{

    /**
     * @param op_xpath
     * @param opMap
     * @param tokenQueue
     */
    protected TokenedXPathStep(int op_xpath, OpMapVector opMap,
            ObjectVector tokenQueue, XPathStep step)
    {
        super(op_xpath, opMap, tokenQueue, step);
    }

    private String namespace = null;

    private String token = null;

    public String getNamespace()
    {
        return namespace;
    }

    protected void setNamespace(String namespace)
    {
        this.namespace = namespace;
    }

    public String getToken()
    {
        return token;
    }

    protected void setToken(String token)
    {
        this.token = token;
    }

    public String toString()
    {
        StringBuffer buffer = new StringBuffer();
        buffer.append(" Namespace: " + namespace);
        buffer.append(System.getProperty("line.separator"));
        buffer.append(" Token: " + token);
        buffer.append(System.getProperty("line.separator"));
        return buffer.toString() + super.toString();
    }
}
